/* CharacterAttributes.c generated by valac 0.20.1, the Vala compiler
 * generated from CharacterAttributes.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Parses Character Attributes (SGR) control sequences*/

#include <glib.h>
#include <glib-object.h>
#include <clutter/clutter.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <stdlib.h>


#define TYPE_CHARACTER_ATTRIBUTES (character_attributes_get_type ())
#define CHARACTER_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributes))
#define CHARACTER_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributesClass))
#define IS_CHARACTER_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHARACTER_ATTRIBUTES))
#define IS_CHARACTER_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHARACTER_ATTRIBUTES))
#define CHARACTER_ATTRIBUTES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributesClass))

typedef struct _CharacterAttributes CharacterAttributes;
typedef struct _CharacterAttributesClass CharacterAttributesClass;
typedef struct _CharacterAttributesPrivate CharacterAttributesPrivate;

#define TYPE_TEXT_MENU (text_menu_get_type ())
#define TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_MENU, TextMenu))
#define TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_MENU, TextMenuClass))
#define IS_TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_MENU))
#define IS_TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_MENU))
#define TEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_MENU, TextMenuClass))

typedef struct _TextMenu TextMenu;
typedef struct _TextMenuClass TextMenuClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TERMINAL_STREAM_TYPE_STREAM_ELEMENT (terminal_stream_stream_element_get_type ())
#define TERMINAL_STREAM_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement))
#define TERMINAL_STREAM_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_STREAM_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))

typedef struct _TerminalStreamStreamElement TerminalStreamStreamElement;
typedef struct _TerminalStreamStreamElementClass TerminalStreamStreamElementClass;

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_STREAM_ELEMENT_TYPE (terminal_stream_stream_element_stream_element_type_get_type ())

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE (terminal_stream_stream_element_control_sequence_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_OUTPUT_TYPE_INTERPRETATION_STATUS (terminal_output_interpretation_status_get_type ())

#define TYPE_COLOR_SCHEME (color_scheme_get_type ())
#define COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_SCHEME, ColorScheme))
#define COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_SCHEME, ColorSchemeClass))
#define IS_COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_SCHEME))
#define IS_COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_SCHEME))
#define COLOR_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_SCHEME, ColorSchemeClass))

typedef struct _ColorScheme ColorScheme;
typedef struct _ColorSchemeClass ColorSchemeClass;

#define TYPE_TEXT_ATTRIBUTES (text_attributes_get_type ())
#define TEXT_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_ATTRIBUTES, TextAttributes))
#define TEXT_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_ATTRIBUTES, TextAttributesClass))
#define IS_TEXT_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_ATTRIBUTES))
#define IS_TEXT_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_ATTRIBUTES))
#define TEXT_ATTRIBUTES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_ATTRIBUTES, TextAttributesClass))

typedef struct _TextAttributes TextAttributes;
typedef struct _TextAttributesClass TextAttributesClass;
typedef struct _TextAttributesPrivate TextAttributesPrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _CharacterAttributes {
	GObject parent_instance;
	CharacterAttributesPrivate * priv;
};

struct _CharacterAttributesClass {
	GObjectClass parent_class;
};

struct _CharacterAttributesPrivate {
	gint _foreground_color;
	gint _background_color;
	ClutterColor _rgb_foreground_color;
	ClutterColor _rgb_background_color;
	gboolean _use_rgb_foreground_color;
	gboolean _use_rgb_background_color;
	gboolean _bold;
	gboolean _underlined;
	gboolean _blink;
	gboolean _inverse;
	gboolean _invisible;
	TextMenu* _text_menu;
};

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT,
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE
} TerminalStreamStreamElementStreamElementType;

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS
} TerminalStreamStreamElementControlSequenceType;

typedef enum  {
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_SUPPORTED
} TerminalOutputInterpretationStatus;

struct _TextAttributes {
	GObject parent_instance;
	TextAttributesPrivate * priv;
};

struct _TextAttributesClass {
	GObjectClass parent_class;
};

struct _TextAttributesPrivate {
	ClutterColor _foreground_color;
	ClutterColor _background_color;
	gboolean _bold;
	gboolean _underlined;
	TextMenu* _text_menu;
};


static gpointer character_attributes_parent_class = NULL;
static gpointer text_attributes_parent_class = NULL;

GType character_attributes_get_type (void) G_GNUC_CONST;
GType text_menu_get_type (void) G_GNUC_CONST;
#define CHARACTER_ATTRIBUTES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributesPrivate))
enum  {
	CHARACTER_ATTRIBUTES_DUMMY_PROPERTY,
	CHARACTER_ATTRIBUTES_FOREGROUND_COLOR,
	CHARACTER_ATTRIBUTES_BACKGROUND_COLOR,
	CHARACTER_ATTRIBUTES_RGB_FOREGROUND_COLOR,
	CHARACTER_ATTRIBUTES_RGB_BACKGROUND_COLOR,
	CHARACTER_ATTRIBUTES_USE_RGB_FOREGROUND_COLOR,
	CHARACTER_ATTRIBUTES_USE_RGB_BACKGROUND_COLOR,
	CHARACTER_ATTRIBUTES_BOLD,
	CHARACTER_ATTRIBUTES_UNDERLINED,
	CHARACTER_ATTRIBUTES_BLINK,
	CHARACTER_ATTRIBUTES_INVERSE,
	CHARACTER_ATTRIBUTES_INVISIBLE,
	CHARACTER_ATTRIBUTES_TEXT_MENU
};
gboolean character_attributes_equals (CharacterAttributes* self, CharacterAttributes* attributes);
gint character_attributes_get_foreground_color (CharacterAttributes* self);
gint character_attributes_get_background_color (CharacterAttributes* self);
void character_attributes_get_rgb_foreground_color (CharacterAttributes* self, ClutterColor* result);
static gboolean _clutter_color_equal (const ClutterColor* s1, const ClutterColor* s2);
void character_attributes_get_rgb_background_color (CharacterAttributes* self, ClutterColor* result);
gboolean character_attributes_get_use_rgb_foreground_color (CharacterAttributes* self);
gboolean character_attributes_get_use_rgb_background_color (CharacterAttributes* self);
gboolean character_attributes_get_bold (CharacterAttributes* self);
gboolean character_attributes_get_underlined (CharacterAttributes* self);
gboolean character_attributes_get_blink (CharacterAttributes* self);
gboolean character_attributes_get_inverse (CharacterAttributes* self);
gboolean character_attributes_get_invisible (CharacterAttributes* self);
TextMenu* character_attributes_get_text_menu (CharacterAttributes* self);
static void character_attributes_reset (CharacterAttributes* self);
void character_attributes_set_foreground_color (CharacterAttributes* self, gint value);
void character_attributes_set_background_color (CharacterAttributes* self, gint value);
void character_attributes_set_rgb_foreground_color (CharacterAttributes* self, ClutterColor* value);
void character_attributes_set_rgb_background_color (CharacterAttributes* self, ClutterColor* value);
void character_attributes_set_use_rgb_foreground_color (CharacterAttributes* self, gboolean value);
void character_attributes_set_use_rgb_background_color (CharacterAttributes* self, gboolean value);
void character_attributes_set_bold (CharacterAttributes* self, gboolean value);
void character_attributes_set_underlined (CharacterAttributes* self, gboolean value);
void character_attributes_set_blink (CharacterAttributes* self, gboolean value);
void character_attributes_set_inverse (CharacterAttributes* self, gboolean value);
void character_attributes_set_invisible (CharacterAttributes* self, gboolean value);
void character_attributes_set_text_menu (CharacterAttributes* self, TextMenu* value);
static void character_attributes_copy_method (CharacterAttributes* self, CharacterAttributes* character_attributes);
CharacterAttributes* character_attributes_new (void);
CharacterAttributes* character_attributes_construct (GType object_type);
CharacterAttributes* character_attributes_new_copy (CharacterAttributes* character_attributes);
CharacterAttributes* character_attributes_construct_copy (GType object_type, CharacterAttributes* character_attributes);
GType terminal_stream_stream_element_get_type (void) G_GNUC_CONST;
CharacterAttributes* character_attributes_new_from_stream_element (TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes);
CharacterAttributes* character_attributes_construct_from_stream_element (GType object_type, TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes);
GType terminal_stream_stream_element_stream_element_type_get_type (void) G_GNUC_CONST;
TerminalStreamStreamElementStreamElementType terminal_stream_stream_element_get_stream_element_type (TerminalStreamStreamElement* self);
GType terminal_stream_stream_element_control_sequence_type_get_type (void) G_GNUC_CONST;
TerminalStreamStreamElementControlSequenceType terminal_stream_stream_element_get_control_sequence_type (TerminalStreamStreamElement* self);
GeeList* terminal_stream_stream_element_get_control_sequence_parameters (TerminalStreamStreamElement* self);
GType terminal_output_interpretation_status_get_type (void) G_GNUC_CONST;
void terminal_output_print_interpretation_status (TerminalStreamStreamElement* stream_element, TerminalOutputInterpretationStatus interpretation_status);
void utilities_get_rgb_color (gint red, gint green, gint blue, ClutterColor* result);
GType color_scheme_get_type (void) G_GNUC_CONST;
GType text_attributes_get_type (void) G_GNUC_CONST;
TextAttributes* character_attributes_get_text_attributes (CharacterAttributes* self, ColorScheme* color_scheme, gboolean dark);
TextAttributes* text_attributes_new (void);
TextAttributes* text_attributes_construct (GType object_type);
void text_attributes_set_foreground_color (TextAttributes* self, ClutterColor* value);
void text_attributes_set_background_color (TextAttributes* self, ClutterColor* value);
void color_scheme_get_foreground_color (ColorScheme* self, gboolean dark, ClutterColor* result);
void color_scheme_get_indexed_color (ColorScheme* self, gint index, gboolean dark, ClutterColor* result);
void color_scheme_get_background_color (ColorScheme* self, gboolean dark, ClutterColor* result);
void text_attributes_set_bold (TextAttributes* self, gboolean value);
void text_attributes_set_underlined (TextAttributes* self, gboolean value);
void text_attributes_set_text_menu (TextAttributes* self, TextMenu* value);
static void character_attributes_finalize (GObject* obj);
static void _vala_character_attributes_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_character_attributes_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define TEXT_ATTRIBUTES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEXT_ATTRIBUTES, TextAttributesPrivate))
enum  {
	TEXT_ATTRIBUTES_DUMMY_PROPERTY,
	TEXT_ATTRIBUTES_FOREGROUND_COLOR,
	TEXT_ATTRIBUTES_BACKGROUND_COLOR,
	TEXT_ATTRIBUTES_BOLD,
	TEXT_ATTRIBUTES_UNDERLINED,
	TEXT_ATTRIBUTES_TEXT_MENU
};
gchar* text_attributes_get_markup_attributes (TextAttributes* self, ColorScheme* color_scheme, gboolean dark);
void text_attributes_get_foreground_color (TextAttributes* self, ClutterColor* result);
gchar* utilities_get_parsable_color_string (ClutterColor* color);
void text_attributes_get_background_color (TextAttributes* self, ClutterColor* result);
gboolean text_attributes_get_bold (TextAttributes* self);
TextMenu* text_attributes_get_text_menu (TextAttributes* self);
gint text_menu_get_color (TextMenu* self);
gboolean text_attributes_get_underlined (TextAttributes* self);
static void text_attributes_finalize (GObject* obj);
static void _vala_text_attributes_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_text_attributes_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gboolean _clutter_color_equal (const ClutterColor* s1, const ClutterColor* s2) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1 == s2) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return TRUE;
#line 397 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1 == NULL) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 403 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s2 == NULL) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 409 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1->red != s2->red) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 415 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1->green != s2->green) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 421 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1->blue != s2->blue) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 427 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (s1->alpha != s2->alpha) {
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return FALSE;
#line 433 "CharacterAttributes.c"
	}
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return TRUE;
#line 437 "CharacterAttributes.c"
}


gboolean character_attributes_equals (CharacterAttributes* self, CharacterAttributes* attributes) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gint _tmp11_;
	CharacterAttributes* _tmp12_;
	gint _tmp13_;
	gboolean _tmp17_;
	gboolean _tmp21_;
	gboolean _tmp25_;
	gboolean _tmp29_;
	gboolean _tmp33_;
	gboolean _tmp37_;
	gboolean _tmp41_;
	gboolean _tmp45_;
	gboolean _tmp49_;
	gboolean _tmp53_;
	gboolean _tmp57_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (attributes != NULL, FALSE);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp11_ = self->priv->_foreground_color;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp12_ = attributes;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp13_ = _tmp12_->priv->_foreground_color;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp11_ == _tmp13_) {
#line 480 "CharacterAttributes.c"
		gint _tmp14_;
		CharacterAttributes* _tmp15_;
		gint _tmp16_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp14_ = self->priv->_background_color;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp15_ = attributes;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp16_ = _tmp15_->priv->_background_color;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp10_ = _tmp14_ == _tmp16_;
#line 492 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp10_ = FALSE;
#line 496 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp17_ = _tmp10_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp17_) {
#line 502 "CharacterAttributes.c"
		ClutterColor _tmp18_;
		CharacterAttributes* _tmp19_;
		ClutterColor _tmp20_;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp18_ = self->priv->_rgb_foreground_color;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp19_ = attributes;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp20_ = _tmp19_->priv->_rgb_foreground_color;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp9_ = _clutter_color_equal (&_tmp18_, &_tmp20_) == TRUE;
#line 514 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp9_ = FALSE;
#line 518 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp21_ = _tmp9_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp21_) {
#line 524 "CharacterAttributes.c"
		ClutterColor _tmp22_;
		CharacterAttributes* _tmp23_;
		ClutterColor _tmp24_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp22_ = self->priv->_rgb_background_color;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp23_ = attributes;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp24_ = _tmp23_->priv->_rgb_background_color;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp8_ = _clutter_color_equal (&_tmp22_, &_tmp24_) == TRUE;
#line 536 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp8_ = FALSE;
#line 540 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp25_ = _tmp8_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp25_) {
#line 546 "CharacterAttributes.c"
		gboolean _tmp26_;
		CharacterAttributes* _tmp27_;
		gboolean _tmp28_;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp26_ = self->priv->_use_rgb_foreground_color;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp27_ = attributes;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp28_ = _tmp27_->priv->_use_rgb_foreground_color;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp7_ = _tmp26_ == _tmp28_;
#line 558 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp7_ = FALSE;
#line 562 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp29_ = _tmp7_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp29_) {
#line 568 "CharacterAttributes.c"
		gboolean _tmp30_;
		CharacterAttributes* _tmp31_;
		gboolean _tmp32_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp30_ = self->priv->_use_rgb_background_color;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp31_ = attributes;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp32_ = _tmp31_->priv->_use_rgb_background_color;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp6_ = _tmp30_ == _tmp32_;
#line 580 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp6_ = FALSE;
#line 584 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp33_ = _tmp6_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp33_) {
#line 590 "CharacterAttributes.c"
		gboolean _tmp34_;
		CharacterAttributes* _tmp35_;
		gboolean _tmp36_;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp34_ = self->priv->_bold;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp35_ = attributes;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp36_ = _tmp35_->priv->_bold;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp5_ = _tmp34_ == _tmp36_;
#line 602 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp5_ = FALSE;
#line 606 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp37_ = _tmp5_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp37_) {
#line 612 "CharacterAttributes.c"
		gboolean _tmp38_;
		CharacterAttributes* _tmp39_;
		gboolean _tmp40_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp38_ = self->priv->_underlined;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp39_ = attributes;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp40_ = _tmp39_->priv->_underlined;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp4_ = _tmp38_ == _tmp40_;
#line 624 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp4_ = FALSE;
#line 628 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp41_ = _tmp4_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp41_) {
#line 634 "CharacterAttributes.c"
		gboolean _tmp42_;
		CharacterAttributes* _tmp43_;
		gboolean _tmp44_;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp42_ = self->priv->_blink;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp43_ = attributes;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp44_ = _tmp43_->priv->_blink;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp3_ = _tmp42_ == _tmp44_;
#line 646 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp3_ = FALSE;
#line 650 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp45_ = _tmp3_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp45_) {
#line 656 "CharacterAttributes.c"
		gboolean _tmp46_;
		CharacterAttributes* _tmp47_;
		gboolean _tmp48_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp46_ = self->priv->_inverse;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp47_ = attributes;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp48_ = _tmp47_->priv->_inverse;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp2_ = _tmp46_ == _tmp48_;
#line 668 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp2_ = FALSE;
#line 672 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp49_ = _tmp2_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp49_) {
#line 678 "CharacterAttributes.c"
		gboolean _tmp50_;
		CharacterAttributes* _tmp51_;
		gboolean _tmp52_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp50_ = self->priv->_invisible;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp51_ = attributes;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp52_ = _tmp51_->priv->_invisible;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp1_ = _tmp50_ == _tmp52_;
#line 690 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp1_ = FALSE;
#line 694 "CharacterAttributes.c"
	}
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp53_ = _tmp1_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp53_) {
#line 700 "CharacterAttributes.c"
		TextMenu* _tmp54_;
		CharacterAttributes* _tmp55_;
		TextMenu* _tmp56_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp54_ = self->priv->_text_menu;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp55_ = attributes;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp56_ = _tmp55_->priv->_text_menu;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp0_ = _tmp54_ == _tmp56_;
#line 712 "CharacterAttributes.c"
	} else {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp0_ = FALSE;
#line 716 "CharacterAttributes.c"
	}
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp57_ = _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp57_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 724 "CharacterAttributes.c"
}


static void character_attributes_reset (CharacterAttributes* self) {
	ClutterColor _tmp0_ = {0};
	ClutterColor _tmp1_ = {0};
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_foreground_color (self, -1);
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_background_color (self, -1);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	memset (&_tmp0_, 0, sizeof (ClutterColor));
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_rgb_foreground_color (self, &_tmp0_);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	memset (&_tmp1_, 0, sizeof (ClutterColor));
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_rgb_background_color (self, &_tmp1_);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_use_rgb_foreground_color (self, FALSE);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_use_rgb_background_color (self, FALSE);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_bold (self, FALSE);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_underlined (self, FALSE);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_blink (self, FALSE);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_inverse (self, FALSE);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_invisible (self, FALSE);
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_text_menu (self, NULL);
#line 761 "CharacterAttributes.c"
}


static void character_attributes_copy_method (CharacterAttributes* self, CharacterAttributes* character_attributes) {
	CharacterAttributes* _tmp0_;
	gint _tmp1_;
	CharacterAttributes* _tmp2_;
	gint _tmp3_;
	CharacterAttributes* _tmp4_;
	ClutterColor _tmp5_;
	CharacterAttributes* _tmp6_;
	ClutterColor _tmp7_;
	CharacterAttributes* _tmp8_;
	gboolean _tmp9_;
	CharacterAttributes* _tmp10_;
	gboolean _tmp11_;
	CharacterAttributes* _tmp12_;
	gboolean _tmp13_;
	CharacterAttributes* _tmp14_;
	gboolean _tmp15_;
	CharacterAttributes* _tmp16_;
	gboolean _tmp17_;
	CharacterAttributes* _tmp18_;
	gboolean _tmp19_;
	CharacterAttributes* _tmp20_;
	gboolean _tmp21_;
	CharacterAttributes* _tmp22_;
	TextMenu* _tmp23_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (character_attributes != NULL);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = character_attributes;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = _tmp0_->priv->_foreground_color;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_foreground_color (self, _tmp1_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp2_ = character_attributes;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp3_ = _tmp2_->priv->_background_color;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_background_color (self, _tmp3_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp4_ = character_attributes;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp5_ = _tmp4_->priv->_rgb_foreground_color;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_rgb_foreground_color (self, &_tmp5_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp6_ = character_attributes;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp7_ = _tmp6_->priv->_rgb_background_color;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_rgb_background_color (self, &_tmp7_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp8_ = character_attributes;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp9_ = _tmp8_->priv->_use_rgb_foreground_color;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_use_rgb_foreground_color (self, _tmp9_);
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp10_ = character_attributes;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp11_ = _tmp10_->priv->_use_rgb_background_color;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_use_rgb_background_color (self, _tmp11_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp12_ = character_attributes;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp13_ = _tmp12_->priv->_bold;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_bold (self, _tmp13_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp14_ = character_attributes;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp15_ = _tmp14_->priv->_underlined;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_underlined (self, _tmp15_);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp16_ = character_attributes;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp17_ = _tmp16_->priv->_blink;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_blink (self, _tmp17_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp18_ = character_attributes;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp19_ = _tmp18_->priv->_inverse;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_inverse (self, _tmp19_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp20_ = character_attributes;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp21_ = _tmp20_->priv->_invisible;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_invisible (self, _tmp21_);
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp22_ = character_attributes;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp23_ = _tmp22_->priv->_text_menu;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_set_text_menu (self, _tmp23_);
#line 866 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_construct (GType object_type) {
	CharacterAttributes * self = NULL;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = (CharacterAttributes*) g_object_new (object_type, NULL);
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_reset (self);
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return self;
#line 878 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_new (void) {
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return character_attributes_construct (TYPE_CHARACTER_ATTRIBUTES);
#line 885 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_construct_copy (GType object_type, CharacterAttributes* character_attributes) {
	CharacterAttributes * self = NULL;
	CharacterAttributes* _tmp0_;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (character_attributes != NULL, NULL);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = (CharacterAttributes*) g_object_new (object_type, NULL);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = character_attributes;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_copy_method (self, _tmp0_);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return self;
#line 902 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_new_copy (CharacterAttributes* character_attributes) {
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return character_attributes_construct_copy (TYPE_CHARACTER_ATTRIBUTES, character_attributes);
#line 909 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_construct_from_stream_element (GType object_type, TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes) {
	CharacterAttributes * self = NULL;
	gboolean _tmp0_ = FALSE;
	TerminalStreamStreamElement* _tmp1_;
	TerminalStreamStreamElementStreamElementType _tmp2_;
	TerminalStreamStreamElementStreamElementType _tmp3_;
	gboolean _tmp7_;
	TerminalStreamStreamElement* _tmp9_;
	GeeList* _tmp10_;
	GeeList* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	CharacterAttributes* _tmp14_;
	TerminalStreamStreamElement* _tmp15_;
	GeeList* _tmp16_;
	GeeList* _tmp17_;
	GeeListIterator* _tmp18_ = NULL;
	GeeListIterator* iterator;
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (stream_element != NULL, NULL);
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (current_attributes != NULL, NULL);
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = (CharacterAttributes*) g_object_new (object_type, NULL);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = stream_element;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp2_ = terminal_stream_stream_element_get_stream_element_type (_tmp1_);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp3_ = _tmp2_;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp3_ == TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE) {
#line 945 "CharacterAttributes.c"
		TerminalStreamStreamElement* _tmp4_;
		TerminalStreamStreamElementControlSequenceType _tmp5_;
		TerminalStreamStreamElementControlSequenceType _tmp6_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp4_ = stream_element;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp5_ = terminal_stream_stream_element_get_control_sequence_type (_tmp4_);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp6_ = _tmp5_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp0_ = _tmp6_ == TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES;
#line 957 "CharacterAttributes.c"
	} else {
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp0_ = FALSE;
#line 961 "CharacterAttributes.c"
	}
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp7_ = _tmp0_;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (!_tmp7_) {
#line 967 "CharacterAttributes.c"
		const gchar* _tmp8_ = NULL;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp8_ = _ ("Cannot parse stream element into character attributes");
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_critical ("CharacterAttributes.vala:101: %s", _tmp8_);
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return self;
#line 975 "CharacterAttributes.c"
	}
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp9_ = stream_element;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp10_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp9_);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp11_ = _tmp10_;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp12_ = gee_collection_get_is_empty ((GeeCollection*) _tmp11_);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp13_ = _tmp12_;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp13_) {
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_reset (self);
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		return self;
#line 993 "CharacterAttributes.c"
	}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp14_ = current_attributes;
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_copy_method (self, _tmp14_);
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp15_ = stream_element;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp16_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp15_);
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp17_ = _tmp16_;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp18_ = gee_list_list_iterator (_tmp17_);
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	iterator = _tmp18_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	while (TRUE) {
#line 1011 "CharacterAttributes.c"
		GeeListIterator* _tmp19_;
		gboolean _tmp20_ = FALSE;
		GeeListIterator* _tmp21_;
		gpointer _tmp22_ = NULL;
		gchar* parameter;
		const gchar* _tmp23_;
		gint _tmp24_ = 0;
		gint attribute_code;
		gint _tmp25_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp19_ = iterator;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp20_ = gee_iterator_next ((GeeIterator*) _tmp19_);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		if (!_tmp20_) {
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			break;
#line 1029 "CharacterAttributes.c"
		}
#line 121 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp21_ = iterator;
#line 121 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp22_ = gee_iterator_get ((GeeIterator*) _tmp21_);
#line 121 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		parameter = (gchar*) _tmp22_;
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp23_ = parameter;
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp24_ = atoi (_tmp23_);
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		attribute_code = _tmp24_;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp25_ = attribute_code;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		switch (_tmp25_) {
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 0:
#line 1049 "CharacterAttributes.c"
			{
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_reset (self);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1055 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 1:
#line 1059 "CharacterAttributes.c"
			{
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_bold (self, TRUE);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1065 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 4:
#line 1069 "CharacterAttributes.c"
			{
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_underlined (self, TRUE);
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1075 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 5:
#line 1079 "CharacterAttributes.c"
			{
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_blink (self, TRUE);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1085 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 7:
#line 1089 "CharacterAttributes.c"
			{
#line 140 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_inverse (self, TRUE);
#line 141 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1095 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 8:
#line 1099 "CharacterAttributes.c"
			{
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_invisible (self, TRUE);
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1105 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 22:
#line 1109 "CharacterAttributes.c"
			{
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_bold (self, FALSE);
#line 149 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1115 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 24:
#line 1119 "CharacterAttributes.c"
			{
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_underlined (self, FALSE);
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1125 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 25:
#line 1129 "CharacterAttributes.c"
			{
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_blink (self, FALSE);
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1135 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 27:
#line 1139 "CharacterAttributes.c"
			{
#line 157 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_inverse (self, FALSE);
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1145 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 28:
#line 1149 "CharacterAttributes.c"
			{
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_invisible (self, FALSE);
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1155 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 30:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 31:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 32:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 33:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 34:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 35:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 36:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 37:
#line 1173 "CharacterAttributes.c"
			{
				gint _tmp26_;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp26_ = attribute_code;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_foreground_color (self, _tmp26_ - 30);
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_foreground_color (self, FALSE);
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1184 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 39:
#line 1188 "CharacterAttributes.c"
			{
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_foreground_color (self, -1);
#line 177 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_foreground_color (self, FALSE);
#line 178 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1196 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 40:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 41:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 42:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 43:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 44:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 45:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 46:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 47:
#line 1214 "CharacterAttributes.c"
			{
				gint _tmp27_;
#line 189 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp27_ = attribute_code;
#line 189 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_background_color (self, _tmp27_ - 40);
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_background_color (self, FALSE);
#line 191 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1225 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 49:
#line 1229 "CharacterAttributes.c"
			{
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_background_color (self, -1);
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_background_color (self, FALSE);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1237 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 90:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 91:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 92:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 93:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 94:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 95:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 96:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 97:
#line 1255 "CharacterAttributes.c"
			{
				gint _tmp28_;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp28_ = attribute_code;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_foreground_color (self, (_tmp28_ - 90) + 8);
#line 207 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_foreground_color (self, FALSE);
#line 208 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1266 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 100:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 101:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 102:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 103:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 104:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 105:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 106:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 107:
#line 1284 "CharacterAttributes.c"
			{
				gint _tmp29_;
#line 219 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp29_ = attribute_code;
#line 219 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_background_color (self, (_tmp29_ - 100) + 8);
#line 220 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				character_attributes_set_use_rgb_background_color (self, FALSE);
#line 221 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1295 "CharacterAttributes.c"
			}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 38:
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			case 48:
#line 1301 "CharacterAttributes.c"
			{
				GeeListIterator* _tmp30_;
				gboolean _tmp31_ = FALSE;
#line 225 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp30_ = iterator;
#line 225 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp31_ = gee_iterator_next ((GeeIterator*) _tmp30_);
#line 225 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				if (_tmp31_) {
#line 1311 "CharacterAttributes.c"
					GeeListIterator* _tmp32_;
					gpointer _tmp33_ = NULL;
					gchar* _tmp34_;
					gint _tmp35_ = 0;
					gint _tmp36_;
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp32_ = iterator;
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp33_ = gee_iterator_get ((GeeIterator*) _tmp32_);
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp34_ = (gchar*) _tmp33_;
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp35_ = atoi (_tmp34_);
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp36_ = _tmp35_;
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_g_free0 (_tmp34_);
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					switch (_tmp36_) {
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
						case 5:
#line 1333 "CharacterAttributes.c"
						{
							GeeListIterator* _tmp37_;
							gboolean _tmp38_ = FALSE;
#line 230 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							_tmp37_ = iterator;
#line 230 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							_tmp38_ = gee_iterator_next ((GeeIterator*) _tmp37_);
#line 230 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							if (_tmp38_) {
#line 1343 "CharacterAttributes.c"
								GeeListIterator* _tmp39_;
								gpointer _tmp40_ = NULL;
								gchar* _tmp41_;
								gint _tmp42_ = 0;
								gint _tmp43_;
								gint color_code;
								gint _tmp44_;
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp39_ = iterator;
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp40_ = gee_iterator_get ((GeeIterator*) _tmp39_);
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp41_ = (gchar*) _tmp40_;
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp42_ = atoi (_tmp41_);
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp43_ = _tmp42_;
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_g_free0 (_tmp41_);
#line 231 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								color_code = _tmp43_;
#line 232 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp44_ = attribute_code;
#line 232 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								if (_tmp44_ == 38) {
#line 1369 "CharacterAttributes.c"
									gint _tmp45_;
#line 233 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp45_ = color_code;
#line 233 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									character_attributes_set_foreground_color (self, _tmp45_);
#line 234 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									character_attributes_set_use_rgb_foreground_color (self, FALSE);
#line 1377 "CharacterAttributes.c"
								} else {
									gint _tmp46_;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp46_ = attribute_code;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									if (_tmp46_ == 48) {
#line 1384 "CharacterAttributes.c"
										gint _tmp47_;
#line 236 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp47_ = color_code;
#line 236 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										character_attributes_set_background_color (self, _tmp47_);
#line 237 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										character_attributes_set_use_rgb_background_color (self, FALSE);
#line 1392 "CharacterAttributes.c"
									}
								}
							} else {
								TerminalStreamStreamElement* _tmp48_;
#line 240 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp48_ = stream_element;
#line 240 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								terminal_output_print_interpretation_status (_tmp48_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 1401 "CharacterAttributes.c"
							}
#line 243 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							break;
#line 1405 "CharacterAttributes.c"
						}
#line 226 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
						case 2:
#line 1409 "CharacterAttributes.c"
						{
							GeeListIterator* _tmp49_;
							gboolean _tmp50_ = FALSE;
#line 248 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							_tmp49_ = iterator;
#line 248 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							_tmp50_ = gee_iterator_next ((GeeIterator*) _tmp49_);
#line 248 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							if (_tmp50_) {
#line 1419 "CharacterAttributes.c"
								GeeListIterator* _tmp51_;
								gpointer _tmp52_ = NULL;
								gchar* _tmp53_;
								gint _tmp54_ = 0;
								gint _tmp55_;
								gint red;
								GeeListIterator* _tmp56_;
								gboolean _tmp57_ = FALSE;
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp51_ = iterator;
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp52_ = gee_iterator_get ((GeeIterator*) _tmp51_);
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp53_ = (gchar*) _tmp52_;
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp54_ = atoi (_tmp53_);
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp55_ = _tmp54_;
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_g_free0 (_tmp53_);
#line 249 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								red = _tmp55_;
#line 250 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp56_ = iterator;
#line 250 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp57_ = gee_iterator_next ((GeeIterator*) _tmp56_);
#line 250 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								if (_tmp57_) {
#line 1448 "CharacterAttributes.c"
									GeeListIterator* _tmp58_;
									gpointer _tmp59_ = NULL;
									gchar* _tmp60_;
									gint _tmp61_ = 0;
									gint _tmp62_;
									gint green;
									GeeListIterator* _tmp63_;
									gboolean _tmp64_ = FALSE;
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp58_ = iterator;
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp59_ = gee_iterator_get ((GeeIterator*) _tmp58_);
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp60_ = (gchar*) _tmp59_;
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp61_ = atoi (_tmp60_);
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp62_ = _tmp61_;
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_g_free0 (_tmp60_);
#line 251 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									green = _tmp62_;
#line 252 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp63_ = iterator;
#line 252 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp64_ = gee_iterator_next ((GeeIterator*) _tmp63_);
#line 252 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									if (_tmp64_) {
#line 1477 "CharacterAttributes.c"
										GeeListIterator* _tmp65_;
										gpointer _tmp66_ = NULL;
										gchar* _tmp67_;
										gint _tmp68_ = 0;
										gint _tmp69_;
										gint blue;
										gint _tmp70_;
										gint _tmp71_;
										gint _tmp72_;
										ClutterColor _tmp73_ = {0};
										ClutterColor color;
										gint _tmp74_;
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp65_ = iterator;
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp66_ = gee_iterator_get ((GeeIterator*) _tmp65_);
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp67_ = (gchar*) _tmp66_;
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp68_ = atoi (_tmp67_);
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp69_ = _tmp68_;
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_g_free0 (_tmp67_);
#line 253 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										blue = _tmp69_;
#line 254 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp70_ = red;
#line 254 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp71_ = green;
#line 254 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp72_ = blue;
#line 254 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										utilities_get_rgb_color (_tmp70_, _tmp71_, _tmp72_, &_tmp73_);
#line 254 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										color = _tmp73_;
#line 255 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp74_ = attribute_code;
#line 255 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										if (_tmp74_ == 38) {
#line 1518 "CharacterAttributes.c"
											ClutterColor _tmp75_;
#line 256 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
											_tmp75_ = color;
#line 256 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
											character_attributes_set_rgb_foreground_color (self, &_tmp75_);
#line 257 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
											character_attributes_set_use_rgb_foreground_color (self, TRUE);
#line 1526 "CharacterAttributes.c"
										} else {
											gint _tmp76_;
#line 258 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
											_tmp76_ = attribute_code;
#line 258 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
											if (_tmp76_ == 48) {
#line 1533 "CharacterAttributes.c"
												ClutterColor _tmp77_;
#line 259 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
												_tmp77_ = color;
#line 259 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
												character_attributes_set_rgb_background_color (self, &_tmp77_);
#line 260 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
												character_attributes_set_use_rgb_background_color (self, TRUE);
#line 1541 "CharacterAttributes.c"
											}
										}
									} else {
										TerminalStreamStreamElement* _tmp78_;
#line 263 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										_tmp78_ = stream_element;
#line 263 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
										terminal_output_print_interpretation_status (_tmp78_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 1550 "CharacterAttributes.c"
									}
								} else {
									TerminalStreamStreamElement* _tmp79_;
#line 267 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									_tmp79_ = stream_element;
#line 267 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
									terminal_output_print_interpretation_status (_tmp79_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 1558 "CharacterAttributes.c"
								}
							} else {
								TerminalStreamStreamElement* _tmp80_;
#line 271 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								_tmp80_ = stream_element;
#line 271 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
								terminal_output_print_interpretation_status (_tmp80_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 1566 "CharacterAttributes.c"
							}
#line 274 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							break;
#line 1570 "CharacterAttributes.c"
						}
						default:
						{
							TerminalStreamStreamElement* _tmp81_;
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							_tmp81_ = stream_element;
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							terminal_output_print_interpretation_status (_tmp81_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
							break;
#line 1581 "CharacterAttributes.c"
						}
					}
				} else {
					TerminalStreamStreamElement* _tmp82_;
#line 282 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					_tmp82_ = stream_element;
#line 282 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
					terminal_output_print_interpretation_status (_tmp82_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 1590 "CharacterAttributes.c"
				}
#line 285 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1594 "CharacterAttributes.c"
			}
			default:
			{
				TerminalStreamStreamElement* _tmp83_;
#line 288 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp83_ = stream_element;
#line 288 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				terminal_output_print_interpretation_status (_tmp83_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 290 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				break;
#line 1605 "CharacterAttributes.c"
			}
		}
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (parameter);
#line 1610 "CharacterAttributes.c"
	}
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_object_unref0 (iterator);
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return self;
#line 1616 "CharacterAttributes.c"
}


CharacterAttributes* character_attributes_new_from_stream_element (TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes) {
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return character_attributes_construct_from_stream_element (TYPE_CHARACTER_ATTRIBUTES, stream_element, current_attributes);
#line 1623 "CharacterAttributes.c"
}


TextAttributes* character_attributes_get_text_attributes (CharacterAttributes* self, ColorScheme* color_scheme, gboolean dark) {
	TextAttributes* result = NULL;
	TextAttributes* _tmp0_;
	TextAttributes* text_attributes;
	gboolean _tmp1_;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_;
	TextAttributes* _tmp38_;
	gboolean _tmp39_;
	TextAttributes* _tmp40_;
	gboolean _tmp41_;
	TextAttributes* _tmp42_;
	TextMenu* _tmp43_;
#line 296 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (color_scheme != NULL, NULL);
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = text_attributes_new ();
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	text_attributes = _tmp0_;
#line 299 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = self->priv->_invisible;
#line 299 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp1_) {
#line 1652 "CharacterAttributes.c"
		TextAttributes* _tmp2_;
		ClutterColor _tmp3_ = {0};
		TextAttributes* _tmp4_;
		ClutterColor _tmp5_ = {0};
#line 301 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp2_ = text_attributes;
#line 301 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		clutter_color_from_string (&_tmp3_, "#00000000");
#line 301 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_foreground_color (_tmp2_, &_tmp3_);
#line 302 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp4_ = text_attributes;
#line 302 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		clutter_color_from_string (&_tmp5_, "#00000000");
#line 302 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_background_color (_tmp4_, &_tmp5_);
#line 1669 "CharacterAttributes.c"
	} else {
		ClutterColor color1 = {0};
		gboolean _tmp6_;
		ClutterColor color2 = {0};
		gboolean _tmp16_;
		gboolean _tmp26_;
#line 308 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp6_ = self->priv->_use_rgb_foreground_color;
#line 308 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		if (_tmp6_) {
#line 1680 "CharacterAttributes.c"
			ClutterColor _tmp7_;
#line 309 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp7_ = self->priv->_rgb_foreground_color;
#line 309 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			color1 = _tmp7_;
#line 1686 "CharacterAttributes.c"
		} else {
			gint _tmp8_;
#line 311 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp8_ = self->priv->_foreground_color;
#line 311 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			if (_tmp8_ == (-1)) {
#line 1693 "CharacterAttributes.c"
				ColorScheme* _tmp9_;
				gboolean _tmp10_;
				ClutterColor _tmp11_ = {0};
#line 312 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp9_ = color_scheme;
#line 312 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp10_ = dark;
#line 312 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color_scheme_get_foreground_color (_tmp9_, _tmp10_, &_tmp11_);
#line 312 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color1 = _tmp11_;
#line 1705 "CharacterAttributes.c"
			} else {
				ColorScheme* _tmp12_;
				gint _tmp13_;
				gboolean _tmp14_;
				ClutterColor _tmp15_ = {0};
#line 314 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp12_ = color_scheme;
#line 314 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp13_ = self->priv->_foreground_color;
#line 314 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp14_ = dark;
#line 314 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color_scheme_get_indexed_color (_tmp12_, _tmp13_, _tmp14_, &_tmp15_);
#line 314 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color1 = _tmp15_;
#line 1721 "CharacterAttributes.c"
			}
		}
#line 319 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp16_ = self->priv->_use_rgb_background_color;
#line 319 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		if (_tmp16_) {
#line 1728 "CharacterAttributes.c"
			ClutterColor _tmp17_;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp17_ = self->priv->_rgb_background_color;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			color2 = _tmp17_;
#line 1734 "CharacterAttributes.c"
		} else {
			gint _tmp18_;
#line 322 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp18_ = self->priv->_background_color;
#line 322 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			if (_tmp18_ == (-1)) {
#line 1741 "CharacterAttributes.c"
				ColorScheme* _tmp19_;
				gboolean _tmp20_;
				ClutterColor _tmp21_ = {0};
#line 323 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp19_ = color_scheme;
#line 323 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp20_ = dark;
#line 323 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color_scheme_get_background_color (_tmp19_, _tmp20_, &_tmp21_);
#line 323 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color2 = _tmp21_;
#line 1753 "CharacterAttributes.c"
			} else {
				ColorScheme* _tmp22_;
				gint _tmp23_;
				gboolean _tmp24_;
				ClutterColor _tmp25_ = {0};
#line 325 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp22_ = color_scheme;
#line 325 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp23_ = self->priv->_background_color;
#line 325 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				_tmp24_ = dark;
#line 325 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color_scheme_get_indexed_color (_tmp22_, _tmp23_, _tmp24_, &_tmp25_);
#line 325 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
				color2 = _tmp25_;
#line 1769 "CharacterAttributes.c"
			}
		}
#line 329 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp26_ = self->priv->_inverse;
#line 329 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		if (_tmp26_) {
#line 1776 "CharacterAttributes.c"
			TextAttributes* _tmp27_;
			ClutterColor _tmp28_;
			TextAttributes* _tmp29_;
			ClutterColor _tmp30_;
#line 330 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp27_ = text_attributes;
#line 330 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp28_ = color2;
#line 330 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_set_foreground_color (_tmp27_, &_tmp28_);
#line 331 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp29_ = text_attributes;
#line 331 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp30_ = color1;
#line 331 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_set_background_color (_tmp29_, &_tmp30_);
#line 1793 "CharacterAttributes.c"
		} else {
			TextAttributes* _tmp31_;
			ClutterColor _tmp32_;
			TextAttributes* _tmp33_;
			ClutterColor _tmp34_;
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp31_ = text_attributes;
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp32_ = color1;
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_set_foreground_color (_tmp31_, &_tmp32_);
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp33_ = text_attributes;
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp34_ = color2;
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_set_background_color (_tmp33_, &_tmp34_);
#line 1811 "CharacterAttributes.c"
		}
	}
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp36_ = self->priv->_bold;
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp36_) {
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp35_ = TRUE;
#line 1820 "CharacterAttributes.c"
	} else {
		gboolean _tmp37_;
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp37_ = self->priv->_blink;
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp35_ = _tmp37_;
#line 1827 "CharacterAttributes.c"
	}
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp38_ = text_attributes;
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp39_ = _tmp35_;
#line 339 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	text_attributes_set_bold (_tmp38_, _tmp39_);
#line 341 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp40_ = text_attributes;
#line 341 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp41_ = self->priv->_underlined;
#line 341 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	text_attributes_set_underlined (_tmp40_, _tmp41_);
#line 343 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp42_ = text_attributes;
#line 343 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp43_ = self->priv->_text_menu;
#line 343 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	text_attributes_set_text_menu (_tmp42_, _tmp43_);
#line 345 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = text_attributes;
#line 345 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 1851 "CharacterAttributes.c"
}


gint character_attributes_get_foreground_color (CharacterAttributes* self) {
	gint result;
	gint _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_foreground_color;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 1866 "CharacterAttributes.c"
}


void character_attributes_set_foreground_color (CharacterAttributes* self, gint value) {
	gint _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_foreground_color = _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "foreground-color");
#line 1880 "CharacterAttributes.c"
}


gint character_attributes_get_background_color (CharacterAttributes* self) {
	gint result;
	gint _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_background_color;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 1895 "CharacterAttributes.c"
}


void character_attributes_set_background_color (CharacterAttributes* self, gint value) {
	gint _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_background_color = _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "background-color");
#line 1909 "CharacterAttributes.c"
}


void character_attributes_get_rgb_foreground_color (CharacterAttributes* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_rgb_foreground_color;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	*result = _tmp0_;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return;
#line 1923 "CharacterAttributes.c"
}


void character_attributes_set_rgb_foreground_color (CharacterAttributes* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = *value;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_rgb_foreground_color = _tmp0_;
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "rgb-foreground-color");
#line 1937 "CharacterAttributes.c"
}


void character_attributes_get_rgb_background_color (CharacterAttributes* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_rgb_background_color;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	*result = _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return;
#line 1951 "CharacterAttributes.c"
}


void character_attributes_set_rgb_background_color (CharacterAttributes* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = *value;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_rgb_background_color = _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "rgb-background-color");
#line 1965 "CharacterAttributes.c"
}


gboolean character_attributes_get_use_rgb_foreground_color (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_use_rgb_foreground_color;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 1980 "CharacterAttributes.c"
}


void character_attributes_set_use_rgb_foreground_color (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_use_rgb_foreground_color = _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "use-rgb-foreground-color");
#line 1994 "CharacterAttributes.c"
}


gboolean character_attributes_get_use_rgb_background_color (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_use_rgb_background_color;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2009 "CharacterAttributes.c"
}


void character_attributes_set_use_rgb_background_color (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_use_rgb_background_color = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "use-rgb-background-color");
#line 2023 "CharacterAttributes.c"
}


gboolean character_attributes_get_bold (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_bold;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2038 "CharacterAttributes.c"
}


void character_attributes_set_bold (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_bold = _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "bold");
#line 2052 "CharacterAttributes.c"
}


gboolean character_attributes_get_underlined (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_underlined;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2067 "CharacterAttributes.c"
}


void character_attributes_set_underlined (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_underlined = _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "underlined");
#line 2081 "CharacterAttributes.c"
}


gboolean character_attributes_get_blink (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_blink;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2096 "CharacterAttributes.c"
}


void character_attributes_set_blink (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_blink = _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "blink");
#line 2110 "CharacterAttributes.c"
}


gboolean character_attributes_get_inverse (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_inverse;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2125 "CharacterAttributes.c"
}


void character_attributes_set_inverse (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_inverse = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "inverse");
#line 2139 "CharacterAttributes.c"
}


gboolean character_attributes_get_invisible (CharacterAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_invisible;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2154 "CharacterAttributes.c"
}


void character_attributes_set_invisible (CharacterAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_invisible = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "invisible");
#line 2168 "CharacterAttributes.c"
}


TextMenu* character_attributes_get_text_menu (CharacterAttributes* self) {
	TextMenu* result;
	TextMenu* _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_text_menu;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2183 "CharacterAttributes.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return self ? g_object_ref (self) : NULL;
#line 2190 "CharacterAttributes.c"
}


void character_attributes_set_text_menu (CharacterAttributes* self, TextMenu* value) {
	TextMenu* _tmp0_;
	TextMenu* _tmp1_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_object_unref0 (self->priv->_text_menu);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_text_menu = _tmp1_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "text-menu");
#line 2209 "CharacterAttributes.c"
}


static void character_attributes_class_init (CharacterAttributesClass * klass) {
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	character_attributes_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_type_class_add_private (klass, sizeof (CharacterAttributesPrivate));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_character_attributes_get_property;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_character_attributes_set_property;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->finalize = character_attributes_finalize;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_FOREGROUND_COLOR, g_param_spec_int ("foreground-color", "foreground-color", "foreground-color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_BACKGROUND_COLOR, g_param_spec_int ("background-color", "background-color", "background-color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_RGB_FOREGROUND_COLOR, g_param_spec_boxed ("rgb-foreground-color", "rgb-foreground-color", "rgb-foreground-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_RGB_BACKGROUND_COLOR, g_param_spec_boxed ("rgb-background-color", "rgb-background-color", "rgb-background-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_USE_RGB_FOREGROUND_COLOR, g_param_spec_boolean ("use-rgb-foreground-color", "use-rgb-foreground-color", "use-rgb-foreground-color", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_USE_RGB_BACKGROUND_COLOR, g_param_spec_boolean ("use-rgb-background-color", "use-rgb-background-color", "use-rgb-background-color", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_BOLD, g_param_spec_boolean ("bold", "bold", "bold", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_UNDERLINED, g_param_spec_boolean ("underlined", "underlined", "underlined", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_BLINK, g_param_spec_boolean ("blink", "blink", "blink", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_INVERSE, g_param_spec_boolean ("inverse", "inverse", "inverse", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_INVISIBLE, g_param_spec_boolean ("invisible", "invisible", "invisible", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHARACTER_ATTRIBUTES_TEXT_MENU, g_param_spec_object ("text-menu", "text-menu", "text-menu", TYPE_TEXT_MENU, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2248 "CharacterAttributes.c"
}


static void character_attributes_instance_init (CharacterAttributes * self) {
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv = CHARACTER_ATTRIBUTES_GET_PRIVATE (self);
#line 2255 "CharacterAttributes.c"
}


static void character_attributes_finalize (GObject* obj) {
	CharacterAttributes * self;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHARACTER_ATTRIBUTES, CharacterAttributes);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_object_unref0 (self->priv->_text_menu);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (character_attributes_parent_class)->finalize (obj);
#line 2267 "CharacterAttributes.c"
}


GType character_attributes_get_type (void) {
	static volatile gsize character_attributes_type_id__volatile = 0;
	if (g_once_init_enter (&character_attributes_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CharacterAttributesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) character_attributes_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CharacterAttributes), 0, (GInstanceInitFunc) character_attributes_instance_init, NULL };
		GType character_attributes_type_id;
		character_attributes_type_id = g_type_register_static (G_TYPE_OBJECT, "CharacterAttributes", &g_define_type_info, 0);
		g_once_init_leave (&character_attributes_type_id__volatile, character_attributes_type_id);
	}
	return character_attributes_type_id__volatile;
}


static void _vala_character_attributes_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	CharacterAttributes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHARACTER_ATTRIBUTES, CharacterAttributes);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_FOREGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_int (value, character_attributes_get_foreground_color (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BACKGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_int (value, character_attributes_get_background_color (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_RGB_FOREGROUND_COLOR:
#line 2302 "CharacterAttributes.c"
		{
			ClutterColor boxed;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			character_attributes_get_rgb_foreground_color (self, &boxed);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			g_value_set_boxed (value, &boxed);
#line 2309 "CharacterAttributes.c"
		}
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_RGB_BACKGROUND_COLOR:
#line 2315 "CharacterAttributes.c"
		{
			ClutterColor boxed;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			character_attributes_get_rgb_background_color (self, &boxed);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			g_value_set_boxed (value, &boxed);
#line 2322 "CharacterAttributes.c"
		}
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_USE_RGB_FOREGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_use_rgb_foreground_color (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_USE_RGB_BACKGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_use_rgb_background_color (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BOLD:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_bold (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_UNDERLINED:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_underlined (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BLINK:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_blink (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_INVERSE:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_inverse (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_INVISIBLE:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, character_attributes_get_invisible (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_TEXT_MENU:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_object (value, character_attributes_get_text_menu (self));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2374 "CharacterAttributes.c"
		default:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2380 "CharacterAttributes.c"
	}
}


static void _vala_character_attributes_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	CharacterAttributes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHARACTER_ATTRIBUTES, CharacterAttributes);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_FOREGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_foreground_color (self, g_value_get_int (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BACKGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_background_color (self, g_value_get_int (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_RGB_FOREGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_rgb_foreground_color (self, g_value_get_boxed (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_RGB_BACKGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_rgb_background_color (self, g_value_get_boxed (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_USE_RGB_FOREGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_use_rgb_foreground_color (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_USE_RGB_BACKGROUND_COLOR:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_use_rgb_background_color (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BOLD:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_bold (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_UNDERLINED:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_underlined (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_BLINK:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_blink (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_INVERSE:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_inverse (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_INVISIBLE:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_invisible (self, g_value_get_boolean (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case CHARACTER_ATTRIBUTES_TEXT_MENU:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		character_attributes_set_text_menu (self, g_value_get_object (value));
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2462 "CharacterAttributes.c"
		default:
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2468 "CharacterAttributes.c"
	}
}


gchar* text_attributes_get_markup_attributes (TextAttributes* self, ColorScheme* color_scheme, gboolean dark) {
	gchar* result = NULL;
	GString* _tmp0_;
	GString* attribute_builder;
	ClutterColor _tmp1_;
	ColorScheme* _tmp2_;
	gboolean _tmp3_;
	ClutterColor _tmp4_ = {0};
	ClutterColor _tmp13_;
	ColorScheme* _tmp14_;
	gboolean _tmp15_;
	ClutterColor _tmp16_ = {0};
	gboolean _tmp25_;
	TextMenu* _tmp27_;
	GString* _tmp44_;
	const gchar* _tmp45_;
	gchar* _tmp46_;
#line 360 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (color_scheme != NULL, NULL);
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = g_string_new ("");
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	attribute_builder = _tmp0_;
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = self->priv->_foreground_color;
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp2_ = color_scheme;
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp3_ = dark;
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	color_scheme_get_foreground_color (_tmp2_, _tmp3_, &_tmp4_);
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_clutter_color_equal (&_tmp1_, &_tmp4_) != TRUE) {
#line 2508 "CharacterAttributes.c"
		GString* _tmp5_;
		ClutterColor _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp5_ = attribute_builder;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp6_ = self->priv->_foreground_color;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp7_ = utilities_get_parsable_color_string (&_tmp6_);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp8_ = _tmp7_;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp9_ = g_strconcat (" foreground='", _tmp8_, NULL);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp10_ = _tmp9_;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp11_ = g_strconcat (_tmp10_, "'", NULL);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp12_ = _tmp11_;
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_string_append (_tmp5_, _tmp12_);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp12_);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp10_);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp8_);
#line 2541 "CharacterAttributes.c"
	}
#line 366 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp13_ = self->priv->_background_color;
#line 366 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp14_ = color_scheme;
#line 366 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp15_ = dark;
#line 366 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	color_scheme_get_background_color (_tmp14_, _tmp15_, &_tmp16_);
#line 366 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_clutter_color_equal (&_tmp13_, &_tmp16_) != TRUE) {
#line 2553 "CharacterAttributes.c"
		GString* _tmp17_;
		ClutterColor _tmp18_;
		gchar* _tmp19_ = NULL;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp17_ = attribute_builder;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp18_ = self->priv->_background_color;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp19_ = utilities_get_parsable_color_string (&_tmp18_);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp20_ = _tmp19_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp21_ = g_strconcat (" background='", _tmp20_, NULL);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp22_ = _tmp21_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp23_ = g_strconcat (_tmp22_, "'", NULL);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp24_ = _tmp23_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_string_append (_tmp17_, _tmp24_);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp24_);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp22_);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp20_);
#line 2586 "CharacterAttributes.c"
	}
#line 369 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp25_ = self->priv->_bold;
#line 369 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp25_) {
#line 2592 "CharacterAttributes.c"
		GString* _tmp26_;
#line 370 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp26_ = attribute_builder;
#line 370 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_string_append (_tmp26_, " font_weight='bold'");
#line 2598 "CharacterAttributes.c"
	}
#line 372 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp27_ = self->priv->_text_menu;
#line 372 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	if (_tmp27_ != NULL) {
#line 2604 "CharacterAttributes.c"
		GString* _tmp28_;
		ColorScheme* _tmp29_;
		TextMenu* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		gboolean _tmp33_;
		ClutterColor _tmp34_ = {0};
		gchar* _tmp35_ = NULL;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		GString* _tmp41_;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp28_ = attribute_builder;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp29_ = color_scheme;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp30_ = self->priv->_text_menu;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp31_ = text_menu_get_color (_tmp30_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp32_ = _tmp31_;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp33_ = dark;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		color_scheme_get_indexed_color (_tmp29_, _tmp32_, _tmp33_, &_tmp34_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp35_ = utilities_get_parsable_color_string (&_tmp34_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp36_ = _tmp35_;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp37_ = g_strconcat (" foreground='", _tmp36_, NULL);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp38_ = _tmp37_;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp39_ = g_strconcat (_tmp38_, "'", NULL);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp40_ = _tmp39_;
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_string_append (_tmp28_, _tmp40_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp40_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp38_);
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_g_free0 (_tmp36_);
#line 375 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp41_ = attribute_builder;
#line 375 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_string_append (_tmp41_, " underline='single'");
#line 2657 "CharacterAttributes.c"
	} else {
		gboolean _tmp42_;
#line 379 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		_tmp42_ = self->priv->_underlined;
#line 379 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		if (_tmp42_) {
#line 2664 "CharacterAttributes.c"
			GString* _tmp43_;
#line 380 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			_tmp43_ = attribute_builder;
#line 380 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			g_string_append (_tmp43_, " underline='single'");
#line 2670 "CharacterAttributes.c"
		}
	}
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp44_ = attribute_builder;
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp45_ = _tmp44_->str;
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp46_ = g_strdup (_tmp45_);
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp46_;
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_string_free0 (attribute_builder);
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2685 "CharacterAttributes.c"
}


TextAttributes* text_attributes_construct (GType object_type) {
	TextAttributes * self = NULL;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = (TextAttributes*) g_object_new (object_type, NULL);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return self;
#line 2695 "CharacterAttributes.c"
}


TextAttributes* text_attributes_new (void) {
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return text_attributes_construct (TYPE_TEXT_ATTRIBUTES);
#line 2702 "CharacterAttributes.c"
}


void text_attributes_get_foreground_color (TextAttributes* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_foreground_color;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	*result = _tmp0_;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return;
#line 2716 "CharacterAttributes.c"
}


void text_attributes_set_foreground_color (TextAttributes* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = *value;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_foreground_color = _tmp0_;
#line 353 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "foreground-color");
#line 2730 "CharacterAttributes.c"
}


void text_attributes_get_background_color (TextAttributes* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_background_color;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	*result = _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return;
#line 2744 "CharacterAttributes.c"
}


void text_attributes_set_background_color (TextAttributes* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = *value;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_background_color = _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "background-color");
#line 2758 "CharacterAttributes.c"
}


gboolean text_attributes_get_bold (TextAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_bold;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2773 "CharacterAttributes.c"
}


void text_attributes_set_bold (TextAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_bold = _tmp0_;
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "bold");
#line 2787 "CharacterAttributes.c"
}


gboolean text_attributes_get_underlined (TextAttributes* self) {
	gboolean result;
	gboolean _tmp0_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_underlined;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2802 "CharacterAttributes.c"
}


void text_attributes_set_underlined (TextAttributes* self, gboolean value) {
	gboolean _tmp0_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_underlined = _tmp0_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "underlined");
#line 2816 "CharacterAttributes.c"
}


TextMenu* text_attributes_get_text_menu (TextAttributes* self) {
	TextMenu* result;
	TextMenu* _tmp0_;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = self->priv->_text_menu;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	result = _tmp0_;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	return result;
#line 2831 "CharacterAttributes.c"
}


void text_attributes_set_text_menu (TextAttributes* self, TextMenu* value) {
	TextMenu* _tmp0_;
	TextMenu* _tmp1_;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_return_if_fail (self != NULL);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp0_ = value;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_object_unref0 (self->priv->_text_menu);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv->_text_menu = _tmp1_;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_notify ((GObject *) self, "text-menu");
#line 2850 "CharacterAttributes.c"
}


static void text_attributes_class_init (TextAttributesClass * klass) {
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	text_attributes_parent_class = g_type_class_peek_parent (klass);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_type_class_add_private (klass, sizeof (TextAttributesPrivate));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_text_attributes_get_property;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_text_attributes_set_property;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (klass)->finalize = text_attributes_finalize;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_ATTRIBUTES_FOREGROUND_COLOR, g_param_spec_boxed ("foreground-color", "foreground-color", "foreground-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_ATTRIBUTES_BACKGROUND_COLOR, g_param_spec_boxed ("background-color", "background-color", "background-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_ATTRIBUTES_BOLD, g_param_spec_boolean ("bold", "bold", "bold", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_ATTRIBUTES_UNDERLINED, g_param_spec_boolean ("underlined", "underlined", "underlined", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_ATTRIBUTES_TEXT_MENU, g_param_spec_object ("text-menu", "text-menu", "text-menu", TYPE_TEXT_MENU, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2875 "CharacterAttributes.c"
}


static void text_attributes_instance_init (TextAttributes * self) {
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self->priv = TEXT_ATTRIBUTES_GET_PRIVATE (self);
#line 2882 "CharacterAttributes.c"
}


static void text_attributes_finalize (GObject* obj) {
	TextAttributes * self;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_ATTRIBUTES, TextAttributes);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	_g_object_unref0 (self->priv->_text_menu);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	G_OBJECT_CLASS (text_attributes_parent_class)->finalize (obj);
#line 2894 "CharacterAttributes.c"
}


GType text_attributes_get_type (void) {
	static volatile gsize text_attributes_type_id__volatile = 0;
	if (g_once_init_enter (&text_attributes_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TextAttributesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_attributes_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextAttributes), 0, (GInstanceInitFunc) text_attributes_instance_init, NULL };
		GType text_attributes_type_id;
		text_attributes_type_id = g_type_register_static (G_TYPE_OBJECT, "TextAttributes", &g_define_type_info, 0);
		g_once_init_leave (&text_attributes_type_id__volatile, text_attributes_type_id);
	}
	return text_attributes_type_id__volatile;
}


static void _vala_text_attributes_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TextAttributes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TEXT_ATTRIBUTES, TextAttributes);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	switch (property_id) {
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_FOREGROUND_COLOR:
#line 2917 "CharacterAttributes.c"
		{
			ClutterColor boxed;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_get_foreground_color (self, &boxed);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			g_value_set_boxed (value, &boxed);
#line 2924 "CharacterAttributes.c"
		}
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_BACKGROUND_COLOR:
#line 2930 "CharacterAttributes.c"
		{
			ClutterColor boxed;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			text_attributes_get_background_color (self, &boxed);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
			g_value_set_boxed (value, &boxed);
#line 2937 "CharacterAttributes.c"
		}
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_BOLD:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, text_attributes_get_bold (self));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_UNDERLINED:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_boolean (value, text_attributes_get_underlined (self));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_TEXT_MENU:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		g_value_set_object (value, text_attributes_get_text_menu (self));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2959 "CharacterAttributes.c"
		default:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 2965 "CharacterAttributes.c"
	}
}


static void _vala_text_attributes_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TextAttributes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TEXT_ATTRIBUTES, TextAttributes);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
	switch (property_id) {
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_FOREGROUND_COLOR:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_foreground_color (self, g_value_get_boxed (value));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_BACKGROUND_COLOR:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_background_color (self, g_value_get_boxed (value));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_BOLD:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_bold (self, g_value_get_boolean (value));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_UNDERLINED:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_underlined (self, g_value_get_boolean (value));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		case TEXT_ATTRIBUTES_TEXT_MENU:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		text_attributes_set_text_menu (self, g_value_get_object (value));
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 3005 "CharacterAttributes.c"
		default:
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 351 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/CharacterAttributes.vala"
		break;
#line 3011 "CharacterAttributes.c"
	}
}



