/* ColorScheme.c generated by valac 0.20.1, the Vala compiler
 * generated from ColorScheme.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define TYPE_COLOR_SCHEME (color_scheme_get_type ())
#define COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_SCHEME, ColorScheme))
#define COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_SCHEME, ColorSchemeClass))
#define IS_COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_SCHEME))
#define IS_COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_SCHEME))
#define COLOR_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_SCHEME, ColorSchemeClass))

typedef struct _ColorScheme ColorScheme;
typedef struct _ColorSchemeClass ColorSchemeClass;
typedef struct _ColorSchemePrivate ColorSchemePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))

struct _ColorScheme {
	GObject parent_instance;
	ColorSchemePrivate * priv;
};

struct _ColorSchemeClass {
	GObjectClass parent_class;
};

struct _ColorSchemePrivate {
	gchar* _name;
	gchar* _author;
	ClutterColor dark_cursor_color;
	ClutterColor light_cursor_color;
	ClutterColor dark_foreground_color;
	ClutterColor light_foreground_color;
	ClutterColor dark_background_color;
	ClutterColor light_background_color;
	GeeMap* dark_indexed_colors;
	GeeMap* light_indexed_colors;
};


static gpointer color_scheme_parent_class = NULL;

GType color_scheme_get_type (void) G_GNUC_CONST;
#define COLOR_SCHEME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COLOR_SCHEME, ColorSchemePrivate))
enum  {
	COLOR_SCHEME_DUMMY_PROPERTY,
	COLOR_SCHEME_NAME,
	COLOR_SCHEME_AUTHOR
};
ColorScheme* color_scheme_new_load_from_file (const gchar* filename);
ColorScheme* color_scheme_construct_load_from_file (GType object_type, const gchar* filename);
static ClutterColor* _clutter_color_dup (ClutterColor* self);
void utilities_get_rgb_color (gint red, gint green, gint blue, ClutterColor* result);
void color_scheme_set_name (ColorScheme* self, const gchar* value);
void color_scheme_set_author (ColorScheme* self, const gchar* value);
void color_scheme_get_cursor_color (ColorScheme* self, gboolean dark, ClutterColor* result);
void color_scheme_get_foreground_color (ColorScheme* self, gboolean dark, ClutterColor* result);
void color_scheme_get_background_color (ColorScheme* self, gboolean dark, ClutterColor* result);
void color_scheme_get_indexed_color (ColorScheme* self, gint index, gboolean dark, ClutterColor* result);
ColorScheme* color_scheme_new (void);
ColorScheme* color_scheme_construct (GType object_type);
const gchar* color_scheme_get_name (ColorScheme* self);
const gchar* color_scheme_get_author (ColorScheme* self);
static void color_scheme_finalize (GObject* obj);
static void _vala_color_scheme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_color_scheme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


static ClutterColor* _clutter_color_dup (ClutterColor* self) {
	ClutterColor* dup;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	dup = g_new0 (ClutterColor, 1);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	memcpy (dup, self, sizeof (ClutterColor));
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return dup;
#line 112 "ColorScheme.c"
}


ColorScheme* color_scheme_construct_load_from_file (GType object_type, const gchar* filename) {
	ColorScheme * self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GKeyFile* _tmp42_;
	GKeyFile* colors_file;
	GError * _inner_error_ = NULL;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self = (ColorScheme*) g_object_new (object_type, NULL);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->dark_cursor_color, "#ffffff");
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->light_cursor_color, "#000000");
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->dark_foreground_color, "#ffffff");
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->light_foreground_color, "#000000");
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->dark_background_color, "#000000");
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	clutter_color_from_string (&self->priv->light_background_color, "#ffffff");
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, CLUTTER_TYPE_COLOR, (GBoxedCopyFunc) _clutter_color_dup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_object_unref0 (self->priv->dark_indexed_colors);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self->priv->dark_indexed_colors = (GeeMap*) _tmp0_;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, CLUTTER_TYPE_COLOR, (GBoxedCopyFunc) _clutter_color_dup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_object_unref0 (self->priv->light_indexed_colors);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self->priv->light_indexed_colors = (GeeMap*) _tmp1_;
#line 151 "ColorScheme.c"
	{
		gint red;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		red = 0;
#line 156 "ColorScheme.c"
		{
			gboolean _tmp2_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp2_ = TRUE;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			while (TRUE) {
#line 163 "ColorScheme.c"
				gboolean _tmp3_;
				gint _tmp5_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp3_ = _tmp2_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				if (!_tmp3_) {
#line 170 "ColorScheme.c"
					gint _tmp4_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp4_ = red;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					red = _tmp4_ + 1;
#line 176 "ColorScheme.c"
				}
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp2_ = FALSE;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp5_ = red;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				if (!(_tmp5_ < 6)) {
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					break;
#line 186 "ColorScheme.c"
				}
				{
					gint green;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					green = 0;
#line 192 "ColorScheme.c"
					{
						gboolean _tmp6_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						_tmp6_ = TRUE;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						while (TRUE) {
#line 199 "ColorScheme.c"
							gboolean _tmp7_;
							gint _tmp9_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
							_tmp7_ = _tmp6_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
							if (!_tmp7_) {
#line 206 "ColorScheme.c"
								gint _tmp8_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp8_ = green;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								green = _tmp8_ + 1;
#line 212 "ColorScheme.c"
							}
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
							_tmp6_ = FALSE;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
							_tmp9_ = green;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
							if (!(_tmp9_ < 6)) {
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 222 "ColorScheme.c"
							}
							{
								gint blue;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								blue = 0;
#line 228 "ColorScheme.c"
								{
									gboolean _tmp10_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
									_tmp10_ = TRUE;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
									while (TRUE) {
#line 235 "ColorScheme.c"
										gboolean _tmp11_;
										gint _tmp13_;
										gint _tmp14_;
										gint _tmp15_;
										gint _tmp16_;
										gint index;
										gint _tmp17_;
										gint _tmp18_;
										gint _tmp19_;
										ClutterColor _tmp20_ = {0};
										ClutterColor color;
										GeeMap* _tmp21_;
										gint _tmp22_;
										ClutterColor _tmp23_;
										GeeMap* _tmp24_;
										gint _tmp25_;
										ClutterColor _tmp26_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp11_ = _tmp10_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										if (!_tmp11_) {
#line 257 "ColorScheme.c"
											gint _tmp12_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
											_tmp12_ = blue;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
											blue = _tmp12_ + 1;
#line 263 "ColorScheme.c"
										}
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp10_ = FALSE;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp13_ = blue;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										if (!(_tmp13_ < 6)) {
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
											break;
#line 273 "ColorScheme.c"
										}
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp14_ = red;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp15_ = green;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp16_ = blue;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										index = ((16 + (_tmp14_ * 36)) + (_tmp15_ * 6)) + _tmp16_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp17_ = red;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp18_ = green;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp19_ = blue;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										utilities_get_rgb_color (_tmp17_ * 51, _tmp18_ * 51, _tmp19_ * 51, &_tmp20_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										color = _tmp20_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp21_ = self->priv->dark_indexed_colors;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp22_ = index;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp23_ = color;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										gee_map_set (_tmp21_, (gpointer) ((gintptr) _tmp22_), &_tmp23_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp24_ = self->priv->light_indexed_colors;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp25_ = index;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										_tmp26_ = color;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
										gee_map_set (_tmp24_, (gpointer) ((gintptr) _tmp25_), &_tmp26_);
#line 309 "ColorScheme.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint gray;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		gray = 0;
#line 323 "ColorScheme.c"
		{
			gboolean _tmp27_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp27_ = TRUE;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			while (TRUE) {
#line 330 "ColorScheme.c"
				gboolean _tmp28_;
				gint _tmp30_;
				gint _tmp31_;
				gint index;
				gint _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				ClutterColor _tmp35_ = {0};
				ClutterColor color;
				GeeMap* _tmp36_;
				gint _tmp37_;
				ClutterColor _tmp38_;
				GeeMap* _tmp39_;
				gint _tmp40_;
				ClutterColor _tmp41_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp28_ = _tmp27_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				if (!_tmp28_) {
#line 350 "ColorScheme.c"
					gint _tmp29_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp29_ = gray;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					gray = _tmp29_ + 1;
#line 356 "ColorScheme.c"
				}
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp27_ = FALSE;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp30_ = gray;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				if (!(_tmp30_ < 24)) {
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					break;
#line 366 "ColorScheme.c"
				}
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp31_ = gray;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				index = 232 + _tmp31_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp32_ = gray;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp33_ = gray;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp34_ = gray;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				utilities_get_rgb_color (8 + (_tmp32_ * 10), 8 + (_tmp33_ * 10), 8 + (_tmp34_ * 10), &_tmp35_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				color = _tmp35_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp36_ = self->priv->dark_indexed_colors;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp37_ = index;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp38_ = color;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				gee_map_set (_tmp36_, (gpointer) ((gintptr) _tmp37_), &_tmp38_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp39_ = self->priv->light_indexed_colors;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp40_ = index;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp41_ = color;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				gee_map_set (_tmp39_, (gpointer) ((gintptr) _tmp40_), &_tmp41_);
#line 398 "ColorScheme.c"
			}
		}
	}
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp42_ = g_key_file_new ();
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	colors_file = _tmp42_;
#line 406 "ColorScheme.c"
	{
		GKeyFile* _tmp43_;
		const gchar* _tmp44_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp43_ = colors_file;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp44_ = filename;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_key_file_load_from_file (_tmp43_, _tmp44_, G_KEY_FILE_NONE, &_inner_error_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_inner_error_ != NULL) {
#line 418 "ColorScheme.c"
			goto __catch18_g_error;
		}
	}
	goto __finally18;
	__catch18_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp45_ = NULL;
		const gchar* _tmp46_;
		const gchar* _tmp47_;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		e = _inner_error_;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_inner_error_ = NULL;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp45_ = _ ("Failed to load color scheme %s: %s");
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp46_ = filename;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp47_ = e->message;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_error (_tmp45_, _tmp46_, _tmp47_);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_error_free0 (e);
#line 443 "ColorScheme.c"
	}
	__finally18:
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_inner_error_ != NULL) {
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_key_file_free0 (colors_file);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_clear_error (&_inner_error_);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		return NULL;
#line 456 "ColorScheme.c"
	}
	{
		GKeyFile* _tmp48_;
		gchar* _tmp49_ = NULL;
		gchar* _tmp50_;
		gchar* _tmp51_;
		GKeyFile* _tmp52_;
		gchar* _tmp53_ = NULL;
		gchar* _tmp54_;
		gchar* _tmp55_;
		GKeyFile* _tmp56_;
		gsize _tmp57_;
		gchar** _tmp58_ = NULL;
		gchar** _tmp59_;
		gint _tmp59__length1;
		gint __tmp59__size_;
		GKeyFile* _tmp77_;
		gsize _tmp78_;
		gchar** _tmp79_ = NULL;
		gchar** _tmp80_;
		gint _tmp80__length1;
		gint __tmp80__size_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp48_ = colors_file;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp49_ = g_key_file_get_string (_tmp48_, "About", "name", &_inner_error_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp50_ = _tmp49_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_inner_error_ != NULL) {
#line 487 "ColorScheme.c"
			goto __catch19_g_error;
		}
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp51_ = _tmp50_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		color_scheme_set_name (self, _tmp51_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_free0 (_tmp51_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp52_ = colors_file;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp53_ = g_key_file_get_string (_tmp52_, "About", "author", &_inner_error_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp54_ = _tmp53_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_inner_error_ != NULL) {
#line 504 "ColorScheme.c"
			goto __catch19_g_error;
		}
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp55_ = _tmp54_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		color_scheme_set_author (self, _tmp55_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_free0 (_tmp55_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp56_ = colors_file;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp58_ = g_key_file_get_keys (_tmp56_, "Dark", &_tmp57_, &_inner_error_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp59_ = _tmp58_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp59__length1 = _tmp57_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		__tmp59__size_ = _tmp59__length1;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_inner_error_ != NULL) {
#line 525 "ColorScheme.c"
			goto __catch19_g_error;
		}
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection = _tmp59_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection_length1 = _tmp59__length1;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			for (key_it = 0; key_it < _tmp59__length1; key_it = key_it + 1) {
#line 539 "ColorScheme.c"
				gchar* _tmp60_;
				gchar* key = NULL;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp60_ = g_strdup (key_collection[key_it]);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				key = _tmp60_;
#line 546 "ColorScheme.c"
				{
					GKeyFile* _tmp61_;
					const gchar* _tmp62_;
					gchar* _tmp63_ = NULL;
					gchar* _tmp64_;
					gchar* _tmp65_;
					ClutterColor color = {0};
					const gchar* _tmp66_;
					const gchar* _tmp67_;
					GQuark _tmp69_ = 0U;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp68_label0 = 0;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp68_label1 = 0;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp68_label2 = 0;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp61_ = colors_file;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp62_ = key;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp63_ = g_key_file_get_string (_tmp61_, "Dark", _tmp62_, &_inner_error_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp64_ = _tmp63_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					if (_inner_error_ != NULL) {
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						_g_free0 (key);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 577 "ColorScheme.c"
						goto __catch19_g_error;
					}
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp65_ = _tmp64_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					clutter_color_from_string (&color, _tmp65_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_g_free0 (_tmp65_);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp66_ = key;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp67_ = _tmp66_;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp69_ = (NULL == _tmp67_) ? 0 : g_quark_from_string (_tmp67_);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					if (_tmp69_ == ((0 != _tmp68_label0) ? _tmp68_label0 : (_tmp68_label0 = g_quark_from_static_string ("cursor")))) {
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 596 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp70_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp70_ = color;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->dark_cursor_color = _tmp70_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 606 "ColorScheme.c"
							}
						}
					} else if (_tmp69_ == ((0 != _tmp68_label1) ? _tmp68_label1 : (_tmp68_label1 = g_quark_from_static_string ("foreground")))) {
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 612 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp71_;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp71_ = color;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->dark_foreground_color = _tmp71_;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 622 "ColorScheme.c"
							}
						}
					} else if (_tmp69_ == ((0 != _tmp68_label2) ? _tmp68_label2 : (_tmp68_label2 = g_quark_from_static_string ("background")))) {
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 628 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp72_;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp72_ = color;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->dark_background_color = _tmp72_;
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 638 "ColorScheme.c"
							}
						}
					} else {
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 644 "ColorScheme.c"
							default:
							{
								GeeMap* _tmp73_;
								const gchar* _tmp74_;
								gint _tmp75_ = 0;
								ClutterColor _tmp76_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp73_ = self->priv->dark_indexed_colors;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp74_ = key;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp75_ = atoi (_tmp74_);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp76_ = color;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								gee_map_set (_tmp73_, (gpointer) ((gintptr) _tmp75_), &_tmp76_);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 663 "ColorScheme.c"
							}
						}
					}
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_g_free0 (key);
#line 669 "ColorScheme.c"
				}
			}
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 674 "ColorScheme.c"
		}
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp77_ = colors_file;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp79_ = g_key_file_get_keys (_tmp77_, "Light", &_tmp78_, &_inner_error_);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp80_ = _tmp79_;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp80__length1 = _tmp78_;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		__tmp80__size_ = _tmp80__length1;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_inner_error_ != NULL) {
#line 688 "ColorScheme.c"
			goto __catch19_g_error;
		}
		{
			gchar** key_collection = NULL;
			gint key_collection_length1 = 0;
			gint _key_collection_size_ = 0;
			gint key_it = 0;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection = _tmp80_;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection_length1 = _tmp80__length1;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			for (key_it = 0; key_it < _tmp80__length1; key_it = key_it + 1) {
#line 702 "ColorScheme.c"
				gchar* _tmp81_;
				gchar* key = NULL;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				_tmp81_ = g_strdup (key_collection[key_it]);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
				key = _tmp81_;
#line 709 "ColorScheme.c"
				{
					GKeyFile* _tmp82_;
					const gchar* _tmp83_;
					gchar* _tmp84_ = NULL;
					gchar* _tmp85_;
					gchar* _tmp86_;
					ClutterColor color = {0};
					const gchar* _tmp87_;
					const gchar* _tmp88_;
					GQuark _tmp90_ = 0U;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp89_label0 = 0;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp89_label1 = 0;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					static GQuark _tmp89_label2 = 0;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp82_ = colors_file;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp83_ = key;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp84_ = g_key_file_get_string (_tmp82_, "Light", _tmp83_, &_inner_error_);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp85_ = _tmp84_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					if (_inner_error_ != NULL) {
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						_g_free0 (key);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 740 "ColorScheme.c"
						goto __catch19_g_error;
					}
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp86_ = _tmp85_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					clutter_color_from_string (&color, _tmp86_);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_g_free0 (_tmp86_);
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp87_ = key;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp88_ = _tmp87_;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_tmp90_ = (NULL == _tmp88_) ? 0 : g_quark_from_string (_tmp88_);
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					if (_tmp90_ == ((0 != _tmp89_label0) ? _tmp89_label0 : (_tmp89_label0 = g_quark_from_static_string ("cursor")))) {
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 759 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp91_;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp91_ = color;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->light_cursor_color = _tmp91_;
#line 104 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 769 "ColorScheme.c"
							}
						}
					} else if (_tmp90_ == ((0 != _tmp89_label1) ? _tmp89_label1 : (_tmp89_label1 = g_quark_from_static_string ("foreground")))) {
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 775 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp92_;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp92_ = color;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->light_foreground_color = _tmp92_;
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 785 "ColorScheme.c"
							}
						}
					} else if (_tmp90_ == ((0 != _tmp89_label2) ? _tmp89_label2 : (_tmp89_label2 = g_quark_from_static_string ("background")))) {
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 791 "ColorScheme.c"
							default:
							{
								ClutterColor _tmp93_;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp93_ = color;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								self->priv->light_background_color = _tmp93_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 801 "ColorScheme.c"
							}
						}
					} else {
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
						switch (0) {
#line 807 "ColorScheme.c"
							default:
							{
								GeeMap* _tmp94_;
								const gchar* _tmp95_;
								gint _tmp96_ = 0;
								ClutterColor _tmp97_;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp94_ = self->priv->light_indexed_colors;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp95_ = key;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp96_ = atoi (_tmp95_);
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								_tmp97_ = color;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								gee_map_set (_tmp94_, (gpointer) ((gintptr) _tmp96_), &_tmp97_);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
								break;
#line 826 "ColorScheme.c"
							}
						}
					}
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
					_g_free0 (key);
#line 832 "ColorScheme.c"
				}
			}
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 837 "ColorScheme.c"
		}
	}
	goto __finally19;
	__catch19_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp98_ = NULL;
		const gchar* _tmp99_;
		GError* _tmp100_;
		const gchar* _tmp101_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		e = _inner_error_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_inner_error_ = NULL;
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp98_ = _ ("Error in color scheme %s: %s");
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp99_ = filename;
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp100_ = e;
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp101_ = _tmp100_->message;
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_warning (_tmp98_, _tmp99_, _tmp101_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_error_free0 (e);
#line 864 "ColorScheme.c"
	}
	__finally19:
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_inner_error_ != NULL) {
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_key_file_free0 (colors_file);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		return NULL;
#line 877 "ColorScheme.c"
	}
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_key_file_free0 (colors_file);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return self;
#line 883 "ColorScheme.c"
}


ColorScheme* color_scheme_new_load_from_file (const gchar* filename) {
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return color_scheme_construct_load_from_file (TYPE_COLOR_SCHEME, filename);
#line 890 "ColorScheme.c"
}


void color_scheme_get_cursor_color (ColorScheme* self, gboolean dark, ClutterColor* result) {
	ClutterColor _tmp0_ = {0};
	gboolean _tmp1_;
	ClutterColor _tmp4_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = dark;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_tmp1_) {
#line 904 "ColorScheme.c"
		ClutterColor _tmp2_;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp2_ = self->priv->dark_cursor_color;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp2_;
#line 910 "ColorScheme.c"
	} else {
		ClutterColor _tmp3_;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp3_ = self->priv->light_cursor_color;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp3_;
#line 917 "ColorScheme.c"
	}
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp4_ = _tmp0_;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	*result = _tmp4_;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return;
#line 925 "ColorScheme.c"
}


void color_scheme_get_foreground_color (ColorScheme* self, gboolean dark, ClutterColor* result) {
	ClutterColor _tmp0_ = {0};
	gboolean _tmp1_;
	ClutterColor _tmp4_;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = dark;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_tmp1_) {
#line 939 "ColorScheme.c"
		ClutterColor _tmp2_;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp2_ = self->priv->dark_foreground_color;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp2_;
#line 945 "ColorScheme.c"
	} else {
		ClutterColor _tmp3_;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp3_ = self->priv->light_foreground_color;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp3_;
#line 952 "ColorScheme.c"
	}
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp4_ = _tmp0_;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	*result = _tmp4_;
#line 124 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return;
#line 960 "ColorScheme.c"
}


void color_scheme_get_background_color (ColorScheme* self, gboolean dark, ClutterColor* result) {
	ClutterColor _tmp0_ = {0};
	gboolean _tmp1_;
	ClutterColor _tmp4_;
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = dark;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_tmp1_) {
#line 974 "ColorScheme.c"
		ClutterColor _tmp2_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp2_ = self->priv->dark_background_color;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp2_;
#line 980 "ColorScheme.c"
	} else {
		ClutterColor _tmp3_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp3_ = self->priv->light_background_color;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp3_;
#line 987 "ColorScheme.c"
	}
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp4_ = _tmp0_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	*result = _tmp4_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return;
#line 995 "ColorScheme.c"
}


void color_scheme_get_indexed_color (ColorScheme* self, gint index, gboolean dark, ClutterColor* result) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp8_;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = dark;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_tmp1_) {
#line 1009 "ColorScheme.c"
		GeeMap* _tmp2_;
		gint _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp2_ = self->priv->dark_indexed_colors;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp3_ = index;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp4_ = gee_map_has_key (_tmp2_, (gpointer) ((gintptr) _tmp3_));
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp4_;
#line 1021 "ColorScheme.c"
	} else {
		GeeMap* _tmp5_;
		gint _tmp6_;
		gboolean _tmp7_ = FALSE;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp5_ = self->priv->light_indexed_colors;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp6_ = index;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp7_ = gee_map_has_key (_tmp5_, (gpointer) ((gintptr) _tmp6_));
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp0_ = _tmp7_;
#line 1034 "ColorScheme.c"
	}
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp8_ = _tmp0_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	if (_tmp8_) {
#line 1040 "ColorScheme.c"
		ClutterColor* _tmp9_ = NULL;
		gboolean _tmp10_;
		ClutterColor* _tmp17_;
		ClutterColor _tmp18_;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp10_ = dark;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		if (_tmp10_) {
#line 1049 "ColorScheme.c"
			GeeMap* _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_ = NULL;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp11_ = self->priv->dark_indexed_colors;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp12_ = index;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp13_ = gee_map_get (_tmp11_, (gpointer) ((gintptr) _tmp12_));
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_g_free0 (_tmp9_);
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp9_ = (ClutterColor*) _tmp13_;
#line 1063 "ColorScheme.c"
		} else {
			GeeMap* _tmp14_;
			gint _tmp15_;
			gpointer _tmp16_ = NULL;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp14_ = self->priv->light_indexed_colors;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp15_ = index;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp16_ = gee_map_get (_tmp14_, (gpointer) ((gintptr) _tmp15_));
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_g_free0 (_tmp9_);
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
			_tmp9_ = (ClutterColor*) _tmp16_;
#line 1078 "ColorScheme.c"
		}
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp17_ = _tmp9_;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp18_ = *_tmp17_;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_g_free0 (_tmp17_);
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		*result = _tmp18_;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		return;
#line 1090 "ColorScheme.c"
	} else {
		const gchar* _tmp19_ = NULL;
		gint _tmp20_;
		ClutterColor _tmp21_ = {0};
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp19_ = _ ("Invalid color index: %i");
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		_tmp20_ = index;
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_critical (_tmp19_, _tmp20_);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		clutter_color_from_string (&_tmp21_, "#00000000");
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		*result = _tmp21_;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		return;
#line 1107 "ColorScheme.c"
	}
}


ColorScheme* color_scheme_construct (GType object_type) {
	ColorScheme * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self = (ColorScheme*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return self;
#line 1118 "ColorScheme.c"
}


ColorScheme* color_scheme_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return color_scheme_construct (TYPE_COLOR_SCHEME);
#line 1125 "ColorScheme.c"
}


const gchar* color_scheme_get_name (ColorScheme* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp0_ = self->priv->_name;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return result;
#line 1140 "ColorScheme.c"
}


void color_scheme_set_name (ColorScheme* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp0_ = value;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_free0 (self->priv->_name);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self->priv->_name = _tmp1_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_object_notify ((GObject *) self, "name");
#line 1159 "ColorScheme.c"
}


const gchar* color_scheme_get_author (ColorScheme* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp0_ = self->priv->_author;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	return result;
#line 1174 "ColorScheme.c"
}


void color_scheme_set_author (ColorScheme* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_return_if_fail (self != NULL);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp0_ = value;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_free0 (self->priv->_author);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self->priv->_author = _tmp1_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_object_notify ((GObject *) self, "author");
#line 1193 "ColorScheme.c"
}


static void color_scheme_class_init (ColorSchemeClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	color_scheme_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_type_class_add_private (klass, sizeof (ColorSchemePrivate));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_color_scheme_get_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_color_scheme_set_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	G_OBJECT_CLASS (klass)->finalize = color_scheme_finalize;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_SCHEME_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COLOR_SCHEME_AUTHOR, g_param_spec_string ("author", "author", "author", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1212 "ColorScheme.c"
}


static void color_scheme_instance_init (ColorScheme * self) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self->priv = COLOR_SCHEME_GET_PRIVATE (self);
#line 1219 "ColorScheme.c"
}


static void color_scheme_finalize (GObject* obj) {
	ColorScheme * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COLOR_SCHEME, ColorScheme);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_free0 (self->priv->_name);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_free0 (self->priv->_author);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_object_unref0 (self->priv->dark_indexed_colors);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	_g_object_unref0 (self->priv->light_indexed_colors);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	G_OBJECT_CLASS (color_scheme_parent_class)->finalize (obj);
#line 1237 "ColorScheme.c"
}


GType color_scheme_get_type (void) {
	static volatile gsize color_scheme_type_id__volatile = 0;
	if (g_once_init_enter (&color_scheme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ColorSchemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) color_scheme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ColorScheme), 0, (GInstanceInitFunc) color_scheme_instance_init, NULL };
		GType color_scheme_type_id;
		color_scheme_type_id = g_type_register_static (G_TYPE_OBJECT, "ColorScheme", &g_define_type_info, 0);
		g_once_init_leave (&color_scheme_type_id__volatile, color_scheme_type_id);
	}
	return color_scheme_type_id__volatile;
}


static void _vala_color_scheme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ColorScheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_SCHEME, ColorScheme);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		case COLOR_SCHEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_value_set_string (value, color_scheme_get_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		case COLOR_SCHEME_AUTHOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		g_value_set_string (value, color_scheme_get_author (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 1270 "ColorScheme.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 1276 "ColorScheme.c"
	}
}


static void _vala_color_scheme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ColorScheme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COLOR_SCHEME, ColorScheme);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		case COLOR_SCHEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		color_scheme_set_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		case COLOR_SCHEME_AUTHOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		color_scheme_set_author (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 1298 "ColorScheme.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ColorScheme.vala"
		break;
#line 1304 "ColorScheme.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1312 "ColorScheme.c"
		int i;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1320 "ColorScheme.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	g_free (array);
#line 1332 "ColorScheme.c"
}



