/* Command.c generated by valac 0.20.1, the Vala compiler
 * generated from Command.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _CommandPrivate CommandPrivate;

#define COMMAND_TYPE_COMMAND_TYPE (command_command_type_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
};

typedef enum  {
	COMMAND_COMMAND_TYPE_QUIT_PROGRAM,
	COMMAND_COMMAND_TYPE_SEND_TO_SHELL,
	COMMAND_COMMAND_TYPE_CLEAR_SHELL_COMMAND,
	COMMAND_COMMAND_TYPE_SET_SHELL_COMMAND,
	COMMAND_COMMAND_TYPE_RUN_SHELL_COMMAND,
	COMMAND_COMMAND_TYPE_TOGGLE_VISIBLE,
	COMMAND_COMMAND_TYPE_TOGGLE_FULLSCREEN,
	COMMAND_COMMAND_TYPE_TOGGLE_DROPDOWN,
	COMMAND_COMMAND_TYPE_ADD_TAB,
	COMMAND_COMMAND_TYPE_SPLIT,
	COMMAND_COMMAND_TYPE_CLOSE,
	COMMAND_COMMAND_TYPE_LOG,
	COMMAND_COMMAND_TYPE_PRINT_METRICS,
	COMMAND_COMMAND_TYPE_COPY_TO_CLIPBOARD,
	COMMAND_COMMAND_TYPE_OPEN_URL
} CommandCommandType;

struct _CommandPrivate {
	CommandCommandType _command;
	GeeList* _parameters;
};

typedef void (*CommandCommandExecuteFunction) (Command* command, void* user_data);

static gpointer command_parent_class = NULL;
static GRegex* command_command_pattern;
static GRegex* command_command_pattern = NULL;
static GRegex* command_placeholder_pattern;
static GRegex* command_placeholder_pattern = NULL;
extern CommandCommandExecuteFunction command_execute_function;
extern gpointer command_execute_function_target;
extern GDestroyNotify command_execute_function_target_destroy_notify;
CommandCommandExecuteFunction command_execute_function = NULL;
gpointer command_execute_function_target = NULL;
GDestroyNotify command_execute_function_target_destroy_notify = NULL;

GType command_get_type (void) G_GNUC_CONST;
GType command_command_type_get_type (void) G_GNUC_CONST;
#define COMMAND_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMMAND, CommandPrivate))
enum  {
	COMMAND_DUMMY_PROPERTY,
	COMMAND_COMMAND,
	COMMAND_PARAMETERS
};
void command_initialize (void);
Command* command_new_from_command_specification (const gchar* command_specification);
Command* command_construct_from_command_specification (GType object_type, const gchar* command_specification);
gpointer utilities_get_enum_value_from_name (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GType type, const gchar* name);
void command_set_command (Command* self, CommandCommandType value);
void command_set_parameters (Command* self, GeeList* value);
GeeList* command_get_parameters (Command* self);
void command_execute (Command* self, GeeList* placeholder_substitutes);
Command* command_new (void);
Command* command_construct (GType object_type);
CommandCommandType command_get_command (Command* self);
gint command_get_numeric_parameter (Command* self, gint index, gint default_value);
gchar* command_get_text_parameter (Command* self, gint index, const gchar* default_value);
static void command_finalize (GObject* obj);
static void _vala_command_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_command_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType command_command_type_get_type (void) {
	static volatile gsize command_command_type_type_id__volatile = 0;
	if (g_once_init_enter (&command_command_type_type_id__volatile)) {
		static const GEnumValue values[] = {{COMMAND_COMMAND_TYPE_QUIT_PROGRAM, "COMMAND_COMMAND_TYPE_QUIT_PROGRAM", "quit-program"}, {COMMAND_COMMAND_TYPE_SEND_TO_SHELL, "COMMAND_COMMAND_TYPE_SEND_TO_SHELL", "send-to-shell"}, {COMMAND_COMMAND_TYPE_CLEAR_SHELL_COMMAND, "COMMAND_COMMAND_TYPE_CLEAR_SHELL_COMMAND", "clear-shell-command"}, {COMMAND_COMMAND_TYPE_SET_SHELL_COMMAND, "COMMAND_COMMAND_TYPE_SET_SHELL_COMMAND", "set-shell-command"}, {COMMAND_COMMAND_TYPE_RUN_SHELL_COMMAND, "COMMAND_COMMAND_TYPE_RUN_SHELL_COMMAND", "run-shell-command"}, {COMMAND_COMMAND_TYPE_TOGGLE_VISIBLE, "COMMAND_COMMAND_TYPE_TOGGLE_VISIBLE", "toggle-visible"}, {COMMAND_COMMAND_TYPE_TOGGLE_FULLSCREEN, "COMMAND_COMMAND_TYPE_TOGGLE_FULLSCREEN", "toggle-fullscreen"}, {COMMAND_COMMAND_TYPE_TOGGLE_DROPDOWN, "COMMAND_COMMAND_TYPE_TOGGLE_DROPDOWN", "toggle-dropdown"}, {COMMAND_COMMAND_TYPE_ADD_TAB, "COMMAND_COMMAND_TYPE_ADD_TAB", "add-tab"}, {COMMAND_COMMAND_TYPE_SPLIT, "COMMAND_COMMAND_TYPE_SPLIT", "split"}, {COMMAND_COMMAND_TYPE_CLOSE, "COMMAND_COMMAND_TYPE_CLOSE", "close"}, {COMMAND_COMMAND_TYPE_LOG, "COMMAND_COMMAND_TYPE_LOG", "log"}, {COMMAND_COMMAND_TYPE_PRINT_METRICS, "COMMAND_COMMAND_TYPE_PRINT_METRICS", "print-metrics"}, {COMMAND_COMMAND_TYPE_COPY_TO_CLIPBOARD, "COMMAND_COMMAND_TYPE_COPY_TO_CLIPBOARD", "copy-to-clipboard"}, {COMMAND_COMMAND_TYPE_OPEN_URL, "COMMAND_COMMAND_TYPE_OPEN_URL", "open-url"}, {0, NULL, NULL}};
		GType command_command_type_type_id;
		command_command_type_type_id = g_enum_register_static ("CommandCommandType", values);
		g_once_init_leave (&command_command_type_type_id__volatile, command_command_type_type_id);
	}
	return command_command_type_type_id__volatile;
}


void command_initialize (void) {
	GError * _inner_error_ = NULL;
	{
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp0_ = g_regex_new ("(\\w+)(?:\\s+\"(.*?)\")?(?:\\s+\"(.*?)\")?(?:\\s+\"(.*?)\")?(?:\\s+\"(" \
".*?)\")?(?:\\s+\"(.*?)\")?", G_REGEX_OPTIMIZE | G_REGEX_DOTALL, 0, &_inner_error_);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp1_ = _tmp0_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		if (_inner_error_ != NULL) {
#line 150 "Command.c"
			goto __catch25_g_error;
		}
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_regex_unref0 (command_command_pattern);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_command_pattern = _tmp1_;
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp2_ = g_regex_new ("%\\d", G_REGEX_OPTIMIZE, 0, &_inner_error_);
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp3_ = _tmp2_;
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		if (_inner_error_ != NULL) {
#line 163 "Command.c"
			goto __catch25_g_error;
		}
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_regex_unref0 (command_placeholder_pattern);
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_placeholder_pattern = _tmp3_;
#line 170 "Command.c"
	}
	goto __finally25;
	__catch25_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		e = _inner_error_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp4_ = e->message;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_error ("Command.vala:61: %s", _tmp4_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_error_free0 (e);
#line 187 "Command.c"
	}
	__finally25:
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	if (_inner_error_ != NULL) {
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		return;
#line 198 "Command.c"
	}
}


Command* command_construct_from_command_specification (GType object_type, const gchar* command_specification) {
	Command * self = NULL;
	GMatchInfo* match_info = NULL;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GMatchInfo* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gpointer _tmp11_ = NULL;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (command_specification != NULL, NULL);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self = (Command*) g_object_new (object_type, NULL);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = command_command_pattern;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp1_ = command_specification;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_match_info_free0 (match_info);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	match_info = _tmp2_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	if (!_tmp3_) {
#line 234 "Command.c"
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp4_ = _ ("Invalid command specification: '%s'");
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp5_ = command_specification;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_warning (_tmp4_, _tmp5_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_match_info_free0 (match_info);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		return self;
#line 247 "Command.c"
	}
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp6_ = match_info;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp7_ = g_match_info_fetch (_tmp6_, 1);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp8_ = _tmp7_;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp9_ = g_strconcat ("COMMAND_COMMAND_TYPE_", _tmp8_, NULL);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp10_ = _tmp9_;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp11_ = utilities_get_enum_value_from_name (COMMAND_TYPE_COMMAND_TYPE, NULL, NULL, COMMAND_TYPE_COMMAND_TYPE, _tmp10_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	command_set_command (self, (CommandCommandType) ((gintptr) _tmp11_));
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_free0 (_tmp10_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_free0 (_tmp8_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp12_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp13_ = _tmp12_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	command_set_parameters (self, (GeeList*) _tmp13_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_object_unref0 (_tmp13_);
#line 275 "Command.c"
	{
		gint i;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		i = 2;
#line 280 "Command.c"
		{
			gboolean _tmp14_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp14_ = TRUE;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			while (TRUE) {
#line 287 "Command.c"
				gboolean _tmp15_;
				gint _tmp17_;
				GMatchInfo* _tmp18_;
				gint _tmp19_ = 0;
				GMatchInfo* _tmp20_;
				gint _tmp21_;
				gchar* _tmp22_ = NULL;
				gchar* parameter;
				const gchar* _tmp23_;
				gchar* _tmp24_ = NULL;
				GeeList* _tmp25_;
				const gchar* _tmp26_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp15_ = _tmp14_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				if (!_tmp15_) {
#line 304 "Command.c"
					gint _tmp16_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp16_ = i;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					i = _tmp16_ + 1;
#line 310 "Command.c"
				}
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp14_ = FALSE;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp17_ = i;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp18_ = match_info;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp19_ = g_match_info_get_match_count (_tmp18_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				if (!(_tmp17_ < _tmp19_)) {
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					break;
#line 324 "Command.c"
				}
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp20_ = match_info;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp21_ = i;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp22_ = g_match_info_fetch (_tmp20_, _tmp21_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				parameter = _tmp22_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp23_ = parameter;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp24_ = g_strcompress (_tmp23_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_g_free0 (parameter);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				parameter = _tmp24_;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp25_ = self->priv->_parameters;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp26_ = parameter;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				gee_collection_add ((GeeCollection*) _tmp25_, _tmp26_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_g_free0 (parameter);
#line 350 "Command.c"
			}
		}
	}
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_match_info_free0 (match_info);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return self;
#line 358 "Command.c"
}


Command* command_new_from_command_specification (const gchar* command_specification) {
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return command_construct_from_command_specification (TYPE_COMMAND, command_specification);
#line 365 "Command.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return self ? g_object_ref (self) : NULL;
#line 372 "Command.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 385 "Command.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 415 "Command.c"
				goto __catch27_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			return NULL;
#line 424 "Command.c"
		}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = regex;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = replacement;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 440 "Command.c"
				goto __catch27_g_regex_error;
			}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			return NULL;
#line 451 "Command.c"
		}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = _tmp8_;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 459 "Command.c"
	}
	goto __finally27;
	__catch27_g_regex_error:
	{
		GError* e = NULL;
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1247 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 473 "Command.c"
	}
	__finally27:
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return NULL;
#line 484 "Command.c"
	}
}


void command_execute (Command* self, GeeList* placeholder_substitutes) {
	GeeList* _tmp0_;
	GError * _inner_error_ = NULL;
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_if_fail (self != NULL);
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = placeholder_substitutes;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	if (_tmp0_ == NULL) {
#line 498 "Command.c"
		CommandCommandExecuteFunction _tmp1_;
		void* _tmp1__target;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp1_ = command_execute_function;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp1__target = command_execute_function_target;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp1_ (self, _tmp1__target);
#line 507 "Command.c"
	} else {
		Command* _tmp2_;
		Command* substitute_command;
		Command* _tmp3_;
		CommandCommandType _tmp4_;
		Command* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		Command* _tmp55_;
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp2_ = command_new ();
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		substitute_command = _tmp2_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp3_ = substitute_command;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp4_ = self->priv->_command;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_set_command (_tmp3_, _tmp4_);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp5_ = substitute_command;
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp6_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp7_ = _tmp6_;
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_set_parameters (_tmp5_, (GeeList*) _tmp7_);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_object_unref0 (_tmp7_);
#line 537 "Command.c"
		{
			GeeList* _tmp8_;
			GeeList* _tmp9_;
			GeeList* _parameter_list;
			GeeList* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _parameter_size;
			gint _parameter_index;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp8_ = self->priv->_parameters;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_parameter_list = _tmp9_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp10_ = _parameter_list;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp11_ = gee_collection_get_size ((GeeCollection*) _tmp10_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp12_ = _tmp11_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_parameter_size = _tmp12_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_parameter_index = -1;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			while (TRUE) {
#line 565 "Command.c"
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				GeeList* _tmp16_;
				gint _tmp17_;
				gpointer _tmp18_ = NULL;
				gchar* parameter;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* substitute_parameter;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp13_ = _parameter_index;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_parameter_index = _tmp13_ + 1;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp14_ = _parameter_index;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp15_ = _parameter_size;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				if (!(_tmp14_ < _tmp15_)) {
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					break;
#line 588 "Command.c"
				}
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp16_ = _parameter_list;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp17_ = _parameter_index;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp18_ = gee_list_get (_tmp16_, _tmp17_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				parameter = (gchar*) _tmp18_;
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp19_ = parameter;
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_tmp20_ = g_strdup (_tmp19_);
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				substitute_parameter = _tmp20_;
#line 604 "Command.c"
				{
					GRegex* _tmp44_;
					const gchar* _tmp45_;
					gchar* _tmp46_ = NULL;
					gchar* _tmp47_;
					Command* _tmp48_;
					GeeList* _tmp49_;
					const gchar* _tmp50_;
					{
						gint i;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						i = 0;
#line 617 "Command.c"
						{
							gboolean _tmp21_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
							_tmp21_ = TRUE;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
							while (TRUE) {
#line 624 "Command.c"
								gboolean _tmp22_;
								gint _tmp24_;
								GeeList* _tmp25_;
								gint _tmp26_;
								gint _tmp27_;
								const gchar* _tmp28_;
								gint _tmp29_;
								gchar* _tmp30_ = NULL;
								gchar* _tmp31_;
								gchar* _tmp32_;
								gchar* _tmp33_;
								GeeList* _tmp34_;
								gint _tmp35_;
								gpointer _tmp36_ = NULL;
								gchar* _tmp37_;
								gchar* _tmp38_ = NULL;
								const gchar* _tmp39_ = NULL;
								GeeList* _tmp40_;
								gint _tmp41_;
								gpointer _tmp42_ = NULL;
								gchar* _tmp43_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp22_ = _tmp21_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								if (!_tmp22_) {
#line 650 "Command.c"
									gint _tmp23_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
									_tmp23_ = i;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
									i = _tmp23_ + 1;
#line 656 "Command.c"
								}
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp21_ = FALSE;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp24_ = i;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp25_ = placeholder_substitutes;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp27_ = _tmp26_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								if (!(_tmp24_ < _tmp27_)) {
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
									break;
#line 672 "Command.c"
								}
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp28_ = substitute_parameter;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp29_ = i;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp30_ = g_strdup_printf ("%i", _tmp29_ + 1);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp31_ = _tmp30_;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp32_ = g_strconcat ("%", _tmp31_, NULL);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp33_ = _tmp32_;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp34_ = placeholder_substitutes;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp35_ = i;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp36_ = gee_list_get (_tmp34_, _tmp35_);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp37_ = (gchar*) _tmp36_;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp38_ = string_replace (_tmp28_, _tmp33_, _tmp37_);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_g_free0 (substitute_parameter);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								substitute_parameter = _tmp38_;
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_g_free0 (_tmp37_);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_g_free0 (_tmp33_);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_g_free0 (_tmp31_);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp39_ = _ ("placeholder_substitute: %s");
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp40_ = placeholder_substitutes;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp41_ = i;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp42_ = gee_list_get (_tmp40_, _tmp41_);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_tmp43_ = (gchar*) _tmp42_;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								g_message (_tmp39_, _tmp43_);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
								_g_free0 (_tmp43_);
#line 720 "Command.c"
							}
						}
					}
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp44_ = command_placeholder_pattern;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp45_ = substitute_parameter;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp46_ = g_regex_replace (_tmp44_, _tmp45_, (gssize) (-1), 0, "", 0, &_inner_error_);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp47_ = _tmp46_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					if (_inner_error_ != NULL) {
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						if (_inner_error_->domain == G_REGEX_ERROR) {
#line 736 "Command.c"
							goto __catch26_g_regex_error;
						}
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						_g_free0 (substitute_parameter);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						_g_free0 (parameter);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						_g_object_unref0 (_parameter_list);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						_g_object_unref0 (substitute_command);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
						return;
#line 753 "Command.c"
					}
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_free0 (substitute_parameter);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					substitute_parameter = _tmp47_;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp48_ = substitute_command;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp49_ = _tmp48_->priv->_parameters;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp50_ = substitute_parameter;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					gee_collection_add ((GeeCollection*) _tmp49_, _tmp50_);
#line 767 "Command.c"
				}
				goto __finally26;
				__catch26_g_regex_error:
				{
					GError* e = NULL;
					const gchar* _tmp51_ = NULL;
					GRegex* _tmp52_;
					const gchar* _tmp53_;
					const gchar* _tmp54_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					e = _inner_error_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp51_ = _ ("Error substituting parameter. placeholder_pattern: %s substitute_param" \
"eter: %s, exception: %s");
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp52_ = command_placeholder_pattern;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp53_ = substitute_parameter;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_tmp54_ = e->message;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					g_error (_tmp51_, g_regex_get_pattern, _tmp53_, _tmp54_);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_error_free0 (e);
#line 793 "Command.c"
				}
				__finally26:
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				if (_inner_error_ != NULL) {
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_free0 (substitute_parameter);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_free0 (parameter);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_object_unref0 (_parameter_list);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					_g_object_unref0 (substitute_command);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					g_clear_error (&_inner_error_);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
					return;
#line 812 "Command.c"
				}
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_g_free0 (substitute_parameter);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
				_g_free0 (parameter);
#line 818 "Command.c"
			}
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_g_object_unref0 (_parameter_list);
#line 822 "Command.c"
		}
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp55_ = substitute_command;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_execute (_tmp55_, NULL);
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_object_unref0 (substitute_command);
#line 830 "Command.c"
	}
}


gint command_get_numeric_parameter (Command* self, gint index, gint default_value) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = index;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp1_ = default_value;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp3_ = _tmp2_;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp4_ = command_get_text_parameter (self, _tmp0_, _tmp3_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp5_ = _tmp4_;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp6_ = atoi (_tmp5_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp7_ = _tmp6_;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_free0 (_tmp5_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_free0 (_tmp3_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	result = _tmp7_;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return result;
#line 871 "Command.c"
}


gchar* command_get_text_parameter (Command* self, gint index, const gchar* default_value) {
	gchar* result = NULL;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (default_value != NULL, NULL);
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = self->priv->_parameters;
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp2_ = _tmp1_;
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp3_ = index;
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	if (_tmp2_ <= _tmp3_) {
#line 895 "Command.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp4_ = default_value;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		result = _tmp5_;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		return result;
#line 906 "Command.c"
	} else {
		GeeList* _tmp6_;
		gint _tmp7_;
		gpointer _tmp8_ = NULL;
		gchar* parameter;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp6_ = self->priv->_parameters;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp7_ = index;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp8_ = gee_list_get (_tmp6_, _tmp7_);
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		parameter = (gchar*) _tmp8_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp10_ = parameter;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		if (g_strcmp0 (_tmp10_, "") == 0) {
#line 928 "Command.c"
			const gchar* _tmp11_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp11_ = default_value;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp9_ = _tmp11_;
#line 934 "Command.c"
		} else {
			const gchar* _tmp12_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp12_ = parameter;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
			_tmp9_ = _tmp12_;
#line 941 "Command.c"
		}
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp13_ = _tmp9_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		result = _tmp14_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		_g_free0 (parameter);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		return result;
#line 953 "Command.c"
	}
}


Command* command_construct (GType object_type) {
	Command * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self = (Command*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return self;
#line 964 "Command.c"
}


Command* command_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return command_construct (TYPE_COMMAND);
#line 971 "Command.c"
}


CommandCommandType command_get_command (Command* self) {
	CommandCommandType result;
	CommandCommandType _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = self->priv->_command;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return result;
#line 986 "Command.c"
}


void command_set_command (Command* self, CommandCommandType value) {
	CommandCommandType _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = value;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self->priv->_command = _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_object_notify ((GObject *) self, "command");
#line 1000 "Command.c"
}


GeeList* command_get_parameters (Command* self) {
	GeeList* result;
	GeeList* _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = self->priv->_parameters;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	result = _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	return result;
#line 1015 "Command.c"
}


void command_set_parameters (Command* self, GeeList* value) {
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp0_ = value;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_object_unref0 (self->priv->_parameters);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self->priv->_parameters = _tmp1_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_object_notify ((GObject *) self, "parameters");
#line 1034 "Command.c"
}


static void command_class_init (CommandClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	command_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_type_class_add_private (klass, sizeof (CommandPrivate));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_command_get_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_command_set_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	G_OBJECT_CLASS (klass)->finalize = command_finalize;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMMAND_COMMAND, g_param_spec_enum ("command", "command", "command", COMMAND_TYPE_COMMAND_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), COMMAND_PARAMETERS, g_param_spec_object ("parameters", "parameters", "parameters", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1053 "Command.c"
}


static void command_instance_init (Command * self) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self->priv = COMMAND_GET_PRIVATE (self);
#line 1060 "Command.c"
}


static void command_finalize (GObject* obj) {
	Command * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMMAND, Command);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	_g_object_unref0 (self->priv->_parameters);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	G_OBJECT_CLASS (command_parent_class)->finalize (obj);
#line 1072 "Command.c"
}


GType command_get_type (void) {
	static volatile gsize command_type_id__volatile = 0;
	if (g_once_init_enter (&command_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Command), 0, (GInstanceInitFunc) command_instance_init, NULL };
		GType command_type_id;
		command_type_id = g_type_register_static (G_TYPE_OBJECT, "Command", &g_define_type_info, 0);
		g_once_init_leave (&command_type_id__volatile, command_type_id);
	}
	return command_type_id__volatile;
}


static void _vala_command_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Command * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMMAND, Command);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		case COMMAND_COMMAND:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_value_set_enum (value, command_get_command (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		case COMMAND_PARAMETERS:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		g_value_set_object (value, command_get_parameters (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 1105 "Command.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 1111 "Command.c"
	}
}


static void _vala_command_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Command * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_COMMAND, Command);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		case COMMAND_COMMAND:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_set_command (self, g_value_get_enum (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		case COMMAND_PARAMETERS:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		command_set_parameters (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 1133 "Command.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Command.vala"
		break;
#line 1139 "Command.c"
	}
}



