/* KeyBindings.c generated by valac 0.20.1, the Vala compiler
 * generated from KeyBindings.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <keybinder.h>


#define TYPE_KEY_BINDINGS (key_bindings_get_type ())
#define KEY_BINDINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_BINDINGS, KeyBindings))
#define KEY_BINDINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_BINDINGS, KeyBindingsClass))
#define IS_KEY_BINDINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_BINDINGS))
#define IS_KEY_BINDINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_BINDINGS))
#define KEY_BINDINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_BINDINGS, KeyBindingsClass))

typedef struct _KeyBindings KeyBindings;
typedef struct _KeyBindingsClass KeyBindingsClass;
typedef struct _KeyBindingsPrivate KeyBindingsPrivate;

#define KEY_BINDINGS_TYPE_KEY_BINDING (key_bindings_key_binding_get_type ())
#define KEY_BINDINGS_KEY_BINDING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KEY_BINDINGS_TYPE_KEY_BINDING, KeyBindingsKeyBinding))
#define KEY_BINDINGS_KEY_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KEY_BINDINGS_TYPE_KEY_BINDING, KeyBindingsKeyBindingClass))
#define KEY_BINDINGS_IS_KEY_BINDING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KEY_BINDINGS_TYPE_KEY_BINDING))
#define KEY_BINDINGS_IS_KEY_BINDING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KEY_BINDINGS_TYPE_KEY_BINDING))
#define KEY_BINDINGS_KEY_BINDING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KEY_BINDINGS_TYPE_KEY_BINDING, KeyBindingsKeyBindingClass))

typedef struct _KeyBindingsKeyBinding KeyBindingsKeyBinding;
typedef struct _KeyBindingsKeyBindingClass KeyBindingsKeyBindingClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _KeyBindingsKeyBindingPrivate KeyBindingsKeyBindingPrivate;

#define TERMINAL_OUTPUT_TYPE_TERMINAL_MODE (terminal_output_terminal_mode_get_type ())

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))

struct _KeyBindings {
	GObject parent_instance;
	KeyBindingsPrivate * priv;
};

struct _KeyBindingsClass {
	GObjectClass parent_class;
};

typedef enum  {
	TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD = 1 << 0,
	TERMINAL_OUTPUT_TERMINAL_MODE_NUMLOCK = 1 << 1,
	TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR = 1 << 2,
	TERMINAL_OUTPUT_TERMINAL_MODE_CRLF = 1 << 3
} TerminalOutputTerminalMode;

struct _KeyBindingsKeyBinding {
	GObject parent_instance;
	KeyBindingsKeyBindingPrivate * priv;
	gchar* key_specification;
	guint key;
	GdkModifierType modifiers;
	TerminalOutputTerminalMode set_terminal_modes;
	TerminalOutputTerminalMode unset_terminal_modes;
	GeeList* commands;
};

struct _KeyBindingsKeyBindingClass {
	GObjectClass parent_class;
};


static gpointer key_bindings_parent_class = NULL;
static GeeList* key_bindings_key_bindings;
static GeeList* key_bindings_key_bindings = NULL;
static GRegex* key_bindings_key_specification_pattern;
static GRegex* key_bindings_key_specification_pattern = NULL;
static gpointer key_bindings_key_binding_parent_class = NULL;

GType key_bindings_get_type (void) G_GNUC_CONST;
enum  {
	KEY_BINDINGS_DUMMY_PROPERTY
};
static GType key_bindings_key_binding_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void key_bindings_initialize (void);
void key_bindings_load_from_file (const gchar* filename);
static KeyBindingsKeyBinding* key_bindings_key_binding_new (void);
static KeyBindingsKeyBinding* key_bindings_key_binding_construct (GType object_type);
GType terminal_output_terminal_mode_get_type (void) G_GNUC_CONST;
GType command_get_type (void) G_GNUC_CONST;
gpointer utilities_get_enum_value_from_name (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GType type, const gchar* name);
Command* command_new_from_command_specification (const gchar* command_specification);
Command* command_construct_from_command_specification (GType object_type, const gchar* command_specification);
static void ________lambda51_ (const gchar* keystring, void* user_data);
void command_execute (Command* self, GeeList* placeholder_substitutes);
static void _________lambda51__keybinder_handler (const gchar* keystring, void* udata);
GeeList* key_bindings_get_key_commands (guint key, GdkModifierType modifiers, TerminalOutputTerminalMode terminal_modes);
KeyBindings* key_bindings_new (void);
KeyBindings* key_bindings_construct (GType object_type);
enum  {
	KEY_BINDINGS_KEY_BINDING_DUMMY_PROPERTY
};
static void key_bindings_key_binding_finalize (GObject* obj);
static void key_bindings_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void key_bindings_initialize (void) {
	GeeArrayList* _tmp0_;
	GError * _inner_error_ = NULL;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_tmp0_ = gee_array_list_new (KEY_BINDINGS_TYPE_KEY_BINDING, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_g_object_unref0 (key_bindings_key_bindings);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	key_bindings_key_bindings = (GeeList*) _tmp0_;
#line 156 "KeyBindings.c"
	{
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp1_ = g_regex_new ("(.+)\\{(.+)\\}", G_REGEX_OPTIMIZE, 0, &_inner_error_);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp2_ = _tmp1_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		if (_inner_error_ != NULL) {
#line 166 "KeyBindings.c"
			goto __catch22_g_error;
		}
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_regex_unref0 (key_bindings_key_specification_pattern);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		key_bindings_key_specification_pattern = _tmp2_;
#line 173 "KeyBindings.c"
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		e = _inner_error_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_inner_error_ = NULL;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp3_ = e->message;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_error ("KeyBindings.vala:45: %s", _tmp3_);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_error_free0 (e);
#line 190 "KeyBindings.c"
	}
	__finally22:
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	if (_inner_error_ != NULL) {
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_clear_error (&_inner_error_);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		return;
#line 201 "KeyBindings.c"
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
#line 1085 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1086 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1086 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1087 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1087 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1088 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _result_;
#line 1088 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 225 "KeyBindings.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1158 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1158 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 248 "KeyBindings.c"
		glong _tmp4_;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 256 "KeyBindings.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 268 "KeyBindings.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1168 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 293 "KeyBindings.c"
		glong _tmp2_;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 299 "KeyBindings.c"
	} else {
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 303 "KeyBindings.c"
	}
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 309 "KeyBindings.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 321 "KeyBindings.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 331 "KeyBindings.c"
	}
#line 1177 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1177 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 337 "KeyBindings.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1179 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1179 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 351 "KeyBindings.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 361 "KeyBindings.c"
	}
#line 1183 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1183 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 367 "KeyBindings.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 376 "KeyBindings.c"
	}
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 396 "KeyBindings.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return self ? g_object_ref (self) : NULL;
#line 403 "KeyBindings.c"
}


static void ________lambda51_ (const gchar* keystring, void* user_data) {
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	g_return_if_fail (keystring != NULL);
#line 410 "KeyBindings.c"
	{
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		GeeList* _key_binding_inner_list;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _key_binding_inner_size;
		gint _key_binding_inner_index;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp0_ = key_bindings_key_bindings;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_inner_list = _tmp1_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp2_ = _key_binding_inner_list;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp4_ = _tmp3_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_inner_size = _tmp4_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_inner_index = -1;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		while (TRUE) {
#line 438 "KeyBindings.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			KeyBindingsKeyBinding* key_binding_inner;
			KeyBindingsKeyBinding* _tmp11_;
			const gchar* _tmp12_;
			void* _tmp13_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp5_ = _key_binding_inner_index;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_key_binding_inner_index = _tmp5_ + 1;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp6_ = _key_binding_inner_index;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp7_ = _key_binding_inner_size;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				break;
#line 461 "KeyBindings.c"
			}
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp8_ = _key_binding_inner_list;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp9_ = _key_binding_inner_index;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp10_ = gee_list_get (_tmp8_, _tmp9_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			key_binding_inner = (KeyBindingsKeyBinding*) _tmp10_;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp11_ = key_binding_inner;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp12_ = _tmp11_->key_specification;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp13_ = user_data;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if (g_strcmp0 (_tmp12_, (const gchar*) _tmp13_) == 0) {
#line 479 "KeyBindings.c"
				{
					KeyBindingsKeyBinding* _tmp14_;
					GeeList* _tmp15_;
					GeeList* _tmp16_;
					GeeList* _command_list;
					GeeList* _tmp17_;
					gint _tmp18_;
					gint _tmp19_;
					gint _command_size;
					gint _command_index;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp14_ = key_binding_inner;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp15_ = _tmp14_->commands;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_command_list = _tmp16_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp17_ = _command_list;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp18_ = gee_collection_get_size ((GeeCollection*) _tmp17_);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp19_ = _tmp18_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_command_size = _tmp19_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_command_index = -1;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					while (TRUE) {
#line 510 "KeyBindings.c"
						gint _tmp20_;
						gint _tmp21_;
						gint _tmp22_;
						GeeList* _tmp23_;
						gint _tmp24_;
						gpointer _tmp25_ = NULL;
						Command* command;
						Command* _tmp26_;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp20_ = _command_index;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_command_index = _tmp20_ + 1;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp21_ = _command_index;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp22_ = _command_size;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						if (!(_tmp21_ < _tmp22_)) {
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
							break;
#line 531 "KeyBindings.c"
						}
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp23_ = _command_list;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp24_ = _command_index;
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp25_ = gee_list_get (_tmp23_, _tmp24_);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						command = (Command*) _tmp25_;
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_tmp26_ = command;
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						command_execute (_tmp26_, NULL);
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_g_object_unref0 (command);
#line 547 "KeyBindings.c"
					}
#line 110 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_g_object_unref0 (_command_list);
#line 551 "KeyBindings.c"
				}
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_g_object_unref0 (key_binding_inner);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				break;
#line 557 "KeyBindings.c"
			}
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_g_object_unref0 (key_binding_inner);
#line 561 "KeyBindings.c"
		}
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_object_unref0 (_key_binding_inner_list);
#line 565 "KeyBindings.c"
	}
}


static void _________lambda51__keybinder_handler (const gchar* keystring, void* udata) {
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	________lambda51_ (keystring, udata);
#line 573 "KeyBindings.c"
}


void key_bindings_load_from_file (const gchar* filename) {
	GKeyFile* _tmp0_;
	GKeyFile* key_bindings_file;
	GError * _inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	g_return_if_fail (filename != NULL);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_tmp0_ = g_key_file_new ();
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	key_bindings_file = _tmp0_;
#line 587 "KeyBindings.c"
	{
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp1_ = key_bindings_file;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp2_ = filename;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_key_file_load_from_file (_tmp1_, _tmp2_, G_KEY_FILE_NONE, &_inner_error_);
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		if (_inner_error_ != NULL) {
#line 599 "KeyBindings.c"
			goto __catch23_g_error;
		}
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		e = _inner_error_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp3_ = _ ("Loading key bindings file %s failed: %s");
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp4_ = filename;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp5_ = e->message;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_error (_tmp3_, _tmp4_, _tmp5_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_error_free0 (e);
#line 624 "KeyBindings.c"
	}
	__finally23:
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	if (_inner_error_ != NULL) {
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_key_file_free0 (key_bindings_file);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_clear_error (&_inner_error_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		return;
#line 637 "KeyBindings.c"
	}
	{
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar** _tmp8_ = NULL;
		gchar** group_names;
		gint group_names_length1;
		gint _group_names_size_;
		gchar** _tmp9_;
		gint _tmp9__length1;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp6_ = g_strdup ("Global");
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp7_ = g_strdup ("Application");
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp8_ = g_new0 (gchar*, 2 + 1);
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp8_[0] = _tmp6_;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp8_[1] = _tmp7_;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		group_names = _tmp8_;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		group_names_length1 = 2;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_group_names_size_ = group_names_length1;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp9_ = group_names;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp9__length1 = group_names_length1;
#line 668 "KeyBindings.c"
		{
			gchar** group_name_collection = NULL;
			gint group_name_collection_length1 = 0;
			gint _group_name_collection_size_ = 0;
			gint group_name_it = 0;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			group_name_collection = _tmp9_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			group_name_collection_length1 = _tmp9__length1;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			for (group_name_it = 0; group_name_it < _tmp9__length1; group_name_it = group_name_it + 1) {
#line 680 "KeyBindings.c"
				gchar* _tmp10_;
				gchar* group_name = NULL;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_tmp10_ = g_strdup (group_name_collection[group_name_it]);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				group_name = _tmp10_;
#line 687 "KeyBindings.c"
				{
					GKeyFile* _tmp11_;
					const gchar* _tmp12_;
					gsize _tmp13_;
					gchar** _tmp14_ = NULL;
					gchar** _tmp15_;
					gint _tmp15__length1;
					gint __tmp15__size_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp11_ = key_bindings_file;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp12_ = group_name;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp14_ = g_key_file_get_keys (_tmp11_, _tmp12_, &_tmp13_, &_inner_error_);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp15_ = _tmp14_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_tmp15__length1 = _tmp13_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					__tmp15__size_ = _tmp15__length1;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					if (_inner_error_ != NULL) {
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						_g_free0 (group_name);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						group_names = (_vala_array_free (group_names, group_names_length1, (GDestroyNotify) g_free), NULL);
#line 714 "KeyBindings.c"
						goto __catch24_g_error;
					}
					{
						gchar** key_specification_collection = NULL;
						gint key_specification_collection_length1 = 0;
						gint _key_specification_collection_size_ = 0;
						gint key_specification_it = 0;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						key_specification_collection = _tmp15_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						key_specification_collection_length1 = _tmp15__length1;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						for (key_specification_it = 0; key_specification_it < _tmp15__length1; key_specification_it = key_specification_it + 1) {
#line 728 "KeyBindings.c"
							gchar* _tmp16_;
							gchar* key_specification = NULL;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
							_tmp16_ = g_strdup (key_specification_collection[key_specification_it]);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
							key_specification = _tmp16_;
#line 735 "KeyBindings.c"
							{
								KeyBindingsKeyBinding* _tmp17_;
								KeyBindingsKeyBinding* key_binding;
								KeyBindingsKeyBinding* _tmp18_;
								const gchar* _tmp19_;
								gchar* _tmp20_;
								const gchar* _tmp21_;
								gchar* _tmp22_;
								gchar* accelerator;
								GMatchInfo* match_info = NULL;
								GRegex* _tmp23_;
								const gchar* _tmp24_;
								GMatchInfo* _tmp25_ = NULL;
								gboolean _tmp26_ = FALSE;
								const gchar* _tmp70_;
								KeyBindingsKeyBinding* _tmp71_;
								KeyBindingsKeyBinding* _tmp72_;
								guint _tmp73_ = 0U;
								GdkModifierType _tmp74_ = 0;
								GKeyFile* _tmp75_;
								const gchar* _tmp76_;
								const gchar* _tmp77_;
								gsize _tmp78_;
								gchar** _tmp79_ = NULL;
								gchar** _tmp80_;
								gint _tmp80__length1;
								gint __tmp80__size_;
								GeeList* _tmp87_;
								KeyBindingsKeyBinding* _tmp88_;
								const gchar* _tmp89_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp17_ = key_bindings_key_binding_new ();
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								key_binding = _tmp17_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp18_ = key_binding;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp19_ = key_specification;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp20_ = g_strdup (_tmp19_);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_free0 (_tmp18_->key_specification);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp18_->key_specification = _tmp20_;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp21_ = key_specification;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp22_ = g_strdup (_tmp21_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								accelerator = _tmp22_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp23_ = key_bindings_key_specification_pattern;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp24_ = key_specification;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp26_ = g_regex_match (_tmp23_, _tmp24_, 0, &_tmp25_);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_match_info_free0 (match_info);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								match_info = _tmp25_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								if (_tmp26_) {
#line 798 "KeyBindings.c"
									GMatchInfo* _tmp27_;
									gchar* _tmp28_ = NULL;
									gchar* _tmp29_;
									gchar* _tmp30_ = NULL;
									GMatchInfo* _tmp31_;
									gchar* _tmp32_ = NULL;
									gchar* _tmp33_;
									gchar** _tmp34_;
									gchar** _tmp35_ = NULL;
									gchar** _tmp36_;
									gint _tmp36__length1;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp27_ = match_info;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp28_ = g_match_info_fetch (_tmp27_, 1);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp29_ = _tmp28_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp30_ = string_strip (_tmp29_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (accelerator);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									accelerator = _tmp30_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (_tmp29_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp31_ = match_info;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp32_ = g_match_info_fetch (_tmp31_, 2);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp33_ = _tmp32_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, ";", 0);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp36_ = _tmp35_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp36__length1 = _vala_array_length (_tmp34_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (_tmp33_);
#line 838 "KeyBindings.c"
									{
										gchar** mode_specification_collection = NULL;
										gint mode_specification_collection_length1 = 0;
										gint _mode_specification_collection_size_ = 0;
										gint mode_specification_it = 0;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										mode_specification_collection = _tmp36_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										mode_specification_collection_length1 = _tmp36__length1;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										for (mode_specification_it = 0; mode_specification_it < _tmp36__length1; mode_specification_it = mode_specification_it + 1) {
#line 850 "KeyBindings.c"
											gchar* _tmp37_;
											gchar* mode_specification = NULL;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp37_ = g_strdup (mode_specification_collection[mode_specification_it]);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											mode_specification = _tmp37_;
#line 857 "KeyBindings.c"
											{
												const gchar* _tmp38_;
												gchar* _tmp39_ = NULL;
												const gchar* _tmp40_;
												gint _tmp41_;
												gint _tmp42_;
												const gchar* _tmp45_;
												gchar* _tmp46_ = NULL;
												gchar* _tmp47_;
												gboolean _tmp48_;
												gboolean negated_mode;
												gboolean _tmp49_;
												const gchar* _tmp54_;
												gchar* _tmp55_ = NULL;
												gchar* _tmp56_;
												gchar* _tmp57_;
												gchar* _tmp58_;
												gpointer _tmp59_ = NULL;
												TerminalOutputTerminalMode _tmp60_;
												TerminalOutputTerminalMode terminal_mode;
												gboolean _tmp61_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp38_ = mode_specification;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp39_ = string_strip (_tmp38_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_g_free0 (mode_specification);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												mode_specification = _tmp39_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp40_ = mode_specification;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp41_ = strlen (_tmp40_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp42_ = _tmp41_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												if (_tmp42_ == 0) {
#line 895 "KeyBindings.c"
													const gchar* _tmp43_ = NULL;
													const gchar* _tmp44_;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp43_ = _ ("Invalid key specification (empty mode): '%s'");
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp44_ = key_specification;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													g_warning (_tmp43_, _tmp44_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_g_free0 (mode_specification);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													continue;
#line 908 "KeyBindings.c"
												}
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp45_ = mode_specification;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp46_ = string_substring (_tmp45_, (glong) 0, (glong) 1);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp47_ = _tmp46_;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp48_ = g_strcmp0 (_tmp47_, "~") == 0;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_g_free0 (_tmp47_);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												negated_mode = _tmp48_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp49_ = negated_mode;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												if (_tmp49_) {
#line 926 "KeyBindings.c"
													const gchar* _tmp50_;
													gchar* _tmp51_ = NULL;
													gchar* _tmp52_;
													gchar* _tmp53_ = NULL;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp50_ = mode_specification;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp51_ = string_substring (_tmp50_, (glong) 1, (glong) (-1));
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp52_ = _tmp51_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp53_ = string_strip (_tmp52_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_g_free0 (mode_specification);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													mode_specification = _tmp53_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_g_free0 (_tmp52_);
#line 945 "KeyBindings.c"
												}
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp54_ = mode_specification;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp55_ = g_utf8_strup (_tmp54_, (gssize) (-1));
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp56_ = _tmp55_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp57_ = g_strconcat ("TERMINAL_OUTPUT_TERMINAL_MODE_", _tmp56_, NULL);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp58_ = _tmp57_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp59_ = utilities_get_enum_value_from_name (TERMINAL_OUTPUT_TYPE_TERMINAL_MODE, NULL, NULL, TERMINAL_OUTPUT_TYPE_TERMINAL_MODE, _tmp58_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp60_ = (TerminalOutputTerminalMode) ((gintptr) _tmp59_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_g_free0 (_tmp58_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_g_free0 (_tmp56_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												terminal_mode = _tmp60_;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_tmp61_ = negated_mode;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												if (_tmp61_) {
#line 971 "KeyBindings.c"
													KeyBindingsKeyBinding* _tmp62_;
													KeyBindingsKeyBinding* _tmp63_;
													TerminalOutputTerminalMode _tmp64_;
													TerminalOutputTerminalMode _tmp65_;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp62_ = key_binding;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp63_ = key_binding;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp64_ = _tmp63_->unset_terminal_modes;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp65_ = terminal_mode;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp63_->unset_terminal_modes = _tmp64_ | _tmp65_;
#line 986 "KeyBindings.c"
												} else {
													KeyBindingsKeyBinding* _tmp66_;
													KeyBindingsKeyBinding* _tmp67_;
													TerminalOutputTerminalMode _tmp68_;
													TerminalOutputTerminalMode _tmp69_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp66_ = key_binding;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp67_ = key_binding;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp68_ = _tmp67_->set_terminal_modes;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp69_ = terminal_mode;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
													_tmp67_->set_terminal_modes = _tmp68_ | _tmp69_;
#line 1002 "KeyBindings.c"
												}
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
												_g_free0 (mode_specification);
#line 1006 "KeyBindings.c"
											}
										}
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										mode_specification_collection = (_vala_array_free (mode_specification_collection, mode_specification_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1011 "KeyBindings.c"
									}
								}
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp70_ = accelerator;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp71_ = key_binding;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp72_ = key_binding;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								gtk_accelerator_parse (_tmp70_, &_tmp73_, &_tmp74_);
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp71_->key = _tmp73_;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp72_->modifiers = _tmp74_;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp75_ = key_bindings_file;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp76_ = group_name;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp77_ = key_specification;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp79_ = g_key_file_get_string_list (_tmp75_, _tmp76_, _tmp77_, &_tmp78_, &_inner_error_);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp80_ = _tmp79_;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp80__length1 = _tmp78_;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								__tmp80__size_ = _tmp80__length1;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								if (_inner_error_ != NULL) {
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_match_info_free0 (match_info);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (accelerator);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_object_unref0 (key_binding);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (key_specification);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									key_specification_collection = (_vala_array_free (key_specification_collection, key_specification_collection_length1, (GDestroyNotify) g_free), NULL);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_g_free0 (group_name);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									group_names = (_vala_array_free (group_names, group_names_length1, (GDestroyNotify) g_free), NULL);
#line 1056 "KeyBindings.c"
									goto __catch24_g_error;
								}
								{
									gchar** command_specification_collection = NULL;
									gint command_specification_collection_length1 = 0;
									gint _command_specification_collection_size_ = 0;
									gint command_specification_it = 0;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									command_specification_collection = _tmp80_;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									command_specification_collection_length1 = _tmp80__length1;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									for (command_specification_it = 0; command_specification_it < _tmp80__length1; command_specification_it = command_specification_it + 1) {
#line 1070 "KeyBindings.c"
										gchar* _tmp81_;
										gchar* command_specification = NULL;
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										_tmp81_ = g_strdup (command_specification_collection[command_specification_it]);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
										command_specification = _tmp81_;
#line 1077 "KeyBindings.c"
										{
											KeyBindingsKeyBinding* _tmp82_;
											GeeList* _tmp83_;
											const gchar* _tmp84_;
											Command* _tmp85_;
											Command* _tmp86_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp82_ = key_binding;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp83_ = _tmp82_->commands;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp84_ = command_specification;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp85_ = command_new_from_command_specification (_tmp84_);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_tmp86_ = _tmp85_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											gee_collection_add ((GeeCollection*) _tmp83_, _tmp86_);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_g_object_unref0 (_tmp86_);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
											_g_free0 (command_specification);
#line 1100 "KeyBindings.c"
										}
									}
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									command_specification_collection = (_vala_array_free (command_specification_collection, command_specification_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1105 "KeyBindings.c"
								}
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp87_ = key_bindings_key_bindings;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp88_ = key_binding;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								gee_collection_add ((GeeCollection*) _tmp87_, _tmp88_);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_tmp89_ = group_name;
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								if (g_strcmp0 (_tmp89_, "Global") == 0) {
#line 1117 "KeyBindings.c"
									const gchar* _tmp90_;
									const gchar* _tmp91_;
									gchar* _tmp92_;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp90_ = accelerator;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp91_ = key_specification;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									_tmp92_ = g_strconcat (_tmp91_, "", NULL);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
									keybinder_bind (_tmp90_, _________lambda51__keybinder_handler, _tmp92_);
#line 1129 "KeyBindings.c"
								}
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_match_info_free0 (match_info);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_free0 (accelerator);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_object_unref0 (key_binding);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
								_g_free0 (key_specification);
#line 1139 "KeyBindings.c"
							}
						}
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
						key_specification_collection = (_vala_array_free (key_specification_collection, key_specification_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1144 "KeyBindings.c"
					}
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
					_g_free0 (group_name);
#line 1148 "KeyBindings.c"
				}
			}
		}
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		group_names = (_vala_array_free (group_names, group_names_length1, (GDestroyNotify) g_free), NULL);
#line 1154 "KeyBindings.c"
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp93_ = NULL;
		const gchar* _tmp94_;
		GError* _tmp95_;
		const gchar* _tmp96_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		e = _inner_error_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_inner_error_ = NULL;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp93_ = _ ("Error in key bindings file %s: %s");
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp94_ = filename;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp95_ = e;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp96_ = _tmp95_->message;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_warning (_tmp93_, _tmp94_, _tmp96_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_error_free0 (e);
#line 1180 "KeyBindings.c"
	}
	__finally24:
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	if (_inner_error_ != NULL) {
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_key_file_free0 (key_bindings_file);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		return;
#line 1193 "KeyBindings.c"
	}
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_g_key_file_free0 (key_bindings_file);
#line 1197 "KeyBindings.c"
}


GeeList* key_bindings_get_key_commands (guint key, GdkModifierType modifiers, TerminalOutputTerminalMode terminal_modes) {
	GeeList* result = NULL;
	{
		GeeList* _tmp0_;
		GeeList* _tmp1_;
		GeeList* _key_binding_list;
		GeeList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _key_binding_size;
		gint _key_binding_index;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp0_ = key_bindings_key_bindings;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_list = _tmp1_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp2_ = _key_binding_list;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp3_ = gee_collection_get_size ((GeeCollection*) _tmp2_);
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_tmp4_ = _tmp3_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_size = _tmp4_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_key_binding_index = -1;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		while (TRUE) {
#line 1230 "KeyBindings.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GeeList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			KeyBindingsKeyBinding* key_binding;
			KeyBindingsKeyBinding* _tmp11_;
			guint _tmp12_;
			guint _tmp13_;
			KeyBindingsKeyBinding* _tmp14_;
			GdkModifierType _tmp15_;
			GdkModifierType _tmp16_;
			KeyBindingsKeyBinding* _tmp17_;
			GdkModifierType _tmp18_;
			KeyBindingsKeyBinding* _tmp19_;
			TerminalOutputTerminalMode _tmp20_;
			TerminalOutputTerminalMode _tmp21_;
			KeyBindingsKeyBinding* _tmp22_;
			TerminalOutputTerminalMode _tmp23_;
			KeyBindingsKeyBinding* _tmp24_;
			TerminalOutputTerminalMode _tmp25_;
			TerminalOutputTerminalMode _tmp26_;
			KeyBindingsKeyBinding* _tmp27_;
			GeeList* _tmp28_;
			GeeList* _tmp29_;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp5_ = _key_binding_index;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_key_binding_index = _tmp5_ + 1;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp6_ = _key_binding_index;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp7_ = _key_binding_size;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				break;
#line 1269 "KeyBindings.c"
			}
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp8_ = _key_binding_list;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp9_ = _key_binding_index;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp10_ = gee_list_get (_tmp8_, _tmp9_);
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			key_binding = (KeyBindingsKeyBinding*) _tmp10_;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp11_ = key_binding;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp12_ = _tmp11_->key;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp13_ = key;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if (_tmp12_ != _tmp13_) {
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_g_object_unref0 (key_binding);
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				continue;
#line 1291 "KeyBindings.c"
			}
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp14_ = key_binding;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp15_ = _tmp14_->modifiers;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp16_ = modifiers;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp17_ = key_binding;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp18_ = _tmp17_->modifiers;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if ((_tmp15_ & _tmp16_) != _tmp18_) {
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_g_object_unref0 (key_binding);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				continue;
#line 1309 "KeyBindings.c"
			}
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp19_ = key_binding;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp20_ = _tmp19_->set_terminal_modes;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp21_ = terminal_modes;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp22_ = key_binding;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp23_ = _tmp22_->set_terminal_modes;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if ((_tmp20_ & _tmp21_) != _tmp23_) {
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_g_object_unref0 (key_binding);
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				continue;
#line 1327 "KeyBindings.c"
			}
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp24_ = key_binding;
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp25_ = _tmp24_->unset_terminal_modes;
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp26_ = terminal_modes;
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			if ((_tmp25_ & _tmp26_) != 0) {
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				_g_object_unref0 (key_binding);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
				continue;
#line 1341 "KeyBindings.c"
			}
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp27_ = key_binding;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp28_ = _tmp27_->commands;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			result = _tmp29_;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_g_object_unref0 (key_binding);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			_g_object_unref0 (_key_binding_list);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
			return result;
#line 1357 "KeyBindings.c"
		}
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
		_g_object_unref0 (_key_binding_list);
#line 1361 "KeyBindings.c"
	}
#line 141 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	result = NULL;
#line 141 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return result;
#line 1367 "KeyBindings.c"
}


KeyBindings* key_bindings_construct (GType object_type) {
	KeyBindings * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	self = (KeyBindings*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return self;
#line 1377 "KeyBindings.c"
}


KeyBindings* key_bindings_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return key_bindings_construct (TYPE_KEY_BINDINGS);
#line 1384 "KeyBindings.c"
}


static KeyBindingsKeyBinding* key_bindings_key_binding_construct (GType object_type) {
	KeyBindingsKeyBinding * self = NULL;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	self = (KeyBindingsKeyBinding*) g_object_new (object_type, NULL);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return self;
#line 1394 "KeyBindings.c"
}


static KeyBindingsKeyBinding* key_bindings_key_binding_new (void) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	return key_bindings_key_binding_construct (KEY_BINDINGS_TYPE_KEY_BINDING);
#line 1401 "KeyBindings.c"
}


static void key_bindings_key_binding_class_init (KeyBindingsKeyBindingClass * klass) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	key_bindings_key_binding_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	G_OBJECT_CLASS (klass)->finalize = key_bindings_key_binding_finalize;
#line 1410 "KeyBindings.c"
}


static void key_bindings_key_binding_instance_init (KeyBindingsKeyBinding * self) {
	GeeArrayList* _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_tmp0_ = gee_array_list_new (TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	self->commands = (GeeList*) _tmp0_;
#line 1420 "KeyBindings.c"
}


static void key_bindings_key_binding_finalize (GObject* obj) {
	KeyBindingsKeyBinding * self;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KEY_BINDINGS_TYPE_KEY_BINDING, KeyBindingsKeyBinding);
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_g_free0 (self->key_specification);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	_g_object_unref0 (self->commands);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	G_OBJECT_CLASS (key_bindings_key_binding_parent_class)->finalize (obj);
#line 1434 "KeyBindings.c"
}


static GType key_bindings_key_binding_get_type (void) {
	static volatile gsize key_bindings_key_binding_type_id__volatile = 0;
	if (g_once_init_enter (&key_bindings_key_binding_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KeyBindingsKeyBindingClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) key_bindings_key_binding_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyBindingsKeyBinding), 0, (GInstanceInitFunc) key_bindings_key_binding_instance_init, NULL };
		GType key_bindings_key_binding_type_id;
		key_bindings_key_binding_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyBindingsKeyBinding", &g_define_type_info, 0);
		g_once_init_leave (&key_bindings_key_binding_type_id__volatile, key_bindings_key_binding_type_id);
	}
	return key_bindings_key_binding_type_id__volatile;
}


static void key_bindings_class_init (KeyBindingsClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	key_bindings_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	G_OBJECT_CLASS (klass)->finalize = key_bindings_finalize;
#line 1455 "KeyBindings.c"
}


static void key_bindings_instance_init (KeyBindings * self) {
}


static void key_bindings_finalize (GObject* obj) {
	KeyBindings * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_KEY_BINDINGS, KeyBindings);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/KeyBindings.vala"
	G_OBJECT_CLASS (key_bindings_parent_class)->finalize (obj);
#line 1469 "KeyBindings.c"
}


GType key_bindings_get_type (void) {
	static volatile gsize key_bindings_type_id__volatile = 0;
	if (g_once_init_enter (&key_bindings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KeyBindingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) key_bindings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KeyBindings), 0, (GInstanceInitFunc) key_bindings_instance_init, NULL };
		GType key_bindings_type_id;
		key_bindings_type_id = g_type_register_static (G_TYPE_OBJECT, "KeyBindings", &g_define_type_info, 0);
		g_once_init_leave (&key_bindings_type_id__volatile, key_bindings_type_id);
	}
	return key_bindings_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1488 "KeyBindings.c"
		int i;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1496 "KeyBindings.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	g_free (array);
#line 1508 "KeyBindings.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if (array) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		while (((gpointer*) array)[length]) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			length++;
#line 1521 "KeyBindings.c"
		}
	}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	return length;
#line 1526 "KeyBindings.c"
}



