/* NotifyingList.c generated by valac 0.20.1, the Vala compiler
 * generated from NotifyingList.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Drop-in replacement for ArrayList that provides notifications*/
/* for events affecting the list's contents*/
/* TODO: Only send signals if operations succeed*/
/* TODO: Make this thread-safe*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>


#define TYPE_NOTIFYING_LIST (notifying_list_get_type ())
#define NOTIFYING_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFYING_LIST, NotifyingList))
#define NOTIFYING_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFYING_LIST, NotifyingListClass))
#define IS_NOTIFYING_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFYING_LIST))
#define IS_NOTIFYING_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFYING_LIST))
#define NOTIFYING_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFYING_LIST, NotifyingListClass))

typedef struct _NotifyingList NotifyingList;
typedef struct _NotifyingListClass NotifyingListClass;
typedef struct _NotifyingListPrivate NotifyingListPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NotifyingList {
	GeeArrayList parent_instance;
	NotifyingListPrivate * priv;
};

struct _NotifyingListClass {
	GeeArrayListClass parent_class;
};

struct _NotifyingListPrivate {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
};


static gpointer notifying_list_parent_class = NULL;

GType notifying_list_get_type (void) G_GNUC_CONST;
#define NOTIFYING_LIST_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_NOTIFYING_LIST, NotifyingListPrivate))
enum  {
	NOTIFYING_LIST_DUMMY_PROPERTY,
	NOTIFYING_LIST_T_TYPE,
	NOTIFYING_LIST_T_DUP_FUNC,
	NOTIFYING_LIST_T_DESTROY_FUNC
};
static void notifying_list_real_set (GeeAbstractList* base, gint index, gconstpointer item);
static gboolean notifying_list_real_add (GeeAbstractCollection* base, gconstpointer item);
static void notifying_list_real_insert (GeeAbstractList* base, gint index, gconstpointer item);
static gboolean notifying_list_real_remove (GeeAbstractCollection* base, gconstpointer item);
static gpointer notifying_list_real_remove_at (GeeAbstractList* base, gint index);
static void notifying_list_real_clear (GeeAbstractCollection* base);
gboolean notifying_list_add_all (NotifyingList* self, GeeCollection* collection);
NotifyingList* notifying_list_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
NotifyingList* notifying_list_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
static void g_cclosure_user_marshal_VOID__INT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void _vala_notifying_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_notifying_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void notifying_list_real_set (GeeAbstractList* base, gint index, gconstpointer item) {
	NotifyingList * self;
	gint _tmp0_;
	gpointer _tmp1_ = NULL;
	gpointer old_item;
	gint _tmp2_;
	gconstpointer _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gconstpointer _tmp6_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = index;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp0_);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	old_item = _tmp1_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = index;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp3_ = item;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_LIST_CLASS (notifying_list_parent_class)->set ((GeeAbstractList*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp2_, _tmp3_);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp4_ = index;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-removed", _tmp4_, old_item);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp5_ = index;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp6_ = item;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-inserted", _tmp5_, _tmp6_);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	((old_item == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (old_item = (self->priv->t_destroy_func (old_item), NULL));
#line 124 "NotifyingList.c"
}


static gboolean notifying_list_real_add (GeeAbstractCollection* base, gconstpointer item) {
	NotifyingList * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _result_;
	gint _tmp2_;
	gint _tmp3_;
	gconstpointer _tmp4_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = item;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = GEE_ABSTRACT_COLLECTION_CLASS (notifying_list_parent_class)->add ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp0_);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_result_ = _tmp1_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp3_ = _tmp2_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp4_ = item;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-inserted", _tmp3_ - 1, _tmp4_);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	result = _result_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return result;
#line 157 "NotifyingList.c"
}


static void notifying_list_real_insert (GeeAbstractList* base, gint index, gconstpointer item) {
	NotifyingList * self;
	gint _tmp0_;
	gconstpointer _tmp1_;
	gint _tmp2_;
	gconstpointer _tmp3_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = index;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = item;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_LIST_CLASS (notifying_list_parent_class)->insert ((GeeAbstractList*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp0_, _tmp1_);
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = index;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp3_ = item;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-inserted", _tmp2_, _tmp3_);
#line 181 "NotifyingList.c"
}


static gboolean notifying_list_real_remove (GeeAbstractCollection* base, gconstpointer item) {
	NotifyingList * self;
	gboolean result = FALSE;
	gconstpointer _tmp0_;
	gint _tmp1_ = 0;
	gint index;
	gconstpointer _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _result_;
	gconstpointer _tmp4_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = item;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = gee_abstract_list_index_of ((GeeAbstractList*) self, _tmp0_);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	index = _tmp1_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = item;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp3_ = GEE_ABSTRACT_COLLECTION_CLASS (notifying_list_parent_class)->remove ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp2_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_result_ = _tmp3_;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp4_ = item;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-removed", index, _tmp4_);
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	result = _result_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return result;
#line 217 "NotifyingList.c"
}


static gpointer notifying_list_real_remove_at (GeeAbstractList* base, gint index) {
	NotifyingList * self;
	gpointer result = NULL;
	gint _tmp0_;
	gpointer _tmp1_ = NULL;
	gpointer item;
	gint _tmp2_;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = index;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = GEE_ABSTRACT_LIST_CLASS (notifying_list_parent_class)->remove_at ((GeeAbstractList*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp0_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	item = _tmp1_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = index;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_emit_by_name (self, "item-removed", _tmp2_, item);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	result = item;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return result;
#line 244 "NotifyingList.c"
}


static void notifying_list_real_clear (GeeAbstractCollection* base) {
	NotifyingList * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* items;
	GeeArrayList* _tmp1_;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) base;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = gee_array_list_new (self->priv->t_type, (GBoxedCopyFunc) self->priv->t_dup_func, self->priv->t_destroy_func, NULL, NULL, NULL);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	items = _tmp0_;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = items;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	gee_array_list_add_all (_tmp1_, (GeeCollection*) self);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_COLLECTION_CLASS (notifying_list_parent_class)->clear ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList));
#line 265 "NotifyingList.c"
	{
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint i;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_tmp2_ = items;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_tmp4_ = _tmp3_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		i = _tmp4_ - 1;
#line 279 "NotifyingList.c"
		{
			gboolean _tmp5_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp5_ = TRUE;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			while (TRUE) {
#line 286 "NotifyingList.c"
				gboolean _tmp6_;
				gint _tmp8_;
				gint _tmp9_;
				GeeArrayList* _tmp10_;
				gint _tmp11_;
				gpointer _tmp12_ = NULL;
				gpointer _tmp13_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp6_ = _tmp5_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				if (!_tmp6_) {
#line 298 "NotifyingList.c"
					gint _tmp7_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
					_tmp7_ = i;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
					i = _tmp7_ - 1;
#line 304 "NotifyingList.c"
				}
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp5_ = FALSE;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp8_ = i;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				if (!(_tmp8_ >= 0)) {
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
					break;
#line 314 "NotifyingList.c"
				}
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp9_ = i;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp10_ = items;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp11_ = i;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _tmp11_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				_tmp13_ = _tmp12_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				g_signal_emit_by_name (self, "item-removed", _tmp9_, _tmp13_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				((_tmp13_ == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (_tmp13_ = (self->priv->t_destroy_func (_tmp13_), NULL));
#line 330 "NotifyingList.c"
			}
		}
	}
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_g_object_unref0 (items);
#line 336 "NotifyingList.c"
}


gboolean notifying_list_add_all (NotifyingList* self, GeeCollection* collection) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gint original_size;
	GeeCollection* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _result_;
	gint i;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_return_val_if_fail (collection != NULL, FALSE);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp0_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp1_ = _tmp0_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	original_size = _tmp1_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp2_ = collection;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_tmp3_ = gee_array_list_add_all (G_TYPE_CHECK_INSTANCE_CAST (self, GEE_TYPE_ARRAY_LIST, GeeArrayList), _tmp2_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	_result_ = _tmp3_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	i = 0;
#line 367 "NotifyingList.c"
	{
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _item_it;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_tmp4_ = collection;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_item_it = _tmp5_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		while (TRUE) {
#line 380 "NotifyingList.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			gpointer item;
			gint _tmp10_;
			gint _tmp11_;
			gconstpointer _tmp12_;
			gint _tmp13_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp6_ = _item_it;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			if (!_tmp7_) {
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
				break;
#line 398 "NotifyingList.c"
			}
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp8_ = _item_it;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			item = _tmp9_;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp10_ = original_size;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp11_ = i;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp12_ = item;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			g_signal_emit_by_name (self, "item-inserted", _tmp10_ + _tmp11_, _tmp12_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			_tmp13_ = i;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			i = _tmp13_ + 1;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
			((item == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (item = (self->priv->t_destroy_func (item), NULL));
#line 420 "NotifyingList.c"
		}
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		_g_object_unref0 (_item_it);
#line 424 "NotifyingList.c"
	}
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	result = _result_;
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return result;
#line 430 "NotifyingList.c"
}


NotifyingList* notifying_list_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
	NotifyingList * self = NULL;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self = (NotifyingList*) gee_array_list_construct (object_type, t_type, (GBoxedCopyFunc) t_dup_func, t_destroy_func, NULL, NULL, NULL);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self->priv->t_type = t_type;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self->priv->t_dup_func = t_dup_func;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self->priv->t_destroy_func = t_destroy_func;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return self;
#line 446 "NotifyingList.c"
}


NotifyingList* notifying_list_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	return notifying_list_construct (TYPE_NOTIFYING_LIST, t_type, t_dup_func, t_destroy_func);
#line 453 "NotifyingList.c"
}


static void g_cclosure_user_marshal_VOID__INT_POINTER (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_POINTER) (gpointer data1, gint arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_return_if_fail (n_param_values == 3);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		data1 = closure->data;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		data2 = param_values->data[0].v_pointer;
#line 472 "NotifyingList.c"
	} else {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		data1 = param_values->data[0].v_pointer;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		data2 = closure->data;
#line 478 "NotifyingList.c"
	}
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	callback = (GMarshalFunc_VOID__INT_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 484 "NotifyingList.c"
}


static void notifying_list_class_init (NotifyingListClass * klass) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	notifying_list_parent_class = g_type_class_peek_parent (klass);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_type_class_add_private (klass, sizeof (NotifyingListPrivate));
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_LIST_CLASS (klass)->set = notifying_list_real_set;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->add = notifying_list_real_add;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_LIST_CLASS (klass)->insert = notifying_list_real_insert;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->remove = notifying_list_real_remove;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_LIST_CLASS (klass)->remove_at = notifying_list_real_remove_at;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	GEE_ABSTRACT_COLLECTION_CLASS (klass)->clear = notifying_list_real_clear;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_notifying_list_get_property;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_notifying_list_set_property;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFYING_LIST_T_TYPE, g_param_spec_gtype ("t-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFYING_LIST_T_DUP_FUNC, g_param_spec_pointer ("t-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOTIFYING_LIST_T_DESTROY_FUNC, g_param_spec_pointer ("t-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_new ("item_inserted", TYPE_NOTIFYING_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_POINTER, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_POINTER);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_new ("item_removed", TYPE_NOTIFYING_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_POINTER, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_POINTER);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	g_signal_new ("item_modified", TYPE_NOTIFYING_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_POINTER, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_POINTER);
#line 521 "NotifyingList.c"
}


static void notifying_list_instance_init (NotifyingList * self) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	self->priv = NOTIFYING_LIST_GET_PRIVATE (self);
#line 528 "NotifyingList.c"
}


GType notifying_list_get_type (void) {
	static volatile gsize notifying_list_type_id__volatile = 0;
	if (g_once_init_enter (&notifying_list_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NotifyingListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifying_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotifyingList), 0, (GInstanceInitFunc) notifying_list_instance_init, NULL };
		GType notifying_list_type_id;
		notifying_list_type_id = g_type_register_static (GEE_TYPE_ARRAY_LIST, "NotifyingList", &g_define_type_info, 0);
		g_once_init_leave (&notifying_list_type_id__volatile, notifying_list_type_id);
	}
	return notifying_list_type_id__volatile;
}


static void _vala_notifying_list_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NotifyingList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NOTIFYING_LIST, NotifyingList);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	switch (property_id) {
#line 549 "NotifyingList.c"
		default:
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		break;
#line 555 "NotifyingList.c"
	}
}


static void _vala_notifying_list_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NotifyingList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NOTIFYING_LIST, NotifyingList);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
	switch (property_id) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		case NOTIFYING_LIST_T_TYPE:
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		self->priv->t_type = g_value_get_gtype (value);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		break;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		case NOTIFYING_LIST_T_DUP_FUNC:
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		self->priv->t_dup_func = g_value_get_pointer (value);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		break;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		case NOTIFYING_LIST_T_DESTROY_FUNC:
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		self->priv->t_destroy_func = g_value_get_pointer (value);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		break;
#line 583 "NotifyingList.c"
		default:
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/NotifyingList.vala"
		break;
#line 589 "NotifyingList.c"
	}
}



