/* Settings.c generated by valac 0.20.1, the Vala compiler
 * generated from Settings.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <pango/pango.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define TYPE_SETTINGS (settings_get_type ())
#define SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS, Settings))
#define SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS, SettingsClass))
#define IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS))
#define IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS))
#define SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS, SettingsClass))

typedef struct _Settings Settings;
typedef struct _SettingsClass SettingsClass;
typedef struct _SettingsPrivate SettingsPrivate;

#define TYPE_COLOR_SCHEME (color_scheme_get_type ())
#define COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_SCHEME, ColorScheme))
#define COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_SCHEME, ColorSchemeClass))
#define IS_COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_SCHEME))
#define IS_COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_SCHEME))
#define COLOR_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_SCHEME, ColorSchemeClass))

typedef struct _ColorScheme ColorScheme;
typedef struct _ColorSchemeClass ColorSchemeClass;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))

struct _Settings {
	GObject parent_instance;
	SettingsPrivate * priv;
};

struct _SettingsClass {
	GObjectClass parent_class;
};

struct _SettingsPrivate {
	GSettings* _settings;
	gboolean _dark;
	gdouble _opacity;
	gchar* _color_scheme_name;
	ColorScheme* _color_scheme;
	ClutterColor _foreground_color;
	ClutterColor _background_color;
	gchar* _theme_name;
	Theme* _theme;
	gchar* _terminal_font_name;
	PangoFontDescription* _terminal_font;
	gint _character_width;
	gint _character_height;
	gchar* _label_font_name;
	PangoFontDescription* _label_font;
	gint _terminal_lines;
	gint _terminal_columns;
	gchar* _shell_path;
	gchar** _shell_arguments;
	gint _shell_arguments_length1;
	gint __shell_arguments_size_;
	gchar* _emulated_terminal;
	gint _render_interval;
	gboolean _case_sensitive_autocompletion;
};


static gpointer settings_parent_class = NULL;
static Settings* settings_instance;
static Settings* settings_instance = NULL;
extern GeeMap* final_term_color_schemes;
extern GeeMap* final_term_themes;

GType settings_get_type (void) G_GNUC_CONST;
GType color_scheme_get_type (void) G_GNUC_CONST;
GType theme_get_type (void) G_GNUC_CONST;
#define SETTINGS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SETTINGS, SettingsPrivate))
enum  {
	SETTINGS_DUMMY_PROPERTY,
	SETTINGS_DARK,
	SETTINGS_OPACITY,
	SETTINGS_COLOR_SCHEME_NAME,
	SETTINGS_COLOR_SCHEME,
	SETTINGS_FOREGROUND_COLOR,
	SETTINGS_BACKGROUND_COLOR,
	SETTINGS_THEME_NAME,
	SETTINGS_THEME,
	SETTINGS_TERMINAL_FONT_NAME,
	SETTINGS_TERMINAL_FONT,
	SETTINGS_CHARACTER_WIDTH,
	SETTINGS_CHARACTER_HEIGHT,
	SETTINGS_LABEL_FONT_NAME,
	SETTINGS_LABEL_FONT,
	SETTINGS_TERMINAL_LINES,
	SETTINGS_TERMINAL_COLUMNS,
	SETTINGS_SHELL_PATH,
	SETTINGS_SHELL_ARGUMENTS,
	SETTINGS_EMULATED_TERMINAL,
	SETTINGS_RENDER_INTERVAL,
	SETTINGS_CASE_SENSITIVE_AUTOCOMPLETION
};
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void settings_update_cache (Settings* self);
static GSettings* settings_get_settings (Settings* self);
const gchar* settings_get_color_scheme_name (Settings* self);
ColorScheme* settings_get_color_scheme (Settings* self);
void color_scheme_get_foreground_color (ColorScheme* self, gboolean dark, ClutterColor* result);
gboolean settings_get_dark (Settings* self);
void color_scheme_get_background_color (ColorScheme* self, gboolean dark, ClutterColor* result);
const gchar* settings_get_theme_name (Settings* self);
const gchar* settings_get_terminal_font_name (Settings* self);
void utilities_get_text_size (PangoFontDescription* font, const gchar* text, gint* width, gint* height);
PangoFontDescription* settings_get_terminal_font (Settings* self);
const gchar* settings_get_label_font_name (Settings* self);
void settings_load_from_schema (const gchar* schema_name);
Settings* settings_new (void);
Settings* settings_construct (GType object_type);
static void settings_set_settings (Settings* self, GSettings* value);
static void __lambda6_ (const gchar* key);
static void ___lambda6__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self);
Settings* settings_get_default (void);
void settings_set_dark (Settings* self, gboolean value);
gdouble settings_get_opacity (Settings* self);
void settings_set_opacity (Settings* self, gdouble value);
void settings_set_color_scheme_name (Settings* self, const gchar* value);
void settings_get_foreground_color (Settings* self, ClutterColor* result);
void settings_get_background_color (Settings* self, ClutterColor* result);
void settings_set_theme_name (Settings* self, const gchar* value);
Theme* settings_get_theme (Settings* self);
void settings_set_terminal_font_name (Settings* self, const gchar* value);
gint settings_get_character_width (Settings* self);
gint settings_get_character_height (Settings* self);
void settings_set_label_font_name (Settings* self, const gchar* value);
PangoFontDescription* settings_get_label_font (Settings* self);
gint settings_get_terminal_lines (Settings* self);
void settings_set_terminal_lines (Settings* self, gint value);
gint settings_get_terminal_columns (Settings* self);
void settings_set_terminal_columns (Settings* self, gint value);
const gchar* settings_get_shell_path (Settings* self);
void settings_set_shell_path (Settings* self, const gchar* value);
gchar** settings_get_shell_arguments (Settings* self, int* result_length1);
void settings_set_shell_arguments (Settings* self, gchar** value, int value_length1);
const gchar* settings_get_emulated_terminal (Settings* self);
void settings_set_emulated_terminal (Settings* self, const gchar* value);
gint settings_get_render_interval (Settings* self);
void settings_set_render_interval (Settings* self, gint value);
gboolean settings_get_case_sensitive_autocompletion (Settings* self);
void settings_set_case_sensitive_autocompletion (Settings* self, gboolean value);
static void settings_finalize (GObject* obj);
static void _vala_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static void _vala_PangoFontDescription_free (PangoFontDescription* self) {
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 203 "Settings.c"
}


static void settings_update_cache (Settings* self) {
	GSettings* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GSettings* _tmp2_;
	gdouble _tmp3_ = 0.0;
	GSettings* _tmp4_;
	gchar* _tmp5_ = NULL;
	GeeMap* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp9_ = NULL;
	ColorScheme* _tmp10_;
	ColorScheme* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	ClutterColor _tmp14_ = {0};
	ColorScheme* _tmp15_;
	ColorScheme* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	ClutterColor _tmp19_ = {0};
	GSettings* _tmp20_;
	gchar* _tmp21_ = NULL;
	GeeMap* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	gpointer _tmp25_ = NULL;
	GSettings* _tmp26_;
	gchar* _tmp27_ = NULL;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	PangoFontDescription* _tmp30_ = NULL;
	PangoFontDescription* _tmp31_;
	PangoFontDescription* _tmp32_;
	gint _tmp33_ = 0;
	gint _tmp34_ = 0;
	GSettings* _tmp35_;
	gchar* _tmp36_ = NULL;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	PangoFontDescription* _tmp39_ = NULL;
	GSettings* _tmp40_;
	gint _tmp41_ = 0;
	GSettings* _tmp42_;
	gint _tmp43_ = 0;
	GSettings* _tmp44_;
	gchar* _tmp45_ = NULL;
	GSettings* _tmp46_;
	gchar** _tmp47_;
	gchar** _tmp48_ = NULL;
	GSettings* _tmp49_;
	gchar* _tmp50_ = NULL;
	GSettings* _tmp51_;
	gint _tmp52_ = 0;
	GSettings* _tmp53_;
	gboolean _tmp54_ = FALSE;
#line 147 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = g_settings_get_boolean (_tmp0_, "dark");
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_dark = _tmp1_;
#line 150 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp2_ = self->priv->_settings;
#line 150 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp3_ = g_settings_get_double (_tmp2_, "opacity");
#line 150 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_opacity = _tmp3_;
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp4_ = self->priv->_settings;
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp5_ = g_settings_get_string (_tmp4_, "color-scheme");
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_color_scheme_name);
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_color_scheme_name = _tmp5_;
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp6_ = final_term_color_schemes;
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp7_ = settings_get_color_scheme_name (self);
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp8_ = _tmp7_;
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp9_ = gee_map_get (_tmp6_, _tmp8_);
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_color_scheme);
#line 153 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_color_scheme = (ColorScheme*) _tmp9_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp10_ = settings_get_color_scheme (self);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp11_ = _tmp10_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp12_ = settings_get_dark (self);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp13_ = _tmp12_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	color_scheme_get_foreground_color (_tmp11_, _tmp13_, &_tmp14_);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_foreground_color = _tmp14_;
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp15_ = settings_get_color_scheme (self);
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp16_ = _tmp15_;
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp17_ = settings_get_dark (self);
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp18_ = _tmp17_;
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	color_scheme_get_background_color (_tmp16_, _tmp18_, &_tmp19_);
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_background_color = _tmp19_;
#line 157 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp20_ = self->priv->_settings;
#line 157 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp21_ = g_settings_get_string (_tmp20_, "theme");
#line 157 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_theme_name);
#line 157 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_theme_name = _tmp21_;
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp22_ = final_term_themes;
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp23_ = settings_get_theme_name (self);
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp24_ = _tmp23_;
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp25_ = gee_map_get (_tmp22_, _tmp24_);
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_theme);
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_theme = (Theme*) _tmp25_;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp26_ = self->priv->_settings;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp27_ = g_settings_get_string (_tmp26_, "terminal-font");
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_terminal_font_name);
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_terminal_font_name = _tmp27_;
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp28_ = settings_get_terminal_font_name (self);
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp29_ = _tmp28_;
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp30_ = pango_font_description_from_string (_tmp29_);
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	__vala_PangoFontDescription_free0 (self->priv->_terminal_font);
#line 161 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_terminal_font = _tmp30_;
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp31_ = settings_get_terminal_font (self);
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp32_ = _tmp31_;
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	utilities_get_text_size (_tmp32_, "X", &_tmp33_, &_tmp34_);
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_character_width = _tmp33_;
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_character_height = _tmp34_;
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp35_ = self->priv->_settings;
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp36_ = g_settings_get_string (_tmp35_, "label-font");
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_label_font_name);
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_label_font_name = _tmp36_;
#line 167 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp37_ = settings_get_label_font_name (self);
#line 167 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp38_ = _tmp37_;
#line 167 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp39_ = pango_font_description_from_string (_tmp38_);
#line 167 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	__vala_PangoFontDescription_free0 (self->priv->_label_font);
#line 167 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_label_font = _tmp39_;
#line 169 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp40_ = self->priv->_settings;
#line 169 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp41_ = g_settings_get_int (_tmp40_, "terminal-lines");
#line 169 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_terminal_lines = _tmp41_;
#line 170 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp42_ = self->priv->_settings;
#line 170 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp43_ = g_settings_get_int (_tmp42_, "terminal-columns");
#line 170 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_terminal_columns = _tmp43_;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp44_ = self->priv->_settings;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp45_ = g_settings_get_string (_tmp44_, "shell-path");
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_shell_path);
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_shell_path = _tmp45_;
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp46_ = self->priv->_settings;
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp48_ = _tmp47_ = g_settings_get_strv (_tmp46_, "shell-arguments");
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_shell_arguments = (_vala_array_free (self->priv->_shell_arguments, self->priv->_shell_arguments_length1, (GDestroyNotify) g_free), NULL);
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_shell_arguments = _tmp48_;
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_shell_arguments_length1 = _vala_array_length (_tmp47_);
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->__shell_arguments_size_ = self->priv->_shell_arguments_length1;
#line 175 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp49_ = self->priv->_settings;
#line 175 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp50_ = g_settings_get_string (_tmp49_, "emulated-terminal");
#line 175 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_emulated_terminal);
#line 175 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_emulated_terminal = _tmp50_;
#line 177 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp51_ = self->priv->_settings;
#line 177 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp52_ = g_settings_get_int (_tmp51_, "render-interval");
#line 177 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_render_interval = _tmp52_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp53_ = self->priv->_settings;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp54_ = g_settings_get_boolean (_tmp53_, "case-sensitive-autocompletion");
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_case_sensitive_autocompletion = _tmp54_;
#line 439 "Settings.c"
}


static void __lambda6_ (const gchar* key) {
	Settings* _tmp0_;
	Settings* _tmp1_;
	const gchar* _tmp2_;
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (key != NULL);
#line 191 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = settings_instance;
#line 191 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	settings_update_cache (_tmp0_);
#line 192 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = settings_instance;
#line 192 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp2_ = key;
#line 192 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_signal_emit_by_name (_tmp1_, "changed", _tmp2_);
#line 459 "Settings.c"
}


static void ___lambda6__g_settings_changed (GSettings* _sender, const gchar* key, gpointer self) {
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	__lambda6_ (key);
#line 466 "Settings.c"
}


void settings_load_from_schema (const gchar* schema_name) {
	Settings* _tmp0_;
	Settings* _tmp2_;
	const gchar* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	Settings* _tmp6_;
	Settings* _tmp7_;
	GSettings* _tmp8_;
#line 182 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (schema_name != NULL);
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = settings_instance;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	if (_tmp0_ == NULL) {
#line 485 "Settings.c"
		Settings* _tmp1_;
#line 184 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		_tmp1_ = settings_new ();
#line 184 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		_g_object_unref0 (settings_instance);
#line 184 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_instance = _tmp1_;
#line 493 "Settings.c"
	}
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp2_ = settings_instance;
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp3_ = schema_name;
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp4_ = g_settings_new (_tmp3_);
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp5_ = _tmp4_;
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	settings_set_settings (_tmp2_, _tmp5_);
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (_tmp5_);
#line 188 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp6_ = settings_instance;
#line 188 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	settings_update_cache (_tmp6_);
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp7_ = settings_instance;
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp8_ = _tmp7_->priv->_settings;
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_signal_connect (_tmp8_, "changed", (GCallback) ___lambda6__g_settings_changed, NULL);
#line 517 "Settings.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return self ? g_object_ref (self) : NULL;
#line 524 "Settings.c"
}


Settings* settings_get_default (void) {
	Settings* result = NULL;
	Settings* _tmp0_;
	Settings* _tmp2_;
	Settings* _tmp3_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = settings_instance;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	if (_tmp0_ == NULL) {
#line 537 "Settings.c"
		const gchar* _tmp1_ = NULL;
#line 198 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		_tmp1_ = _ ("No Settings instance available yet");
#line 198 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_error ("Settings.vala:198: %s", _tmp1_);
#line 543 "Settings.c"
	}
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp2_ = settings_instance;
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp3_;
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 553 "Settings.c"
}


Settings* settings_construct (GType object_type) {
	Settings * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self = (Settings*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return self;
#line 563 "Settings.c"
}


Settings* settings_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return settings_construct (TYPE_SETTINGS);
#line 570 "Settings.c"
}


static GSettings* settings_get_settings (Settings* self) {
	GSettings* result;
	GSettings* _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 585 "Settings.c"
}


static void settings_set_settings (Settings* self, GSettings* value) {
	GSettings* _tmp0_;
	GSettings* _tmp1_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = value;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_settings);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_settings = _tmp1_;
#line 602 "Settings.c"
}


gboolean settings_get_dark (Settings* self) {
	gboolean result;
	gboolean _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_dark;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 617 "Settings.c"
}


void settings_set_dark (Settings* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_boolean (_tmp0_, "dark", _tmp1_);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "dark");
#line 634 "Settings.c"
}


gdouble settings_get_opacity (Settings* self) {
	gdouble result;
	gdouble _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_opacity;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 649 "Settings.c"
}


void settings_set_opacity (Settings* self, gdouble value) {
	GSettings* _tmp0_;
	gdouble _tmp1_;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_double (_tmp0_, "opacity", _tmp1_);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "opacity");
#line 666 "Settings.c"
}


const gchar* settings_get_color_scheme_name (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_color_scheme_name;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 681 "Settings.c"
}


void settings_set_color_scheme_name (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "color-scheme", _tmp1_);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "color-scheme-name");
#line 698 "Settings.c"
}


ColorScheme* settings_get_color_scheme (Settings* self) {
	ColorScheme* result;
	ColorScheme* _tmp0_;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_color_scheme;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 713 "Settings.c"
}


void settings_get_foreground_color (Settings* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_foreground_color;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	*result = _tmp0_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return;
#line 727 "Settings.c"
}


void settings_get_background_color (Settings* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_background_color;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	*result = _tmp0_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return;
#line 741 "Settings.c"
}


const gchar* settings_get_theme_name (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_theme_name;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 756 "Settings.c"
}


void settings_set_theme_name (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "theme", _tmp1_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "theme-name");
#line 773 "Settings.c"
}


Theme* settings_get_theme (Settings* self) {
	Theme* result;
	Theme* _tmp0_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_theme;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 788 "Settings.c"
}


const gchar* settings_get_terminal_font_name (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_terminal_font_name;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 803 "Settings.c"
}


void settings_set_terminal_font_name (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "terminal-font", _tmp1_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "terminal-font-name");
#line 820 "Settings.c"
}


PangoFontDescription* settings_get_terminal_font (Settings* self) {
	PangoFontDescription* result;
	PangoFontDescription* _tmp0_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_terminal_font;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 835 "Settings.c"
}


gint settings_get_character_width (Settings* self) {
	gint result;
	gint _tmp0_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_character_width;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 850 "Settings.c"
}


gint settings_get_character_height (Settings* self) {
	gint result;
	gint _tmp0_;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_character_height;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 865 "Settings.c"
}


const gchar* settings_get_label_font_name (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_label_font_name;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 880 "Settings.c"
}


void settings_set_label_font_name (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "label-font", _tmp1_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "label-font-name");
#line 897 "Settings.c"
}


PangoFontDescription* settings_get_label_font (Settings* self) {
	PangoFontDescription* result;
	PangoFontDescription* _tmp0_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_label_font;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 912 "Settings.c"
}


gint settings_get_terminal_lines (Settings* self) {
	gint result;
	gint _tmp0_;
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_terminal_lines;
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 927 "Settings.c"
}


void settings_set_terminal_lines (Settings* self, gint value) {
	GSettings* _tmp0_;
	gint _tmp1_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_int (_tmp0_, "terminal-lines", _tmp1_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "terminal-lines");
#line 944 "Settings.c"
}


gint settings_get_terminal_columns (Settings* self) {
	gint result;
	gint _tmp0_;
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_terminal_columns;
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 959 "Settings.c"
}


void settings_set_terminal_columns (Settings* self, gint value) {
	GSettings* _tmp0_;
	gint _tmp1_;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_int (_tmp0_, "terminal-columns", _tmp1_);
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "terminal-columns");
#line 976 "Settings.c"
}


const gchar* settings_get_shell_path (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_shell_path;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 991 "Settings.c"
}


void settings_set_shell_path (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "shell-path", _tmp1_);
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "shell-path");
#line 1008 "Settings.c"
}


gchar** settings_get_shell_arguments (Settings* self, int* result_length1) {
	gchar** result;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_shell_arguments;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0__length1 = self->priv->_shell_arguments_length1;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = _tmp0_;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1__length1 = _tmp0__length1;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	if (result_length1) {
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		*result_length1 = _tmp1__length1;
#line 1032 "Settings.c"
	}
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp1_;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 1038 "Settings.c"
}


void settings_set_shell_arguments (Settings* self, gchar** value, int value_length1) {
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1__length1 = value_length1;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_strv (_tmp0_, "shell-arguments", _tmp1_);
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "shell-arguments");
#line 1058 "Settings.c"
}


const gchar* settings_get_emulated_terminal (Settings* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_emulated_terminal;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 131 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 1073 "Settings.c"
}


void settings_set_emulated_terminal (Settings* self, const gchar* value) {
	GSettings* _tmp0_;
	const gchar* _tmp1_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_string (_tmp0_, "emulated-terminal", _tmp1_);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "emulated-terminal");
#line 1090 "Settings.c"
}


gint settings_get_render_interval (Settings* self) {
	gint result;
	gint _tmp0_;
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_render_interval;
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 1105 "Settings.c"
}


void settings_set_render_interval (Settings* self, gint value) {
	GSettings* _tmp0_;
	gint _tmp1_;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_int (_tmp0_, "render-interval", _tmp1_);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "render-interval");
#line 1122 "Settings.c"
}


gboolean settings_get_case_sensitive_autocompletion (Settings* self) {
	gboolean result;
	gboolean _tmp0_;
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_case_sensitive_autocompletion;
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	result = _tmp0_;
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	return result;
#line 1137 "Settings.c"
}


void settings_set_case_sensitive_autocompletion (Settings* self, gboolean value) {
	GSettings* _tmp0_;
	gboolean _tmp1_;
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_return_if_fail (self != NULL);
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp0_ = self->priv->_settings;
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_tmp1_ = value;
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_settings_set_boolean (_tmp0_, "case-sensitive-autocompletion", _tmp1_);
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_notify ((GObject *) self, "case-sensitive-autocompletion");
#line 1154 "Settings.c"
}


static void settings_class_init (SettingsClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	settings_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_type_class_add_private (klass, sizeof (SettingsPrivate));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_settings_get_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_settings_set_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	G_OBJECT_CLASS (klass)->finalize = settings_finalize;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_DARK, g_param_spec_boolean ("dark", "dark", "dark", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_OPACITY, g_param_spec_double ("opacity", "opacity", "opacity", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_COLOR_SCHEME_NAME, g_param_spec_string ("color-scheme-name", "color-scheme-name", "color-scheme-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_COLOR_SCHEME, g_param_spec_object ("color-scheme", "color-scheme", "color-scheme", TYPE_COLOR_SCHEME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_FOREGROUND_COLOR, g_param_spec_boxed ("foreground-color", "foreground-color", "foreground-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_BACKGROUND_COLOR, g_param_spec_boxed ("background-color", "background-color", "background-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_THEME_NAME, g_param_spec_string ("theme-name", "theme-name", "theme-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_THEME, g_param_spec_object ("theme", "theme", "theme", TYPE_THEME, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_TERMINAL_FONT_NAME, g_param_spec_string ("terminal-font-name", "terminal-font-name", "terminal-font-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_TERMINAL_FONT, g_param_spec_boxed ("terminal-font", "terminal-font", "terminal-font", pango_font_description_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_CHARACTER_WIDTH, g_param_spec_int ("character-width", "character-width", "character-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_CHARACTER_HEIGHT, g_param_spec_int ("character-height", "character-height", "character-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_LABEL_FONT_NAME, g_param_spec_string ("label-font-name", "label-font-name", "label-font-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_LABEL_FONT, g_param_spec_boxed ("label-font", "label-font", "label-font", pango_font_description_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_TERMINAL_LINES, g_param_spec_int ("terminal-lines", "terminal-lines", "terminal-lines", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_TERMINAL_COLUMNS, g_param_spec_int ("terminal-columns", "terminal-columns", "terminal-columns", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_SHELL_PATH, g_param_spec_string ("shell-path", "shell-path", "shell-path", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_SHELL_ARGUMENTS, g_param_spec_boxed ("shell-arguments", "shell-arguments", "shell-arguments", G_TYPE_STRV, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_EMULATED_TERMINAL, g_param_spec_string ("emulated-terminal", "emulated-terminal", "emulated-terminal", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_RENDER_INTERVAL, g_param_spec_int ("render-interval", "render-interval", "render-interval", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SETTINGS_CASE_SENSITIVE_AUTOCOMPLETION, g_param_spec_boolean ("case-sensitive-autocompletion", "case-sensitive-autocompletion", "case-sensitive-autocompletion", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	g_signal_new ("changed", TYPE_SETTINGS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 1213 "Settings.c"
}


static void settings_instance_init (Settings * self) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv = SETTINGS_GET_PRIVATE (self);
#line 1220 "Settings.c"
}


static void settings_finalize (GObject* obj) {
	Settings * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SETTINGS, Settings);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_settings);
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_color_scheme_name);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_color_scheme);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_theme_name);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_object_unref0 (self->priv->_theme);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_terminal_font_name);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	__vala_PangoFontDescription_free0 (self->priv->_terminal_font);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_label_font_name);
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	__vala_PangoFontDescription_free0 (self->priv->_label_font);
#line 117 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_shell_path);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	self->priv->_shell_arguments = (_vala_array_free (self->priv->_shell_arguments, self->priv->_shell_arguments_length1, (GDestroyNotify) g_free), NULL);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	_g_free0 (self->priv->_emulated_terminal);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	G_OBJECT_CLASS (settings_parent_class)->finalize (obj);
#line 1254 "Settings.c"
}


GType settings_get_type (void) {
	static volatile gsize settings_type_id__volatile = 0;
	if (g_once_init_enter (&settings_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SettingsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Settings), 0, (GInstanceInitFunc) settings_instance_init, NULL };
		GType settings_type_id;
		settings_type_id = g_type_register_static (G_TYPE_OBJECT, "Settings", &g_define_type_info, 0);
		g_once_init_leave (&settings_type_id__volatile, settings_type_id);
	}
	return settings_type_id__volatile;
}


static void _vala_settings_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Settings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SETTINGS, Settings);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_DARK:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_boolean (value, settings_get_dark (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_double (value, settings_get_opacity (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_COLOR_SCHEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_color_scheme_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_COLOR_SCHEME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_object (value, settings_get_color_scheme (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_FOREGROUND_COLOR:
#line 1301 "Settings.c"
		{
			ClutterColor boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			settings_get_foreground_color (self, &boxed);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			g_value_set_boxed (value, &boxed);
#line 1308 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_BACKGROUND_COLOR:
#line 1314 "Settings.c"
		{
			ClutterColor boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			settings_get_background_color (self, &boxed);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			g_value_set_boxed (value, &boxed);
#line 1321 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_THEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_theme_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_THEME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_object (value, settings_get_theme (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_FONT_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_terminal_font_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_FONT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_boxed (value, settings_get_terminal_font (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_CHARACTER_WIDTH:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_int (value, settings_get_character_width (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_CHARACTER_HEIGHT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_int (value, settings_get_character_height (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_LABEL_FONT_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_label_font_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_LABEL_FONT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_boxed (value, settings_get_label_font (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_LINES:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_int (value, settings_get_terminal_lines (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_COLUMNS:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_int (value, settings_get_terminal_columns (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_SHELL_PATH:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_shell_path (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_SHELL_ARGUMENTS:
#line 1393 "Settings.c"
		{
			int length;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			g_value_set_boxed (value, settings_get_shell_arguments (self, &length));
#line 1398 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_EMULATED_TERMINAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_string (value, settings_get_emulated_terminal (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_RENDER_INTERVAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_int (value, settings_get_render_interval (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_CASE_SENSITIVE_AUTOCOMPLETION:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		g_value_set_boolean (value, settings_get_case_sensitive_autocompletion (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 1420 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 1426 "Settings.c"
	}
}


static void _vala_settings_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Settings * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SETTINGS, Settings);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_DARK:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_dark (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_opacity (self, g_value_get_double (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_COLOR_SCHEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_color_scheme_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_THEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_theme_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_FONT_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_terminal_font_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_LABEL_FONT_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_label_font_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_LINES:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_terminal_lines (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_TERMINAL_COLUMNS:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_terminal_columns (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_SHELL_PATH:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_shell_path (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_SHELL_ARGUMENTS:
#line 1492 "Settings.c"
		{
			gpointer boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			boxed = g_value_get_boxed (value);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
			settings_set_shell_arguments (self, boxed, g_strv_length (boxed));
#line 1499 "Settings.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_EMULATED_TERMINAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_emulated_terminal (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_RENDER_INTERVAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_render_interval (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		case SETTINGS_CASE_SENSITIVE_AUTOCOMPLETION:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		settings_set_case_sensitive_autocompletion (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 1521 "Settings.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Settings.vala"
		break;
#line 1527 "Settings.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1535 "Settings.c"
		int i;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1543 "Settings.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	g_free (array);
#line 1555 "Settings.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if (array) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		while (((gpointer*) array)[length]) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			length++;
#line 1568 "Settings.c"
		}
	}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	return length;
#line 1573 "Settings.c"
}



