/* SettingsWindow.c generated by valac 0.20.1, the Vala compiler
 * generated from SettingsWindow.vala, do not modify */

/*
 * Copyright © 2013–2014 Tom Beckmann <tomjonabc@gmail.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_SETTINGS_WINDOW (settings_window_get_type ())
#define SETTINGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS_WINDOW, SettingsWindow))
#define SETTINGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS_WINDOW, SettingsWindowClass))
#define IS_SETTINGS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS_WINDOW))
#define IS_SETTINGS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS_WINDOW))
#define SETTINGS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS_WINDOW, SettingsWindowClass))

typedef struct _SettingsWindow SettingsWindow;
typedef struct _SettingsWindowClass SettingsWindowClass;
typedef struct _SettingsWindowPrivate SettingsWindowPrivate;
typedef struct _Block8Data Block8Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_SETTINGS (settings_get_type ())
#define SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SETTINGS, Settings))
#define SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SETTINGS, SettingsClass))
#define IS_SETTINGS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SETTINGS))
#define IS_SETTINGS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SETTINGS))
#define SETTINGS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SETTINGS, SettingsClass))

typedef struct _Settings Settings;
typedef struct _SettingsClass SettingsClass;

#define TYPE_COLOR_SCHEME (color_scheme_get_type ())
#define COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COLOR_SCHEME, ColorScheme))
#define COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COLOR_SCHEME, ColorSchemeClass))
#define IS_COLOR_SCHEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COLOR_SCHEME))
#define IS_COLOR_SCHEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COLOR_SCHEME))
#define COLOR_SCHEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COLOR_SCHEME, ColorSchemeClass))

typedef struct _ColorScheme ColorScheme;
typedef struct _ColorSchemeClass ColorSchemeClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;

struct _SettingsWindow {
	GtkDialog parent_instance;
	SettingsWindowPrivate * priv;
};

struct _SettingsWindowClass {
	GtkDialogClass parent_class;
};

struct _Block8Data {
	int _ref_count_;
	SettingsWindow * self;
	GtkSpinButton* rows;
	GtkSpinButton* columns;
	GtkFontButton* terminal_font;
	GtkFontButton* label_font;
	GtkSwitch* dark_look;
	GtkComboBoxText* color_scheme;
	GtkComboBoxText* theme;
	GtkScale* opacity;
};


static gpointer settings_window_parent_class = NULL;
extern GeeMap* final_term_color_schemes;
extern GeeMap* final_term_themes;

GType settings_window_get_type (void) G_GNUC_CONST;
enum  {
	SETTINGS_WINDOW_DUMMY_PROPERTY
};
SettingsWindow* settings_window_new (void);
SettingsWindow* settings_window_construct (GType object_type);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
GType settings_get_type (void) G_GNUC_CONST;
Settings* settings_get_default (void);
gint settings_get_terminal_lines (Settings* self);
static void __lambda30_ (Block8Data* _data8_);
void settings_set_terminal_lines (Settings* self, gint value);
static void ___lambda30__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
gint settings_get_terminal_columns (Settings* self);
static void __lambda31_ (Block8Data* _data8_);
void settings_set_terminal_columns (Settings* self, gint value);
static void ___lambda31__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self);
static gboolean __lambda32_ (SettingsWindow* self, PangoFontFamily* family, PangoFontFace* face);
static gboolean ___lambda32__gtk_font_filter_func (PangoFontFamily* family, PangoFontFace* face, gpointer self);
const gchar* settings_get_terminal_font_name (Settings* self);
static void __lambda33_ (Block8Data* _data8_);
void settings_set_terminal_font_name (Settings* self, const gchar* value);
static void ___lambda33__gtk_font_button_font_set (GtkFontButton* _sender, gpointer self);
const gchar* settings_get_label_font_name (Settings* self);
static void __lambda34_ (Block8Data* _data8_);
void settings_set_label_font_name (Settings* self, const gchar* value);
static void ___lambda34__gtk_font_button_font_set (GtkFontButton* _sender, gpointer self);
gboolean settings_get_dark (Settings* self);
static void __lambda35_ (Block8Data* _data8_);
void settings_set_dark (Settings* self, gboolean value);
static void ___lambda35__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GType color_scheme_get_type (void) G_GNUC_CONST;
const gchar* settings_get_color_scheme_name (Settings* self);
static void __lambda36_ (Block8Data* _data8_);
void settings_set_color_scheme_name (Settings* self, const gchar* value);
static void ___lambda36__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
GType theme_get_type (void) G_GNUC_CONST;
const gchar* settings_get_theme_name (Settings* self);
static void __lambda37_ (Block8Data* _data8_);
void settings_set_theme_name (Settings* self, const gchar* value);
static void ___lambda37__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
gdouble settings_get_opacity (Settings* self);
static void __lambda38_ (Block8Data* _data8_);
void settings_set_opacity (Settings* self, gdouble value);
static void ___lambda38__gtk_range_value_changed (GtkRange* _sender, gpointer self);
static GtkLabel* settings_window_create_header (SettingsWindow* self, const gchar* title);
static GtkLabel* settings_window_create_label (SettingsWindow* self, const gchar* text);


static Block8Data* block8_data_ref (Block8Data* _data8_) {
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return _data8_;
#line 165 "SettingsWindow.c"
}


static void block8_data_unref (void * _userdata_) {
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 174 "SettingsWindow.c"
		SettingsWindow * self;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		self = _data8_->self;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->opacity);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->theme);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->color_scheme);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->dark_look);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->label_font);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->terminal_font);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->columns);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_data8_->rows);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (self);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		g_slice_free (Block8Data, _data8_);
#line 198 "SettingsWindow.c"
	}
}


static void __lambda30_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkSpinButton* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->rows;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_spin_button_get_value (_tmp2_);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_terminal_lines (_tmp1_, (gint) _tmp4_);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 226 "SettingsWindow.c"
}


static void ___lambda30__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda30_ (self);
#line 233 "SettingsWindow.c"
}


static void __lambda31_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkSpinButton* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->columns;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_spin_button_get_value (_tmp2_);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_terminal_columns (_tmp1_, (gint) _tmp4_);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 260 "SettingsWindow.c"
}


static void ___lambda31__gtk_spin_button_value_changed (GtkSpinButton* _sender, gpointer self) {
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda31_ (self);
#line 267 "SettingsWindow.c"
}


static gboolean __lambda32_ (SettingsWindow* self, PangoFontFamily* family, PangoFontFace* face) {
	gboolean result = FALSE;
	PangoFontFamily* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (family != NULL, FALSE);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (face != NULL, FALSE);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = family;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = pango_font_family_is_monospace (_tmp0_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	result = _tmp1_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return result;
#line 287 "SettingsWindow.c"
}


static gboolean ___lambda32__gtk_font_filter_func (PangoFontFamily* family, PangoFontFace* face, gpointer self) {
	gboolean result;
	result = __lambda32_ (self, family, face);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return result;
#line 296 "SettingsWindow.c"
}


static void __lambda33_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkFontButton* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->terminal_font;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_font_button_get_font_name (_tmp2_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_terminal_font_name (_tmp1_, _tmp4_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 323 "SettingsWindow.c"
}


static void ___lambda33__gtk_font_button_font_set (GtkFontButton* _sender, gpointer self) {
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda33_ (self);
#line 330 "SettingsWindow.c"
}


static void __lambda34_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkFontButton* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->label_font;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_font_button_get_font_name (_tmp2_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_label_font_name (_tmp1_, _tmp4_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 357 "SettingsWindow.c"
}


static void ___lambda34__gtk_font_button_font_set (GtkFontButton* _sender, gpointer self) {
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda34_ (self);
#line 364 "SettingsWindow.c"
}


static void __lambda35_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->dark_look;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_dark (_tmp1_, _tmp4_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 391 "SettingsWindow.c"
}


static void ___lambda35__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda35_ (self);
#line 398 "SettingsWindow.c"
}


static void __lambda36_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkComboBoxText* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->color_scheme;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp2_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_color_scheme_name (_tmp1_, _tmp4_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 425 "SettingsWindow.c"
}


static void ___lambda36__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda36_ (self);
#line 432 "SettingsWindow.c"
}


static void __lambda37_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	GtkComboBoxText* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _data8_->theme;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp2_);
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_theme_name (_tmp1_, _tmp4_);
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 459 "SettingsWindow.c"
}


static void ___lambda37__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda37_ (self);
#line 466 "SettingsWindow.c"
}


static void __lambda38_ (Block8Data* _data8_) {
	SettingsWindow * self;
	Settings* _tmp0_ = NULL;
	Settings* _tmp1_;
	gdouble _tmp2_ = 0.0;
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = _data8_->self;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = settings_get_default ();
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = _tmp0_;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = gtk_range_get_value ((GtkRange*) _data8_->opacity);
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_set_opacity (_tmp1_, _tmp2_ / 100.0);
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp1_);
#line 487 "SettingsWindow.c"
}


static void ___lambda38__gtk_range_value_changed (GtkRange* _sender, gpointer self) {
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	__lambda38_ (self);
#line 494 "SettingsWindow.c"
}


SettingsWindow* settings_window_construct (GType object_type) {
	SettingsWindow * self = NULL;
	Block8Data* _data8_;
	const gchar* _tmp0_ = NULL;
	GtkBox* _tmp1_;
	GtkBox* dimensions_columns;
	GtkBox* _tmp2_;
	GtkBox* dimensions_rows;
	GtkSpinButton* _tmp3_;
	GtkSpinButton* _tmp4_;
	GtkSpinButton* _tmp5_;
	Settings* _tmp6_ = NULL;
	Settings* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GtkSpinButton* _tmp10_;
	GtkSpinButton* _tmp11_;
	Settings* _tmp12_ = NULL;
	Settings* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	GtkSpinButton* _tmp16_;
	GtkBox* _tmp17_;
	GtkSpinButton* _tmp18_;
	GtkBox* _tmp19_;
	const gchar* _tmp20_ = NULL;
	GtkLabel* _tmp21_;
	GtkLabel* _tmp22_;
	GtkBox* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkBox* _tmp25_;
	const gchar* _tmp26_ = NULL;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkFontButton* _tmp29_;
	GtkFontButton* _tmp30_;
	GtkFontButton* _tmp31_;
	GtkFontButton* _tmp32_;
	Settings* _tmp33_ = NULL;
	Settings* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	GtkFontButton* _tmp37_;
	GtkFontButton* _tmp38_;
	GtkFontButton* _tmp39_;
	GtkFontButton* _tmp40_;
	Settings* _tmp41_ = NULL;
	Settings* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	GtkFontButton* _tmp45_;
	GtkSwitch* _tmp46_;
	GtkSwitch* _tmp47_;
	Settings* _tmp48_ = NULL;
	Settings* _tmp49_;
	gboolean _tmp50_;
	gboolean _tmp51_;
	GtkSwitch* _tmp52_;
	GtkSwitch* _tmp53_;
	GtkComboBoxText* _tmp54_;
	GtkComboBoxText* _tmp68_;
	Settings* _tmp69_ = NULL;
	Settings* _tmp70_;
	const gchar* _tmp71_;
	const gchar* _tmp72_;
	GtkComboBoxText* _tmp73_;
	GtkComboBoxText* _tmp74_;
	GtkComboBoxText* _tmp88_;
	Settings* _tmp89_ = NULL;
	Settings* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	GtkComboBoxText* _tmp93_;
	GtkScale* _tmp94_;
	Settings* _tmp95_ = NULL;
	Settings* _tmp96_;
	gdouble _tmp97_;
	gdouble _tmp98_;
	GtkGrid* _tmp99_;
	GtkGrid* grid;
	const gchar* _tmp100_ = NULL;
	GtkLabel* _tmp101_ = NULL;
	GtkLabel* _tmp102_;
	const gchar* _tmp103_ = NULL;
	GtkLabel* _tmp104_ = NULL;
	GtkLabel* _tmp105_;
	GtkBox* _tmp106_;
	GtkBox* _tmp107_;
	const gchar* _tmp108_ = NULL;
	GtkLabel* _tmp109_ = NULL;
	GtkLabel* _tmp110_;
	const gchar* _tmp111_ = NULL;
	GtkLabel* _tmp112_ = NULL;
	GtkLabel* _tmp113_;
	GtkFontButton* _tmp114_;
	const gchar* _tmp115_ = NULL;
	GtkLabel* _tmp116_ = NULL;
	GtkLabel* _tmp117_;
	GtkFontButton* _tmp118_;
	const gchar* _tmp119_ = NULL;
	GtkLabel* _tmp120_ = NULL;
	GtkLabel* _tmp121_;
	GtkSwitch* _tmp122_;
	const gchar* _tmp123_ = NULL;
	GtkLabel* _tmp124_ = NULL;
	GtkLabel* _tmp125_;
	GtkComboBoxText* _tmp126_;
	const gchar* _tmp127_ = NULL;
	GtkLabel* _tmp128_ = NULL;
	GtkLabel* _tmp129_;
	GtkComboBoxText* _tmp130_;
	const gchar* _tmp131_ = NULL;
	GtkLabel* _tmp132_ = NULL;
	GtkLabel* _tmp133_;
	GtkBox* _tmp134_ = NULL;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->_ref_count_ = 1;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	self = (SettingsWindow*) g_object_new (object_type, NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->self = g_object_ref (self);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = _ ("Preferences");
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_window_set_title ((GtkWindow*) self, _tmp0_);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_dialog_add_buttons ((GtkDialog*) self, GTK_STOCK_CLOSE, GTK_RESPONSE_CANCEL, NULL);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	dimensions_columns = _tmp1_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp2_);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	dimensions_rows = _tmp2_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 10, (gdouble) 200, (gdouble) 1);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp3_);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->rows = _tmp3_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 10, (gdouble) 300, (gdouble) 1);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp4_);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->columns = _tmp4_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp5_ = _data8_->rows;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp6_ = settings_get_default ();
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp7_ = _tmp6_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp8_ = settings_get_terminal_lines (_tmp7_);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp9_ = _tmp8_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_spin_button_set_value (_tmp5_, (gdouble) _tmp9_);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp7_);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp10_ = _data8_->rows;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data (_tmp10_, "value-changed", (GCallback) ___lambda30__gtk_spin_button_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp11_ = _data8_->columns;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp12_ = settings_get_default ();
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp13_ = _tmp12_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp14_ = settings_get_terminal_columns (_tmp13_);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp15_ = _tmp14_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_spin_button_set_value (_tmp11_, (gdouble) _tmp15_);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp13_);
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp16_ = _data8_->columns;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data (_tmp16_, "value-changed", (GCallback) ___lambda31__gtk_spin_button_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp17_ = dimensions_columns;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp18_ = _data8_->columns;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_box_pack_start (_tmp17_, (GtkWidget*) _tmp18_, FALSE, TRUE, (guint) 0);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp19_ = dimensions_columns;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp20_ = _ ("columns");
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new (_tmp20_);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp21_);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp22_ = _tmp21_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_box_pack_start (_tmp19_, (GtkWidget*) _tmp22_, FALSE, TRUE, (guint) 0);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp22_);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp23_ = dimensions_rows;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp24_ = _data8_->rows;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_box_pack_start (_tmp23_, (GtkWidget*) _tmp24_, FALSE, TRUE, (guint) 0);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp25_ = dimensions_rows;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp26_ = _ ("rows");
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_tmp26_);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp27_);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp28_ = _tmp27_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_box_pack_start (_tmp25_, (GtkWidget*) _tmp28_, FALSE, TRUE, (guint) 0);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp28_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp29_ = (GtkFontButton*) gtk_font_button_new ();
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp29_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->terminal_font = _tmp29_;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp30_ = _data8_->terminal_font;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_font_button_set_use_font (_tmp30_, TRUE);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp31_ = _data8_->terminal_font;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_font_chooser_set_filter_func ((GtkFontChooser*) _tmp31_, ___lambda32__gtk_font_filter_func, g_object_ref (self), g_object_unref);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp32_ = _data8_->terminal_font;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp33_ = settings_get_default ();
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp34_ = _tmp33_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp35_ = settings_get_terminal_font_name (_tmp34_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp36_ = _tmp35_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_font_button_set_font_name (_tmp32_, _tmp36_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp34_);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp37_ = _data8_->terminal_font;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data (_tmp37_, "font-set", (GCallback) ___lambda33__gtk_font_button_font_set, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp38_ = (GtkFontButton*) gtk_font_button_new ();
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp38_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->label_font = _tmp38_;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp39_ = _data8_->label_font;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_font_button_set_use_font (_tmp39_, TRUE);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp40_ = _data8_->label_font;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp41_ = settings_get_default ();
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp42_ = _tmp41_;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp43_ = settings_get_label_font_name (_tmp42_);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp44_ = _tmp43_;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_font_button_set_font_name (_tmp40_, _tmp44_);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp42_);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp45_ = _data8_->label_font;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data (_tmp45_, "font-set", (GCallback) ___lambda34__gtk_font_button_font_set, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp46_ = (GtkSwitch*) gtk_switch_new ();
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp46_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->dark_look = _tmp46_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp47_ = _data8_->dark_look;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp48_ = settings_get_default ();
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp49_ = _tmp48_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp50_ = settings_get_dark (_tmp49_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp51_ = _tmp50_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_switch_set_active (_tmp47_, _tmp51_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp49_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp52_ = _data8_->dark_look;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp52_, GTK_ALIGN_START);
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp53_ = _data8_->dark_look;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data ((GObject*) _tmp53_, "notify::active", (GCallback) ___lambda35__g_object_notify, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp54_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp54_);
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->color_scheme = _tmp54_;
#line 821 "SettingsWindow.c"
	{
		GeeMap* _tmp55_;
		GeeSet* _tmp56_;
		GeeSet* _tmp57_;
		GeeSet* _tmp58_;
		GeeIterator* _tmp59_ = NULL;
		GeeIterator* _tmp60_;
		GeeIterator* _color_scheme_name_it;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp55_ = final_term_color_schemes;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp56_ = gee_map_get_keys (_tmp55_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp57_ = _tmp56_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp58_ = _tmp57_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp59_ = gee_iterable_iterator ((GeeIterable*) _tmp58_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp60_ = _tmp59_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_tmp58_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_color_scheme_name_it = _tmp60_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		while (TRUE) {
#line 848 "SettingsWindow.c"
			GeeIterator* _tmp61_;
			gboolean _tmp62_ = FALSE;
			GeeIterator* _tmp63_;
			gpointer _tmp64_ = NULL;
			gchar* color_scheme_name;
			GtkComboBoxText* _tmp65_;
			const gchar* _tmp66_;
			const gchar* _tmp67_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp61_ = _color_scheme_name_it;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp62_ = gee_iterator_next (_tmp61_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			if (!_tmp62_) {
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
				break;
#line 865 "SettingsWindow.c"
			}
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp63_ = _color_scheme_name_it;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp64_ = gee_iterator_get (_tmp63_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			color_scheme_name = (gchar*) _tmp64_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp65_ = _data8_->color_scheme;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp66_ = color_scheme_name;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp67_ = color_scheme_name;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			gtk_combo_box_text_append (_tmp65_, _tmp66_, _tmp67_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_g_free0 (color_scheme_name);
#line 883 "SettingsWindow.c"
		}
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_color_scheme_name_it);
#line 887 "SettingsWindow.c"
	}
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp68_ = _data8_->color_scheme;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp69_ = settings_get_default ();
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp70_ = _tmp69_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp71_ = settings_get_color_scheme_name (_tmp70_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp72_ = _tmp71_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp68_, _tmp72_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp70_);
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp73_ = _data8_->color_scheme;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data ((GtkComboBox*) _tmp73_, "changed", (GCallback) ___lambda36__gtk_combo_box_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp74_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp74_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->theme = _tmp74_;
#line 913 "SettingsWindow.c"
	{
		GeeMap* _tmp75_;
		GeeSet* _tmp76_;
		GeeSet* _tmp77_;
		GeeSet* _tmp78_;
		GeeIterator* _tmp79_ = NULL;
		GeeIterator* _tmp80_;
		GeeIterator* _theme_name_it;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp75_ = final_term_themes;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp76_ = gee_map_get_keys (_tmp75_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp77_ = _tmp76_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp78_ = _tmp77_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp79_ = gee_iterable_iterator ((GeeIterable*) _tmp78_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_tmp80_ = _tmp79_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_tmp78_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_theme_name_it = _tmp80_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		while (TRUE) {
#line 940 "SettingsWindow.c"
			GeeIterator* _tmp81_;
			gboolean _tmp82_ = FALSE;
			GeeIterator* _tmp83_;
			gpointer _tmp84_ = NULL;
			gchar* theme_name;
			GtkComboBoxText* _tmp85_;
			const gchar* _tmp86_;
			const gchar* _tmp87_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp81_ = _theme_name_it;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp82_ = gee_iterator_next (_tmp81_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			if (!_tmp82_) {
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
				break;
#line 957 "SettingsWindow.c"
			}
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp83_ = _theme_name_it;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp84_ = gee_iterator_get (_tmp83_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			theme_name = (gchar*) _tmp84_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp85_ = _data8_->theme;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp86_ = theme_name;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_tmp87_ = theme_name;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			gtk_combo_box_text_append (_tmp85_, _tmp86_, _tmp87_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
			_g_free0 (theme_name);
#line 975 "SettingsWindow.c"
		}
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
		_g_object_unref0 (_theme_name_it);
#line 979 "SettingsWindow.c"
	}
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp88_ = _data8_->theme;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp89_ = settings_get_default ();
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp90_ = _tmp89_;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp91_ = settings_get_theme_name (_tmp90_);
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp92_ = _tmp91_;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_combo_box_set_active_id ((GtkComboBox*) _tmp88_, _tmp92_);
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp90_);
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp93_ = _data8_->theme;
#line 89 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data ((GtkComboBox*) _tmp93_, "changed", (GCallback) ___lambda37__gtk_combo_box_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp94_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 1);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp94_);
#line 93 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_->opacity = _tmp94_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp95_ = settings_get_default ();
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp96_ = _tmp95_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp97_ = settings_get_opacity (_tmp96_);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp98_ = _tmp97_;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_range_set_value ((GtkRange*) _data8_->opacity, _tmp98_ * 100.0);
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp96_);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_signal_connect_data ((GtkRange*) _data8_->opacity, "value-changed", (GCallback) ___lambda38__gtk_range_value_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp99_ = (GtkGrid*) gtk_grid_new ();
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp99_);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	grid = _tmp99_;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_set_column_homogeneous (grid, TRUE);
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_set_column_spacing (grid, 12);
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_set_row_spacing (grid, 6);
#line 103 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_set ((GtkWidget*) grid, "margin", 12, NULL);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp100_ = _ ("General");
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp101_ = settings_window_create_header (self, _tmp100_);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp102_ = _tmp101_;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp102_, 0, 0, 1, 1);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp102_);
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp103_ = _ ("Default dimensions:");
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp104_ = settings_window_create_label (self, _tmp103_);
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp105_ = _tmp104_;
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp105_, 0, 1, 1, 1);
#line 107 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp105_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp106_ = dimensions_columns;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp106_, 1, 1, 1, 1);
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp107_ = dimensions_rows;
#line 109 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp107_, 1, 2, 1, 1);
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp108_ = _ ("Appearance");
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp109_ = settings_window_create_header (self, _tmp108_);
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp110_ = _tmp109_;
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp110_, 0, 3, 1, 1);
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp110_);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp111_ = _ ("Terminal font:");
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp112_ = settings_window_create_label (self, _tmp111_);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp113_ = _tmp112_;
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp113_, 0, 4, 1, 1);
#line 113 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp113_);
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp114_ = _data8_->terminal_font;
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp114_, 1, 4, 1, 1);
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp115_ = _ ("Label font:");
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp116_ = settings_window_create_label (self, _tmp115_);
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp117_ = _tmp116_;
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp117_, 0, 5, 1, 1);
#line 116 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp117_);
#line 117 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp118_ = _data8_->label_font;
#line 117 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp118_, 1, 5, 1, 1);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp119_ = _ ("Dark look:");
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp120_ = settings_window_create_label (self, _tmp119_);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp121_ = _tmp120_;
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp121_, 0, 6, 1, 1);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp121_);
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp122_ = _data8_->dark_look;
#line 120 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp122_, 1, 6, 1, 1);
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp123_ = _ ("Color scheme:");
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp124_ = settings_window_create_label (self, _tmp123_);
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp125_ = _tmp124_;
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp125_, 0, 7, 1, 1);
#line 122 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp125_);
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp126_ = _data8_->color_scheme;
#line 123 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp126_, 1, 7, 1, 1);
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp127_ = _ ("Theme:");
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp128_ = settings_window_create_label (self, _tmp127_);
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp129_ = _tmp128_;
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp129_, 0, 8, 1, 1);
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp129_);
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp130_ = _data8_->theme;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp130_, 1, 8, 1, 1);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp131_ = _ ("Opacity:");
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp132_ = settings_window_create_label (self, _tmp131_);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp133_ = _tmp132_;
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _tmp133_, 0, 9, 1, 1);
#line 129 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (_tmp133_);
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_grid_attach (grid, (GtkWidget*) _data8_->opacity, 1, 9, 1, 1);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp134_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_container_add ((GtkContainer*) _tmp134_, (GtkWidget*) grid);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (grid);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (dimensions_rows);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_object_unref0 (dimensions_columns);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	block8_data_unref (_data8_);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_data8_ = NULL;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return self;
#line 1169 "SettingsWindow.c"
}


SettingsWindow* settings_window_new (void) {
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return settings_window_construct (TYPE_SETTINGS_WINDOW);
#line 1176 "SettingsWindow.c"
}


static GtkLabel* settings_window_create_header (SettingsWindow* self, const gchar* title) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* label;
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 135 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = title;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = g_strconcat ("<span weight='bold'>", _tmp0_, NULL);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp2_ = _tmp1_;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp3_ = g_strconcat (_tmp2_, "</span>", NULL);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp4_ = _tmp3_;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp5_);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp6_ = _tmp5_;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_free0 (_tmp4_);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_g_free0 (_tmp2_);
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	label = _tmp6_;
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_label_set_use_markup (label, TRUE);
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_START);
#line 139 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	result = label;
#line 139 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return result;
#line 1224 "SettingsWindow.c"
}


static GtkLabel* settings_window_create_label (SettingsWindow* self, const gchar* text) {
	GtkLabel* result = NULL;
	const gchar* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* label;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp0_ = text;
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_tmp0_);
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	g_object_ref_sink (_tmp1_);
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	label = _tmp1_;
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	gtk_widget_set_halign ((GtkWidget*) label, GTK_ALIGN_END);
#line 145 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	result = label;
#line 145 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	return result;
#line 1251 "SettingsWindow.c"
}


static void settings_window_class_init (SettingsWindowClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/SettingsWindow.vala"
	settings_window_parent_class = g_type_class_peek_parent (klass);
#line 1258 "SettingsWindow.c"
}


static void settings_window_instance_init (SettingsWindow * self) {
}


GType settings_window_get_type (void) {
	static volatile gsize settings_window_type_id__volatile = 0;
	if (g_once_init_enter (&settings_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SettingsWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) settings_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SettingsWindow), 0, (GInstanceInitFunc) settings_window_instance_init, NULL };
		GType settings_window_type_id;
		settings_window_type_id = g_type_register_static (GTK_TYPE_DIALOG, "SettingsWindow", &g_define_type_info, 0);
		g_once_init_leave (&settings_window_type_id__volatile, settings_window_type_id);
	}
	return settings_window_type_id__volatile;
}



