/* TextMenu.c generated by valac 0.20.1, the Vala compiler
 * generated from TextMenu.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gee.h>


#define TYPE_TEXT_MENU (text_menu_get_type ())
#define TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_MENU, TextMenu))
#define TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_MENU, TextMenuClass))
#define IS_TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_MENU))
#define IS_TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_MENU))
#define TEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_MENU, TextMenuClass))

typedef struct _TextMenu TextMenu;
typedef struct _TextMenuClass TextMenuClass;
typedef struct _TextMenuPrivate TextMenuPrivate;

#define TEXT_MENU_TYPE_MARKER_TYPE (text_menu_marker_type_get_type ())
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef struct _Block9Data Block9Data;
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _TextMenu {
	GObject parent_instance;
	TextMenuPrivate * priv;
};

struct _TextMenuClass {
	GObjectClass parent_class;
};

typedef enum  {
	TEXT_MENU_MARKER_TYPE_CODE,
	TEXT_MENU_MARKER_TYPE_PATTERN
} TextMenuMarkerType;

struct _TextMenuPrivate {
	TextMenuMarkerType _marker_type;
	gint _code;
	GRegex* _pattern;
	gchar* _label;
	gint _color;
	GtkMenu* _menu;
	gchar* _text;
};

struct _Block9Data {
	int _ref_count_;
	TextMenu * self;
	GeeArrayList* commands;
};


static gpointer text_menu_parent_class = NULL;

GType text_menu_get_type (void) G_GNUC_CONST;
GType text_menu_marker_type_get_type (void) G_GNUC_CONST;
#define TEXT_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TEXT_MENU, TextMenuPrivate))
enum  {
	TEXT_MENU_DUMMY_PROPERTY,
	TEXT_MENU_MARKER_TYPE,
	TEXT_MENU_CODE,
	TEXT_MENU_PATTERN,
	TEXT_MENU_LABEL,
	TEXT_MENU_COLOR,
	TEXT_MENU_MENU,
	TEXT_MENU_TEXT
};
gchar* text_menu_escape_parameters (TextMenu* self, const gchar* s);
TextMenu* text_menu_new_load_from_file (const gchar* filename);
TextMenu* text_menu_construct_load_from_file (GType object_type, const gchar* filename);
void text_menu_set_marker_type (TextMenu* self, TextMenuMarkerType value);
void text_menu_set_code (TextMenu* self, gint value);
void text_menu_set_pattern (TextMenu* self, GRegex* value);
void text_menu_set_label (TextMenu* self, const gchar* value);
void text_menu_set_color (TextMenu* self, gint value);
void text_menu_set_menu (TextMenu* self, GtkMenu* value);
GtkMenu* text_menu_get_menu (TextMenu* self);
GType command_get_type (void) G_GNUC_CONST;
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
Command* command_new_from_command_specification (const gchar* command_specification);
Command* command_construct_from_command_specification (GType object_type, const gchar* command_specification);
static void ______lambda9_ (Block9Data* _data9_);
const gchar* text_menu_get_text (TextMenu* self);
void command_execute (Command* self, GeeList* placeholder_substitutes);
static void _______lambda9__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
TextMenu* text_menu_new (void);
TextMenu* text_menu_construct (GType object_type);
TextMenuMarkerType text_menu_get_marker_type (TextMenu* self);
gint text_menu_get_code (TextMenu* self);
GRegex* text_menu_get_pattern (TextMenu* self);
const gchar* text_menu_get_label (TextMenu* self);
gint text_menu_get_color (TextMenu* self);
void text_menu_set_text (TextMenu* self, const gchar* value);
static void text_menu_finalize (GObject* obj);
static void _vala_text_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_text_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType text_menu_marker_type_get_type (void) {
	static volatile gsize text_menu_marker_type_type_id__volatile = 0;
	if (g_once_init_enter (&text_menu_marker_type_type_id__volatile)) {
		static const GEnumValue values[] = {{TEXT_MENU_MARKER_TYPE_CODE, "TEXT_MENU_MARKER_TYPE_CODE", "code"}, {TEXT_MENU_MARKER_TYPE_PATTERN, "TEXT_MENU_MARKER_TYPE_PATTERN", "pattern"}, {0, NULL, NULL}};
		GType text_menu_marker_type_type_id;
		text_menu_marker_type_type_id = g_enum_register_static ("TextMenuMarkerType", values);
		g_once_init_leave (&text_menu_marker_type_type_id__volatile, text_menu_marker_type_type_id);
	}
	return text_menu_marker_type_type_id__volatile;
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1242 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 167 "TextMenu.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* regex;
		GRegex* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 197 "TextMenu.c"
				goto __catch15_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			return NULL;
#line 206 "TextMenu.c"
		}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = regex;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = replacement;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp7_ = g_regex_replace_literal (_tmp5_, self, (gssize) (-1), 0, _tmp6_, 0, &_inner_error_);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 222 "TextMenu.c"
				goto __catch15_g_regex_error;
			}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
			return NULL;
#line 233 "TextMenu.c"
		}
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = _tmp8_;
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1245 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 241 "TextMenu.c"
	}
	goto __finally15;
	__catch15_g_regex_error:
	{
		GError* e = NULL;
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1247 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 255 "TextMenu.c"
	}
	__finally15:
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return NULL;
#line 266 "TextMenu.c"
	}
}


gchar* text_menu_escape_parameters (TextMenu* self, const gchar* s) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = s;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = string_replace (_tmp0_, "'", "'\\''");
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp1_;
#line 43 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 287 "TextMenu.c"
}


static Block9Data* block9_data_ref (Block9Data* _data9_) {
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return _data9_;
#line 296 "TextMenu.c"
}


static void block9_data_unref (void * _userdata_) {
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 305 "TextMenu.c"
		TextMenu * self;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		self = _data9_->self;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_object_unref0 (_data9_->commands);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_object_unref0 (self);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_slice_free (Block9Data, _data9_);
#line 315 "TextMenu.c"
	}
}


static gpointer _g_object_ref0 (gpointer self) {
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 323 "TextMenu.c"
}


static void ______lambda9_ (Block9Data* _data9_) {
	TextMenu * self;
	GeeArrayList* _tmp0_;
	GeeArrayList* placeholder_substitutes;
	GeeArrayList* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self = _data9_->self;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	placeholder_substitutes = _tmp0_;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = placeholder_substitutes;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp2_ = self->priv->_text;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp3_ = text_menu_escape_parameters (self, _tmp2_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp4_ = _tmp3_;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp4_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_free0 (_tmp4_);
#line 353 "TextMenu.c"
	{
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		GeeArrayList* _command_list;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _command_size;
		gint _command_index;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp5_ = _data9_->commands;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_command_list = _tmp6_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp7_ = _command_list;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp7_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp9_ = _tmp8_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_command_size = _tmp9_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_command_index = -1;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		while (TRUE) {
#line 381 "TextMenu.c"
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GeeArrayList* _tmp13_;
			gint _tmp14_;
			gpointer _tmp15_ = NULL;
			Command* command;
			Command* _tmp16_;
			GeeArrayList* _tmp17_;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp10_ = _command_index;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_command_index = _tmp10_ + 1;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp11_ = _command_index;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp12_ = _command_size;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			if (!(_tmp11_ < _tmp12_)) {
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
				break;
#line 403 "TextMenu.c"
			}
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp13_ = _command_list;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp14_ = _command_index;
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _tmp14_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			command = (Command*) _tmp15_;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp16_ = command;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp17_ = placeholder_substitutes;
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			command_execute (_tmp16_, (GeeList*) _tmp17_);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_g_object_unref0 (command);
#line 421 "TextMenu.c"
		}
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_object_unref0 (_command_list);
#line 425 "TextMenu.c"
	}
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_object_unref0 (placeholder_substitutes);
#line 429 "TextMenu.c"
}


static void _______lambda9__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	______lambda9_ (self);
#line 436 "TextMenu.c"
}


TextMenu* text_menu_construct_load_from_file (GType object_type, const gchar* filename) {
	TextMenu * self = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* menu_file;
	GError * _inner_error_ = NULL;
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self = (TextMenu*) g_object_new (object_type, NULL);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = g_key_file_new ();
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	menu_file = _tmp0_;
#line 453 "TextMenu.c"
	{
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp1_ = menu_file;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp2_ = filename;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_key_file_load_from_file (_tmp1_, _tmp2_, G_KEY_FILE_NONE, &_inner_error_);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_inner_error_ != NULL) {
#line 465 "TextMenu.c"
			goto __catch16_g_error;
		}
	}
	goto __finally16;
	__catch16_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		e = _inner_error_;
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_inner_error_ = NULL;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp3_ = _ ("Failed to load text menu definitions %s: %s");
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp4_ = filename;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp5_ = e->message;
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_error (_tmp3_, _tmp4_, _tmp5_);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_error_free0 (e);
#line 490 "TextMenu.c"
	}
	__finally16:
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	if (_inner_error_ != NULL) {
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_key_file_free0 (menu_file);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_clear_error (&_inner_error_);
#line 49 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		return NULL;
#line 503 "TextMenu.c"
	}
	{
		GKeyFile* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
		GKeyFile* _tmp22_;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		gchar* _tmp25_;
		GKeyFile* _tmp26_;
		gint _tmp27_ = 0;
		gint _tmp28_;
		GtkMenu* _tmp29_;
		GtkMenu* _tmp30_;
		GKeyFile* _tmp31_;
		gsize _tmp32_;
		gchar** _tmp33_ = NULL;
		gchar** _tmp34_;
		gint _tmp34__length1;
		gint __tmp34__size_;
		GtkMenu* _tmp63_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp6_ = menu_file;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp7_ = g_key_file_get_string (_tmp6_, "Parameters", "marker-type", &_inner_error_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp8_ = _tmp7_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_inner_error_ != NULL) {
#line 535 "TextMenu.c"
			goto __catch17_g_error;
		}
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp9_ = _tmp8_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp10_ = g_strcmp0 (_tmp9_, "code") == 0;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_free0 (_tmp9_);
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_tmp10_) {
#line 546 "TextMenu.c"
			GKeyFile* _tmp11_;
			gint _tmp12_ = 0;
			gint _tmp13_;
#line 55 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			text_menu_set_marker_type (self, TEXT_MENU_MARKER_TYPE_CODE);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp11_ = menu_file;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp12_ = g_key_file_get_integer (_tmp11_, "Parameters", "code", &_inner_error_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp13_ = _tmp12_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			if (_inner_error_ != NULL) {
#line 560 "TextMenu.c"
				goto __catch17_g_error;
			}
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			text_menu_set_code (self, _tmp13_);
#line 565 "TextMenu.c"
		} else {
			GKeyFile* _tmp14_;
			gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
			gchar* _tmp17_;
			GRegex* _tmp18_;
			GRegex* _tmp19_;
			GRegex* _tmp20_;
			GRegex* _tmp21_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			text_menu_set_marker_type (self, TEXT_MENU_MARKER_TYPE_PATTERN);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp14_ = menu_file;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp15_ = g_key_file_get_value (_tmp14_, "Parameters", "pattern", &_inner_error_);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp16_ = _tmp15_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			if (_inner_error_ != NULL) {
#line 585 "TextMenu.c"
				goto __catch17_g_error;
			}
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp17_ = _tmp16_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp18_ = g_regex_new (_tmp17_, G_REGEX_OPTIMIZE, 0, &_inner_error_);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp19_ = _tmp18_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_g_free0 (_tmp17_);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp20_ = _tmp19_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			if (_inner_error_ != NULL) {
#line 600 "TextMenu.c"
				goto __catch17_g_error;
			}
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_tmp21_ = _tmp20_;
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			text_menu_set_pattern (self, _tmp21_);
#line 59 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			_g_regex_unref0 (_tmp21_);
#line 609 "TextMenu.c"
		}
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp22_ = menu_file;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp23_ = g_key_file_get_string (_tmp22_, "Parameters", "label", &_inner_error_);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp24_ = _tmp23_;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_inner_error_ != NULL) {
#line 619 "TextMenu.c"
			goto __catch17_g_error;
		}
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp25_ = _tmp24_;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_label (self, _tmp25_);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_free0 (_tmp25_);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp26_ = menu_file;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp27_ = g_key_file_get_integer (_tmp26_, "Parameters", "color", &_inner_error_);
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp28_ = _tmp27_;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_inner_error_ != NULL) {
#line 636 "TextMenu.c"
			goto __catch17_g_error;
		}
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_color (self, _tmp28_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp29_ = (GtkMenu*) gtk_menu_new ();
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_object_ref_sink (_tmp29_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp30_ = _tmp29_;
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_menu (self, _tmp30_);
#line 65 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_object_unref0 (_tmp30_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp31_ = menu_file;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp33_ = g_key_file_get_keys (_tmp31_, "Menu", &_tmp32_, &_inner_error_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp34_ = _tmp33_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp34__length1 = _tmp32_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		__tmp34__size_ = _tmp34__length1;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		if (_inner_error_ != NULL) {
#line 663 "TextMenu.c"
			goto __catch17_g_error;
		}
		{
			gchar** label_collection = NULL;
			gint label_collection_length1 = 0;
			gint _label_collection_size_ = 0;
			gint label_it = 0;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			label_collection = _tmp34_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			label_collection_length1 = _tmp34__length1;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			for (label_it = 0; label_it < _tmp34__length1; label_it = label_it + 1) {
#line 677 "TextMenu.c"
				gchar* _tmp35_;
				gchar* label = NULL;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
				_tmp35_ = g_strdup (label_collection[label_it]);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
				label = _tmp35_;
#line 684 "TextMenu.c"
				{
					const gchar* _tmp36_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
					_tmp36_ = label;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
					if (g_strcmp0 (_tmp36_, "$$$SEPARATOR$$$") == 0) {
#line 691 "TextMenu.c"
						GtkMenu* _tmp37_;
						GtkSeparatorMenuItem* _tmp38_;
						GtkSeparatorMenuItem* _tmp39_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp37_ = self->priv->_menu;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp38_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						g_object_ref_sink (_tmp38_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp39_ = _tmp38_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						gtk_menu_shell_append ((GtkMenuShell*) _tmp37_, (GtkWidget*) ((GtkMenuItem*) _tmp39_));
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_g_object_unref0 (_tmp39_);
#line 707 "TextMenu.c"
					} else {
						Block9Data* _data9_;
						GtkMenuItem* _tmp40_;
						GtkMenuItem* menu_item;
						GtkMenuItem* _tmp41_;
						GList* _tmp42_ = NULL;
						GList* _tmp43_;
						gconstpointer _tmp44_ = NULL;
						GtkLabel* _tmp45_;
						GtkLabel* _tmp46_;
						GtkLabel* menu_item_label;
						GtkLabel* _tmp47_;
						const gchar* _tmp48_;
						GeeArrayList* _tmp49_;
						GKeyFile* _tmp50_;
						const gchar* _tmp51_;
						gsize _tmp52_;
						gchar** _tmp53_ = NULL;
						gchar** _tmp54_;
						gint _tmp54__length1;
						gint __tmp54__size_;
						GtkMenuItem* _tmp60_;
						GtkMenu* _tmp61_;
						GtkMenuItem* _tmp62_;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_data9_ = g_slice_new0 (Block9Data);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_data9_->_ref_count_ = 1;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_data9_->self = g_object_ref (self);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						g_object_ref_sink (_tmp40_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						menu_item = _tmp40_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp41_ = menu_item;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp42_ = gtk_container_get_children ((GtkContainer*) _tmp41_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp43_ = _tmp42_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp44_ = g_list_nth_data (_tmp43_, (guint) 0);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST ((GtkWidget*) _tmp44_, GTK_TYPE_LABEL, GtkLabel));
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp46_ = _tmp45_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_g_list_free0 (_tmp43_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						menu_item_label = _tmp46_;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp47_ = menu_item_label;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp48_ = label;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						gtk_label_set_markup (_tmp47_, _tmp48_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp49_ = gee_array_list_new (TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_data9_->commands = _tmp49_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp50_ = menu_file;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp51_ = label;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp53_ = g_key_file_get_string_list (_tmp50_, "Menu", _tmp51_, &_tmp52_, &_inner_error_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp54_ = _tmp53_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp54__length1 = _tmp52_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						__tmp54__size_ = _tmp54__length1;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						if (_inner_error_ != NULL) {
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							_g_object_unref0 (menu_item_label);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							_g_object_unref0 (menu_item);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							block9_data_unref (_data9_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							_data9_ = NULL;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							_g_free0 (label);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							label_collection = (_vala_array_free (label_collection, label_collection_length1, (GDestroyNotify) g_free), NULL);
#line 796 "TextMenu.c"
							goto __catch17_g_error;
						}
						{
							gchar** command_specification_collection = NULL;
							gint command_specification_collection_length1 = 0;
							gint _command_specification_collection_size_ = 0;
							gint command_specification_it = 0;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							command_specification_collection = _tmp54_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							command_specification_collection_length1 = _tmp54__length1;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							for (command_specification_it = 0; command_specification_it < _tmp54__length1; command_specification_it = command_specification_it + 1) {
#line 810 "TextMenu.c"
								gchar* _tmp55_;
								gchar* command_specification = NULL;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
								_tmp55_ = g_strdup (command_specification_collection[command_specification_it]);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
								command_specification = _tmp55_;
#line 817 "TextMenu.c"
								{
									GeeArrayList* _tmp56_;
									const gchar* _tmp57_;
									Command* _tmp58_;
									Command* _tmp59_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_tmp56_ = _data9_->commands;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_tmp57_ = command_specification;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_tmp58_ = command_new_from_command_specification (_tmp57_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_tmp59_ = _tmp58_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp56_, _tmp59_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_g_object_unref0 (_tmp59_);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
									_g_free0 (command_specification);
#line 837 "TextMenu.c"
								}
							}
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
							command_specification_collection = (_vala_array_free (command_specification_collection, command_specification_collection_length1, (GDestroyNotify) g_free), NULL);
#line 842 "TextMenu.c"
						}
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp60_ = menu_item;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						g_signal_connect_data (_tmp60_, "activate", (GCallback) _______lambda9__gtk_menu_item_activate, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp61_ = self->priv->_menu;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_tmp62_ = menu_item;
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						gtk_menu_shell_append ((GtkMenuShell*) _tmp61_, (GtkWidget*) _tmp62_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_g_object_unref0 (menu_item_label);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_g_object_unref0 (menu_item);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						block9_data_unref (_data9_);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
						_data9_ = NULL;
#line 862 "TextMenu.c"
					}
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
					_g_free0 (label);
#line 866 "TextMenu.c"
				}
			}
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
			label_collection = (_vala_array_free (label_collection, label_collection_length1, (GDestroyNotify) g_free), NULL);
#line 871 "TextMenu.c"
		}
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp63_ = self->priv->_menu;
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp63_);
#line 877 "TextMenu.c"
	}
	goto __finally17;
	__catch17_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp64_ = NULL;
		const gchar* _tmp65_;
		GError* _tmp66_;
		const gchar* _tmp67_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		e = _inner_error_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_inner_error_ = NULL;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp64_ = _ ("Error in text menu %s: %s");
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp65_ = filename;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp66_ = e;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_tmp67_ = _tmp66_->message;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_warning (_tmp64_, _tmp65_, _tmp67_);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_error_free0 (e);
#line 903 "TextMenu.c"
	}
	__finally17:
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	if (_inner_error_ != NULL) {
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		_g_key_file_free0 (menu_file);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_clear_error (&_inner_error_);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		return NULL;
#line 916 "TextMenu.c"
	}
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_key_file_free0 (menu_file);
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return self;
#line 922 "TextMenu.c"
}


TextMenu* text_menu_new_load_from_file (const gchar* filename) {
#line 47 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return text_menu_construct_load_from_file (TYPE_TEXT_MENU, filename);
#line 929 "TextMenu.c"
}


TextMenu* text_menu_construct (GType object_type) {
	TextMenu * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self = (TextMenu*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return self;
#line 939 "TextMenu.c"
}


TextMenu* text_menu_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return text_menu_construct (TYPE_TEXT_MENU);
#line 946 "TextMenu.c"
}


TextMenuMarkerType text_menu_get_marker_type (TextMenu* self) {
	TextMenuMarkerType result;
	TextMenuMarkerType _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_marker_type;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 961 "TextMenu.c"
}


void text_menu_set_marker_type (TextMenu* self, TextMenuMarkerType value) {
	TextMenuMarkerType _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_marker_type = _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "marker-type");
#line 975 "TextMenu.c"
}


gint text_menu_get_code (TextMenu* self) {
	gint result;
	gint _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_code;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 990 "TextMenu.c"
}


void text_menu_set_code (TextMenu* self, gint value) {
	gint _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_code = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "code");
#line 1004 "TextMenu.c"
}


GRegex* text_menu_get_pattern (TextMenu* self) {
	GRegex* result;
	GRegex* _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_pattern;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 1019 "TextMenu.c"
}


static gpointer _g_regex_ref0 (gpointer self) {
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return self ? g_regex_ref (self) : NULL;
#line 1026 "TextMenu.c"
}


void text_menu_set_pattern (TextMenu* self, GRegex* value) {
	GRegex* _tmp0_;
	GRegex* _tmp1_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = _g_regex_ref0 (_tmp0_);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_regex_unref0 (self->priv->_pattern);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_pattern = _tmp1_;
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "pattern");
#line 1045 "TextMenu.c"
}


const gchar* text_menu_get_label (TextMenu* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_label;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 1060 "TextMenu.c"
}


void text_menu_set_label (TextMenu* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_free0 (self->priv->_label);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_label = _tmp1_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "label");
#line 1079 "TextMenu.c"
}


gint text_menu_get_color (TextMenu* self) {
	gint result;
	gint _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_color;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 1094 "TextMenu.c"
}


void text_menu_set_color (TextMenu* self, gint value) {
	gint _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_color = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "color");
#line 1108 "TextMenu.c"
}


GtkMenu* text_menu_get_menu (TextMenu* self) {
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_menu;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 1123 "TextMenu.c"
}


void text_menu_set_menu (TextMenu* self, GtkMenu* value) {
	GtkMenu* _tmp0_;
	GtkMenu* _tmp1_;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_object_unref0 (self->priv->_menu);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_menu = _tmp1_;
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "menu");
#line 1142 "TextMenu.c"
}


const gchar* text_menu_get_text (TextMenu* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = self->priv->_text;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	result = _tmp0_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	return result;
#line 1157 "TextMenu.c"
}


void text_menu_set_text (TextMenu* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_return_if_fail (self != NULL);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp0_ = value;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_free0 (self->priv->_text);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv->_text = _tmp1_;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_notify ((GObject *) self, "text");
#line 1176 "TextMenu.c"
}


static void text_menu_class_init (TextMenuClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	text_menu_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_type_class_add_private (klass, sizeof (TextMenuPrivate));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_text_menu_get_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_text_menu_set_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = text_menu_finalize;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_MARKER_TYPE, g_param_spec_enum ("marker-type", "marker-type", "marker-type", TEXT_MENU_TYPE_MARKER_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_CODE, g_param_spec_int ("code", "code", "code", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_PATTERN, g_param_spec_boxed ("pattern", "pattern", "pattern", G_TYPE_REGEX, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_LABEL, g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_COLOR, g_param_spec_int ("color", "color", "color", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_MENU, g_param_spec_object ("menu", "menu", "menu", GTK_TYPE_MENU, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TEXT_MENU_TEXT, g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1205 "TextMenu.c"
}


static void text_menu_instance_init (TextMenu * self) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self->priv = TEXT_MENU_GET_PRIVATE (self);
#line 1212 "TextMenu.c"
}


static void text_menu_finalize (GObject* obj) {
	TextMenu * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_MENU, TextMenu);
#line 33 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_regex_unref0 (self->priv->_pattern);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_free0 (self->priv->_label);
#line 38 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_object_unref0 (self->priv->_menu);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	_g_free0 (self->priv->_text);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	G_OBJECT_CLASS (text_menu_parent_class)->finalize (obj);
#line 1230 "TextMenu.c"
}


GType text_menu_get_type (void) {
	static volatile gsize text_menu_type_id__volatile = 0;
	if (g_once_init_enter (&text_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TextMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextMenu), 0, (GInstanceInitFunc) text_menu_instance_init, NULL };
		GType text_menu_type_id;
		text_menu_type_id = g_type_register_static (G_TYPE_OBJECT, "TextMenu", &g_define_type_info, 0);
		g_once_init_leave (&text_menu_type_id__volatile, text_menu_type_id);
	}
	return text_menu_type_id__volatile;
}


static void _vala_text_menu_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TEXT_MENU, TextMenu);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_MARKER_TYPE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_enum (value, text_menu_get_marker_type (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_CODE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_int (value, text_menu_get_code (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_PATTERN:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_boxed (value, text_menu_get_pattern (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_LABEL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_string (value, text_menu_get_label (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_COLOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_int (value, text_menu_get_color (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_MENU:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_object (value, text_menu_get_menu (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_TEXT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		g_value_set_string (value, text_menu_get_text (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 1293 "TextMenu.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 1299 "TextMenu.c"
	}
}


static void _vala_text_menu_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TextMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TEXT_MENU, TextMenu);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_MARKER_TYPE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_marker_type (self, g_value_get_enum (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_CODE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_code (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_PATTERN:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_pattern (self, g_value_get_boxed (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_LABEL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_label (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_COLOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_color (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_MENU:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_menu (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		case TEXT_MENU_TEXT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		text_menu_set_text (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 1351 "TextMenu.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TextMenu.vala"
		break;
#line 1357 "TextMenu.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1365 "TextMenu.c"
		int i;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1373 "TextMenu.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/ScrollableListView.vala"
	g_free (array);
#line 1385 "TextMenu.c"
}



