/* Theme.c generated by valac 0.20.1, the Vala compiler
 * generated from Theme.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <mx/mx.h>
#include <clutter/clutter.h>
#include <glib/gi18n-lib.h>


#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_key_file_free0(var) ((var == NULL) ? NULL : (var = (g_key_file_free (var), NULL)))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
};

struct _ThemePrivate {
	gchar* _name;
	gchar* _author;
	MxStyle* _style;
	gint _gutter_size;
	ClutterColor _gutter_color;
	ClutterColor _gutter_border_color;
	gint _collapse_button_x;
	gint _collapse_button_y;
	gint _collapse_button_width;
	gint _collapse_button_height;
	ClutterColor _menu_button_arrow_color;
	gint _margin_left;
	gint _margin_right;
	gint _cursor_minimum_opacity;
	gint _cursor_maximum_opacity;
	gint _cursor_blinking_interval;
	gint _cursor_motion_speed;
};


static gpointer theme_parent_class = NULL;

GType theme_get_type (void) G_GNUC_CONST;
#define THEME_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_THEME, ThemePrivate))
enum  {
	THEME_DUMMY_PROPERTY,
	THEME_NAME,
	THEME_AUTHOR,
	THEME_STYLE,
	THEME_GUTTER_SIZE,
	THEME_GUTTER_COLOR,
	THEME_GUTTER_BORDER_COLOR,
	THEME_COLLAPSE_BUTTON_X,
	THEME_COLLAPSE_BUTTON_Y,
	THEME_COLLAPSE_BUTTON_WIDTH,
	THEME_COLLAPSE_BUTTON_HEIGHT,
	THEME_MENU_BUTTON_ARROW_COLOR,
	THEME_MARGIN_LEFT,
	THEME_MARGIN_RIGHT,
	THEME_CURSOR_MINIMUM_OPACITY,
	THEME_CURSOR_MAXIMUM_OPACITY,
	THEME_CURSOR_BLINKING_INTERVAL,
	THEME_CURSOR_MOTION_SPEED
};
Theme* theme_new_load_from_file (const gchar* filename);
Theme* theme_construct_load_from_file (GType object_type, const gchar* filename);
void theme_set_name (Theme* self, const gchar* value);
void theme_set_author (Theme* self, const gchar* value);
void theme_set_style (Theme* self, MxStyle* value);
MxStyle* theme_get_style (Theme* self);
gchar* utilities_get_absolute_filename (const gchar* filename, const gchar* relative_filename);
void theme_set_gutter_size (Theme* self, gint value);
void theme_set_gutter_color (Theme* self, ClutterColor* value);
void theme_set_gutter_border_color (Theme* self, ClutterColor* value);
void theme_set_collapse_button_x (Theme* self, gint value);
void theme_set_collapse_button_y (Theme* self, gint value);
void theme_set_collapse_button_width (Theme* self, gint value);
void theme_set_collapse_button_height (Theme* self, gint value);
void theme_set_menu_button_arrow_color (Theme* self, ClutterColor* value);
void theme_set_margin_left (Theme* self, gint value);
void theme_set_margin_right (Theme* self, gint value);
void theme_set_cursor_minimum_opacity (Theme* self, gint value);
void theme_set_cursor_maximum_opacity (Theme* self, gint value);
void theme_set_cursor_blinking_interval (Theme* self, gint value);
void theme_set_cursor_motion_speed (Theme* self, gint value);
Theme* theme_new (void);
Theme* theme_construct (GType object_type);
const gchar* theme_get_name (Theme* self);
const gchar* theme_get_author (Theme* self);
gint theme_get_gutter_size (Theme* self);
void theme_get_gutter_color (Theme* self, ClutterColor* result);
void theme_get_gutter_border_color (Theme* self, ClutterColor* result);
gint theme_get_collapse_button_x (Theme* self);
gint theme_get_collapse_button_y (Theme* self);
gint theme_get_collapse_button_width (Theme* self);
gint theme_get_collapse_button_height (Theme* self);
void theme_get_menu_button_arrow_color (Theme* self, ClutterColor* result);
gint theme_get_margin_left (Theme* self);
gint theme_get_margin_right (Theme* self);
gint theme_get_cursor_minimum_opacity (Theme* self);
gint theme_get_cursor_maximum_opacity (Theme* self);
gint theme_get_cursor_blinking_interval (Theme* self);
gint theme_get_cursor_motion_speed (Theme* self);
static void theme_finalize (GObject* obj);
static void _vala_theme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_theme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


Theme* theme_construct_load_from_file (GType object_type, const gchar* filename) {
	Theme * self = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* theme_file;
	GError * _inner_error_ = NULL;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = g_key_file_new ();
#line 51 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	theme_file = _tmp0_;
#line 162 "Theme.c"
	{
		GKeyFile* _tmp1_;
		const gchar* _tmp2_;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp1_ = theme_file;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp2_ = filename;
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_key_file_load_from_file (_tmp1_, _tmp2_, G_KEY_FILE_NONE, &_inner_error_);
#line 53 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 174 "Theme.c"
			goto __catch20_g_error;
		}
	}
	goto __finally20;
	__catch20_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		e = _inner_error_;
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_inner_error_ = NULL;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp3_ = _ ("Could not load theme %s: %s");
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp4_ = filename;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp5_ = e->message;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_error (_tmp3_, _tmp4_, _tmp5_);
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_error_free0 (e);
#line 199 "Theme.c"
	}
	__finally20:
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	if (_inner_error_ != NULL) {
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_key_file_free0 (theme_file);
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_clear_error (&_inner_error_);
#line 52 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		return NULL;
#line 212 "Theme.c"
	}
	{
		GKeyFile* _tmp6_;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GKeyFile* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_;
		MxStyle* _tmp14_;
		MxStyle* _tmp15_;
		GKeyFile* _tmp16_;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_;
		MxStyle* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_;
		GKeyFile* _tmp24_;
		gint _tmp25_ = 0;
		gint _tmp26_;
		GKeyFile* _tmp27_;
		gchar* _tmp28_ = NULL;
		gchar* _tmp29_;
		gchar* _tmp30_;
		ClutterColor _tmp31_ = {0};
		GKeyFile* _tmp32_;
		gchar* _tmp33_ = NULL;
		gchar* _tmp34_;
		gchar* _tmp35_;
		ClutterColor _tmp36_ = {0};
		GKeyFile* _tmp37_;
		gint _tmp38_ = 0;
		gint _tmp39_;
		GKeyFile* _tmp40_;
		gint _tmp41_ = 0;
		gint _tmp42_;
		GKeyFile* _tmp43_;
		gint _tmp44_ = 0;
		gint _tmp45_;
		GKeyFile* _tmp46_;
		gint _tmp47_ = 0;
		gint _tmp48_;
		GKeyFile* _tmp49_;
		gchar* _tmp50_ = NULL;
		gchar* _tmp51_;
		gchar* _tmp52_;
		ClutterColor _tmp53_ = {0};
		GKeyFile* _tmp54_;
		gint _tmp55_ = 0;
		gint _tmp56_;
		GKeyFile* _tmp57_;
		gint _tmp58_ = 0;
		gint _tmp59_;
		GKeyFile* _tmp60_;
		gint _tmp61_ = 0;
		gint _tmp62_;
		GKeyFile* _tmp63_;
		gint _tmp64_ = 0;
		gint _tmp65_;
		GKeyFile* _tmp66_;
		gint _tmp67_ = 0;
		gint _tmp68_;
		GKeyFile* _tmp69_;
		gint _tmp70_ = 0;
		gint _tmp71_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp6_ = theme_file;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp7_ = g_key_file_get_string (_tmp6_, "About", "name", &_inner_error_);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp8_ = _tmp7_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 289 "Theme.c"
			goto __catch21_g_error;
		}
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp9_ = _tmp8_;
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_name (self, _tmp9_);
#line 57 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp9_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp10_ = theme_file;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp11_ = g_key_file_get_string (_tmp10_, "About", "author", &_inner_error_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp12_ = _tmp11_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 306 "Theme.c"
			goto __catch21_g_error;
		}
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp13_ = _tmp12_;
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_author (self, _tmp13_);
#line 58 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp13_);
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp14_ = mx_style_new ();
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp15_ = _tmp14_;
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_style (self, _tmp15_);
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_object_unref0 (_tmp15_);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp16_ = theme_file;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp17_ = g_key_file_get_string (_tmp16_, "Theme", "stylesheet", &_inner_error_);
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp18_ = _tmp17_;
#line 62 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 331 "Theme.c"
			goto __catch21_g_error;
		}
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp19_ = self->priv->_style;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp20_ = filename;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp21_ = _tmp18_;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp22_ = utilities_get_absolute_filename (_tmp20_, _tmp21_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp23_ = _tmp22_;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		mx_style_load_from_file (_tmp19_, _tmp23_, &_inner_error_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp23_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp21_);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 352 "Theme.c"
			goto __catch21_g_error;
		}
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp24_ = theme_file;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp25_ = g_key_file_get_integer (_tmp24_, "Theme", "gutter-size", &_inner_error_);
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp26_ = _tmp25_;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 363 "Theme.c"
			goto __catch21_g_error;
		}
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_size (self, _tmp26_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp27_ = theme_file;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp28_ = g_key_file_get_string (_tmp27_, "Theme", "gutter-color", &_inner_error_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp29_ = _tmp28_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 376 "Theme.c"
			goto __catch21_g_error;
		}
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp30_ = _tmp29_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		clutter_color_from_string (&_tmp31_, _tmp30_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_color (self, &_tmp31_);
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp30_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp32_ = theme_file;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp33_ = g_key_file_get_string (_tmp32_, "Theme", "gutter-border-color", &_inner_error_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp34_ = _tmp33_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 395 "Theme.c"
			goto __catch21_g_error;
		}
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp35_ = _tmp34_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		clutter_color_from_string (&_tmp36_, _tmp35_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_border_color (self, &_tmp36_);
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp35_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp37_ = theme_file;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp38_ = g_key_file_get_integer (_tmp37_, "Theme", "collapse-button-x", &_inner_error_);
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp39_ = _tmp38_;
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 414 "Theme.c"
			goto __catch21_g_error;
		}
#line 69 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_x (self, _tmp39_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp40_ = theme_file;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp41_ = g_key_file_get_integer (_tmp40_, "Theme", "collapse-button-y", &_inner_error_);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp42_ = _tmp41_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 427 "Theme.c"
			goto __catch21_g_error;
		}
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_y (self, _tmp42_);
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp43_ = theme_file;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp44_ = g_key_file_get_integer (_tmp43_, "Theme", "collapse-button-width", &_inner_error_);
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp45_ = _tmp44_;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 440 "Theme.c"
			goto __catch21_g_error;
		}
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_width (self, _tmp45_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp46_ = theme_file;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp47_ = g_key_file_get_integer (_tmp46_, "Theme", "collapse-button-height", &_inner_error_);
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp48_ = _tmp47_;
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 453 "Theme.c"
			goto __catch21_g_error;
		}
#line 72 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_height (self, _tmp48_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp49_ = theme_file;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp50_ = g_key_file_get_string (_tmp49_, "Theme", "menu-button-arrow-color", &_inner_error_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp51_ = _tmp50_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 466 "Theme.c"
			goto __catch21_g_error;
		}
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp52_ = _tmp51_;
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		clutter_color_from_string (&_tmp53_, _tmp52_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_menu_button_arrow_color (self, &_tmp53_);
#line 74 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_free0 (_tmp52_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp54_ = theme_file;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp55_ = g_key_file_get_integer (_tmp54_, "Theme", "margin-left", &_inner_error_);
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp56_ = _tmp55_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 485 "Theme.c"
			goto __catch21_g_error;
		}
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_margin_left (self, _tmp56_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp57_ = theme_file;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp58_ = g_key_file_get_integer (_tmp57_, "Theme", "margin-right", &_inner_error_);
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp59_ = _tmp58_;
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 498 "Theme.c"
			goto __catch21_g_error;
		}
#line 77 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_margin_right (self, _tmp59_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp60_ = theme_file;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp61_ = g_key_file_get_integer (_tmp60_, "Theme", "cursor-minimum-opacity", &_inner_error_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp62_ = _tmp61_;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 511 "Theme.c"
			goto __catch21_g_error;
		}
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_minimum_opacity (self, _tmp62_);
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp63_ = theme_file;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp64_ = g_key_file_get_integer (_tmp63_, "Theme", "cursor-maximum-opacity", &_inner_error_);
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp65_ = _tmp64_;
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 524 "Theme.c"
			goto __catch21_g_error;
		}
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_maximum_opacity (self, _tmp65_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp66_ = theme_file;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp67_ = g_key_file_get_integer (_tmp66_, "Theme", "cursor-blinking-interval", &_inner_error_);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp68_ = _tmp67_;
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 537 "Theme.c"
			goto __catch21_g_error;
		}
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_blinking_interval (self, _tmp68_);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp69_ = theme_file;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp70_ = g_key_file_get_integer (_tmp69_, "Theme", "cursor-motion-speed", &_inner_error_);
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp71_ = _tmp70_;
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		if (_inner_error_ != NULL) {
#line 550 "Theme.c"
			goto __catch21_g_error;
		}
#line 83 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_motion_speed (self, _tmp71_);
#line 555 "Theme.c"
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp72_ = NULL;
		const gchar* _tmp73_;
		GError* _tmp74_;
		const gchar* _tmp75_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		e = _inner_error_;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_inner_error_ = NULL;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp72_ = _ ("Error in theme %s: %s");
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp73_ = filename;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp74_ = e;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_tmp75_ = _tmp74_->message;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_warning (_tmp72_, _tmp73_, _tmp75_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_error_free0 (e);
#line 581 "Theme.c"
	}
	__finally21:
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	if (_inner_error_ != NULL) {
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		_g_key_file_free0 (theme_file);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_clear_error (&_inner_error_);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		return NULL;
#line 594 "Theme.c"
	}
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_key_file_free0 (theme_file);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return self;
#line 600 "Theme.c"
}


Theme* theme_new_load_from_file (const gchar* filename) {
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return theme_construct_load_from_file (TYPE_THEME, filename);
#line 607 "Theme.c"
}


Theme* theme_construct (GType object_type) {
	Theme * self = NULL;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return self;
#line 617 "Theme.c"
}


Theme* theme_new (void) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return theme_construct (TYPE_THEME);
#line 624 "Theme.c"
}


const gchar* theme_get_name (Theme* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_name;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 639 "Theme.c"
}


void theme_set_name (Theme* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_free0 (self->priv->_name);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_name = _tmp1_;
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "name");
#line 658 "Theme.c"
}


const gchar* theme_get_author (Theme* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_author;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 673 "Theme.c"
}


void theme_set_author (Theme* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_free0 (self->priv->_author);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_author = _tmp1_;
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "author");
#line 692 "Theme.c"
}


MxStyle* theme_get_style (Theme* self) {
	MxStyle* result;
	MxStyle* _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_style;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 707 "Theme.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return self ? g_object_ref (self) : NULL;
#line 714 "Theme.c"
}


void theme_set_style (Theme* self, MxStyle* value) {
	MxStyle* _tmp0_;
	MxStyle* _tmp1_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_object_unref0 (self->priv->_style);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_style = _tmp1_;
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "style");
#line 733 "Theme.c"
}


gint theme_get_gutter_size (Theme* self) {
	gint result;
	gint _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_gutter_size;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 748 "Theme.c"
}


void theme_set_gutter_size (Theme* self, gint value) {
	gint _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_gutter_size = _tmp0_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "gutter-size");
#line 762 "Theme.c"
}


void theme_get_gutter_color (Theme* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_gutter_color;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	*result = _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return;
#line 776 "Theme.c"
}


void theme_set_gutter_color (Theme* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = *value;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_gutter_color = _tmp0_;
#line 31 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "gutter-color");
#line 790 "Theme.c"
}


void theme_get_gutter_border_color (Theme* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_gutter_border_color;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	*result = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return;
#line 804 "Theme.c"
}


void theme_set_gutter_border_color (Theme* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = *value;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_gutter_border_color = _tmp0_;
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "gutter-border-color");
#line 818 "Theme.c"
}


gint theme_get_collapse_button_x (Theme* self) {
	gint result;
	gint _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_collapse_button_x;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 833 "Theme.c"
}


void theme_set_collapse_button_x (Theme* self, gint value) {
	gint _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_collapse_button_x = _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "collapse-button-x");
#line 847 "Theme.c"
}


gint theme_get_collapse_button_y (Theme* self) {
	gint result;
	gint _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_collapse_button_y;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 862 "Theme.c"
}


void theme_set_collapse_button_y (Theme* self, gint value) {
	gint _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_collapse_button_y = _tmp0_;
#line 35 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "collapse-button-y");
#line 876 "Theme.c"
}


gint theme_get_collapse_button_width (Theme* self) {
	gint result;
	gint _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_collapse_button_width;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 891 "Theme.c"
}


void theme_set_collapse_button_width (Theme* self, gint value) {
	gint _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_collapse_button_width = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "collapse-button-width");
#line 905 "Theme.c"
}


gint theme_get_collapse_button_height (Theme* self) {
	gint result;
	gint _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_collapse_button_height;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 920 "Theme.c"
}


void theme_set_collapse_button_height (Theme* self, gint value) {
	gint _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_collapse_button_height = _tmp0_;
#line 37 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "collapse-button-height");
#line 934 "Theme.c"
}


void theme_get_menu_button_arrow_color (Theme* self, ClutterColor* result) {
	ClutterColor _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_menu_button_arrow_color;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	*result = _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return;
#line 948 "Theme.c"
}


void theme_set_menu_button_arrow_color (Theme* self, ClutterColor* value) {
	ClutterColor _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = *value;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_menu_button_arrow_color = _tmp0_;
#line 39 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "menu-button-arrow-color");
#line 962 "Theme.c"
}


gint theme_get_margin_left (Theme* self) {
	gint result;
	gint _tmp0_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_margin_left;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 977 "Theme.c"
}


void theme_set_margin_left (Theme* self, gint value) {
	gint _tmp0_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_margin_left = _tmp0_;
#line 41 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "margin-left");
#line 991 "Theme.c"
}


gint theme_get_margin_right (Theme* self) {
	gint result;
	gint _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_margin_right;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 1006 "Theme.c"
}


void theme_set_margin_right (Theme* self, gint value) {
	gint _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_margin_right = _tmp0_;
#line 42 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "margin-right");
#line 1020 "Theme.c"
}


gint theme_get_cursor_minimum_opacity (Theme* self) {
	gint result;
	gint _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_cursor_minimum_opacity;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 1035 "Theme.c"
}


void theme_set_cursor_minimum_opacity (Theme* self, gint value) {
	gint _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_cursor_minimum_opacity = _tmp0_;
#line 44 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "cursor-minimum-opacity");
#line 1049 "Theme.c"
}


gint theme_get_cursor_maximum_opacity (Theme* self) {
	gint result;
	gint _tmp0_;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_cursor_maximum_opacity;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 1064 "Theme.c"
}


void theme_set_cursor_maximum_opacity (Theme* self, gint value) {
	gint _tmp0_;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_cursor_maximum_opacity = _tmp0_;
#line 45 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "cursor-maximum-opacity");
#line 1078 "Theme.c"
}


gint theme_get_cursor_blinking_interval (Theme* self) {
	gint result;
	gint _tmp0_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_cursor_blinking_interval;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 1093 "Theme.c"
}


void theme_set_cursor_blinking_interval (Theme* self, gint value) {
	gint _tmp0_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_cursor_blinking_interval = _tmp0_;
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "cursor-blinking-interval");
#line 1107 "Theme.c"
}


gint theme_get_cursor_motion_speed (Theme* self) {
	gint result;
	gint _tmp0_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = self->priv->_cursor_motion_speed;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	return result;
#line 1122 "Theme.c"
}


void theme_set_cursor_motion_speed (Theme* self, gint value) {
	gint _tmp0_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_tmp0_ = value;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv->_cursor_motion_speed = _tmp0_;
#line 48 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_notify ((GObject *) self, "cursor-motion-speed");
#line 1136 "Theme.c"
}


static void theme_class_init (ThemeClass * klass) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	theme_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_type_class_add_private (klass, sizeof (ThemePrivate));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_get_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_set_property;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_AUTHOR, g_param_spec_string ("author", "author", "author", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_STYLE, g_param_spec_object ("style", "style", "style", mx_style_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_GUTTER_SIZE, g_param_spec_int ("gutter-size", "gutter-size", "gutter-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_GUTTER_COLOR, g_param_spec_boxed ("gutter-color", "gutter-color", "gutter-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_GUTTER_BORDER_COLOR, g_param_spec_boxed ("gutter-border-color", "gutter-border-color", "gutter-border-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_COLLAPSE_BUTTON_X, g_param_spec_int ("collapse-button-x", "collapse-button-x", "collapse-button-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_COLLAPSE_BUTTON_Y, g_param_spec_int ("collapse-button-y", "collapse-button-y", "collapse-button-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_COLLAPSE_BUTTON_WIDTH, g_param_spec_int ("collapse-button-width", "collapse-button-width", "collapse-button-width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_COLLAPSE_BUTTON_HEIGHT, g_param_spec_int ("collapse-button-height", "collapse-button-height", "collapse-button-height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MENU_BUTTON_ARROW_COLOR, g_param_spec_boxed ("menu-button-arrow-color", "menu-button-arrow-color", "menu-button-arrow-color", CLUTTER_TYPE_COLOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MARGIN_LEFT, g_param_spec_int ("margin-left", "margin-left", "margin-left", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_MARGIN_RIGHT, g_param_spec_int ("margin-right", "margin-right", "margin-right", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CURSOR_MINIMUM_OPACITY, g_param_spec_int ("cursor-minimum-opacity", "cursor-minimum-opacity", "cursor-minimum-opacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CURSOR_MAXIMUM_OPACITY, g_param_spec_int ("cursor-maximum-opacity", "cursor-maximum-opacity", "cursor-maximum-opacity", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CURSOR_BLINKING_INTERVAL, g_param_spec_int ("cursor-blinking-interval", "cursor-blinking-interval", "cursor-blinking-interval", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CURSOR_MOTION_SPEED, g_param_spec_int ("cursor-motion-speed", "cursor-motion-speed", "cursor-motion-speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1185 "Theme.c"
}


static void theme_instance_init (Theme * self) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self->priv = THEME_GET_PRIVATE (self);
#line 1192 "Theme.c"
}


static void theme_finalize (GObject* obj) {
	Theme * self;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
#line 25 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_free0 (self->priv->_name);
#line 26 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_free0 (self->priv->_author);
#line 28 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	_g_object_unref0 (self->priv->_style);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
#line 1208 "Theme.c"
}


GType theme_get_type (void) {
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
		GType theme_type_id;
		theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, 0);
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}


static void _vala_theme_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_string (value, theme_get_name (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_AUTHOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_string (value, theme_get_author (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_STYLE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_object (value, theme_get_style (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_SIZE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_gutter_size (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_COLOR:
#line 1255 "Theme.c"
		{
			ClutterColor boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			theme_get_gutter_color (self, &boxed);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1262 "Theme.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_BORDER_COLOR:
#line 1268 "Theme.c"
		{
			ClutterColor boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			theme_get_gutter_border_color (self, &boxed);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1275 "Theme.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_X:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_collapse_button_x (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_Y:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_collapse_button_y (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_WIDTH:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_collapse_button_width (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_HEIGHT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_collapse_button_height (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MENU_BUTTON_ARROW_COLOR:
#line 1305 "Theme.c"
		{
			ClutterColor boxed;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			theme_get_menu_button_arrow_color (self, &boxed);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
			g_value_set_boxed (value, &boxed);
#line 1312 "Theme.c"
		}
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MARGIN_LEFT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_margin_left (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MARGIN_RIGHT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_margin_right (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MINIMUM_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_cursor_minimum_opacity (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MAXIMUM_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_cursor_maximum_opacity (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_BLINKING_INTERVAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_cursor_blinking_interval (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MOTION_SPEED:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		g_value_set_int (value, theme_get_cursor_motion_speed (self));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 1352 "Theme.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 1358 "Theme.c"
	}
}


static void _vala_theme_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_NAME:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_AUTHOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_author (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_STYLE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_style (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_SIZE:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_size (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_COLOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_color (self, g_value_get_boxed (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_GUTTER_BORDER_COLOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_gutter_border_color (self, g_value_get_boxed (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_X:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_x (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_Y:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_y (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_WIDTH:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_width (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_COLLAPSE_BUTTON_HEIGHT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_collapse_button_height (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MENU_BUTTON_ARROW_COLOR:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_menu_button_arrow_color (self, g_value_get_boxed (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MARGIN_LEFT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_margin_left (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_MARGIN_RIGHT:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_margin_right (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MINIMUM_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_minimum_opacity (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MAXIMUM_OPACITY:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_maximum_opacity (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_BLINKING_INTERVAL:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_blinking_interval (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		case THEME_CURSOR_MOTION_SPEED:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		theme_set_cursor_motion_speed (self, g_value_get_int (value));
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 1470 "Theme.c"
		default:
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/Theme.vala"
		break;
#line 1476 "Theme.c"
	}
}



