/* TerminalOutput.c generated by valac 0.20.1, the Vala compiler
 * generated from TerminalOutput.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Interprets a terminal stream, generating line-by-line formatted screen output
 *
 * The list elements of this class are mutable,
 * because the screen output can be retroactively
 * modified by control sequences.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>


#define TYPE_TERMINAL_OUTPUT (terminal_output_get_type ())
#define TERMINAL_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TERMINAL_OUTPUT, TerminalOutput))
#define TERMINAL_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TERMINAL_OUTPUT, TerminalOutputClass))
#define IS_TERMINAL_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TERMINAL_OUTPUT))
#define IS_TERMINAL_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TERMINAL_OUTPUT))
#define TERMINAL_OUTPUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TERMINAL_OUTPUT, TerminalOutputClass))

typedef struct _TerminalOutput TerminalOutput;
typedef struct _TerminalOutputClass TerminalOutputClass;
typedef struct _TerminalOutputPrivate TerminalOutputPrivate;

#define TERMINAL_OUTPUT_TYPE_CURSOR_POSITION (terminal_output_cursor_position_get_type ())
typedef struct _TerminalOutputCursorPosition TerminalOutputCursorPosition;

#define TYPE_TERMINAL (terminal_get_type ())
#define TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TERMINAL, Terminal))
#define TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TERMINAL, TerminalClass))
#define IS_TERMINAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TERMINAL))
#define IS_TERMINAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TERMINAL))
#define TERMINAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TERMINAL, TerminalClass))

typedef struct _Terminal Terminal;
typedef struct _TerminalClass TerminalClass;

#define TERMINAL_OUTPUT_TYPE_TERMINAL_MODE (terminal_output_terminal_mode_get_type ())

#define TYPE_CHARACTER_ATTRIBUTES (character_attributes_get_type ())
#define CHARACTER_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributes))
#define CHARACTER_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributesClass))
#define IS_CHARACTER_ATTRIBUTES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHARACTER_ATTRIBUTES))
#define IS_CHARACTER_ATTRIBUTES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHARACTER_ATTRIBUTES))
#define CHARACTER_ATTRIBUTES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHARACTER_ATTRIBUTES, CharacterAttributesClass))

typedef struct _CharacterAttributes CharacterAttributes;
typedef struct _CharacterAttributesClass CharacterAttributesClass;

#define TERMINAL_OUTPUT_TYPE_INTERPRETATION_STATUS (terminal_output_interpretation_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_OUTPUT_TYPE_OUTPUT_LINE (terminal_output_output_line_get_type ())
#define TERMINAL_OUTPUT_OUTPUT_LINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLine))
#define TERMINAL_OUTPUT_OUTPUT_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLineClass))
#define TERMINAL_OUTPUT_IS_OUTPUT_LINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE))
#define TERMINAL_OUTPUT_IS_OUTPUT_LINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE))
#define TERMINAL_OUTPUT_OUTPUT_LINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLineClass))

typedef struct _TerminalOutputOutputLine TerminalOutputOutputLine;
typedef struct _TerminalOutputOutputLineClass TerminalOutputOutputLineClass;

#define TERMINAL_STREAM_TYPE_STREAM_ELEMENT (terminal_stream_stream_element_get_type ())
#define TERMINAL_STREAM_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement))
#define TERMINAL_STREAM_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_STREAM_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))

typedef struct _TerminalStreamStreamElement TerminalStreamStreamElement;
typedef struct _TerminalStreamStreamElementClass TerminalStreamStreamElementClass;

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_STREAM_ELEMENT_TYPE (terminal_stream_stream_element_stream_element_type_get_type ())

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE (terminal_stream_stream_element_control_sequence_type_get_type ())

#define TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT (terminal_output_text_element_get_type ())
#define TERMINAL_OUTPUT_TEXT_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElement))
#define TERMINAL_OUTPUT_TEXT_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElementClass))
#define TERMINAL_OUTPUT_IS_TEXT_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT))
#define TERMINAL_OUTPUT_IS_TEXT_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT))
#define TERMINAL_OUTPUT_TEXT_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElementClass))

typedef struct _TerminalOutputTextElement TerminalOutputTextElement;
typedef struct _TerminalOutputTextElementClass TerminalOutputTextElementClass;

#define TYPE_TEXT_MENU (text_menu_get_type ())
#define TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TEXT_MENU, TextMenu))
#define TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TEXT_MENU, TextMenuClass))
#define IS_TEXT_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TEXT_MENU))
#define IS_TEXT_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TEXT_MENU))
#define TEXT_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TEXT_MENU, TextMenuClass))

typedef struct _TextMenu TextMenu;
typedef struct _TextMenuClass TextMenuClass;

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _TerminalOutputOutputLinePrivate TerminalOutputOutputLinePrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
typedef struct _TerminalOutputTextElementPrivate TerminalOutputTextElementPrivate;
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _TerminalOutputCursorPosition {
	gint line;
	gint column;
};

struct _TerminalOutput {
	GeeArrayList parent_instance;
	TerminalOutputPrivate * priv;
	TerminalOutputCursorPosition cursor_position;
	gboolean command_mode;
	TerminalOutputCursorPosition command_start_position;
};

struct _TerminalOutputClass {
	GeeArrayListClass parent_class;
};

typedef enum  {
	TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD = 1 << 0,
	TERMINAL_OUTPUT_TERMINAL_MODE_NUMLOCK = 1 << 1,
	TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR = 1 << 2,
	TERMINAL_OUTPUT_TERMINAL_MODE_CRLF = 1 << 3
} TerminalOutputTerminalMode;

struct _TerminalOutputPrivate {
	Terminal* terminal;
	gchar* _terminal_title;
	TerminalOutputTerminalMode _terminal_modes;
	CharacterAttributes* current_attributes;
	gint _screen_offset;
	gchar* transient_text;
	gchar* printed_transient_text;
	gchar* last_command;
};

typedef enum  {
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED,
	TERMINAL_OUTPUT_INTERPRETATION_STATUS_SUPPORTED
} TerminalOutputInterpretationStatus;

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT,
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE
} TerminalStreamStreamElementStreamElementType;

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS
} TerminalStreamStreamElementControlSequenceType;

struct _TerminalOutputOutputLine {
	GeeArrayList parent_instance;
	TerminalOutputOutputLinePrivate * priv;
};

struct _TerminalOutputOutputLineClass {
	GeeArrayListClass parent_class;
};

struct _TerminalOutputOutputLinePrivate {
	gboolean _is_prompt_line;
	gint _return_code;
};

struct _TerminalOutputTextElement {
	GObject parent_instance;
	TerminalOutputTextElementPrivate * priv;
};

struct _TerminalOutputTextElementClass {
	GObjectClass parent_class;
};

struct _TerminalOutputTextElementPrivate {
	gchar* _text;
	CharacterAttributes* _attributes;
};


static gpointer terminal_output_parent_class = NULL;
static gpointer terminal_output_output_line_parent_class = NULL;
static gpointer terminal_output_text_element_parent_class = NULL;

GType terminal_output_get_type (void) G_GNUC_CONST;
GType terminal_output_cursor_position_get_type (void) G_GNUC_CONST;
TerminalOutputCursorPosition* terminal_output_cursor_position_dup (const TerminalOutputCursorPosition* self);
void terminal_output_cursor_position_free (TerminalOutputCursorPosition* self);
GType terminal_get_type (void) G_GNUC_CONST;
GType terminal_output_terminal_mode_get_type (void) G_GNUC_CONST;
GType character_attributes_get_type (void) G_GNUC_CONST;
#define TERMINAL_OUTPUT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TERMINAL_OUTPUT, TerminalOutputPrivate))
enum  {
	TERMINAL_OUTPUT_DUMMY_PROPERTY,
	TERMINAL_OUTPUT_TERMINAL_TITLE,
	TERMINAL_OUTPUT_TERMINAL_MODES,
	TERMINAL_OUTPUT_SCREEN_OFFSET
};
GType terminal_output_interpretation_status_get_type (void) G_GNUC_CONST;
TerminalOutput* terminal_output_new (Terminal* terminal);
TerminalOutput* terminal_output_construct (GType object_type, Terminal* terminal);
GType terminal_output_output_line_get_type (void) G_GNUC_CONST;
CharacterAttributes* character_attributes_new (void);
CharacterAttributes* character_attributes_construct (GType object_type);
void terminal_output_set_screen_offset (TerminalOutput* self, gint value);
static void terminal_output_move_cursor (TerminalOutput* self, gint line, gint column);
static void terminal_output_on_line_updated (TerminalOutput* self, gint line_index);
static void _terminal_output_on_line_updated_terminal_output_line_updated (TerminalOutput* _sender, gint line_index, gpointer self);
GType terminal_stream_stream_element_get_type (void) G_GNUC_CONST;
void terminal_output_parse_stream_element (TerminalOutput* self, TerminalStreamStreamElement* stream_element);
GType terminal_stream_stream_element_stream_element_type_get_type (void) G_GNUC_CONST;
TerminalStreamStreamElementStreamElementType terminal_stream_stream_element_get_stream_element_type (TerminalStreamStreamElement* self);
const gchar* terminal_stream_stream_element_get_text (TerminalStreamStreamElement* self);
static void terminal_output_print_text (TerminalOutput* self, const gchar* text);
GType terminal_stream_stream_element_control_sequence_type_get_type (void) G_GNUC_CONST;
TerminalStreamStreamElementControlSequenceType terminal_stream_stream_element_get_control_sequence_type (TerminalStreamStreamElement* self);
TerminalOutputTerminalMode terminal_output_get_terminal_modes (TerminalOutput* self);
void terminal_output_set_terminal_modes (TerminalOutput* self, TerminalOutputTerminalMode value);
GeeList* terminal_stream_stream_element_get_control_sequence_parameters (TerminalStreamStreamElement* self);
gint terminal_stream_stream_element_get_numeric_parameter (TerminalStreamStreamElement* self, gint index, gint default_value);
void terminal_output_print_interpretation_status (TerminalStreamStreamElement* stream_element, TerminalOutputInterpretationStatus interpretation_status);
static void terminal_output_erase_range_screen (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position);
static void terminal_output_get_screen_position (TerminalOutput* self, TerminalOutputCursorPosition* position, TerminalOutputCursorPosition* result);
gint terminal_get_lines (Terminal* self);
gint terminal_get_columns (Terminal* self);
gint terminal_output_get_screen_offset (TerminalOutput* self);
static void terminal_output_erase_line_range (TerminalOutput* self, gint line, gint start_position, gint end_position);
gchar* utilities_repeat_string (const gchar* text, gint count);
TerminalOutputTextElement* terminal_output_text_element_new (const gchar* text, CharacterAttributes* attributes);
TerminalOutputTextElement* terminal_output_text_element_construct (GType object_type, const gchar* text, CharacterAttributes* attributes);
GType terminal_output_text_element_get_type (void) G_GNUC_CONST;
void terminal_output_output_line_insert_element (TerminalOutputOutputLine* self, TerminalOutputTextElement* text_element, gint position, gboolean overwrite);
static void terminal_output_move_cursor_screen (TerminalOutput* self, gint line, gint column);
CharacterAttributes* character_attributes_new_from_stream_element (TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes);
CharacterAttributes* character_attributes_construct_from_stream_element (GType object_type, TerminalStreamStreamElement* stream_element, CharacterAttributes* current_attributes);
gchar* terminal_stream_stream_element_get_text_parameter (TerminalStreamStreamElement* self, gint index, const gchar* default_value);
void terminal_output_set_terminal_title (TerminalOutput* self, const gchar* value);
void terminal_output_output_line_set_is_prompt_line (TerminalOutputOutputLine* self, gboolean value);
gboolean terminal_output_output_line_get_is_prompt_line (TerminalOutputOutputLine* self);
void terminal_output_output_line_set_return_code (TerminalOutputOutputLine* self, gint value);
CharacterAttributes* character_attributes_new_copy (CharacterAttributes* character_attributes);
CharacterAttributes* character_attributes_construct_copy (GType object_type, CharacterAttributes* character_attributes);
GType text_menu_get_type (void) G_GNUC_CONST;
GeeMap* final_term_get_text_menus_by_code (void);
void character_attributes_set_text_menu (CharacterAttributes* self, TextMenu* value);
GType command_get_type (void) G_GNUC_CONST;
Command* command_new_from_command_specification (const gchar* command_specification);
Command* command_construct_from_command_specification (GType object_type, const gchar* command_specification);
void command_execute (Command* self, GeeList* placeholder_substitutes);
const gchar* terminal_stream_stream_element_control_sequence_type_to_string (TerminalStreamStreamElementControlSequenceType self);
void terminal_output_parse_transient_text (TerminalOutput* self, const gchar* transient_text);
void terminal_output_print_transient_text (TerminalOutput* self);
gchar* terminal_output_get_command (TerminalOutput* self);
gint terminal_output_cursor_position_compare (TerminalOutputCursorPosition *self, TerminalOutputCursorPosition* position);
static gchar* terminal_output_get_range (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position);
gint terminal_output_text_element_get_length (TerminalOutputTextElement* self);
static void terminal_output_get_absolute_position (TerminalOutput* self, TerminalOutputCursorPosition* position, TerminalOutputCursorPosition* result);
TerminalOutputOutputLine* terminal_output_output_line_new (void);
TerminalOutputOutputLine* terminal_output_output_line_construct (GType object_type);
gint terminal_output_output_line_get_length (TerminalOutputOutputLine* self);
gchar* terminal_output_output_line_get_text (TerminalOutputOutputLine* self);
static void terminal_output_erase_range (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position);
void terminal_output_output_line_erase_range (TerminalOutputOutputLine* self, gint start_position, gint end_position);
const gchar* terminal_output_get_terminal_title (TerminalOutput* self);
static void g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
#define TERMINAL_OUTPUT_OUTPUT_LINE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLinePrivate))
enum  {
	TERMINAL_OUTPUT_OUTPUT_LINE_DUMMY_PROPERTY,
	TERMINAL_OUTPUT_OUTPUT_LINE_IS_PROMPT_LINE,
	TERMINAL_OUTPUT_OUTPUT_LINE_RETURN_CODE
};
TerminalOutputOutputLine* terminal_output_output_line_generate_text_menu_elements (TerminalOutputOutputLine* self);
GeeMap* final_term_get_text_menus_by_pattern (void);
gint terminal_output_output_line_get_return_code (TerminalOutputOutputLine* self);
GeeList* terminal_output_text_element_get_text_menu_elements (TerminalOutputTextElement* self);
GeeList* terminal_output_output_line_explode (TerminalOutputOutputLine* self);
void terminal_output_output_line_assemble (TerminalOutputOutputLine* self, GeeList* text_elements);
void terminal_output_output_line_optimize (TerminalOutputOutputLine* self);
TerminalOutputTextElement** terminal_output_text_element_explode (TerminalOutputTextElement* self, int* result_length1);
CharacterAttributes* terminal_output_text_element_get_attributes (TerminalOutputTextElement* self);
gboolean character_attributes_equals (CharacterAttributes* self, CharacterAttributes* attributes);
const gchar* terminal_output_text_element_get_text (TerminalOutputTextElement* self);
void terminal_output_output_line_get_text_element_from_index (TerminalOutputOutputLine* self, gint index, TerminalOutputTextElement** text_element, gint** position);
static gint* _int_dup (gint* self);
static void terminal_output_output_line_finalize (GObject* obj);
static void _vala_terminal_output_output_line_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_terminal_output_output_line_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define TERMINAL_OUTPUT_TEXT_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElementPrivate))
enum  {
	TERMINAL_OUTPUT_TEXT_ELEMENT_DUMMY_PROPERTY,
	TERMINAL_OUTPUT_TEXT_ELEMENT_TEXT,
	TERMINAL_OUTPUT_TEXT_ELEMENT_ATTRIBUTES
};
void terminal_output_text_element_set_text (TerminalOutputTextElement* self, const gchar* value);
void terminal_output_text_element_set_attributes (TerminalOutputTextElement* self, CharacterAttributes* value);
TerminalOutputTextElement* terminal_output_text_element_new_copy (TerminalOutputTextElement* text_element);
TerminalOutputTextElement* terminal_output_text_element_construct_copy (GType object_type, TerminalOutputTextElement* text_element);
GeeList* terminal_output_text_element_get_text_menu_elements_for_pattern (TerminalOutputTextElement* self, TerminalOutputTextElement* text_element, GRegex* pattern);
static void terminal_output_text_element_finalize (GObject* obj);
static void _vala_terminal_output_text_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_terminal_output_text_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void terminal_output_finalize (GObject* obj);
static void _vala_terminal_output_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_terminal_output_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


GType terminal_output_terminal_mode_get_type (void) {
	static volatile gsize terminal_output_terminal_mode_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_terminal_mode_type_id__volatile)) {
		static const GFlagsValue values[] = {{TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD, "TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD", "keypad"}, {TERMINAL_OUTPUT_TERMINAL_MODE_NUMLOCK, "TERMINAL_OUTPUT_TERMINAL_MODE_NUMLOCK", "numlock"}, {TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR, "TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR", "cursor"}, {TERMINAL_OUTPUT_TERMINAL_MODE_CRLF, "TERMINAL_OUTPUT_TERMINAL_MODE_CRLF", "crlf"}, {0, NULL, NULL}};
		GType terminal_output_terminal_mode_type_id;
		terminal_output_terminal_mode_type_id = g_flags_register_static ("TerminalOutputTerminalMode", values);
		g_once_init_leave (&terminal_output_terminal_mode_type_id__volatile, terminal_output_terminal_mode_type_id);
	}
	return terminal_output_terminal_mode_type_id__volatile;
}


GType terminal_output_interpretation_status_get_type (void) {
	static volatile gsize terminal_output_interpretation_status_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_interpretation_status_type_id__volatile)) {
		static const GEnumValue values[] = {{TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID, "TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID", "invalid"}, {TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED, "TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED", "unrecognized"}, {TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED, "TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED", "unsupported"}, {TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED, "TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED", "partially-supported"}, {TERMINAL_OUTPUT_INTERPRETATION_STATUS_SUPPORTED, "TERMINAL_OUTPUT_INTERPRETATION_STATUS_SUPPORTED", "supported"}, {0, NULL, NULL}};
		GType terminal_output_interpretation_status_type_id;
		terminal_output_interpretation_status_type_id = g_enum_register_static ("TerminalOutputInterpretationStatus", values);
		g_once_init_leave (&terminal_output_interpretation_status_type_id__volatile, terminal_output_interpretation_status_type_id);
	}
	return terminal_output_interpretation_status_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self ? g_object_ref (self) : NULL;
#line 514 "TerminalOutput.c"
}


static void _terminal_output_on_line_updated_terminal_output_line_updated (TerminalOutput* _sender, gint line_index, gpointer self) {
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_on_line_updated (self, line_index);
#line 521 "TerminalOutput.c"
}


TerminalOutput* terminal_output_construct (GType object_type, Terminal* terminal) {
	TerminalOutput * self = NULL;
	Terminal* _tmp0_;
	Terminal* _tmp1_;
	CharacterAttributes* _tmp2_;
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (terminal != NULL, NULL);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = (TerminalOutput*) gee_array_list_construct (object_type, TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = terminal;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->terminal);
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->terminal = _tmp1_;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = character_attributes_new ();
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->current_attributes);
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->current_attributes = _tmp2_;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_set_screen_offset (self, 0);
#line 85 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_move_cursor (self, 0, 0);
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_connect_object (self, "line-updated", (GCallback) _terminal_output_on_line_updated_terminal_output_line_updated, self, 0);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self;
#line 556 "TerminalOutput.c"
}


TerminalOutput* terminal_output_new (Terminal* terminal) {
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return terminal_output_construct (TYPE_TERMINAL_OUTPUT, terminal);
#line 563 "TerminalOutput.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1157 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1158 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1158 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 586 "TerminalOutput.c"
		glong _tmp4_;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1159 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 594 "TerminalOutput.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1161 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		return result;
#line 606 "TerminalOutput.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1168 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 631 "TerminalOutput.c"
		glong _tmp2_;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 637 "TerminalOutput.c"
	} else {
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 641 "TerminalOutput.c"
	}
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1170 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 647 "TerminalOutput.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1172 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 659 "TerminalOutput.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1174 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 669 "TerminalOutput.c"
	}
#line 1177 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1177 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 675 "TerminalOutput.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1178 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1179 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1179 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 689 "TerminalOutput.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1181 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 699 "TerminalOutput.c"
	}
#line 1183 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1183 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 705 "TerminalOutput.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1184 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 714 "TerminalOutput.c"
	}
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1186 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1187 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 734 "TerminalOutput.c"
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1016 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = c;
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = (gint) (_tmp1_ - ((gchar*) self));
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 752 "TerminalOutput.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
#line 1085 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1086 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1086 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1087 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1087 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1088 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _result_;
#line 1088 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 775 "TerminalOutput.c"
}


void terminal_output_parse_stream_element (TerminalOutput* self, TerminalStreamStreamElement* stream_element) {
	TerminalStreamStreamElement* _tmp0_;
	TerminalStreamStreamElementStreamElementType _tmp1_;
	TerminalStreamStreamElementStreamElementType _tmp2_;
	gchar* _tmp308_;
	gchar* _tmp309_;
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (stream_element != NULL);
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = stream_element;
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = terminal_stream_stream_element_get_stream_element_type (_tmp0_);
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = _tmp1_;
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (_tmp2_) {
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT:
#line 799 "TerminalOutput.c"
		{
			TerminalStreamStreamElement* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			TerminalStreamStreamElement* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
			gchar* _tmp12_ = NULL;
			gchar* text_left;
			const gchar* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			const gchar* _tmp16_;
			TerminalOutputCursorPosition _tmp17_;
			gint _tmp18_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp3_ = stream_element;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp4_ = terminal_stream_stream_element_get_text (_tmp3_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _tmp4_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = stream_element;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = terminal_stream_stream_element_get_text (_tmp6_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _tmp7_;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = self->priv->printed_transient_text;
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = g_utf8_strlen (_tmp9_, (gssize) (-1));
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = string_index_of_nth_char (_tmp8_, (glong) _tmp10_);
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = string_substring (_tmp5_, (glong) _tmp11_, (glong) (-1));
#line 97 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_left = _tmp12_;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp13_ = text_left;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp14_ = strlen (_tmp13_);
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15_ = _tmp14_;
#line 101 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (_tmp15_ == 0) {
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_free0 (text_left);
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 852 "TerminalOutput.c"
			}
#line 104 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp16_ = text_left;
#line 104 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			terminal_output_print_text (self, _tmp16_);
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = self->cursor_position;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp18_ = _tmp17_.line;
#line 105 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_signal_emit_by_name (self, "line-updated", _tmp18_);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_free0 (text_left);
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 868 "TerminalOutput.c"
		}
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE:
#line 872 "TerminalOutput.c"
		{
			TerminalStreamStreamElement* _tmp19_;
			TerminalStreamStreamElementControlSequenceType _tmp20_;
			TerminalStreamStreamElementControlSequenceType _tmp21_;
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp19_ = stream_element;
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp20_ = terminal_stream_stream_element_get_control_sequence_type (_tmp19_);
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp21_ = _tmp20_;
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			switch (_tmp21_) {
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN:
#line 887 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp22_;
					gint _tmp23_;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp22_ = self->cursor_position;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp23_ = _tmp22_.line;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp23_, 0);
#line 119 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 899 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB:
#line 907 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp24_;
					gint _tmp25_;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp24_ = self->cursor_position;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp25_ = _tmp24_.line;
#line 126 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp25_ + 1, 0);
#line 127 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 919 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB:
#line 923 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp26_;
					gint _tmp27_;
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_print_text (self, "\t");
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp26_ = self->cursor_position;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp27_ = _tmp26_.line;
#line 133 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_signal_emit_by_name (self, "line-updated", _tmp27_);
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 937 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL:
#line 941 "TerminalOutput.c"
				{
#line 138 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					gdk_beep ();
#line 139 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 947 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD:
#line 951 "TerminalOutput.c"
				{
					TerminalOutputTerminalMode _tmp28_;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp28_ = self->priv->_terminal_modes;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_set_terminal_modes (self, _tmp28_ | TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD);
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 960 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD:
#line 964 "TerminalOutput.c"
				{
					TerminalOutputTerminalMode _tmp29_;
#line 146 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp29_ = self->priv->_terminal_modes;
#line 146 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_set_terminal_modes (self, _tmp29_ & (~TERMINAL_OUTPUT_TERMINAL_MODE_KEYPAD));
#line 147 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 973 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE:
#line 977 "TerminalOutput.c"
				{
					{
						gint i;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						i = 0;
#line 983 "TerminalOutput.c"
						{
							gboolean _tmp30_;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp30_ = TRUE;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							while (TRUE) {
#line 990 "TerminalOutput.c"
								gboolean _tmp31_;
								gint _tmp33_;
								TerminalStreamStreamElement* _tmp34_;
								GeeList* _tmp35_;
								GeeList* _tmp36_;
								gint _tmp37_;
								gint _tmp38_;
								TerminalStreamStreamElement* _tmp39_;
								gint _tmp40_;
								gint _tmp41_ = 0;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp31_ = _tmp30_;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!_tmp31_) {
#line 1005 "TerminalOutput.c"
									gint _tmp32_;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp32_ = i;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									i = _tmp32_ + 1;
#line 1011 "TerminalOutput.c"
								}
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp30_ = FALSE;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp33_ = i;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp34_ = stream_element;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp35_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp34_);
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp36_ = _tmp35_;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp37_ = gee_collection_get_size ((GeeCollection*) _tmp36_);
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp38_ = _tmp37_;
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!(_tmp33_ < _tmp38_)) {
#line 151 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									break;
#line 1031 "TerminalOutput.c"
								}
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp39_ = stream_element;
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp40_ = i;
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp41_ = terminal_stream_stream_element_get_numeric_parameter (_tmp39_, _tmp40_, -1);
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								switch (_tmp41_) {
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									case 20:
#line 1043 "TerminalOutput.c"
									{
										TerminalOutputTerminalMode _tmp42_;
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp42_ = self->priv->_terminal_modes;
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_set_terminal_modes (self, _tmp42_ | TERMINAL_OUTPUT_TERMINAL_MODE_CRLF);
#line 156 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1052 "TerminalOutput.c"
									}
									default:
									{
										TerminalStreamStreamElement* _tmp43_;
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp43_ = stream_element;
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_print_interpretation_status (_tmp43_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 159 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1063 "TerminalOutput.c"
									}
								}
							}
						}
					}
#line 162 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1071 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE:
#line 1075 "TerminalOutput.c"
				{
					{
						gint i;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						i = 0;
#line 1081 "TerminalOutput.c"
						{
							gboolean _tmp44_;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp44_ = TRUE;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							while (TRUE) {
#line 1088 "TerminalOutput.c"
								gboolean _tmp45_;
								gint _tmp47_;
								TerminalStreamStreamElement* _tmp48_;
								GeeList* _tmp49_;
								GeeList* _tmp50_;
								gint _tmp51_;
								gint _tmp52_;
								TerminalStreamStreamElement* _tmp53_;
								gint _tmp54_;
								gint _tmp55_ = 0;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp45_ = _tmp44_;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!_tmp45_) {
#line 1103 "TerminalOutput.c"
									gint _tmp46_;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp46_ = i;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									i = _tmp46_ + 1;
#line 1109 "TerminalOutput.c"
								}
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp44_ = FALSE;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp47_ = i;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp48_ = stream_element;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp49_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp48_);
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp50_ = _tmp49_;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp51_ = gee_collection_get_size ((GeeCollection*) _tmp50_);
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp52_ = _tmp51_;
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!(_tmp47_ < _tmp52_)) {
#line 165 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									break;
#line 1129 "TerminalOutput.c"
								}
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp53_ = stream_element;
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp54_ = i;
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp55_ = terminal_stream_stream_element_get_numeric_parameter (_tmp53_, _tmp54_, -1);
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								switch (_tmp55_) {
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									case 20:
#line 1141 "TerminalOutput.c"
									{
										TerminalOutputTerminalMode _tmp56_;
#line 169 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp56_ = self->priv->_terminal_modes;
#line 169 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_set_terminal_modes (self, _tmp56_ & (~TERMINAL_OUTPUT_TERMINAL_MODE_CRLF));
#line 170 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1150 "TerminalOutput.c"
									}
									default:
									{
										TerminalStreamStreamElement* _tmp57_;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp57_ = stream_element;
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_print_interpretation_status (_tmp57_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 173 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1161 "TerminalOutput.c"
									}
								}
							}
						}
					}
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1169 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET:
#line 1173 "TerminalOutput.c"
				{
					{
						gint i;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						i = 0;
#line 1179 "TerminalOutput.c"
						{
							gboolean _tmp58_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp58_ = TRUE;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							while (TRUE) {
#line 1186 "TerminalOutput.c"
								gboolean _tmp59_;
								gint _tmp61_;
								TerminalStreamStreamElement* _tmp62_;
								GeeList* _tmp63_;
								GeeList* _tmp64_;
								gint _tmp65_;
								gint _tmp66_;
								TerminalStreamStreamElement* _tmp67_;
								gint _tmp68_;
								gint _tmp69_ = 0;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp59_ = _tmp58_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!_tmp59_) {
#line 1201 "TerminalOutput.c"
									gint _tmp60_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp60_ = i;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									i = _tmp60_ + 1;
#line 1207 "TerminalOutput.c"
								}
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp58_ = FALSE;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp61_ = i;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp62_ = stream_element;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp63_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp62_);
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp64_ = _tmp63_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp65_ = gee_collection_get_size ((GeeCollection*) _tmp64_);
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp66_ = _tmp65_;
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!(_tmp61_ < _tmp66_)) {
#line 179 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									break;
#line 1227 "TerminalOutput.c"
								}
#line 180 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp67_ = stream_element;
#line 180 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp68_ = i;
#line 180 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp69_ = terminal_stream_stream_element_get_numeric_parameter (_tmp67_, _tmp68_, -1);
#line 180 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								switch (_tmp69_) {
#line 180 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									case 1:
#line 1239 "TerminalOutput.c"
									{
										TerminalOutputTerminalMode _tmp70_;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp70_ = self->priv->_terminal_modes;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_set_terminal_modes (self, _tmp70_ | TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR);
#line 184 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1248 "TerminalOutput.c"
									}
									default:
									{
										TerminalStreamStreamElement* _tmp71_;
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp71_ = stream_element;
#line 186 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_print_interpretation_status (_tmp71_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 187 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1259 "TerminalOutput.c"
									}
								}
							}
						}
					}
#line 190 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1267 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET:
#line 1271 "TerminalOutput.c"
				{
					{
						gint i;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						i = 0;
#line 1277 "TerminalOutput.c"
						{
							gboolean _tmp72_;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp72_ = TRUE;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							while (TRUE) {
#line 1284 "TerminalOutput.c"
								gboolean _tmp73_;
								gint _tmp75_;
								TerminalStreamStreamElement* _tmp76_;
								GeeList* _tmp77_;
								GeeList* _tmp78_;
								gint _tmp79_;
								gint _tmp80_;
								TerminalStreamStreamElement* _tmp81_;
								gint _tmp82_;
								gint _tmp83_ = 0;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp73_ = _tmp72_;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!_tmp73_) {
#line 1299 "TerminalOutput.c"
									gint _tmp74_;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp74_ = i;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									i = _tmp74_ + 1;
#line 1305 "TerminalOutput.c"
								}
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp72_ = FALSE;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp75_ = i;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp76_ = stream_element;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp77_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp76_);
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp78_ = _tmp77_;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp79_ = gee_collection_get_size ((GeeCollection*) _tmp78_);
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp80_ = _tmp79_;
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (!(_tmp75_ < _tmp80_)) {
#line 193 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									break;
#line 1325 "TerminalOutput.c"
								}
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp81_ = stream_element;
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp82_ = i;
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp83_ = terminal_stream_stream_element_get_numeric_parameter (_tmp81_, _tmp82_, -1);
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								switch (_tmp83_) {
#line 194 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									case 1:
#line 1337 "TerminalOutput.c"
									{
										TerminalOutputTerminalMode _tmp84_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp84_ = self->priv->_terminal_modes;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_set_terminal_modes (self, _tmp84_ & (~TERMINAL_OUTPUT_TERMINAL_MODE_CURSOR));
#line 198 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1346 "TerminalOutput.c"
									}
									default:
									{
										TerminalStreamStreamElement* _tmp85_;
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp85_ = stream_element;
#line 200 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_print_interpretation_status (_tmp85_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 201 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 1357 "TerminalOutput.c"
									}
								}
							}
						}
					}
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1365 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE:
#line 1369 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp86_;
					gint _tmp87_;
					TerminalOutputCursorPosition _tmp88_;
					gint _tmp89_;
#line 209 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp86_ = self->cursor_position;
#line 209 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp87_ = _tmp86_.line;
#line 209 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp88_ = self->cursor_position;
#line 209 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp89_ = _tmp88_.column;
#line 209 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp87_, _tmp89_ - 1);
#line 210 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1387 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP:
#line 1391 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp90_;
					gint _tmp91_;
					TerminalStreamStreamElement* _tmp92_;
					gint _tmp93_ = 0;
					TerminalOutputCursorPosition _tmp94_;
					gint _tmp95_;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp90_ = self->cursor_position;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp91_ = _tmp90_.line;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp92_ = stream_element;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp93_ = terminal_stream_stream_element_get_numeric_parameter (_tmp92_, 0, 1);
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp94_ = self->cursor_position;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp95_ = _tmp94_.column;
#line 215 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp91_ - _tmp93_, _tmp95_);
#line 216 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1415 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE:
#line 1421 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp96_;
					gint _tmp97_;
					TerminalStreamStreamElement* _tmp98_;
					gint _tmp99_ = 0;
					TerminalOutputCursorPosition _tmp100_;
					gint _tmp101_;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp96_ = self->cursor_position;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp97_ = _tmp96_.line;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp98_ = stream_element;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp99_ = terminal_stream_stream_element_get_numeric_parameter (_tmp98_, 0, 1);
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp100_ = self->cursor_position;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp101_ = _tmp100_.column;
#line 222 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp97_ + _tmp99_, _tmp101_);
#line 223 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1445 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE:
#line 1451 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp102_;
					gint _tmp103_;
					TerminalOutputCursorPosition _tmp104_;
					gint _tmp105_;
					TerminalStreamStreamElement* _tmp106_;
					gint _tmp107_ = 0;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp102_ = self->cursor_position;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp103_ = _tmp102_.line;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp104_ = self->cursor_position;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp105_ = _tmp104_.column;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp106_ = stream_element;
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp107_ = terminal_stream_stream_element_get_numeric_parameter (_tmp106_, 0, 1);
#line 229 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp103_, _tmp105_ + _tmp107_);
#line 230 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1475 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD:
#line 1479 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp108_;
					gint _tmp109_;
					TerminalOutputCursorPosition _tmp110_;
					gint _tmp111_;
					TerminalStreamStreamElement* _tmp112_;
					gint _tmp113_ = 0;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp108_ = self->cursor_position;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp109_ = _tmp108_.line;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp110_ = self->cursor_position;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp111_ = _tmp110_.column;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp112_ = stream_element;
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp113_ = terminal_stream_stream_element_get_numeric_parameter (_tmp112_, 0, 1);
#line 235 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor (self, _tmp109_, _tmp111_ - _tmp113_);
#line 236 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1503 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED:
#line 1507 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp114_;
					gint _tmp115_ = 0;
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp114_ = stream_element;
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp115_ = terminal_stream_stream_element_get_numeric_parameter (_tmp114_, 0, 0);
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					switch (_tmp115_) {
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 0:
#line 1519 "TerminalOutput.c"
						{
							TerminalOutputCursorPosition _tmp116_;
							TerminalOutputCursorPosition _tmp117_ = {0};
							Terminal* _tmp118_;
							gint _tmp119_;
							gint _tmp120_;
							Terminal* _tmp121_;
							gint _tmp122_;
							gint _tmp123_;
							TerminalOutputCursorPosition _tmp124_ = {0};
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp116_ = self->cursor_position;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_get_screen_position (self, &_tmp116_, &_tmp117_);
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp118_ = self->priv->terminal;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp119_ = terminal_get_lines (_tmp118_);
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp120_ = _tmp119_;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp121_ = self->priv->terminal;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp122_ = terminal_get_columns (_tmp121_);
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp123_ = _tmp122_;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp124_.line = _tmp120_;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp124_.column = _tmp123_ + 1;
#line 242 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_erase_range_screen (self, &_tmp117_, &_tmp124_);
#line 243 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1554 "TerminalOutput.c"
						}
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 1:
#line 1558 "TerminalOutput.c"
						{
							TerminalOutputCursorPosition _tmp125_ = {0};
							TerminalOutputCursorPosition _tmp126_;
							TerminalOutputCursorPosition _tmp127_ = {0};
#line 246 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp125_.line = 1;
#line 246 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp125_.column = 1;
#line 246 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp126_ = self->cursor_position;
#line 246 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_get_screen_position (self, &_tmp126_, &_tmp127_);
#line 246 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_erase_range_screen (self, &_tmp125_, &_tmp127_);
#line 247 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1575 "TerminalOutput.c"
						}
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 2:
#line 1579 "TerminalOutput.c"
						{
							gint _tmp128_;
							gint _tmp129_;
							gint _tmp130_;
							gint visible_lines;
							gint _tmp131_;
							gint _tmp132_;
							TerminalOutputCursorPosition _tmp133_;
							gint _tmp134_;
							gint _tmp135_;
							TerminalOutputCursorPosition _tmp136_;
							gint _tmp137_;
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp128_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp129_ = _tmp128_;
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp130_ = self->priv->_screen_offset;
#line 277 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							visible_lines = _tmp129_ - _tmp130_;
#line 278 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp131_ = self->priv->_screen_offset;
#line 278 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp132_ = visible_lines;
#line 278 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_set_screen_offset (self, _tmp131_ + _tmp132_);
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp133_ = self->cursor_position;
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp134_ = _tmp133_.line;
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp135_ = visible_lines;
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp136_ = self->cursor_position;
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp137_ = _tmp136_.column;
#line 279 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_move_cursor (self, _tmp134_ + _tmp135_, _tmp137_);
#line 281 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1620 "TerminalOutput.c"
						}
#line 239 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 3:
#line 1624 "TerminalOutput.c"
						{
							TerminalStreamStreamElement* _tmp138_;
#line 285 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp138_ = stream_element;
#line 285 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_print_interpretation_status (_tmp138_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 286 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1633 "TerminalOutput.c"
						}
						default:
						{
							TerminalStreamStreamElement* _tmp139_;
#line 288 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp139_ = stream_element;
#line 288 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_print_interpretation_status (_tmp139_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 289 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1644 "TerminalOutput.c"
						}
					}
#line 291 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1649 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL:
#line 1653 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp140_;
					gint _tmp141_ = 0;
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp140_ = stream_element;
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp141_ = terminal_stream_stream_element_get_numeric_parameter (_tmp140_, 0, 0);
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					switch (_tmp141_) {
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 0:
#line 1665 "TerminalOutput.c"
						{
							TerminalOutputCursorPosition _tmp142_;
							gint _tmp143_;
							TerminalOutputCursorPosition _tmp144_;
							gint _tmp145_;
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp142_ = self->cursor_position;
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp143_ = _tmp142_.line;
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp144_ = self->cursor_position;
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp145_ = _tmp144_.column;
#line 297 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_erase_line_range (self, _tmp143_, _tmp145_, -1);
#line 298 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1683 "TerminalOutput.c"
						}
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 1:
#line 1687 "TerminalOutput.c"
						{
							TerminalOutputCursorPosition _tmp146_;
							gint _tmp147_;
							TerminalOutputCursorPosition _tmp148_;
							gint _tmp149_;
#line 303 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp146_ = self->cursor_position;
#line 303 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp147_ = _tmp146_.line;
#line 303 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp148_ = self->cursor_position;
#line 303 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp149_ = _tmp148_.column;
#line 303 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_erase_line_range (self, _tmp147_, 0, _tmp149_);
#line 304 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1705 "TerminalOutput.c"
						}
#line 294 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 2:
#line 1709 "TerminalOutput.c"
						{
							TerminalOutputCursorPosition _tmp150_;
							gint _tmp151_;
#line 307 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp150_ = self->cursor_position;
#line 307 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp151_ = _tmp150_.line;
#line 307 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_erase_line_range (self, _tmp151_, 0, -1);
#line 308 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1721 "TerminalOutput.c"
						}
						default:
						{
							TerminalStreamStreamElement* _tmp152_;
#line 310 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp152_ = stream_element;
#line 310 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_print_interpretation_status (_tmp152_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID);
#line 311 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1732 "TerminalOutput.c"
						}
					}
#line 313 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1737 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS:
#line 1741 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp153_;
					gint _tmp154_ = 0;
					gchar* _tmp155_ = NULL;
					gchar* _tmp156_;
					CharacterAttributes* _tmp157_;
					TerminalOutputTextElement* _tmp158_;
					TerminalOutputTextElement* _tmp159_;
					TerminalOutputTextElement* text_element;
					TerminalOutputCursorPosition _tmp160_;
					gint _tmp161_;
					gpointer _tmp162_ = NULL;
					TerminalOutputOutputLine* _tmp163_;
					TerminalOutputTextElement* _tmp164_;
					TerminalOutputCursorPosition _tmp165_;
					gint _tmp166_;
					TerminalOutputCursorPosition _tmp167_;
					gint _tmp168_;
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp153_ = stream_element;
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp154_ = terminal_stream_stream_element_get_numeric_parameter (_tmp153_, 0, 1);
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp155_ = utilities_repeat_string (" ", _tmp154_);
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp156_ = _tmp155_;
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp157_ = self->priv->current_attributes;
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp158_ = terminal_output_text_element_new (_tmp156_, _tmp157_);
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp159_ = _tmp158_;
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_free0 (_tmp156_);
#line 317 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					text_element = _tmp159_;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp160_ = self->cursor_position;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp161_ = _tmp160_.line;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp162_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp161_);
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp163_ = (TerminalOutputOutputLine*) _tmp162_;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp164_ = text_element;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp165_ = self->cursor_position;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp166_ = _tmp165_.column;
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_output_line_insert_element (_tmp163_, _tmp164_, _tmp166_, TRUE);
#line 320 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp163_);
#line 321 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp167_ = self->cursor_position;
#line 321 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp168_ = _tmp167_.line;
#line 321 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_signal_emit_by_name (self, "line-updated", _tmp168_);
#line 322 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (text_element);
#line 322 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1806 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS:
#line 1810 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp169_;
					gint _tmp170_;
					TerminalOutputCursorPosition _tmp171_;
					gint _tmp172_;
					TerminalOutputCursorPosition _tmp173_;
					gint _tmp174_;
					TerminalStreamStreamElement* _tmp175_;
					gint _tmp176_ = 0;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp169_ = self->cursor_position;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp170_ = _tmp169_.line;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp171_ = self->cursor_position;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp172_ = _tmp171_.column;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp173_ = self->cursor_position;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp174_ = _tmp173_.column;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp175_ = stream_element;
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp176_ = terminal_stream_stream_element_get_numeric_parameter (_tmp175_, 0, 1);
#line 326 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_erase_line_range (self, _tmp170_, _tmp172_, _tmp174_ + _tmp176_);
#line 328 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1840 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION:
#line 1846 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp177_;
					gint _tmp178_ = 0;
					gint line;
					TerminalStreamStreamElement* _tmp179_;
					gint _tmp180_ = 0;
					gint column;
					gint _tmp181_;
					gint _tmp182_;
#line 332 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp177_ = stream_element;
#line 332 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp178_ = terminal_stream_stream_element_get_numeric_parameter (_tmp177_, 0, 1);
#line 332 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					line = _tmp178_;
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp179_ = stream_element;
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp180_ = terminal_stream_stream_element_get_numeric_parameter (_tmp179_, 1, 1);
#line 333 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					column = _tmp180_;
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp181_ = line;
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp182_ = column;
#line 334 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor_screen (self, _tmp181_, _tmp182_);
#line 335 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1876 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE:
#line 1880 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp183_;
					gint _tmp184_ = 0;
					TerminalOutputCursorPosition _tmp185_;
					TerminalOutputCursorPosition _tmp186_ = {0};
					gint _tmp187_;
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp183_ = stream_element;
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp184_ = terminal_stream_stream_element_get_numeric_parameter (_tmp183_, 0, 1);
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp185_ = self->cursor_position;
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_get_screen_position (self, &_tmp185_, &_tmp186_);
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp187_ = _tmp186_.column;
#line 338 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor_screen (self, _tmp184_, _tmp187_);
#line 340 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1901 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE:
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE:
#line 1907 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp188_;
					TerminalOutputCursorPosition _tmp189_ = {0};
					gint _tmp190_;
					TerminalStreamStreamElement* _tmp191_;
					gint _tmp192_ = 0;
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp188_ = self->cursor_position;
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_get_screen_position (self, &_tmp188_, &_tmp189_);
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp190_ = _tmp189_.line;
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp191_ = stream_element;
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp192_ = terminal_stream_stream_element_get_numeric_parameter (_tmp191_, 0, 1);
#line 344 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_move_cursor_screen (self, _tmp190_, _tmp192_);
#line 346 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1928 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES:
#line 1932 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp193_;
					CharacterAttributes* _tmp194_;
					CharacterAttributes* _tmp195_;
#line 349 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp193_ = stream_element;
#line 349 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp194_ = self->priv->current_attributes;
#line 349 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp195_ = character_attributes_new_from_stream_element (_tmp193_, _tmp194_);
#line 349 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (self->priv->current_attributes);
#line 349 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->priv->current_attributes = _tmp195_;
#line 350 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1949 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100:
#line 1953 "TerminalOutput.c"
				{
#line 355 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 1957 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS:
#line 1961 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp196_;
					gint _tmp197_ = 0;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp196_ = stream_element;
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp197_ = terminal_stream_stream_element_get_numeric_parameter (_tmp196_, 0, -1);
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					switch (_tmp197_) {
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 0:
#line 1973 "TerminalOutput.c"
						{
							TerminalStreamStreamElement* _tmp198_;
							gchar* _tmp199_ = NULL;
							gchar* _tmp200_;
							TerminalStreamStreamElement* _tmp201_;
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp198_ = stream_element;
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp199_ = terminal_stream_stream_element_get_text_parameter (_tmp198_, 1, "Final Term");
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp200_ = _tmp199_;
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_set_terminal_title (self, _tmp200_);
#line 361 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_g_free0 (_tmp200_);
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp201_ = stream_element;
#line 363 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_print_interpretation_status (_tmp201_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 1995 "TerminalOutput.c"
						}
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						case 2:
#line 1999 "TerminalOutput.c"
						{
							TerminalStreamStreamElement* _tmp202_;
							gchar* _tmp203_ = NULL;
							gchar* _tmp204_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp202_ = stream_element;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp203_ = terminal_stream_stream_element_get_text_parameter (_tmp202_, 1, "Final Term");
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp204_ = _tmp203_;
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_set_terminal_title (self, _tmp204_);
#line 367 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_g_free0 (_tmp204_);
#line 368 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 2016 "TerminalOutput.c"
						}
						default:
						{
							TerminalStreamStreamElement* _tmp205_;
#line 370 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp205_ = stream_element;
#line 370 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							terminal_output_print_interpretation_status (_tmp205_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 371 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 2027 "TerminalOutput.c"
						}
					}
#line 373 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2032 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT:
#line 2036 "TerminalOutput.c"
				{
					TerminalOutputCursorPosition _tmp206_;
					gint _tmp207_;
					gpointer _tmp208_ = NULL;
					TerminalOutputOutputLine* _tmp209_;
					TerminalOutputCursorPosition _tmp210_;
					gint _tmp211_;
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp206_ = self->cursor_position;
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp207_ = _tmp206_.line;
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp208_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp207_);
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp209_ = (TerminalOutputOutputLine*) _tmp208_;
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_output_line_set_is_prompt_line (_tmp209_, TRUE);
#line 376 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp209_);
#line 377 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp210_ = self->cursor_position;
#line 377 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp211_ = _tmp210_.line;
#line 377 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_signal_emit_by_name (self, "line-updated", _tmp211_);
#line 378 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2064 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START:
#line 2068 "TerminalOutput.c"
				{
					gboolean _tmp212_;
					TerminalOutputCursorPosition _tmp214_;
					const gchar* _tmp215_ = NULL;
					TerminalOutputCursorPosition _tmp216_;
					gint _tmp217_;
					TerminalOutputCursorPosition _tmp218_;
					gint _tmp219_;
#line 381 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp212_ = self->command_mode;
#line 381 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (_tmp212_) {
#line 2081 "TerminalOutput.c"
						const gchar* _tmp213_ = NULL;
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp213_ = _ ("Command start control sequence received while already in command mode");
#line 383 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						g_warning ("TerminalOutput.vala:383: %s", _tmp213_);
#line 2087 "TerminalOutput.c"
					}
#line 384 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->command_mode = TRUE;
#line 385 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp214_ = self->cursor_position;
#line 385 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->command_start_position = _tmp214_;
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp215_ = _ ("Command mode entered, cursor_position (line: %i column: %i)");
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp216_ = self->cursor_position;
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp217_ = _tmp216_.line;
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp218_ = self->cursor_position;
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp219_ = _tmp218_.column;
#line 386 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_message (_tmp215_, _tmp217_, _tmp219_);
#line 387 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2109 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED:
#line 2113 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp220_;
					gchar* _tmp221_ = NULL;
					const gchar* _tmp222_;
#line 390 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->command_mode = FALSE;
#line 391 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp220_ = stream_element;
#line 391 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp221_ = terminal_stream_stream_element_get_text_parameter (_tmp220_, 0, "");
#line 391 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_free0 (self->priv->last_command);
#line 391 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->priv->last_command = _tmp221_;
#line 392 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp222_ = self->priv->last_command;
#line 392 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_signal_emit_by_name (self, "command-executed", _tmp222_);
#line 393 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2134 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED:
#line 2138 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp223_;
					gint _tmp224_ = 0;
					gint return_code;
					const gchar* _tmp225_;
#line 396 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp223_ = stream_element;
#line 396 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp224_ = terminal_stream_stream_element_get_numeric_parameter (_tmp223_, 0, 0);
#line 396 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					return_code = _tmp224_;
#line 398 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp225_ = self->priv->last_command;
#line 398 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (_tmp225_ != NULL) {
#line 2154 "TerminalOutput.c"
						const gchar* _tmp226_;
						gint _tmp227_;
#line 399 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp226_ = self->priv->last_command;
#line 399 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp227_ = return_code;
#line 399 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						g_signal_emit_by_name (self, "command-finished", _tmp226_, _tmp227_);
#line 400 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						g_signal_emit_by_name (self, "progress-finished");
#line 2165 "TerminalOutput.c"
						{
							gint _tmp228_;
							gint _tmp229_;
							gint i;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp228_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp229_ = _tmp228_;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							i = _tmp229_ - 1;
#line 2176 "TerminalOutput.c"
							{
								gboolean _tmp230_;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp230_ = TRUE;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								while (TRUE) {
#line 2183 "TerminalOutput.c"
									gboolean _tmp231_;
									gint _tmp233_;
									gint _tmp234_;
									gpointer _tmp235_ = NULL;
									TerminalOutputOutputLine* _tmp236_;
									gboolean _tmp237_;
									gboolean _tmp238_;
									gboolean _tmp239_;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp231_ = _tmp230_;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									if (!_tmp231_) {
#line 2196 "TerminalOutput.c"
										gint _tmp232_;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp232_ = i;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										i = _tmp232_ - 1;
#line 2202 "TerminalOutput.c"
									}
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp230_ = FALSE;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp233_ = i;
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									if (!(_tmp233_ >= 0)) {
#line 403 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 2212 "TerminalOutput.c"
									}
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp234_ = i;
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp235_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp234_);
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp236_ = (TerminalOutputOutputLine*) _tmp235_;
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp237_ = terminal_output_output_line_get_is_prompt_line (_tmp236_);
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp238_ = _tmp237_;
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp239_ = _tmp238_;
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_g_object_unref0 (_tmp236_);
#line 404 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									if (_tmp239_) {
#line 2230 "TerminalOutput.c"
										gint _tmp240_;
										gpointer _tmp241_ = NULL;
										TerminalOutputOutputLine* _tmp242_;
										gint _tmp243_;
										gint _tmp244_;
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp240_ = i;
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp241_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp240_);
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp242_ = (TerminalOutputOutputLine*) _tmp241_;
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp243_ = return_code;
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										terminal_output_output_line_set_return_code (_tmp242_, _tmp243_);
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_g_object_unref0 (_tmp242_);
#line 406 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										_tmp244_ = i;
#line 406 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										g_signal_emit_by_name (self, "line-updated", _tmp244_);
#line 407 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
										break;
#line 2254 "TerminalOutput.c"
									}
								}
							}
						}
					}
#line 412 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2262 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START:
#line 2266 "TerminalOutput.c"
				{
					CharacterAttributes* _tmp245_;
					CharacterAttributes* _tmp246_;
					CharacterAttributes* _tmp247_;
					GeeMap* _tmp248_;
					GeeMap* _tmp249_;
					TerminalStreamStreamElement* _tmp250_;
					gint _tmp251_ = 0;
					gpointer _tmp252_ = NULL;
					TextMenu* _tmp253_;
#line 415 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp245_ = self->priv->current_attributes;
#line 415 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp246_ = character_attributes_new_copy (_tmp245_);
#line 415 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (self->priv->current_attributes);
#line 415 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->priv->current_attributes = _tmp246_;
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp247_ = self->priv->current_attributes;
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp248_ = final_term_get_text_menus_by_code ();
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp249_ = _tmp248_;
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp250_ = stream_element;
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp251_ = terminal_stream_stream_element_get_numeric_parameter (_tmp250_, 0, -1);
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp252_ = gee_map_get (_tmp249_, (gpointer) ((gintptr) _tmp251_));
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp253_ = (TextMenu*) _tmp252_;
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					character_attributes_set_text_menu (_tmp247_, _tmp253_);
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp253_);
#line 417 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2305 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END:
#line 2309 "TerminalOutput.c"
				{
					CharacterAttributes* _tmp254_;
					CharacterAttributes* _tmp255_;
					CharacterAttributes* _tmp256_;
#line 420 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp254_ = self->priv->current_attributes;
#line 420 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp255_ = character_attributes_new_copy (_tmp254_);
#line 420 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (self->priv->current_attributes);
#line 420 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					self->priv->current_attributes = _tmp255_;
#line 421 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp256_ = self->priv->current_attributes;
#line 421 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					character_attributes_set_text_menu (_tmp256_, NULL);
#line 422 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2328 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS:
#line 2332 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp257_;
					gint _tmp258_ = 0;
					gint percentage;
					gint _tmp259_;
#line 425 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp257_ = stream_element;
#line 425 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp258_ = terminal_stream_stream_element_get_numeric_parameter (_tmp257_, 0, -1);
#line 425 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					percentage = _tmp258_;
#line 426 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp259_ = percentage;
#line 426 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (_tmp259_ == (-1)) {
#line 427 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						g_signal_emit_by_name (self, "progress-finished");
#line 2350 "TerminalOutput.c"
					} else {
						TerminalStreamStreamElement* _tmp260_;
						gchar* _tmp261_ = NULL;
						gchar* operation;
						gint _tmp262_;
						const gchar* _tmp263_;
#line 429 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp260_ = stream_element;
#line 429 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp261_ = terminal_stream_stream_element_get_text_parameter (_tmp260_, 1, "");
#line 429 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						operation = _tmp261_;
#line 430 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp262_ = percentage;
#line 430 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp263_ = operation;
#line 430 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						g_signal_emit_by_name (self, "progress-updated", _tmp262_, _tmp263_);
#line 426 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_free0 (operation);
#line 2371 "TerminalOutput.c"
					}
#line 432 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2375 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS:
#line 2379 "TerminalOutput.c"
				{
					GeeArrayList* _tmp264_;
					GeeArrayList* commands;
					GeeArrayList* _tmp265_;
					GeeArrayList* arguments;
					gboolean is_argument;
#line 435 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp264_ = gee_array_list_new (TYPE_COMMAND, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 435 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					commands = _tmp264_;
#line 436 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp265_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 436 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					arguments = _tmp265_;
#line 438 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					is_argument = FALSE;
#line 2396 "TerminalOutput.c"
					{
						TerminalStreamStreamElement* _tmp266_;
						GeeList* _tmp267_;
						GeeList* _tmp268_;
						GeeList* _tmp269_;
						GeeList* _parameter_list;
						GeeList* _tmp270_;
						gint _tmp271_;
						gint _tmp272_;
						gint _parameter_size;
						gint _parameter_index;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp266_ = stream_element;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp267_ = terminal_stream_stream_element_get_control_sequence_parameters (_tmp266_);
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp268_ = _tmp267_;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp269_ = _g_object_ref0 (_tmp268_);
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_parameter_list = _tmp269_;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp270_ = _parameter_list;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp271_ = gee_collection_get_size ((GeeCollection*) _tmp270_);
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp272_ = _tmp271_;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_parameter_size = _tmp272_;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_parameter_index = -1;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						while (TRUE) {
#line 2430 "TerminalOutput.c"
							gint _tmp273_;
							gint _tmp274_;
							gint _tmp275_;
							GeeList* _tmp276_;
							gint _tmp277_;
							gpointer _tmp278_ = NULL;
							gchar* parameter;
							gboolean _tmp279_ = FALSE;
							const gchar* _tmp280_;
							gboolean _tmp282_;
							const gchar* _tmp283_;
							gchar* _tmp284_ = NULL;
							const gchar* _tmp285_;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp273_ = _parameter_index;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_parameter_index = _tmp273_ + 1;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp274_ = _parameter_index;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp275_ = _parameter_size;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							if (!(_tmp274_ < _tmp275_)) {
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								break;
#line 2456 "TerminalOutput.c"
							}
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp276_ = _parameter_list;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp277_ = _parameter_index;
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp278_ = gee_list_get (_tmp276_, _tmp277_);
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							parameter = (gchar*) _tmp278_;
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp280_ = parameter;
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							if (g_strcmp0 (_tmp280_, "#") == 0) {
#line 2470 "TerminalOutput.c"
								gboolean _tmp281_;
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp281_ = is_argument;
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp279_ = !_tmp281_;
#line 2476 "TerminalOutput.c"
							} else {
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp279_ = FALSE;
#line 2480 "TerminalOutput.c"
							}
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp282_ = _tmp279_;
#line 441 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							if (_tmp282_) {
#line 442 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								is_argument = TRUE;
#line 443 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_g_free0 (parameter);
#line 443 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								continue;
#line 2492 "TerminalOutput.c"
							}
#line 446 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp283_ = parameter;
#line 446 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp284_ = string_strip (_tmp283_);
#line 446 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_g_free0 (parameter);
#line 446 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							parameter = _tmp284_;
#line 448 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp285_ = parameter;
#line 448 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							if (g_strcmp0 (_tmp285_, "") != 0) {
#line 2506 "TerminalOutput.c"
								gboolean _tmp286_;
#line 449 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								_tmp286_ = is_argument;
#line 449 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								if (_tmp286_) {
#line 2512 "TerminalOutput.c"
									GeeArrayList* _tmp287_;
									const gchar* _tmp288_;
#line 450 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp287_ = arguments;
#line 450 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp288_ = parameter;
#line 450 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp287_, _tmp288_);
#line 2521 "TerminalOutput.c"
								} else {
									GeeArrayList* _tmp289_;
									const gchar* _tmp290_;
									Command* _tmp291_;
									Command* _tmp292_;
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp289_ = commands;
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp290_ = parameter;
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp291_ = command_new_from_command_specification (_tmp290_);
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_tmp292_ = _tmp291_;
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp289_, _tmp292_);
#line 452 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
									_g_object_unref0 (_tmp292_);
#line 2539 "TerminalOutput.c"
								}
							}
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_g_free0 (parameter);
#line 2544 "TerminalOutput.c"
						}
#line 439 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_object_unref0 (_parameter_list);
#line 2548 "TerminalOutput.c"
					}
					{
						GeeArrayList* _tmp293_;
						GeeArrayList* _tmp294_;
						GeeArrayList* _command_list;
						GeeArrayList* _tmp295_;
						gint _tmp296_;
						gint _tmp297_;
						gint _command_size;
						gint _command_index;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp293_ = commands;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp294_ = _g_object_ref0 (_tmp293_);
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_command_list = _tmp294_;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp295_ = _command_list;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp296_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp295_);
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp297_ = _tmp296_;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_command_size = _tmp297_;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_command_index = -1;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						while (TRUE) {
#line 2577 "TerminalOutput.c"
							gint _tmp298_;
							gint _tmp299_;
							gint _tmp300_;
							GeeArrayList* _tmp301_;
							gint _tmp302_;
							gpointer _tmp303_ = NULL;
							Command* command;
							Command* _tmp304_;
							GeeArrayList* _tmp305_;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp298_ = _command_index;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_command_index = _tmp298_ + 1;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp299_ = _command_index;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp300_ = _command_size;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							if (!(_tmp299_ < _tmp300_)) {
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
								break;
#line 2599 "TerminalOutput.c"
							}
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp301_ = _command_list;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp302_ = _command_index;
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp303_ = gee_abstract_list_get ((GeeAbstractList*) _tmp301_, _tmp302_);
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							command = (Command*) _tmp303_;
#line 458 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp304_ = command;
#line 458 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_tmp305_ = arguments;
#line 458 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							command_execute (_tmp304_, (GeeList*) _tmp305_);
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							_g_object_unref0 (command);
#line 2617 "TerminalOutput.c"
						}
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_object_unref0 (_command_list);
#line 2621 "TerminalOutput.c"
					}
#line 461 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (arguments);
#line 461 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (commands);
#line 461 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2629 "TerminalOutput.c"
				}
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN:
#line 2633 "TerminalOutput.c"
				{
					TerminalStreamStreamElement* _tmp306_;
#line 464 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp306_ = stream_element;
#line 464 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_print_interpretation_status (_tmp306_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED);
#line 465 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2642 "TerminalOutput.c"
				}
				default:
				{
					TerminalStreamStreamElement* _tmp307_;
#line 468 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp307_ = stream_element;
#line 468 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					terminal_output_print_interpretation_status (_tmp307_, TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED);
#line 469 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 2653 "TerminalOutput.c"
				}
			}
#line 471 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2658 "TerminalOutput.c"
		}
		default:
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 2663 "TerminalOutput.c"
	}
#line 474 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp308_ = g_strdup ("");
#line 474 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->transient_text);
#line 474 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->transient_text = _tmp308_;
#line 475 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp309_ = g_strdup ("");
#line 475 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->printed_transient_text);
#line 475 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->printed_transient_text = _tmp309_;
#line 2677 "TerminalOutput.c"
}


void terminal_output_print_interpretation_status (TerminalStreamStreamElement* stream_element, TerminalOutputInterpretationStatus interpretation_status) {
	TerminalStreamStreamElement* _tmp0_;
	TerminalStreamStreamElementStreamElementType _tmp1_;
	TerminalStreamStreamElementStreamElementType _tmp2_;
	TerminalOutputInterpretationStatus _tmp4_;
#line 486 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (stream_element != NULL);
#line 488 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = stream_element;
#line 488 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = terminal_stream_stream_element_get_stream_element_type (_tmp0_);
#line 488 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = _tmp1_;
#line 488 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp2_ != TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE) {
#line 2696 "TerminalOutput.c"
		const gchar* _tmp3_ = NULL;
#line 489 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = _ ("print_interpretation_status should only be called on control sequence " \
"elements");
#line 489 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_critical ("TerminalOutput.vala:489: %s", _tmp3_);
#line 490 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return;
#line 2704 "TerminalOutput.c"
	}
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = interpretation_status;
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (_tmp4_) {
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_INTERPRETATION_STATUS_INVALID:
#line 2712 "TerminalOutput.c"
		{
			const gchar* _tmp5_ = NULL;
			TerminalStreamStreamElement* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			TerminalStreamStreamElement* _tmp9_;
			TerminalStreamStreamElementControlSequenceType _tmp10_;
			TerminalStreamStreamElementControlSequenceType _tmp11_;
			GEnumValue* _tmp12_;
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _ ("Invalid control sequence: '%s' (%s)");
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = stream_element;
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = terminal_stream_stream_element_get_text (_tmp6_);
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _tmp7_;
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = stream_element;
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = terminal_stream_stream_element_get_control_sequence_type (_tmp9_);
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = _tmp10_;
#line 496 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = g_enum_get_value (g_type_class_ref (TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE), _tmp11_);
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_warning (_tmp5_, _tmp8_, (_tmp12_ != NULL) ? _tmp12_->value_name : NULL);
#line 497 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2742 "TerminalOutput.c"
		}
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNRECOGNIZED:
#line 2746 "TerminalOutput.c"
		{
			const gchar* _tmp13_ = NULL;
			TerminalStreamStreamElement* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			TerminalStreamStreamElement* _tmp17_;
			TerminalStreamStreamElementControlSequenceType _tmp18_;
			TerminalStreamStreamElementControlSequenceType _tmp19_;
			GEnumValue* _tmp20_;
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp13_ = _ ("Unrecognized control sequence: '%s' (%s)");
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp14_ = stream_element;
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15_ = terminal_stream_stream_element_get_text (_tmp14_);
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp16_ = _tmp15_;
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = stream_element;
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp18_ = terminal_stream_stream_element_get_control_sequence_type (_tmp17_);
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp19_ = _tmp18_;
#line 500 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp20_ = g_enum_get_value (g_type_class_ref (TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE), _tmp19_);
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_warning (_tmp13_, _tmp16_, (_tmp20_ != NULL) ? _tmp20_->value_name : NULL);
#line 501 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2776 "TerminalOutput.c"
		}
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_INTERPRETATION_STATUS_UNSUPPORTED:
#line 2780 "TerminalOutput.c"
		{
			const gchar* _tmp21_ = NULL;
			TerminalStreamStreamElement* _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			TerminalStreamStreamElement* _tmp25_;
			TerminalStreamStreamElementControlSequenceType _tmp26_;
			TerminalStreamStreamElementControlSequenceType _tmp27_;
			GEnumValue* _tmp28_;
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp21_ = _ ("Unsupported control sequence: '%s' (%s)");
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp22_ = stream_element;
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp23_ = terminal_stream_stream_element_get_text (_tmp22_);
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp24_ = _tmp23_;
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp25_ = stream_element;
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp26_ = terminal_stream_stream_element_get_control_sequence_type (_tmp25_);
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp27_ = _tmp26_;
#line 504 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp28_ = g_enum_get_value (g_type_class_ref (TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE), _tmp27_);
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_warning (_tmp21_, _tmp24_, (_tmp28_ != NULL) ? _tmp28_->value_name : NULL);
#line 505 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2810 "TerminalOutput.c"
		}
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_INTERPRETATION_STATUS_PARTIALLY_SUPPORTED:
#line 2814 "TerminalOutput.c"
		{
			const gchar* _tmp29_ = NULL;
			TerminalStreamStreamElement* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
			TerminalStreamStreamElement* _tmp33_;
			TerminalStreamStreamElementControlSequenceType _tmp34_;
			TerminalStreamStreamElementControlSequenceType _tmp35_;
			GEnumValue* _tmp36_;
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp29_ = _ ("Partially supported control sequence: '%s' (%s)");
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp30_ = stream_element;
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp31_ = terminal_stream_stream_element_get_text (_tmp30_);
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp32_ = _tmp31_;
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp33_ = stream_element;
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp34_ = terminal_stream_stream_element_get_control_sequence_type (_tmp33_);
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp35_ = _tmp34_;
#line 508 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp36_ = g_enum_get_value (g_type_class_ref (TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE), _tmp35_);
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_message (_tmp29_, _tmp32_, (_tmp36_ != NULL) ? _tmp36_->value_name : NULL);
#line 509 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2844 "TerminalOutput.c"
		}
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_INTERPRETATION_STATUS_SUPPORTED:
#line 2848 "TerminalOutput.c"
		{
			const gchar* _tmp37_ = NULL;
			TerminalStreamStreamElement* _tmp38_;
			const gchar* _tmp39_;
			const gchar* _tmp40_;
			TerminalStreamStreamElement* _tmp41_;
			TerminalStreamStreamElementControlSequenceType _tmp42_;
			TerminalStreamStreamElementControlSequenceType _tmp43_;
			GEnumValue* _tmp44_;
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp37_ = _ ("Supported control sequence: '%s' (%s)");
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp38_ = stream_element;
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp39_ = terminal_stream_stream_element_get_text (_tmp38_);
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp40_ = _tmp39_;
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp41_ = stream_element;
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp42_ = terminal_stream_stream_element_get_control_sequence_type (_tmp41_);
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp43_ = _tmp42_;
#line 512 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp44_ = g_enum_get_value (g_type_class_ref (TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE), _tmp43_);
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_debug (_tmp37_, _tmp40_, (_tmp44_ != NULL) ? _tmp44_->value_name : NULL);
#line 513 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2878 "TerminalOutput.c"
		}
		default:
		{
			const gchar* _tmp45_ = NULL;
#line 515 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp45_ = _ ("Unrecognized interpretation status value");
#line 515 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_critical ("TerminalOutput.vala:515: %s", _tmp45_);
#line 516 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			break;
#line 2889 "TerminalOutput.c"
		}
	}
}


void terminal_output_parse_transient_text (TerminalOutput* self, const gchar* transient_text) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	TerminalOutputCursorPosition _tmp2_;
	gint _tmp3_;
#line 520 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 520 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (transient_text != NULL);
#line 521 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = transient_text;
#line 521 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 521 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->transient_text);
#line 521 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->transient_text = _tmp1_;
#line 526 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = self->cursor_position;
#line 526 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = _tmp2_.line;
#line 526 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_emit_by_name (self, "line-updated", _tmp3_);
#line 2918 "TerminalOutput.c"
}


void terminal_output_print_transient_text (TerminalOutput* self) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gchar* text_left;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 529 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->transient_text;
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = self->priv->transient_text;
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = self->priv->printed_transient_text;
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = g_utf8_strlen (_tmp2_, (gssize) (-1));
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = string_index_of_nth_char (_tmp1_, (glong) _tmp3_);
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = string_substring (_tmp0_, (glong) _tmp4_, (glong) (-1));
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_left = _tmp5_;
#line 535 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = text_left;
#line 535 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = strlen (_tmp6_);
#line 535 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = _tmp7_;
#line 535 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp8_ == 0) {
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (text_left);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return;
#line 2965 "TerminalOutput.c"
	}
#line 538 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = text_left;
#line 538 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_print_text (self, _tmp9_);
#line 545 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_on_line_updated (self, 0);
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = self->priv->printed_transient_text;
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = text_left;
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->printed_transient_text);
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->printed_transient_text = _tmp12_;
#line 529 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (text_left);
#line 2985 "TerminalOutput.c"
}


gchar* terminal_output_get_command (TerminalOutput* self) {
	gchar* result = NULL;
	TerminalOutputCursorPosition _tmp0_;
	gint _tmp1_ = 0;
#line 550 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 552 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->cursor_position;
#line 552 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = terminal_output_cursor_position_compare (&self->command_start_position, &_tmp0_);
#line 552 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp1_ < 0) {
#line 3001 "TerminalOutput.c"
		const gchar* _tmp2_ = NULL;
		TerminalOutputCursorPosition _tmp3_;
		gint _tmp4_;
		TerminalOutputCursorPosition _tmp5_;
		gint _tmp6_;
		TerminalOutputCursorPosition _tmp7_;
		gint _tmp8_;
		TerminalOutputCursorPosition _tmp9_;
		gint _tmp10_;
		TerminalOutputCursorPosition _tmp11_;
		TerminalOutputCursorPosition _tmp12_;
		gchar* _tmp13_ = NULL;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = _ ("command_start_position: (%i,%i) cursor_postion: (%i,%i)");
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = self->command_start_position;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = _tmp3_.line;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp5_ = self->command_start_position;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp6_ = _tmp5_.column;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp7_ = self->cursor_position;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp8_ = _tmp7_.line;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp9_ = self->cursor_position;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp10_ = _tmp9_.column;
#line 553 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_warning (_tmp2_, _tmp4_, _tmp6_, _tmp8_, _tmp10_);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp11_ = self->command_start_position;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = self->cursor_position;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp13_ = terminal_output_get_range (self, &_tmp11_, &_tmp12_);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		result = _tmp13_;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return result;
#line 3044 "TerminalOutput.c"
	} else {
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
#line 558 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp14_ = _ ("cursor_position < command_start_position");
#line 558 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_warning ("TerminalOutput.vala:558: %s", _tmp14_);
#line 559 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp15_ = g_strdup ("");
#line 559 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		result = _tmp15_;
#line 559 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return result;
#line 3058 "TerminalOutput.c"
	}
}


static void terminal_output_print_text (TerminalOutput* self, const gchar* text) {
	const gchar* _tmp0_;
	CharacterAttributes* _tmp1_;
	TerminalOutputTextElement* _tmp2_;
	TerminalOutputTextElement* text_element;
	TerminalOutputCursorPosition _tmp3_;
	gint _tmp4_;
	gpointer _tmp5_ = NULL;
	TerminalOutputOutputLine* _tmp6_;
	TerminalOutputCursorPosition _tmp7_;
	gint _tmp8_;
	TerminalOutputCursorPosition _tmp9_;
	gint _tmp10_;
	TerminalOutputCursorPosition _tmp11_;
	gint _tmp12_;
	gint _tmp13_ = 0;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (text != NULL);
#line 564 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = text;
#line 564 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = self->priv->current_attributes;
#line 564 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = terminal_output_text_element_new (_tmp0_, _tmp1_);
#line 564 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_element = _tmp2_;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = self->cursor_position;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = _tmp3_.line;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp4_);
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = (TerminalOutputOutputLine*) _tmp5_;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = self->cursor_position;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = _tmp7_.column;
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_insert_element (_tmp6_, text_element, _tmp8_, TRUE);
#line 565 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp6_);
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = self->cursor_position;
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = _tmp9_.line;
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = self->cursor_position;
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp12_ = _tmp11_.column;
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp13_ = terminal_output_text_element_get_length (text_element);
#line 567 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_move_cursor (self, _tmp10_, _tmp12_ + _tmp13_);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (text_element);
#line 3121 "TerminalOutput.c"
}


static void terminal_output_on_line_updated (TerminalOutput* self, gint line_index) {
	gboolean _tmp0_;
#line 570 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 571 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->command_mode;
#line 571 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp0_) {
#line 3133 "TerminalOutput.c"
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
#line 572 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = terminal_output_get_command (self);
#line 572 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = _tmp1_;
#line 572 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_signal_emit_by_name (self, "command-updated", _tmp2_);
#line 572 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (_tmp2_);
#line 3144 "TerminalOutput.c"
	}
}


static void terminal_output_get_screen_position (TerminalOutput* self, TerminalOutputCursorPosition* position, TerminalOutputCursorPosition* result) {
	TerminalOutputCursorPosition _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	TerminalOutputCursorPosition _tmp3_;
	gint _tmp4_;
	TerminalOutputCursorPosition _tmp5_ = {0};
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (position != NULL);
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = *position;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _tmp0_.line;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = self->priv->_screen_offset;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = *position;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = _tmp3_.column;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_.line = (_tmp1_ - _tmp2_) + 1;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_.column = _tmp4_ + 1;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	*result = _tmp5_;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return;
#line 3178 "TerminalOutput.c"
}


static void terminal_output_get_absolute_position (TerminalOutput* self, TerminalOutputCursorPosition* position, TerminalOutputCursorPosition* result) {
	TerminalOutputCursorPosition _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	TerminalOutputCursorPosition _tmp3_;
	gint _tmp4_;
	TerminalOutputCursorPosition _tmp5_ = {0};
#line 580 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 580 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (position != NULL);
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = *position;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _tmp0_.line;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = self->priv->_screen_offset;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = *position;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = _tmp3_.column;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_.line = (_tmp1_ + _tmp2_) - 1;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_.column = _tmp4_ - 1;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	*result = _tmp5_;
#line 581 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return;
#line 3211 "TerminalOutput.c"
}


static void terminal_output_move_cursor (TerminalOutput* self, gint line, gint column) {
	gint _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_;
	TerminalOutputCursorPosition _tmp5_;
	gint _tmp6_;
	Terminal* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_ = 0;
	TerminalOutputCursorPosition _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint lines_to_add;
	gint _tmp15_;
	TerminalOutputCursorPosition _tmp23_;
	gint _tmp24_;
	TerminalOutputCursorPosition _tmp25_;
	gint _tmp26_;
	gpointer _tmp27_ = NULL;
	TerminalOutputOutputLine* _tmp28_;
	gint _tmp29_ = 0;
	gint _tmp30_;
	gint columns_to_add;
	gint _tmp31_;
	TerminalOutputCursorPosition _tmp43_;
#line 584 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 586 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = line;
#line 586 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = MAX (_tmp0_, 0);
#line 586 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->cursor_position.line = _tmp1_;
#line 587 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = column;
#line 587 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = MAX (_tmp2_, 0);
#line 587 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->cursor_position.column = _tmp3_;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = self->priv->_screen_offset;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = self->cursor_position;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = _tmp5_.line;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = self->priv->terminal;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = terminal_get_lines (_tmp7_);
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = _tmp8_;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = MAX (_tmp4_, (_tmp6_ - _tmp9_) + 1);
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_set_screen_offset (self, _tmp10_);
#line 593 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = self->cursor_position;
#line 593 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp12_ = _tmp11_.line;
#line 593 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 593 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp14_ = _tmp13_;
#line 593 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	lines_to_add = (_tmp12_ - _tmp14_) + 1;
#line 594 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp15_ = lines_to_add;
#line 594 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp15_ > 0) {
#line 3288 "TerminalOutput.c"
		{
			gint i;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			i = 0;
#line 3293 "TerminalOutput.c"
			{
				gboolean _tmp16_;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp16_ = TRUE;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				while (TRUE) {
#line 3300 "TerminalOutput.c"
					gboolean _tmp17_;
					gint _tmp19_;
					gint _tmp20_;
					TerminalOutputOutputLine* _tmp21_;
					TerminalOutputOutputLine* _tmp22_;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp17_ = _tmp16_;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (!_tmp17_) {
#line 3310 "TerminalOutput.c"
						gint _tmp18_;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp18_ = i;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						i = _tmp18_ + 1;
#line 3316 "TerminalOutput.c"
					}
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp16_ = FALSE;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp19_ = i;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp20_ = lines_to_add;
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (!(_tmp19_ < _tmp20_)) {
#line 595 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						break;
#line 3328 "TerminalOutput.c"
					}
#line 596 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp21_ = terminal_output_output_line_new ();
#line 596 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp22_ = _tmp21_;
#line 596 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) self, _tmp22_);
#line 596 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp22_);
#line 3338 "TerminalOutput.c"
				}
			}
		}
#line 598 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_signal_emit_by_name (self, "line-added");
#line 3344 "TerminalOutput.c"
	}
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp23_ = self->cursor_position;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp24_ = _tmp23_.column;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp25_ = self->cursor_position;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp26_ = _tmp25_.line;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp26_);
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp28_ = (TerminalOutputOutputLine*) _tmp27_;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp29_ = terminal_output_output_line_get_length (_tmp28_);
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp30_ = _tmp24_ - _tmp29_;
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp28_);
#line 602 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	columns_to_add = _tmp30_;
#line 603 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp31_ = columns_to_add;
#line 603 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp31_ > 0) {
#line 3370 "TerminalOutput.c"
		gint _tmp32_;
		gchar* _tmp33_ = NULL;
		gchar* _tmp34_;
		CharacterAttributes* _tmp35_;
		TerminalOutputTextElement* _tmp36_;
		TerminalOutputTextElement* _tmp37_;
		TerminalOutputTextElement* text_element;
		TerminalOutputCursorPosition _tmp38_;
		gint _tmp39_;
		gpointer _tmp40_ = NULL;
		TerminalOutputOutputLine* _tmp41_;
		TerminalOutputTextElement* _tmp42_;
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp32_ = columns_to_add;
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp33_ = utilities_repeat_string (" ", _tmp32_);
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp34_ = _tmp33_;
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp35_ = self->priv->current_attributes;
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp36_ = terminal_output_text_element_new (_tmp34_, _tmp35_);
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp37_ = _tmp36_;
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (_tmp34_);
#line 604 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		text_element = _tmp37_;
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp38_ = self->cursor_position;
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp39_ = _tmp38_.line;
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp39_);
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp41_ = (TerminalOutputOutputLine*) _tmp40_;
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp42_ = text_element;
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp42_);
#line 607 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp41_);
#line 603 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (text_element);
#line 3415 "TerminalOutput.c"
	}
#line 610 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp43_ = self->cursor_position;
#line 610 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_emit_by_name (self, "cursor-position-changed", &_tmp43_);
#line 3421 "TerminalOutput.c"
}


static void terminal_output_move_cursor_screen (TerminalOutput* self, gint line, gint column) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 613 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 615 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = line;
#line 615 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = self->priv->_screen_offset;
#line 615 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = column;
#line 615 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_move_cursor (self, (_tmp0_ + _tmp1_) - 1, _tmp2_ - 1);
#line 3439 "TerminalOutput.c"
}


static gchar* terminal_output_get_range (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position) {
	gchar* result = NULL;
	TerminalOutputCursorPosition _tmp0_;
	gint _tmp1_;
	TerminalOutputCursorPosition _tmp2_;
	gint _tmp3_;
	GString* _tmp18_;
	GString* text_builder;
	GString* _tmp19_;
	TerminalOutputCursorPosition _tmp20_;
	gint _tmp21_;
	gpointer _tmp22_ = NULL;
	TerminalOutputOutputLine* _tmp23_;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_;
	TerminalOutputCursorPosition _tmp26_;
	gint _tmp27_;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_;
	GString* _tmp30_;
	GString* _tmp46_;
	TerminalOutputCursorPosition _tmp47_;
	gint _tmp48_;
	gpointer _tmp49_ = NULL;
	TerminalOutputOutputLine* _tmp50_;
	gchar* _tmp51_ = NULL;
	gchar* _tmp52_;
	TerminalOutputCursorPosition _tmp53_;
	gint _tmp54_;
	gchar* _tmp55_ = NULL;
	gchar* _tmp56_;
	GString* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (start_position != NULL, NULL);
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (end_position != NULL, NULL);
#line 622 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = *start_position;
#line 622 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _tmp0_.line;
#line 622 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = *end_position;
#line 622 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = _tmp2_.line;
#line 622 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp1_ == _tmp3_) {
#line 3493 "TerminalOutput.c"
		TerminalOutputCursorPosition _tmp4_;
		gint _tmp5_;
		gpointer _tmp6_ = NULL;
		TerminalOutputOutputLine* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		gchar* line_text;
		const gchar* _tmp10_;
		TerminalOutputCursorPosition _tmp11_;
		gint _tmp12_;
		TerminalOutputCursorPosition _tmp13_;
		gint _tmp14_;
		TerminalOutputCursorPosition _tmp15_;
		gint _tmp16_;
		gchar* _tmp17_ = NULL;
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = *start_position;
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp5_ = _tmp4_.line;
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp5_);
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp7_ = (TerminalOutputOutputLine*) _tmp6_;
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp8_ = terminal_output_output_line_get_text (_tmp7_);
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp9_ = _tmp8_;
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp7_);
#line 623 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		line_text = _tmp9_;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp10_ = line_text;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp11_ = *start_position;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = _tmp11_.column;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp13_ = *end_position;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp14_ = _tmp13_.column;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp15_ = *start_position;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp16_ = _tmp15_.column;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp17_ = string_substring (_tmp10_, (glong) _tmp12_, (glong) (_tmp14_ - _tmp16_));
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		result = _tmp17_;
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (line_text);
#line 624 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return result;
#line 3547 "TerminalOutput.c"
	}
#line 627 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp18_ = g_string_new ("");
#line 627 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_builder = _tmp18_;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp19_ = text_builder;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20_ = *start_position;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp21_ = _tmp20_.line;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp21_);
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp23_ = (TerminalOutputOutputLine*) _tmp22_;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp24_ = terminal_output_output_line_get_text (_tmp23_);
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp25_ = _tmp24_;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp26_ = *start_position;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp27_ = _tmp26_.column;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp28_ = string_substring (_tmp25_, (glong) _tmp27_, (glong) (-1));
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp29_ = _tmp28_;
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_string_append (_tmp19_, _tmp29_);
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (_tmp29_);
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (_tmp25_);
#line 630 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp23_);
#line 631 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp30_ = text_builder;
#line 631 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_string_append (_tmp30_, "\n");
#line 3587 "TerminalOutput.c"
	{
		TerminalOutputCursorPosition _tmp31_;
		gint _tmp32_;
		gint i;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp31_ = *start_position;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp32_ = _tmp31_.line;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		i = _tmp32_ + 1;
#line 3598 "TerminalOutput.c"
		{
			gboolean _tmp33_;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp33_ = TRUE;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			while (TRUE) {
#line 3605 "TerminalOutput.c"
				gboolean _tmp34_;
				gint _tmp36_;
				TerminalOutputCursorPosition _tmp37_;
				gint _tmp38_;
				GString* _tmp39_;
				gint _tmp40_;
				gpointer _tmp41_ = NULL;
				TerminalOutputOutputLine* _tmp42_;
				gchar* _tmp43_ = NULL;
				gchar* _tmp44_;
				GString* _tmp45_;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp34_ = _tmp33_;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!_tmp34_) {
#line 3621 "TerminalOutput.c"
					gint _tmp35_;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp35_ = i;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					i = _tmp35_ + 1;
#line 3627 "TerminalOutput.c"
				}
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp33_ = FALSE;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp36_ = i;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp37_ = *end_position;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp38_ = _tmp37_.line;
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!(_tmp36_ < _tmp38_)) {
#line 633 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 3641 "TerminalOutput.c"
				}
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp39_ = text_builder;
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp40_ = i;
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp41_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp40_);
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp42_ = (TerminalOutputOutputLine*) _tmp41_;
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp43_ = terminal_output_output_line_get_text (_tmp42_);
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp44_ = _tmp43_;
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				g_string_append (_tmp39_, _tmp44_);
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_free0 (_tmp44_);
#line 634 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_tmp42_);
#line 635 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp45_ = text_builder;
#line 635 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				g_string_append (_tmp45_, "\n");
#line 3665 "TerminalOutput.c"
			}
		}
	}
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp46_ = text_builder;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp47_ = *end_position;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp48_ = _tmp47_.line;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp49_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp48_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp50_ = (TerminalOutputOutputLine*) _tmp49_;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp51_ = terminal_output_output_line_get_text (_tmp50_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp52_ = _tmp51_;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp53_ = *end_position;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp54_ = _tmp53_.column;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp55_ = string_substring (_tmp52_, (glong) 0, (glong) _tmp54_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp56_ = _tmp55_;
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_string_append (_tmp46_, _tmp56_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (_tmp56_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (_tmp52_);
#line 638 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp50_);
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp57_ = text_builder;
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp58_ = _tmp57_->str;
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp59_ = g_strdup (_tmp58_);
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp59_;
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_string_free0 (text_builder);
#line 640 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 3711 "TerminalOutput.c"
}


static void terminal_output_erase_range (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position) {
	TerminalOutputCursorPosition _tmp0_;
	gint _tmp1_;
	TerminalOutputCursorPosition _tmp2_;
	gint _tmp3_;
	TerminalOutputCursorPosition _tmp10_;
	gint _tmp11_;
	TerminalOutputCursorPosition _tmp12_;
	gint _tmp13_;
	TerminalOutputCursorPosition _tmp23_;
	gint _tmp24_;
	TerminalOutputCursorPosition _tmp25_;
	gint _tmp26_;
#line 643 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 643 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (start_position != NULL);
#line 643 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (end_position != NULL);
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = *start_position;
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _tmp0_.line;
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = *end_position;
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = _tmp2_.line;
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp1_ == _tmp3_) {
#line 3744 "TerminalOutput.c"
		TerminalOutputCursorPosition _tmp4_;
		gint _tmp5_;
		TerminalOutputCursorPosition _tmp6_;
		gint _tmp7_;
		TerminalOutputCursorPosition _tmp8_;
		gint _tmp9_;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = *start_position;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp5_ = _tmp4_.line;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp6_ = *start_position;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp7_ = _tmp6_.column;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp8_ = *end_position;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp9_ = _tmp8_.column;
#line 645 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_erase_line_range (self, _tmp5_, _tmp7_, _tmp9_);
#line 646 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return;
#line 3767 "TerminalOutput.c"
	}
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = *start_position;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = _tmp10_.line;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp12_ = *start_position;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp13_ = _tmp12_.column;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_erase_line_range (self, _tmp11_, _tmp13_, -1);
#line 3779 "TerminalOutput.c"
	{
		TerminalOutputCursorPosition _tmp14_;
		gint _tmp15_;
		gint i;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp14_ = *start_position;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp15_ = _tmp14_.line;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		i = _tmp15_ + 1;
#line 3790 "TerminalOutput.c"
		{
			gboolean _tmp16_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp16_ = TRUE;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			while (TRUE) {
#line 3797 "TerminalOutput.c"
				gboolean _tmp17_;
				gint _tmp19_;
				TerminalOutputCursorPosition _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp17_ = _tmp16_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!_tmp17_) {
#line 3807 "TerminalOutput.c"
					gint _tmp18_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp18_ = i;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					i = _tmp18_ + 1;
#line 3813 "TerminalOutput.c"
				}
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp16_ = FALSE;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp19_ = i;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp20_ = *end_position;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp21_ = _tmp20_.line;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!(_tmp19_ < _tmp21_)) {
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 3827 "TerminalOutput.c"
				}
#line 653 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp22_ = i;
#line 653 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				terminal_output_erase_line_range (self, _tmp22_, 0, -1);
#line 3833 "TerminalOutput.c"
			}
		}
	}
#line 656 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp23_ = *end_position;
#line 656 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp24_ = _tmp23_.line;
#line 656 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp25_ = *end_position;
#line 656 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp26_ = _tmp25_.column;
#line 656 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_erase_line_range (self, _tmp24_, 0, _tmp26_);
#line 3847 "TerminalOutput.c"
}


static void terminal_output_erase_range_screen (TerminalOutput* self, TerminalOutputCursorPosition* start_position, TerminalOutputCursorPosition* end_position) {
	TerminalOutputCursorPosition _tmp0_;
	TerminalOutputCursorPosition _tmp1_ = {0};
	TerminalOutputCursorPosition absolute_start_position;
	TerminalOutputCursorPosition _tmp2_;
	TerminalOutputCursorPosition _tmp3_ = {0};
	TerminalOutputCursorPosition absolute_end_position;
	TerminalOutputCursorPosition _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_ = 0;
	TerminalOutputCursorPosition _tmp9_;
	gint _tmp10_;
	TerminalOutputCursorPosition _tmp11_;
	gint _tmp12_;
	gpointer _tmp13_ = NULL;
	TerminalOutputOutputLine* _tmp14_;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	TerminalOutputCursorPosition _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp21_ = 0;
	TerminalOutputCursorPosition _tmp22_;
	gint _tmp23_;
	TerminalOutputCursorPosition _tmp24_;
	gint _tmp25_;
	gpointer _tmp26_ = NULL;
	TerminalOutputOutputLine* _tmp27_;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	TerminalOutputCursorPosition _tmp30_;
	TerminalOutputCursorPosition _tmp31_;
#line 659 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 659 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (start_position != NULL);
#line 659 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (end_position != NULL);
#line 661 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = *start_position;
#line 661 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_get_absolute_position (self, &_tmp0_, &_tmp1_);
#line 661 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_start_position = _tmp1_;
#line 662 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = *end_position;
#line 662 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_get_absolute_position (self, &_tmp2_, &_tmp3_);
#line 662 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_end_position = _tmp3_;
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = absolute_start_position;
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = _tmp4_.line;
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = _tmp6_;
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = MIN (_tmp5_, _tmp7_ - 1);
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_start_position.line = _tmp8_;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = absolute_start_position;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = _tmp9_.column;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = absolute_start_position;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp12_ = _tmp11_.line;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp12_);
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp14_ = (TerminalOutputOutputLine*) _tmp13_;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp15_ = terminal_output_output_line_get_length (_tmp14_);
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp16_ = MIN (_tmp10_, _tmp15_);
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_start_position.column = _tmp16_;
#line 666 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp14_);
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp17_ = absolute_end_position;
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp18_ = _tmp17_.line;
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp19_ = gee_abstract_collection_get_size ((GeeCollection*) self);
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20_ = _tmp19_;
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp21_ = MIN (_tmp18_, _tmp20_ - 1);
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_end_position.line = _tmp21_;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp22_ = absolute_end_position;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp23_ = _tmp22_.column;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp24_ = absolute_end_position;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp25_ = _tmp24_.line;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp25_);
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp27_ = (TerminalOutputOutputLine*) _tmp26_;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp28_ = terminal_output_output_line_get_length (_tmp27_);
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp29_ = MIN (_tmp23_, _tmp28_);
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	absolute_end_position.column = _tmp29_;
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp27_);
#line 672 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp30_ = absolute_start_position;
#line 672 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp31_ = absolute_end_position;
#line 672 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_erase_range (self, &_tmp30_, &_tmp31_);
#line 3974 "TerminalOutput.c"
}


static void terminal_output_erase_line_range (TerminalOutput* self, gint line, gint start_position, gint end_position) {
	gint _tmp0_;
	gpointer _tmp1_ = NULL;
	TerminalOutputOutputLine* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 675 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = line;
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) self, _tmp0_);
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = (TerminalOutputOutputLine*) _tmp1_;
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = start_position;
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = end_position;
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_erase_range (_tmp2_, _tmp3_, _tmp4_);
#line 676 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp2_);
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = line;
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_emit_by_name (self, "line-updated", _tmp5_);
#line 4005 "TerminalOutput.c"
}


const gchar* terminal_output_get_terminal_title (TerminalOutput* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_terminal_title;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 4020 "TerminalOutput.c"
}


void terminal_output_set_terminal_title (TerminalOutput* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->_terminal_title);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_terminal_title = _tmp1_;
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "terminal-title");
#line 4039 "TerminalOutput.c"
}


TerminalOutputTerminalMode terminal_output_get_terminal_modes (TerminalOutput* self) {
	TerminalOutputTerminalMode result;
	TerminalOutputTerminalMode _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_terminal_modes;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 4054 "TerminalOutput.c"
}


void terminal_output_set_terminal_modes (TerminalOutput* self, TerminalOutputTerminalMode value) {
	TerminalOutputTerminalMode _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_terminal_modes = _tmp0_;
#line 36 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "terminal-modes");
#line 4068 "TerminalOutput.c"
}


gint terminal_output_get_screen_offset (TerminalOutput* self) {
	gint result;
	gint _tmp0_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_screen_offset;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 4083 "TerminalOutput.c"
}


void terminal_output_set_screen_offset (TerminalOutput* self, gint value) {
	gint _tmp0_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_screen_offset = _tmp0_;
#line 50 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "screen-offset");
#line 4097 "TerminalOutput.c"
}


static void g_cclosure_user_marshal_VOID__STRING_INT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_INT) (gpointer data1, const char* arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = closure->data;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = param_values->data[0].v_pointer;
#line 4116 "TerminalOutput.c"
	} else {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = closure->data;
#line 4122 "TerminalOutput.c"
	}
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback = (GMarshalFunc_VOID__STRING_INT) (marshal_data ? marshal_data : cc->callback);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 4128 "TerminalOutput.c"
}


static void g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__INT_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (n_param_values == 3);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = closure->data;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = param_values->data[0].v_pointer;
#line 4147 "TerminalOutput.c"
	} else {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = closure->data;
#line 4153 "TerminalOutput.c"
	}
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback = (GMarshalFunc_VOID__INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 4159 "TerminalOutput.c"
}


static void g_cclosure_user_marshal_VOID__BOXED (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__BOXED) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (n_param_values == 2);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = closure->data;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = param_values->data[0].v_pointer;
#line 4178 "TerminalOutput.c"
	} else {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data1 = param_values->data[0].v_pointer;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		data2 = closure->data;
#line 4184 "TerminalOutput.c"
	}
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback = (GMarshalFunc_VOID__BOXED) (marshal_data ? marshal_data : cc->callback);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	callback (data1, g_value_get_boxed (param_values + 1), data2);
#line 4190 "TerminalOutput.c"
}


TerminalOutputOutputLine* terminal_output_output_line_generate_text_menu_elements (TerminalOutputOutputLine* self) {
	TerminalOutputOutputLine* result = NULL;
	gboolean matching_pattern;
	gchar* _tmp0_ = NULL;
	gchar* text;
	gboolean _tmp18_;
	TerminalOutputOutputLine* _tmp20_;
	TerminalOutputOutputLine* output_line;
	TerminalOutputOutputLine* _tmp21_;
	gboolean _tmp22_;
	TerminalOutputOutputLine* _tmp23_;
	gint _tmp24_;
#line 706 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 707 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	matching_pattern = FALSE;
#line 708 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = terminal_output_output_line_get_text (self);
#line 708 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text = _tmp0_;
#line 4214 "TerminalOutput.c"
	{
		GeeMap* _tmp1_;
		GeeMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _pattern_it;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = final_term_get_text_menus_by_pattern ();
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = _tmp1_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = gee_map_get_keys (_tmp2_);
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = _tmp3_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp5_ = _tmp4_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp7_ = _tmp6_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp5_);
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_pattern_it = _tmp7_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 4244 "TerminalOutput.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			GRegex* pattern;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
			gboolean _tmp17_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _pattern_it;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!_tmp9_) {
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 4261 "TerminalOutput.c"
			}
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = _pattern_it;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			pattern = (GRegex*) _tmp11_;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp13_ = matching_pattern;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (_tmp13_) {
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp12_ = TRUE;
#line 4275 "TerminalOutput.c"
			} else {
				GRegex* _tmp14_;
				const gchar* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp14_ = pattern;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp15_ = text;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp16_ = g_regex_match (_tmp14_, _tmp15_, 0, NULL);
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp12_ = _tmp16_;
#line 4288 "TerminalOutput.c"
			}
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = _tmp12_;
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			matching_pattern = _tmp17_;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_regex_unref0 (pattern);
#line 4296 "TerminalOutput.c"
		}
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_pattern_it);
#line 4300 "TerminalOutput.c"
	}
#line 713 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp18_ = matching_pattern;
#line 713 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (!_tmp18_) {
#line 4306 "TerminalOutput.c"
		TerminalOutputOutputLine* _tmp19_;
#line 714 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp19_ = _g_object_ref0 (self);
#line 714 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		result = _tmp19_;
#line 714 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (text);
#line 714 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return result;
#line 4316 "TerminalOutput.c"
	}
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20_ = terminal_output_output_line_new ();
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	output_line = _tmp20_;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp21_ = output_line;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp22_ = self->priv->_is_prompt_line;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_set_is_prompt_line (_tmp21_, _tmp22_);
#line 718 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp23_ = output_line;
#line 718 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp24_ = self->priv->_return_code;
#line 718 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_set_return_code (_tmp23_, _tmp24_);
#line 4334 "TerminalOutput.c"
	{
		TerminalOutputOutputLine* _tmp25_;
		TerminalOutputOutputLine* _text_element_list;
		TerminalOutputOutputLine* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
		gint _text_element_size;
		gint _text_element_index;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp25_ = _g_object_ref0 (self);
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_list = _tmp25_;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp26_ = _text_element_list;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp27_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp26_);
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp28_ = _tmp27_;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_size = _tmp28_;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_index = -1;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 4359 "TerminalOutput.c"
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			TerminalOutputOutputLine* _tmp32_;
			gint _tmp33_;
			gpointer _tmp34_ = NULL;
			TerminalOutputTextElement* text_element;
			TerminalOutputOutputLine* _tmp35_;
			TerminalOutputTextElement* _tmp36_;
			GeeList* _tmp37_ = NULL;
			GeeList* _tmp38_;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp29_ = _text_element_index;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_text_element_index = _tmp29_ + 1;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp30_ = _text_element_index;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp31_ = _text_element_size;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp30_ < _tmp31_)) {
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 4383 "TerminalOutput.c"
			}
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp32_ = _text_element_list;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp33_ = _text_element_index;
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _tmp33_);
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_element = (TerminalOutputTextElement*) _tmp34_;
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp35_ = output_line;
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp36_ = text_element;
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp37_ = terminal_output_text_element_get_text_menu_elements (_tmp36_);
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp38_ = _tmp37_;
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_array_list_add_all ((GeeArrayList*) _tmp35_, (GeeCollection*) _tmp38_);
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (_tmp38_);
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_element);
#line 4407 "TerminalOutput.c"
		}
#line 719 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_text_element_list);
#line 4411 "TerminalOutput.c"
	}
#line 722 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = output_line;
#line 722 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (text);
#line 722 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 4419 "TerminalOutput.c"
}


void terminal_output_output_line_insert_element (TerminalOutputOutputLine* self, TerminalOutputTextElement* text_element, gint position, gboolean overwrite) {
	gint _tmp0_;
	gint _tmp1_ = 0;
	GeeList* _tmp3_ = NULL;
	GeeList* character_elements;
	GeeArrayList* _tmp4_;
	GeeArrayList* result_elements;
	GeeArrayList* _tmp5_;
	GeeList* _tmp6_;
	gint _tmp7_;
	GeeList* _tmp8_ = NULL;
	GeeList* _tmp9_;
	GeeArrayList* _tmp10_;
	TerminalOutputTextElement* _tmp11_;
	gint _tmp12_ = 0;
	gboolean _tmp13_;
	gint _tmp18_;
	gint next_position;
	gint _tmp19_;
	gint _tmp20_ = 0;
	GeeArrayList* _tmp27_;
#line 725 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 725 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (text_element != NULL);
#line 727 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = position;
#line 727 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = terminal_output_output_line_get_length (self);
#line 727 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp0_ == _tmp1_) {
#line 4454 "TerminalOutput.c"
		TerminalOutputTextElement* _tmp2_;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = text_element;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) self, _tmp2_);
#line 729 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return;
#line 4462 "TerminalOutput.c"
	}
#line 732 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = terminal_output_output_line_explode (self);
#line 732 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	character_elements = _tmp3_;
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result_elements = _tmp4_;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = result_elements;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = character_elements;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = position;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = gee_list_slice (_tmp6_, 0, _tmp7_);
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = _tmp8_;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_array_list_add_all (_tmp5_, (GeeCollection*) _tmp9_);
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp9_);
#line 736 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = result_elements;
#line 736 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp11_ = text_element;
#line 736 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp13_ = overwrite;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp13_) {
#line 4496 "TerminalOutput.c"
		gint _tmp14_;
		TerminalOutputTextElement* _tmp15_;
		gint _tmp16_ = 0;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp14_ = position;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp15_ = text_element;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp16_ = terminal_output_text_element_get_length (_tmp15_);
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = _tmp14_ + _tmp16_;
#line 4508 "TerminalOutput.c"
	} else {
		gint _tmp17_;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp17_ = position;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = _tmp17_;
#line 4515 "TerminalOutput.c"
	}
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp18_ = _tmp12_;
#line 738 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	next_position = _tmp18_;
#line 742 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp19_ = next_position;
#line 742 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20_ = terminal_output_output_line_get_length (self);
#line 742 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp19_ <= _tmp20_) {
#line 4527 "TerminalOutput.c"
		GeeArrayList* _tmp21_;
		GeeList* _tmp22_;
		gint _tmp23_;
		gint _tmp24_ = 0;
		GeeList* _tmp25_ = NULL;
		GeeList* _tmp26_;
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp21_ = result_elements;
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp22_ = character_elements;
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp23_ = next_position;
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp24_ = terminal_output_output_line_get_length (self);
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp25_ = gee_list_slice (_tmp22_, _tmp23_, _tmp24_);
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp26_ = _tmp25_;
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_array_list_add_all (_tmp21_, (GeeCollection*) _tmp26_);
#line 743 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp26_);
#line 4550 "TerminalOutput.c"
	}
#line 745 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp27_ = result_elements;
#line 745 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_assemble (self, (GeeList*) _tmp27_);
#line 725 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (result_elements);
#line 725 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (character_elements);
#line 4560 "TerminalOutput.c"
}


void terminal_output_output_line_erase_range (TerminalOutputOutputLine* self, gint start_position, gint end_position) {
	GeeList* _tmp0_ = NULL;
	GeeList* character_elements;
	GeeArrayList* _tmp1_;
	GeeArrayList* result_elements;
	GeeArrayList* _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	GeeList* _tmp5_ = NULL;
	GeeList* _tmp6_;
	gint _tmp7_;
	GeeArrayList* _tmp14_;
#line 750 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 751 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = terminal_output_output_line_explode (self);
#line 751 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	character_elements = _tmp0_;
#line 752 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 752 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result_elements = _tmp1_;
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = result_elements;
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = character_elements;
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = start_position;
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = gee_list_slice (_tmp3_, 0, _tmp4_);
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = _tmp5_;
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_array_list_add_all (_tmp2_, (GeeCollection*) _tmp6_);
#line 754 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp6_);
#line 755 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = end_position;
#line 755 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp7_ != (-1)) {
#line 4604 "TerminalOutput.c"
		GeeArrayList* _tmp8_;
		GeeList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_ = 0;
		GeeList* _tmp12_ = NULL;
		GeeList* _tmp13_;
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp8_ = result_elements;
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp9_ = character_elements;
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp10_ = end_position;
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp11_ = terminal_output_output_line_get_length (self);
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = gee_list_slice (_tmp9_, _tmp10_, _tmp11_);
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp13_ = _tmp12_;
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_array_list_add_all (_tmp8_, (GeeCollection*) _tmp13_);
#line 756 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp13_);
#line 4627 "TerminalOutput.c"
	}
#line 759 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp14_ = result_elements;
#line 759 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_assemble (self, (GeeList*) _tmp14_);
#line 750 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (result_elements);
#line 750 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (character_elements);
#line 4637 "TerminalOutput.c"
}


void terminal_output_output_line_optimize (TerminalOutputOutputLine* self) {
	GeeArrayList* _tmp0_;
	GeeArrayList* text_elements;
#line 762 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 763 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 763 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_elements = _tmp0_;
#line 764 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_array_list_add_all (text_elements, (GeeCollection*) self);
#line 765 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_assemble (self, (GeeList*) text_elements);
#line 762 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (text_elements);
#line 4656 "TerminalOutput.c"
}


GeeList* terminal_output_output_line_explode (TerminalOutputOutputLine* self) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* character_elements;
#line 769 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 770 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 770 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	character_elements = _tmp0_;
#line 4670 "TerminalOutput.c"
	{
		TerminalOutputOutputLine* _tmp1_;
		TerminalOutputOutputLine* _text_element_list;
		TerminalOutputOutputLine* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _text_element_size;
		gint _text_element_index;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = _g_object_ref0 (self);
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_list = _tmp1_;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = _text_element_list;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = _tmp3_;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_size = _tmp4_;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_index = -1;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 4695 "TerminalOutput.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			TerminalOutputOutputLine* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			TerminalOutputTextElement* text_element;
			GeeArrayList* _tmp11_;
			TerminalOutputTextElement* _tmp12_;
			gint _tmp13_ = 0;
			TerminalOutputTextElement** _tmp14_ = NULL;
			TerminalOutputTextElement** _tmp15_;
			gint _tmp15__length1;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _text_element_index;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_text_element_index = _tmp5_ + 1;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = _text_element_index;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = _text_element_size;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 4721 "TerminalOutput.c"
			}
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _text_element_list;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = _text_element_index;
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_element = (TerminalOutputTextElement*) _tmp10_;
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = character_elements;
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = text_element;
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp14_ = terminal_output_text_element_explode (_tmp12_, &_tmp13_);
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15_ = _tmp14_;
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15__length1 = _tmp13_;
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_collection_add_all_array ((GeeCollection*) _tmp11_, _tmp15_, _tmp13_);
#line 772 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_object_unref), NULL);
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_element);
#line 4747 "TerminalOutput.c"
		}
#line 771 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_text_element_list);
#line 4751 "TerminalOutput.c"
	}
#line 774 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = (GeeList*) character_elements;
#line 774 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 4757 "TerminalOutput.c"
}


void terminal_output_output_line_assemble (TerminalOutputOutputLine* self, GeeList* text_elements) {
	GeeList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeList* _tmp3_;
	gpointer _tmp4_ = NULL;
	TerminalOutputTextElement* _tmp5_;
	CharacterAttributes* _tmp6_;
	CharacterAttributes* _tmp7_;
	CharacterAttributes* _tmp8_;
	CharacterAttributes* _tmp9_;
	CharacterAttributes* current_attributes;
	GString* _tmp10_;
	GString* text_builder;
	GString* _tmp41_;
	gssize _tmp42_;
#line 780 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 780 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (text_elements != NULL);
#line 781 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) self);
#line 783 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = text_elements;
#line 783 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = gee_collection_get_is_empty ((GeeCollection*) _tmp0_);
#line 783 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = _tmp1_;
#line 783 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp2_) {
#line 784 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return;
#line 4793 "TerminalOutput.c"
	}
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = text_elements;
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = gee_list_get (_tmp3_, 0);
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = (TerminalOutputTextElement*) _tmp4_;
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = terminal_output_text_element_get_attributes (_tmp5_);
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp7_ = _tmp6_;
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp9_ = _tmp8_;
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp5_);
#line 787 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	current_attributes = _tmp9_;
#line 788 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp10_ = g_string_new ("");
#line 788 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_builder = _tmp10_;
#line 4817 "TerminalOutput.c"
	{
		GeeList* _tmp11_;
		GeeList* _tmp12_;
		GeeList* _text_element_list;
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _text_element_size;
		gint _text_element_index;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp11_ = text_elements;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_list = _tmp12_;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp13_ = _text_element_list;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp15_ = _tmp14_;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_size = _tmp15_;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_index = -1;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 4845 "TerminalOutput.c"
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			GeeList* _tmp19_;
			gint _tmp20_;
			gpointer _tmp21_ = NULL;
			TerminalOutputTextElement* text_element;
			TerminalOutputTextElement* _tmp22_;
			CharacterAttributes* _tmp23_;
			CharacterAttributes* _tmp24_;
			CharacterAttributes* _tmp25_;
			gboolean _tmp26_ = FALSE;
			GString* _tmp37_;
			TerminalOutputTextElement* _tmp38_;
			const gchar* _tmp39_;
			const gchar* _tmp40_;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp16_ = _text_element_index;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_text_element_index = _tmp16_ + 1;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = _text_element_index;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp18_ = _text_element_size;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp17_ < _tmp18_)) {
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 4874 "TerminalOutput.c"
			}
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp19_ = _text_element_list;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp20_ = _text_element_index;
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp21_ = gee_list_get (_tmp19_, _tmp20_);
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_element = (TerminalOutputTextElement*) _tmp21_;
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp22_ = text_element;
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp23_ = terminal_output_text_element_get_attributes (_tmp22_);
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp24_ = _tmp23_;
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp25_ = current_attributes;
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp26_ = character_attributes_equals (_tmp24_, _tmp25_);
#line 791 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!_tmp26_) {
#line 4896 "TerminalOutput.c"
				GString* _tmp27_;
				const gchar* _tmp28_;
				CharacterAttributes* _tmp29_;
				TerminalOutputTextElement* _tmp30_;
				TerminalOutputTextElement* _tmp31_;
				TerminalOutputTextElement* _tmp32_;
				CharacterAttributes* _tmp33_;
				CharacterAttributes* _tmp34_;
				CharacterAttributes* _tmp35_;
				GString* _tmp36_;
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp27_ = text_builder;
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp28_ = _tmp27_->str;
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp29_ = current_attributes;
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp30_ = terminal_output_text_element_new (_tmp28_, _tmp29_);
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp31_ = _tmp30_;
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) self, _tmp31_);
#line 792 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_tmp31_);
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp32_ = text_element;
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp33_ = terminal_output_text_element_get_attributes (_tmp32_);
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp34_ = _tmp33_;
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (current_attributes);
#line 793 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				current_attributes = _tmp35_;
#line 794 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp36_ = text_builder;
#line 794 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				g_string_erase (_tmp36_, (gssize) 0, (gssize) (-1));
#line 4937 "TerminalOutput.c"
			}
#line 796 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp37_ = text_builder;
#line 796 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp38_ = text_element;
#line 796 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp39_ = terminal_output_text_element_get_text (_tmp38_);
#line 796 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp40_ = _tmp39_;
#line 796 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_string_append (_tmp37_, _tmp40_);
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_element);
#line 4951 "TerminalOutput.c"
		}
#line 790 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_text_element_list);
#line 4955 "TerminalOutput.c"
	}
#line 799 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp41_ = text_builder;
#line 799 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp42_ = _tmp41_->len;
#line 799 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp42_ > ((gssize) 0)) {
#line 4963 "TerminalOutput.c"
		GString* _tmp43_;
		const gchar* _tmp44_;
		CharacterAttributes* _tmp45_;
		TerminalOutputTextElement* _tmp46_;
		TerminalOutputTextElement* _tmp47_;
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp43_ = text_builder;
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp44_ = _tmp43_->str;
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp45_ = current_attributes;
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp46_ = terminal_output_text_element_new (_tmp44_, _tmp45_);
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp47_ = _tmp46_;
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) self, _tmp47_);
#line 801 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp47_);
#line 4983 "TerminalOutput.c"
	}
#line 780 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_string_free0 (text_builder);
#line 780 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (current_attributes);
#line 4989 "TerminalOutput.c"
}


gint terminal_output_output_line_get_length (TerminalOutputOutputLine* self) {
	gint result = 0;
	gint length;
#line 805 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 806 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	length = 0;
#line 5000 "TerminalOutput.c"
	{
		TerminalOutputOutputLine* _tmp0_;
		TerminalOutputOutputLine* _text_element_list;
		TerminalOutputOutputLine* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _text_element_size;
		gint _text_element_index;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp0_ = _g_object_ref0 (self);
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_list = _tmp0_;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = _text_element_list;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = _tmp2_;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_size = _tmp3_;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_index = -1;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 5025 "TerminalOutput.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			TerminalOutputOutputLine* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_ = NULL;
			TerminalOutputTextElement* text_element;
			gint _tmp10_;
			TerminalOutputTextElement* _tmp11_;
			gint _tmp12_ = 0;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp4_ = _text_element_index;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_text_element_index = _tmp4_ + 1;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _text_element_index;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = _text_element_size;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 5048 "TerminalOutput.c"
			}
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = _text_element_list;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _text_element_index;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_element = (TerminalOutputTextElement*) _tmp9_;
#line 808 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = length;
#line 808 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = text_element;
#line 808 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = terminal_output_text_element_get_length (_tmp11_);
#line 808 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			length = _tmp10_ + _tmp12_;
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_element);
#line 5068 "TerminalOutput.c"
		}
#line 807 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_text_element_list);
#line 5072 "TerminalOutput.c"
	}
#line 810 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = length;
#line 810 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 5078 "TerminalOutput.c"
}


gchar* terminal_output_output_line_get_text (TerminalOutputOutputLine* self) {
	gchar* result = NULL;
	GString* _tmp0_;
	GString* text_builder;
	GString* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 813 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 814 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = g_string_new ("");
#line 814 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_builder = _tmp0_;
#line 5095 "TerminalOutput.c"
	{
		TerminalOutputOutputLine* _tmp1_;
		TerminalOutputOutputLine* _text_element_list;
		TerminalOutputOutputLine* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _text_element_size;
		gint _text_element_index;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = _g_object_ref0 (self);
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_list = _tmp1_;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = _text_element_list;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp4_ = _tmp3_;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_size = _tmp4_;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_text_element_index = -1;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 5120 "TerminalOutput.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			TerminalOutputOutputLine* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_ = NULL;
			TerminalOutputTextElement* text_element;
			GString* _tmp11_;
			TerminalOutputTextElement* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _text_element_index;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_text_element_index = _tmp5_ + 1;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = _text_element_index;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = _text_element_size;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 5144 "TerminalOutput.c"
			}
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _text_element_list;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = _text_element_index;
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			text_element = (TerminalOutputTextElement*) _tmp10_;
#line 816 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = text_builder;
#line 816 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = text_element;
#line 816 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp13_ = terminal_output_text_element_get_text (_tmp12_);
#line 816 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp14_ = _tmp13_;
#line 816 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_string_append (_tmp11_, _tmp14_);
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_element);
#line 5166 "TerminalOutput.c"
		}
#line 815 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_text_element_list);
#line 5170 "TerminalOutput.c"
	}
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp15_ = text_builder;
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp16_ = _tmp15_->str;
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp17_;
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_string_free0 (text_builder);
#line 818 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 5184 "TerminalOutput.c"
}


static gint* _int_dup (gint* self) {
	gint* dup;
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	dup = g_new0 (gint, 1);
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	memcpy (dup, self, sizeof (gint));
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return dup;
#line 5196 "TerminalOutput.c"
}


static gpointer __int_dup0 (gpointer self) {
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self ? _int_dup (self) : NULL;
#line 5203 "TerminalOutput.c"
}


void terminal_output_output_line_get_text_element_from_index (TerminalOutputOutputLine* self, gint index, TerminalOutputTextElement** text_element, gint** position) {
	TerminalOutputTextElement* _vala_text_element = NULL;
	gint* _vala_position = NULL;
	gint current_index;
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 822 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	current_index = 0;
#line 5215 "TerminalOutput.c"
	{
		TerminalOutputOutputLine* _tmp0_;
		TerminalOutputOutputLine* _current_element_list;
		TerminalOutputOutputLine* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _current_element_size;
		gint _current_element_index;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp0_ = _g_object_ref0 (self);
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_current_element_list = _tmp0_;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp1_ = _current_element_list;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp3_ = _tmp2_;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_current_element_size = _tmp3_;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_current_element_index = -1;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 5240 "TerminalOutput.c"
			gint _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			TerminalOutputOutputLine* _tmp7_;
			gint _tmp8_;
			gpointer _tmp9_ = NULL;
			TerminalOutputTextElement* current_element;
			gboolean _tmp10_ = FALSE;
			gint _tmp11_;
			gint _tmp12_;
			gboolean _tmp17_;
			gint _tmp22_;
			TerminalOutputTextElement* _tmp23_;
			gint _tmp24_ = 0;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp4_ = _current_element_index;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_current_element_index = _tmp4_ + 1;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp5_ = _current_element_index;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp6_ = _current_element_size;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 5267 "TerminalOutput.c"
			}
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp7_ = _current_element_list;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp8_ = _current_element_index;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			current_element = (TerminalOutputTextElement*) _tmp9_;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp11_ = index;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = current_index;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (_tmp11_ >= _tmp12_) {
#line 5283 "TerminalOutput.c"
				gint _tmp13_;
				gint _tmp14_;
				TerminalOutputTextElement* _tmp15_;
				gint _tmp16_ = 0;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp13_ = index;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp14_ = current_index;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp15_ = current_element;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp16_ = terminal_output_text_element_get_length (_tmp15_);
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp10_ = _tmp13_ < (_tmp14_ + _tmp16_);
#line 5298 "TerminalOutput.c"
			} else {
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp10_ = FALSE;
#line 5302 "TerminalOutput.c"
			}
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = _tmp10_;
#line 824 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (_tmp17_) {
#line 5308 "TerminalOutput.c"
				TerminalOutputTextElement* _tmp18_;
				TerminalOutputTextElement* _tmp19_;
				gint _tmp20_;
				gint* _tmp21_;
#line 825 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp18_ = current_element;
#line 825 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 825 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_vala_text_element);
#line 825 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_vala_text_element = _tmp19_;
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp20_ = current_index;
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp21_ = __int_dup0 (&_tmp20_);
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_free0 (_vala_position);
#line 826 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_vala_position = _tmp21_;
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (current_element);
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_current_element_list);
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (text_element) {
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					*text_element = _vala_text_element;
#line 5337 "TerminalOutput.c"
				} else {
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_vala_text_element);
#line 5341 "TerminalOutput.c"
				}
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (position) {
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					*position = _vala_position;
#line 5347 "TerminalOutput.c"
				} else {
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_free0 (_vala_position);
#line 5351 "TerminalOutput.c"
				}
#line 827 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				return;
#line 5355 "TerminalOutput.c"
			}
#line 829 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp22_ = current_index;
#line 829 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp23_ = current_element;
#line 829 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp24_ = terminal_output_text_element_get_length (_tmp23_);
#line 829 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			current_index = _tmp22_ + _tmp24_;
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (current_element);
#line 5367 "TerminalOutput.c"
		}
#line 823 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_current_element_list);
#line 5371 "TerminalOutput.c"
	}
#line 832 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_vala_text_element);
#line 832 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_vala_text_element = NULL;
#line 833 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (_vala_position);
#line 833 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_vala_position = NULL;
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (text_element) {
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		*text_element = _vala_text_element;
#line 5385 "TerminalOutput.c"
	} else {
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_vala_text_element);
#line 5389 "TerminalOutput.c"
	}
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (position) {
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		*position = _vala_position;
#line 5395 "TerminalOutput.c"
	} else {
#line 821 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_free0 (_vala_position);
#line 5399 "TerminalOutput.c"
	}
}


TerminalOutputOutputLine* terminal_output_output_line_construct (GType object_type) {
	TerminalOutputOutputLine * self = NULL;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = (TerminalOutputOutputLine*) gee_array_list_construct (object_type, TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self;
#line 5410 "TerminalOutput.c"
}


TerminalOutputOutputLine* terminal_output_output_line_new (void) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return terminal_output_output_line_construct (TERMINAL_OUTPUT_TYPE_OUTPUT_LINE);
#line 5417 "TerminalOutput.c"
}


gboolean terminal_output_output_line_get_is_prompt_line (TerminalOutputOutputLine* self) {
	gboolean result;
	gboolean _tmp0_;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_is_prompt_line;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 5432 "TerminalOutput.c"
}


void terminal_output_output_line_set_is_prompt_line (TerminalOutputOutputLine* self, gboolean value) {
	gboolean _tmp0_;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_is_prompt_line = _tmp0_;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "is-prompt-line");
#line 5446 "TerminalOutput.c"
}


gint terminal_output_output_line_get_return_code (TerminalOutputOutputLine* self) {
	gint result;
	gint _tmp0_;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_return_code;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 5461 "TerminalOutput.c"
}


void terminal_output_output_line_set_return_code (TerminalOutputOutputLine* self, gint value) {
	gint _tmp0_;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_return_code = _tmp0_;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "return-code");
#line 5475 "TerminalOutput.c"
}


static void terminal_output_output_line_class_init (TerminalOutputOutputLineClass * klass) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_output_line_parent_class = g_type_class_peek_parent (klass);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_type_class_add_private (klass, sizeof (TerminalOutputOutputLinePrivate));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_output_output_line_get_property;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_output_output_line_set_property;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_output_output_line_finalize;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_OUTPUT_LINE_IS_PROMPT_LINE, g_param_spec_boolean ("is-prompt-line", "is-prompt-line", "is-prompt-line", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_OUTPUT_LINE_RETURN_CODE, g_param_spec_int ("return-code", "return-code", "return-code", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5494 "TerminalOutput.c"
}


static void terminal_output_output_line_instance_init (TerminalOutputOutputLine * self) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv = TERMINAL_OUTPUT_OUTPUT_LINE_GET_PRIVATE (self);
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_is_prompt_line = FALSE;
#line 700 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_return_code = 0;
#line 5505 "TerminalOutput.c"
}


static void terminal_output_output_line_finalize (GObject* obj) {
	TerminalOutputOutputLine * self;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLine);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (terminal_output_output_line_parent_class)->finalize (obj);
#line 5515 "TerminalOutput.c"
}


GType terminal_output_output_line_get_type (void) {
	static volatile gsize terminal_output_output_line_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_output_line_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalOutputOutputLineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_output_output_line_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalOutputOutputLine), 0, (GInstanceInitFunc) terminal_output_output_line_instance_init, NULL };
		GType terminal_output_output_line_type_id;
		terminal_output_output_line_type_id = g_type_register_static (GEE_TYPE_ARRAY_LIST, "TerminalOutputOutputLine", &g_define_type_info, 0);
		g_once_init_leave (&terminal_output_output_line_type_id__volatile, terminal_output_output_line_type_id);
	}
	return terminal_output_output_line_type_id__volatile;
}


static void _vala_terminal_output_output_line_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TerminalOutputOutputLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLine);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_OUTPUT_LINE_IS_PROMPT_LINE:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_boolean (value, terminal_output_output_line_get_is_prompt_line (self));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_OUTPUT_LINE_RETURN_CODE:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_int (value, terminal_output_output_line_get_return_code (self));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 5548 "TerminalOutput.c"
		default:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 5554 "TerminalOutput.c"
	}
}


static void _vala_terminal_output_output_line_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TerminalOutputOutputLine * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_OUTPUT_TYPE_OUTPUT_LINE, TerminalOutputOutputLine);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_OUTPUT_LINE_IS_PROMPT_LINE:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_output_line_set_is_prompt_line (self, g_value_get_boolean (value));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_OUTPUT_LINE_RETURN_CODE:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_output_line_set_return_code (self, g_value_get_int (value));
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 5576 "TerminalOutput.c"
		default:
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 5582 "TerminalOutput.c"
	}
}


TerminalOutputTextElement* terminal_output_text_element_construct (GType object_type, const gchar* text, CharacterAttributes* attributes) {
	TerminalOutputTextElement * self = NULL;
	const gchar* _tmp0_;
	CharacterAttributes* _tmp1_;
#line 845 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 845 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (attributes != NULL, NULL);
#line 845 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = (TerminalOutputTextElement*) g_object_new (object_type, NULL);
#line 846 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = text;
#line 846 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_text_element_set_text (self, _tmp0_);
#line 847 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = attributes;
#line 847 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_text_element_set_attributes (self, _tmp1_);
#line 845 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self;
#line 5607 "TerminalOutput.c"
}


TerminalOutputTextElement* terminal_output_text_element_new (const gchar* text, CharacterAttributes* attributes) {
#line 845 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return terminal_output_text_element_construct (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, text, attributes);
#line 5614 "TerminalOutput.c"
}


TerminalOutputTextElement* terminal_output_text_element_construct_copy (GType object_type, TerminalOutputTextElement* text_element) {
	TerminalOutputTextElement * self = NULL;
	TerminalOutputTextElement* _tmp0_;
	const gchar* _tmp1_;
	TerminalOutputTextElement* _tmp2_;
	CharacterAttributes* _tmp3_;
	CharacterAttributes* _tmp4_;
	CharacterAttributes* _tmp5_;
#line 850 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (text_element != NULL, NULL);
#line 850 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = (TerminalOutputTextElement*) g_object_new (object_type, NULL);
#line 851 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = text_element;
#line 851 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _tmp0_->priv->_text;
#line 851 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_text_element_set_text (self, _tmp1_);
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = text_element;
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = _tmp2_->priv->_attributes;
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = character_attributes_new_copy (_tmp3_);
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = _tmp4_;
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_text_element_set_attributes (self, _tmp5_);
#line 852 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp5_);
#line 850 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return self;
#line 5650 "TerminalOutput.c"
}


TerminalOutputTextElement* terminal_output_text_element_new_copy (TerminalOutputTextElement* text_element) {
#line 850 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return terminal_output_text_element_construct_copy (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, text_element);
#line 5657 "TerminalOutput.c"
}


GeeList* terminal_output_text_element_get_text_menu_elements (TerminalOutputTextElement* self) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* old_text_elements;
	GeeArrayList* _tmp1_;
	GeeArrayList* current_text_elements;
	GeeArrayList* _tmp2_;
	TerminalOutputTextElement* _tmp3_;
	TerminalOutputTextElement* _tmp4_;
#line 855 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 856 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 856 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	old_text_elements = _tmp0_;
#line 857 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 857 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	current_text_elements = _tmp1_;
#line 859 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = current_text_elements;
#line 859 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = terminal_output_text_element_new_copy (self);
#line 859 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = _tmp3_;
#line 859 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, _tmp4_);
#line 859 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (_tmp4_);
#line 5690 "TerminalOutput.c"
	{
		GeeMap* _tmp5_;
		GeeMap* _tmp6_;
		GeeSet* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeIterator* _tmp10_ = NULL;
		GeeIterator* _tmp11_;
		GeeIterator* _pattern_it;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp5_ = final_term_get_text_menus_by_pattern ();
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp6_ = _tmp5_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp7_ = gee_map_get_keys (_tmp6_);
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp8_ = _tmp7_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp9_ = _tmp8_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp11_ = _tmp10_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_tmp9_);
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_pattern_it = _tmp11_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		while (TRUE) {
#line 5720 "TerminalOutput.c"
			GeeIterator* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GeeIterator* _tmp14_;
			gpointer _tmp15_ = NULL;
			GRegex* pattern;
			GeeArrayList* _tmp16_;
			GeeArrayList* _tmp17_;
			GeeArrayList* _tmp18_;
			GeeArrayList* _tmp19_;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp12_ = _pattern_it;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp13_ = gee_iterator_next (_tmp12_);
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			if (!_tmp13_) {
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				break;
#line 5738 "TerminalOutput.c"
			}
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp14_ = _pattern_it;
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp15_ = gee_iterator_get (_tmp14_);
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			pattern = (GRegex*) _tmp15_;
#line 862 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp16_ = old_text_elements;
#line 862 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp16_);
#line 863 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp17_ = old_text_elements;
#line 863 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp18_ = current_text_elements;
#line 863 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_array_list_add_all (_tmp17_, (GeeCollection*) _tmp18_);
#line 864 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp19_ = current_text_elements;
#line 864 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp19_);
#line 5760 "TerminalOutput.c"
			{
				GeeArrayList* _tmp20_;
				GeeArrayList* _tmp21_;
				GeeArrayList* _text_element_list;
				GeeArrayList* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gint _text_element_size;
				gint _text_element_index;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp20_ = old_text_elements;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp21_ = _g_object_ref0 (_tmp20_);
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_text_element_list = _tmp21_;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp22_ = _text_element_list;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp23_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp22_);
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp24_ = _tmp23_;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_text_element_size = _tmp24_;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_text_element_index = -1;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				while (TRUE) {
#line 5788 "TerminalOutput.c"
					gint _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
					GeeArrayList* _tmp28_;
					gint _tmp29_;
					gpointer _tmp30_ = NULL;
					TerminalOutputTextElement* text_element;
					GeeArrayList* _tmp31_;
					TerminalOutputTextElement* _tmp32_;
					GRegex* _tmp33_;
					GeeList* _tmp34_ = NULL;
					GeeList* _tmp35_;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp25_ = _text_element_index;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_text_element_index = _tmp25_ + 1;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp26_ = _text_element_index;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp27_ = _text_element_size;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (!(_tmp26_ < _tmp27_)) {
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						break;
#line 5813 "TerminalOutput.c"
					}
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp28_ = _text_element_list;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp29_ = _text_element_index;
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _tmp29_);
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					text_element = (TerminalOutputTextElement*) _tmp30_;
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp31_ = current_text_elements;
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp32_ = text_element;
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp33_ = pattern;
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp34_ = terminal_output_text_element_get_text_menu_elements_for_pattern (self, _tmp32_, _tmp33_);
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp35_ = _tmp34_;
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					gee_array_list_add_all (_tmp31_, (GeeCollection*) _tmp35_);
#line 867 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp35_);
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (text_element);
#line 5839 "TerminalOutput.c"
				}
#line 866 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_text_element_list);
#line 5843 "TerminalOutput.c"
			}
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_regex_unref0 (pattern);
#line 5847 "TerminalOutput.c"
		}
#line 861 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_g_object_unref0 (_pattern_it);
#line 5851 "TerminalOutput.c"
	}
#line 871 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = (GeeList*) current_text_elements;
#line 871 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (old_text_elements);
#line 871 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 5859 "TerminalOutput.c"
}


GeeList* terminal_output_text_element_get_text_menu_elements_for_pattern (TerminalOutputTextElement* self, TerminalOutputTextElement* text_element, GRegex* pattern) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* text_elements;
	GMatchInfo* match_info = NULL;
	GRegex* _tmp1_;
	TerminalOutputTextElement* _tmp2_;
	const gchar* _tmp3_;
	GMatchInfo* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GError * _inner_error_ = NULL;
#line 874 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 874 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (text_element != NULL, NULL);
#line 874 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (pattern != NULL, NULL);
#line 875 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = gee_array_list_new (TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 875 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	text_elements = _tmp0_;
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = pattern;
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = text_element;
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = _tmp2_->priv->_text;
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = g_regex_match (_tmp1_, _tmp3_, 0, &_tmp4_);
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_match_info_free0 (match_info);
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	match_info = _tmp4_;
#line 878 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp5_) {
#line 5898 "TerminalOutput.c"
		gint old_end_position;
		gint _tmp53_;
		TerminalOutputTextElement* _tmp54_;
		const gchar* _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
#line 879 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		old_end_position = 0;
#line 5907 "TerminalOutput.c"
		{
			{
				gboolean _tmp6_;
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp6_ = TRUE;
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				while (TRUE) {
#line 5915 "TerminalOutput.c"
					gboolean _tmp7_;
					gint start_position = 0;
					gint end_position = 0;
					GMatchInfo* _tmp11_;
					gint _tmp12_ = 0;
					gint _tmp13_ = 0;
					gint _tmp14_;
					gint _tmp15_;
					TerminalOutputTextElement* _tmp30_;
					CharacterAttributes* _tmp31_;
					CharacterAttributes* _tmp32_;
					CharacterAttributes* character_attributes;
					CharacterAttributes* _tmp33_;
					GeeMap* _tmp34_;
					GeeMap* _tmp35_;
					GRegex* _tmp36_;
					gpointer _tmp37_ = NULL;
					TextMenu* _tmp38_;
					GeeArrayList* _tmp39_;
					TerminalOutputTextElement* _tmp40_;
					const gchar* _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					gchar* _tmp45_ = NULL;
					gchar* _tmp46_;
					CharacterAttributes* _tmp47_;
					TerminalOutputTextElement* _tmp48_;
					TerminalOutputTextElement* _tmp49_;
					gint _tmp50_;
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp7_ = _tmp6_;
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (!_tmp7_) {
#line 5950 "TerminalOutput.c"
						GMatchInfo* _tmp8_;
						gboolean _tmp9_ = FALSE;
						gboolean _tmp10_;
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp8_ = match_info;
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp9_ = g_match_info_next (_tmp8_, &_inner_error_);
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp10_ = _tmp9_;
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						if (_inner_error_ != NULL) {
#line 5962 "TerminalOutput.c"
							goto __catch7_g_error;
						}
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						if (!_tmp10_) {
#line 904 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
							break;
#line 5969 "TerminalOutput.c"
						}
					}
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp6_ = FALSE;
#line 888 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp11_ = match_info;
#line 888 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					g_match_info_fetch_pos (_tmp11_, 0, &_tmp12_, &_tmp13_);
#line 888 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					start_position = _tmp12_;
#line 888 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					end_position = _tmp13_;
#line 890 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp14_ = start_position;
#line 890 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp15_ = old_end_position;
#line 890 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					if (_tmp14_ > _tmp15_) {
#line 5988 "TerminalOutput.c"
						GeeArrayList* _tmp16_;
						TerminalOutputTextElement* _tmp17_;
						const gchar* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
						gchar* _tmp22_ = NULL;
						gchar* _tmp23_;
						TerminalOutputTextElement* _tmp24_;
						CharacterAttributes* _tmp25_;
						CharacterAttributes* _tmp26_;
						CharacterAttributes* _tmp27_;
						TerminalOutputTextElement* _tmp28_;
						TerminalOutputTextElement* _tmp29_;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp16_ = text_elements;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp17_ = text_element;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp18_ = _tmp17_->priv->_text;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp19_ = old_end_position;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp20_ = start_position;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp21_ = old_end_position;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp22_ = string_substring (_tmp18_, (glong) _tmp19_, (glong) (_tmp20_ - _tmp21_));
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp23_ = _tmp22_;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp24_ = text_element;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp25_ = _tmp24_->priv->_attributes;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp26_ = character_attributes_new_copy (_tmp25_);
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp27_ = _tmp26_;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp28_ = terminal_output_text_element_new (_tmp23_, _tmp27_);
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_tmp29_ = _tmp28_;
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp29_);
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_object_unref0 (_tmp29_);
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_object_unref0 (_tmp27_);
#line 892 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
						_g_free0 (_tmp23_);
#line 6039 "TerminalOutput.c"
					}
#line 897 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp30_ = text_element;
#line 897 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp31_ = _tmp30_->priv->_attributes;
#line 897 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp32_ = character_attributes_new_copy (_tmp31_);
#line 897 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					character_attributes = _tmp32_;
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp33_ = character_attributes;
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp34_ = final_term_get_text_menus_by_pattern ();
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp35_ = _tmp34_;
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp36_ = pattern;
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp37_ = gee_map_get (_tmp35_, _tmp36_);
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp38_ = (TextMenu*) _tmp37_;
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					character_attributes_set_text_menu (_tmp33_, _tmp38_);
#line 898 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp38_);
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp39_ = text_elements;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp40_ = text_element;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp41_ = _tmp40_->priv->_text;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp42_ = start_position;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp43_ = end_position;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp44_ = start_position;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp45_ = string_substring (_tmp41_, (glong) _tmp42_, (glong) (_tmp43_ - _tmp44_));
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp46_ = _tmp45_;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp47_ = character_attributes;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp48_ = terminal_output_text_element_new (_tmp46_, _tmp47_);
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp49_ = _tmp48_;
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp49_);
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (_tmp49_);
#line 899 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_free0 (_tmp46_);
#line 903 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp50_ = end_position;
#line 903 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					old_end_position = _tmp50_;
#line 885 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_g_object_unref0 (character_attributes);
#line 6099 "TerminalOutput.c"
				}
			}
		}
		goto __finally7;
		__catch7_g_error:
		{
			GError* e = NULL;
			GError* _tmp51_;
			const gchar* _tmp52_;
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			e = _inner_error_;
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_inner_error_ = NULL;
#line 905 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp51_ = e;
#line 905 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp52_ = _tmp51_->message;
#line 905 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_warning ("TerminalOutput.vala:905: %s", _tmp52_);
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_error_free0 (e);
#line 6121 "TerminalOutput.c"
		}
		__finally7:
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		if (_inner_error_ != NULL) {
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_match_info_free0 (match_info);
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (text_elements);
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			g_clear_error (&_inner_error_);
#line 884 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			return NULL;
#line 6136 "TerminalOutput.c"
		}
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp53_ = old_end_position;
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp54_ = text_element;
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp55_ = _tmp54_->priv->_text;
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp56_ = strlen (_tmp55_);
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp57_ = _tmp56_;
#line 907 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		if (_tmp53_ < _tmp57_) {
#line 6150 "TerminalOutput.c"
			GeeArrayList* _tmp58_;
			TerminalOutputTextElement* _tmp59_;
			const gchar* _tmp60_;
			gint _tmp61_;
			gchar* _tmp62_ = NULL;
			gchar* _tmp63_;
			TerminalOutputTextElement* _tmp64_;
			CharacterAttributes* _tmp65_;
			CharacterAttributes* _tmp66_;
			CharacterAttributes* _tmp67_;
			TerminalOutputTextElement* _tmp68_;
			TerminalOutputTextElement* _tmp69_;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp58_ = text_elements;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp59_ = text_element;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp60_ = _tmp59_->priv->_text;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp61_ = old_end_position;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp62_ = string_substring (_tmp60_, (glong) _tmp61_, (glong) (-1));
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp63_ = _tmp62_;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp64_ = text_element;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp65_ = _tmp64_->priv->_attributes;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp66_ = character_attributes_new_copy (_tmp65_);
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp67_ = _tmp66_;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp68_ = terminal_output_text_element_new (_tmp63_, _tmp67_);
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp69_ = _tmp68_;
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp58_, _tmp69_);
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (_tmp69_);
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_object_unref0 (_tmp67_);
#line 909 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_g_free0 (_tmp63_);
#line 6195 "TerminalOutput.c"
		}
	} else {
		GeeArrayList* _tmp70_;
		TerminalOutputTextElement* _tmp71_;
#line 915 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp70_ = text_elements;
#line 915 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		_tmp71_ = text_element;
#line 915 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp70_, _tmp71_);
#line 6206 "TerminalOutput.c"
	}
#line 918 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = (GeeList*) text_elements;
#line 918 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_match_info_free0 (match_info);
#line 918 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6214 "TerminalOutput.c"
}


gint terminal_output_text_element_get_length (TerminalOutputTextElement* self) {
	gint result = 0;
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
#line 921 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 922 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_text;
#line 922 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = g_utf8_strlen (_tmp0_, (gssize) (-1));
#line 922 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp1_;
#line 922 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6232 "TerminalOutput.c"
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_ = 0U;
#line 995 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 6250 "TerminalOutput.c"
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* str;
	const gchar* _tmp1_;
#line 855 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 855 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 856 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = str;
#line 856 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_unichar_to_utf8 (self, _tmp1_);
#line 857 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = str;
#line 857 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 6271 "TerminalOutput.c"
}


TerminalOutputTextElement** terminal_output_text_element_explode (TerminalOutputTextElement* self, int* result_length1) {
	TerminalOutputTextElement** result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	TerminalOutputTextElement** _tmp2_ = NULL;
	TerminalOutputTextElement** character_elements;
	gint character_elements_length1;
	gint _character_elements_size_;
	TerminalOutputTextElement** _tmp20_;
	gint _tmp20__length1;
#line 930 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_text;
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = g_utf8_strlen (_tmp0_, (gssize) (-1));
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = g_new0 (TerminalOutputTextElement*, _tmp1_ + 1);
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	character_elements = _tmp2_;
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	character_elements_length1 = _tmp1_;
#line 931 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_character_elements_size_ = character_elements_length1;
#line 6299 "TerminalOutput.c"
	{
		gint i;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		i = 0;
#line 6304 "TerminalOutput.c"
		{
			gboolean _tmp3_;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			_tmp3_ = TRUE;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
			while (TRUE) {
#line 6311 "TerminalOutput.c"
				gboolean _tmp4_;
				gint _tmp6_;
				TerminalOutputTextElement** _tmp7_;
				gint _tmp7__length1;
				TerminalOutputTextElement** _tmp8_;
				gint _tmp8__length1;
				gint _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
				gint _tmp12_;
				gint _tmp13_ = 0;
				gunichar _tmp14_ = 0U;
				gchar* _tmp15_ = NULL;
				gchar* _tmp16_;
				CharacterAttributes* _tmp17_;
				TerminalOutputTextElement* _tmp18_;
				TerminalOutputTextElement* _tmp19_;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp4_ = _tmp3_;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!_tmp4_) {
#line 6333 "TerminalOutput.c"
					gint _tmp5_;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					_tmp5_ = i;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					i = _tmp5_ + 1;
#line 6339 "TerminalOutput.c"
				}
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp3_ = FALSE;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp6_ = i;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp7_ = character_elements;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp7__length1 = character_elements_length1;
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				if (!(_tmp6_ < _tmp7__length1)) {
#line 932 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
					break;
#line 6353 "TerminalOutput.c"
				}
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp8_ = character_elements;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp8__length1 = character_elements_length1;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp9_ = i;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp10_ = self->priv->_text;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp11_ = self->priv->_text;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp12_ = i;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp13_ = string_index_of_nth_char (_tmp11_, (glong) _tmp12_);
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp14_ = string_get_char (_tmp10_, (glong) _tmp13_);
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp15_ = g_unichar_to_string (_tmp14_);
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp16_ = _tmp15_;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp17_ = self->priv->_attributes;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp18_ = terminal_output_text_element_new (_tmp16_, _tmp17_);
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_object_unref0 (_tmp8_[_tmp9_]);
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp8_[_tmp9_] = _tmp18_;
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_tmp19_ = _tmp8_[_tmp9_];
#line 934 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
				_g_free0 (_tmp16_);
#line 6387 "TerminalOutput.c"
			}
		}
	}
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20_ = character_elements;
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp20__length1 = character_elements_length1;
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (result_length1) {
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		*result_length1 = _tmp20__length1;
#line 6399 "TerminalOutput.c"
	}
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp20_;
#line 936 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6405 "TerminalOutput.c"
}


const gchar* terminal_output_text_element_get_text (TerminalOutputTextElement* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_text;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6420 "TerminalOutput.c"
}


void terminal_output_text_element_set_text (TerminalOutputTextElement* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->_text);
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_text = _tmp1_;
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "text");
#line 6439 "TerminalOutput.c"
}


CharacterAttributes* terminal_output_text_element_get_attributes (TerminalOutputTextElement* self) {
	CharacterAttributes* result;
	CharacterAttributes* _tmp0_;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = self->priv->_attributes;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp0_;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6454 "TerminalOutput.c"
}


void terminal_output_text_element_set_attributes (TerminalOutputTextElement* self, CharacterAttributes* value) {
	CharacterAttributes* _tmp0_;
	CharacterAttributes* _tmp1_;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_if_fail (self != NULL);
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = value;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->_attributes);
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_attributes = _tmp1_;
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_notify ((GObject *) self, "attributes");
#line 6473 "TerminalOutput.c"
}


static void terminal_output_text_element_class_init (TerminalOutputTextElementClass * klass) {
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_text_element_parent_class = g_type_class_peek_parent (klass);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_type_class_add_private (klass, sizeof (TerminalOutputTextElementPrivate));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_output_text_element_get_property;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_output_text_element_set_property;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_output_text_element_finalize;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_TEXT_ELEMENT_TEXT, g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_TEXT_ELEMENT_ATTRIBUTES, g_param_spec_object ("attributes", "attributes", "attributes", TYPE_CHARACTER_ATTRIBUTES, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 6492 "TerminalOutput.c"
}


static void terminal_output_text_element_instance_init (TerminalOutputTextElement * self) {
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv = TERMINAL_OUTPUT_TEXT_ELEMENT_GET_PRIVATE (self);
#line 6499 "TerminalOutput.c"
}


static void terminal_output_text_element_finalize (GObject* obj) {
	TerminalOutputTextElement * self;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElement);
#line 842 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->_text);
#line 843 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->_attributes);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (terminal_output_text_element_parent_class)->finalize (obj);
#line 6513 "TerminalOutput.c"
}


GType terminal_output_text_element_get_type (void) {
	static volatile gsize terminal_output_text_element_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_text_element_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalOutputTextElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_output_text_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalOutputTextElement), 0, (GInstanceInitFunc) terminal_output_text_element_instance_init, NULL };
		GType terminal_output_text_element_type_id;
		terminal_output_text_element_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalOutputTextElement", &g_define_type_info, 0);
		g_once_init_leave (&terminal_output_text_element_type_id__volatile, terminal_output_text_element_type_id);
	}
	return terminal_output_text_element_type_id__volatile;
}


static void _vala_terminal_output_text_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TerminalOutputTextElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElement);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TEXT_ELEMENT_TEXT:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_string (value, terminal_output_text_element_get_text (self));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TEXT_ELEMENT_ATTRIBUTES:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_object (value, terminal_output_text_element_get_attributes (self));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6546 "TerminalOutput.c"
		default:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6552 "TerminalOutput.c"
	}
}


static void _vala_terminal_output_text_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TerminalOutputTextElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_OUTPUT_TYPE_TEXT_ELEMENT, TerminalOutputTextElement);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TEXT_ELEMENT_TEXT:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_text_element_set_text (self, g_value_get_string (value));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TEXT_ELEMENT_ATTRIBUTES:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_text_element_set_attributes (self, g_value_get_object (value));
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6574 "TerminalOutput.c"
		default:
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 840 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6580 "TerminalOutput.c"
	}
}


gint terminal_output_cursor_position_compare (TerminalOutputCursorPosition *self, TerminalOutputCursorPosition* position) {
	gint result = 0;
	gint _tmp0_;
	TerminalOutputCursorPosition _tmp1_;
	gint _tmp2_;
	gint line_difference;
	gint _tmp3_;
	gint _tmp4_;
	TerminalOutputCursorPosition _tmp5_;
	gint _tmp6_;
#line 60 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_return_val_if_fail (position != NULL, 0);
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = (*self).line;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp1_ = *position;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = _tmp1_.line;
#line 61 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	line_difference = _tmp0_ - _tmp2_;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = line_difference;
#line 63 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	if (_tmp3_ != 0) {
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		result = line_difference;
#line 64 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		return result;
#line 6613 "TerminalOutput.c"
	}
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp4_ = (*self).column;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp5_ = *position;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp6_ = _tmp5_.column;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	result = _tmp4_ - _tmp6_;
#line 66 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return result;
#line 6625 "TerminalOutput.c"
}


TerminalOutputCursorPosition* terminal_output_cursor_position_dup (const TerminalOutputCursorPosition* self) {
	TerminalOutputCursorPosition* dup;
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	dup = g_new0 (TerminalOutputCursorPosition, 1);
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	memcpy (dup, self, sizeof (TerminalOutputCursorPosition));
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	return dup;
#line 6637 "TerminalOutput.c"
}


void terminal_output_cursor_position_free (TerminalOutputCursorPosition* self) {
#line 56 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_free (self);
#line 6644 "TerminalOutput.c"
}


GType terminal_output_cursor_position_get_type (void) {
	static volatile gsize terminal_output_cursor_position_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_cursor_position_type_id__volatile)) {
		GType terminal_output_cursor_position_type_id;
		terminal_output_cursor_position_type_id = g_boxed_type_register_static ("TerminalOutputCursorPosition", (GBoxedCopyFunc) terminal_output_cursor_position_dup, (GBoxedFreeFunc) terminal_output_cursor_position_free);
		g_once_init_leave (&terminal_output_cursor_position_type_id__volatile, terminal_output_cursor_position_type_id);
	}
	return terminal_output_cursor_position_type_id__volatile;
}


static void terminal_output_class_init (TerminalOutputClass * klass) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	terminal_output_parent_class = g_type_class_peek_parent (klass);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_type_class_add_private (klass, sizeof (TerminalOutputPrivate));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_output_get_property;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_output_set_property;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_output_finalize;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_TERMINAL_TITLE, g_param_spec_string ("terminal-title", "terminal-title", "terminal-title", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_TERMINAL_MODES, g_param_spec_flags ("terminal-modes", "terminal-modes", "terminal-modes", TERMINAL_OUTPUT_TYPE_TERMINAL_MODE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_OUTPUT_SCREEN_OFFSET, g_param_spec_int ("screen-offset", "screen-offset", "screen-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("line_added", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("line_updated", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("command_updated", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("command_executed", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("command_finished", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_INT, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_INT);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("progress_updated", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_STRING, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_STRING);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("progress_finished", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	g_signal_new ("cursor_position_changed", TYPE_TERMINAL_OUTPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED, G_TYPE_NONE, 1, TERMINAL_OUTPUT_TYPE_CURSOR_POSITION);
#line 6692 "TerminalOutput.c"
}


static void terminal_output_instance_init (TerminalOutput * self) {
	gchar* _tmp0_;
	TerminalOutputCursorPosition _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv = TERMINAL_OUTPUT_GET_PRIVATE (self);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp0_ = g_strdup ("Final Term");
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->_terminal_title = _tmp0_;
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	memset (&_tmp1_, 0, sizeof (TerminalOutputCursorPosition));
#line 54 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->cursor_position = _tmp1_;
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp2_ = g_strdup ("");
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->transient_text = _tmp2_;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_tmp3_ = g_strdup ("");
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->printed_transient_text = _tmp3_;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->priv->last_command = NULL;
#line 75 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self->command_mode = FALSE;
#line 6723 "TerminalOutput.c"
}


static void terminal_output_finalize (GObject* obj) {
	TerminalOutput * self;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TERMINAL_OUTPUT, TerminalOutput);
#line 32 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->terminal);
#line 34 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->_terminal_title);
#line 46 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_object_unref0 (self->priv->current_attributes);
#line 70 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->transient_text);
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->printed_transient_text);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	_g_free0 (self->priv->last_command);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	G_OBJECT_CLASS (terminal_output_parent_class)->finalize (obj);
#line 6745 "TerminalOutput.c"
}


GType terminal_output_get_type (void) {
	static volatile gsize terminal_output_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_output_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalOutputClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_output_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalOutput), 0, (GInstanceInitFunc) terminal_output_instance_init, NULL };
		GType terminal_output_type_id;
		terminal_output_type_id = g_type_register_static (GEE_TYPE_ARRAY_LIST, "TerminalOutput", &g_define_type_info, 0);
		g_once_init_leave (&terminal_output_type_id__volatile, terminal_output_type_id);
	}
	return terminal_output_type_id__volatile;
}


static void _vala_terminal_output_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TerminalOutput * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TERMINAL_OUTPUT, TerminalOutput);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TERMINAL_TITLE:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_string (value, terminal_output_get_terminal_title (self));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TERMINAL_MODES:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_flags (value, terminal_output_get_terminal_modes (self));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_SCREEN_OFFSET:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		g_value_set_int (value, terminal_output_get_screen_offset (self));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6784 "TerminalOutput.c"
		default:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6790 "TerminalOutput.c"
	}
}


static void _vala_terminal_output_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TerminalOutput * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TERMINAL_OUTPUT, TerminalOutput);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
	switch (property_id) {
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TERMINAL_TITLE:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_set_terminal_title (self, g_value_get_string (value));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_TERMINAL_MODES:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_set_terminal_modes (self, g_value_get_flags (value));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		case TERMINAL_OUTPUT_SCREEN_OFFSET:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		terminal_output_set_screen_offset (self, g_value_get_int (value));
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6818 "TerminalOutput.c"
		default:
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalOutput.vala"
		break;
#line 6824 "TerminalOutput.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



