/* TerminalStream.c generated by valac 0.20.1, the Vala compiler
 * generated from TerminalStream.vala, do not modify */

/*
 * Copyright © 2013–2014 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 *
 * This file is part of Final Term.
 *
 * Final Term is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Final Term is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Final Term.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Processes and stores raw terminal output, parsing control sequences
 */
/* TODO: Rename to "TerminalParser"*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define TYPE_TERMINAL_STREAM (terminal_stream_get_type ())
#define TERMINAL_STREAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TERMINAL_STREAM, TerminalStream))
#define TERMINAL_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TERMINAL_STREAM, TerminalStreamClass))
#define IS_TERMINAL_STREAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TERMINAL_STREAM))
#define IS_TERMINAL_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TERMINAL_STREAM))
#define TERMINAL_STREAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TERMINAL_STREAM, TerminalStreamClass))

typedef struct _TerminalStream TerminalStream;
typedef struct _TerminalStreamClass TerminalStreamClass;
typedef struct _TerminalStreamPrivate TerminalStreamPrivate;

#define TERMINAL_STREAM_TYPE_PARSE_STATE (terminal_stream_parse_state_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TERMINAL_STREAM_TYPE_STREAM_ELEMENT (terminal_stream_stream_element_get_type ())
#define TERMINAL_STREAM_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement))
#define TERMINAL_STREAM_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_IS_STREAM_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TERMINAL_STREAM_TYPE_STREAM_ELEMENT))
#define TERMINAL_STREAM_STREAM_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementClass))

typedef struct _TerminalStreamStreamElement TerminalStreamStreamElement;
typedef struct _TerminalStreamStreamElementClass TerminalStreamStreamElementClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TerminalStreamStreamElementPrivate TerminalStreamStreamElementPrivate;

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_STREAM_ELEMENT_TYPE (terminal_stream_stream_element_stream_element_type_get_type ())

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE (terminal_stream_stream_element_control_sequence_type_get_type ())

#define TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_SPECIFICATION (terminal_stream_stream_element_control_sequence_specification_get_type ())
typedef struct _TerminalStreamStreamElementControlSequenceSpecification TerminalStreamStreamElementControlSequenceSpecification;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _terminal_stream_stream_element_control_sequence_specification_free0(var) ((var == NULL) ? NULL : (var = (terminal_stream_stream_element_control_sequence_specification_free (var), NULL)))

struct _TerminalStream {
	GObject parent_instance;
	TerminalStreamPrivate * priv;
};

struct _TerminalStreamClass {
	GObjectClass parent_class;
};

typedef enum  {
	TERMINAL_STREAM_PARSE_STATE_TEXT,
	TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER,
	TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE,
	TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE,
	TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE,
	TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE
} TerminalStreamParseState;

struct _TerminalStreamPrivate {
	TerminalStreamParseState parse_state;
	GString* sequence_builder;
};

struct _TerminalStreamStreamElement {
	GObject parent_instance;
	TerminalStreamStreamElementPrivate * priv;
};

struct _TerminalStreamStreamElementClass {
	GObjectClass parent_class;
};

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT,
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE
} TerminalStreamStreamElementStreamElementType;

typedef enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS
} TerminalStreamStreamElementControlSequenceType;

struct _TerminalStreamStreamElementPrivate {
	TerminalStreamStreamElementStreamElementType _stream_element_type;
	gchar* _text;
	TerminalStreamStreamElementControlSequenceType _control_sequence_type;
	GeeList* _control_sequence_parameters;
};

struct _TerminalStreamStreamElementControlSequenceSpecification {
	TerminalStreamStreamElementControlSequenceType type;
	GRegex* pattern;
};


static gpointer terminal_stream_parent_class = NULL;
static gpointer terminal_stream_stream_element_parent_class = NULL;
static GeeMultiMap* terminal_stream_stream_element_control_sequence_specifications;
static GeeMultiMap* terminal_stream_stream_element_control_sequence_specifications = NULL;

GType terminal_stream_get_type (void) G_GNUC_CONST;
static GType terminal_stream_parse_state_get_type (void) G_GNUC_UNUSED;
#define TERMINAL_STREAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TERMINAL_STREAM, TerminalStreamPrivate))
enum  {
	TERMINAL_STREAM_DUMMY_PROPERTY
};
#define TERMINAL_STREAM_CONTROL_CHARACTERS "\x07\x08\x0D\x05\x0C\x0A\x0F\x0E\x09\x0B"
#define TERMINAL_STREAM_ESCAPE_SEQUENCE_START_CHARACTER "\x1B"
#define TERMINAL_STREAM_DCS_SEQUENCE_START_CHARACTER "\x90"
#define TERMINAL_STREAM_CSI_SEQUENCE_START_CHARACTER "\x9B"
#define TERMINAL_STREAM_OSC_SEQUENCE_START_CHARACTER "\x9D"
#define TERMINAL_STREAM_ESCAPE_SEQUENCE_DCS "P"
#define TERMINAL_STREAM_ESCAPE_SEQUENCE_CSI "["
#define TERMINAL_STREAM_ESCAPE_SEQUENCE_OSC "]"
#define TERMINAL_STREAM_ESCAPE_SEQUENCE_END_CHARACTERS "DEHMNOVWXZ\\^_FGLMN34568@G0AB4C5RQKYE6ZH7=6789=>Fclmno|}~"
#define TERMINAL_STREAM_DCS_SEQUENCE_END_CHARACTERS "\x9C"
#define TERMINAL_STREAM_CSI_SEQUENCE_END_CHARACTERS "@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
#define TERMINAL_STREAM_OSC_SEQUENCE_END_CHARACTERS "\x07\x9C"
void terminal_stream_parse_character (TerminalStream* self, gunichar character);
static void terminal_stream_emit_sequence (TerminalStream* self);
TerminalStreamStreamElement* terminal_stream_stream_element_new_from_text (const gchar* text);
TerminalStreamStreamElement* terminal_stream_stream_element_construct_from_text (GType object_type, const gchar* text);
GType terminal_stream_stream_element_get_type (void) G_GNUC_CONST;
TerminalStreamStreamElement* terminal_stream_stream_element_new_from_control_sequence (const gchar* control_sequence);
TerminalStreamStreamElement* terminal_stream_stream_element_construct_from_control_sequence (GType object_type, const gchar* control_sequence);
TerminalStream* terminal_stream_new (void);
TerminalStream* terminal_stream_construct (GType object_type);
GType terminal_stream_stream_element_stream_element_type_get_type (void) G_GNUC_CONST;
GType terminal_stream_stream_element_control_sequence_type_get_type (void) G_GNUC_CONST;
#define TERMINAL_STREAM_STREAM_ELEMENT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElementPrivate))
enum  {
	TERMINAL_STREAM_STREAM_ELEMENT_DUMMY_PROPERTY,
	TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE,
	TERMINAL_STREAM_STREAM_ELEMENT_TEXT,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE,
	TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_PARAMETERS
};
static GType terminal_stream_stream_element_control_sequence_specification_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static TerminalStreamStreamElementControlSequenceSpecification* terminal_stream_stream_element_control_sequence_specification_dup (const TerminalStreamStreamElementControlSequenceSpecification* self);
static void terminal_stream_stream_element_control_sequence_specification_free (TerminalStreamStreamElementControlSequenceSpecification* self);
static void terminal_stream_stream_element_control_sequence_specification_copy (const TerminalStreamStreamElementControlSequenceSpecification* self, TerminalStreamStreamElementControlSequenceSpecification* dest);
static void terminal_stream_stream_element_control_sequence_specification_destroy (TerminalStreamStreamElementControlSequenceSpecification* self);
#define TERMINAL_STREAM_STREAM_ELEMENT_ESC_PATTERN_START "\\x1B"
#define TERMINAL_STREAM_STREAM_ELEMENT_DCS_PATTERN_START "(?:(?:\\x1BP)|\\x90)"
#define TERMINAL_STREAM_STREAM_ELEMENT_DCS_PATTERN_END "\\x9C"
#define TERMINAL_STREAM_STREAM_ELEMENT_CSI_PATTERN_START "(?:(?:\\x1B\\[)|\\x9B)"
#define TERMINAL_STREAM_STREAM_ELEMENT_OSC_PATTERN_START "(?:(?:\\x1B\\])|\\x9D)"
#define TERMINAL_STREAM_STREAM_ELEMENT_OSC_PATTERN_END "(?:\\x07|\\x9C|(?:\\x1B\\\\))"
#define TERMINAL_STREAM_STREAM_ELEMENT_FINAL_TERM_PATTERN_DESIGNATOR "133;"
#define TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_PATTERN "(.*)"
#define TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_DELIMITER ";"
static void terminal_stream_stream_element_add_scf_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* character);
static void terminal_stream_stream_element_add_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* pattern, gunichar final_character);
static gunichar terminal_stream_stream_element_get_final_character (const gchar* text);
static void terminal_stream_stream_element_add_esc_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* final_characters);
static void terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_character);
static void terminal_stream_stream_element_add_dcs_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_characters);
static void terminal_stream_stream_element_add_csi_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* final_characters, const gchar* private_mode_characters);
static void terminal_stream_stream_element_add_osc_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_pattern);
static void terminal_stream_stream_element_add_final_term_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_characters);
void terminal_stream_stream_element_set_stream_element_type (TerminalStreamStreamElement* self, TerminalStreamStreamElementStreamElementType value);
void terminal_stream_stream_element_set_text (TerminalStreamStreamElement* self, const gchar* value);
void terminal_stream_stream_element_set_control_sequence_type (TerminalStreamStreamElement* self, TerminalStreamStreamElementControlSequenceType value);
void terminal_stream_stream_element_set_control_sequence_parameters (TerminalStreamStreamElement* self, GeeList* value);
static GeeList* terminal_stream_stream_element_parse_sequence_parameters (const gchar* parameter_string);
gint terminal_stream_stream_element_get_numeric_parameter (TerminalStreamStreamElement* self, gint index, gint default_value);
GeeList* terminal_stream_stream_element_get_control_sequence_parameters (TerminalStreamStreamElement* self);
gchar* terminal_stream_stream_element_get_text_parameter (TerminalStreamStreamElement* self, gint index, const gchar* default_value);
TerminalStreamStreamElement* terminal_stream_stream_element_new (void);
TerminalStreamStreamElement* terminal_stream_stream_element_construct (GType object_type);
TerminalStreamStreamElementStreamElementType terminal_stream_stream_element_get_stream_element_type (TerminalStreamStreamElement* self);
const gchar* terminal_stream_stream_element_get_text (TerminalStreamStreamElement* self);
TerminalStreamStreamElementControlSequenceType terminal_stream_stream_element_get_control_sequence_type (TerminalStreamStreamElement* self);
static void terminal_stream_stream_element_finalize (GObject* obj);
static void _vala_terminal_stream_stream_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_terminal_stream_stream_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void terminal_stream_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const gchar* TERMINAL_STREAM_STREAM_ELEMENT_OSC_FINAL_CHARACTERS[3] = {"\x07", "\x9C", "\\"};
static const gchar* TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS[16] = {"0", "A", "B", "4", "C", "5", "R", "Q", "K", "Y", "E", "6", "Z", "H", "7", "="};

static GType terminal_stream_parse_state_get_type (void) {
	static volatile gsize terminal_stream_parse_state_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_parse_state_type_id__volatile)) {
		static const GEnumValue values[] = {{TERMINAL_STREAM_PARSE_STATE_TEXT, "TERMINAL_STREAM_PARSE_STATE_TEXT", "text"}, {TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER, "TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER", "control-character"}, {TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE, "TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE", "escape-sequence"}, {TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE, "TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE", "dcs-sequence"}, {TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE, "TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE", "csi-sequence"}, {TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE, "TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE", "osc-sequence"}, {0, NULL, NULL}};
		GType terminal_stream_parse_state_type_id;
		terminal_stream_parse_state_type_id = g_enum_register_static ("TerminalStreamParseState", values);
		g_once_init_leave (&terminal_stream_parse_state_type_id__volatile, terminal_stream_parse_state_type_id);
	}
	return terminal_stream_parse_state_type_id__volatile;
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1238 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1238 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1239 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1239 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1239 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1239 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 380 "TerminalStream.c"
}


static gchar* g_unichar_to_string (gunichar self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* str;
	const gchar* _tmp1_;
#line 855 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 855 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 856 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = str;
#line 856 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_unichar_to_utf8 (self, _tmp1_);
#line 857 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = str;
#line 857 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 401 "TerminalStream.c"
}


void terminal_stream_parse_character (TerminalStream* self, gunichar character) {
	TerminalStreamParseState _tmp0_;
	TerminalStreamParseState old_parse_state;
	TerminalStreamParseState _tmp1_;
	GString* _tmp21_;
	gunichar _tmp22_;
	TerminalStreamParseState _tmp23_;
	TerminalStreamParseState _tmp24_;
	TerminalStreamParseState _tmp25_;
#line 67 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->parse_state;
#line 68 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	old_parse_state = _tmp0_;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = self->priv->parse_state;
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	switch (_tmp1_) {
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_TEXT:
#line 426 "TerminalStream.c"
		{
			gunichar _tmp2_;
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
			gunichar _tmp9_;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			GQuark _tmp13_ = 0U;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp2_ = character;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp3_ = g_unichar_to_string (_tmp2_);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp4_ = _tmp3_;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp5_ = string_contains (TERMINAL_STREAM_CONTROL_CHARACTERS, _tmp4_);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp6_ = _tmp5_;
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_free0 (_tmp4_);
#line 73 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp6_) {
#line 451 "TerminalStream.c"
				GString* _tmp7_;
				gunichar _tmp8_;
#line 76 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 78 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp7_ = self->priv->sequence_builder;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp8_ = character;
#line 79 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				g_string_append_unichar (_tmp7_, _tmp8_);
#line 80 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 81 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 82 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				return;
#line 470 "TerminalStream.c"
			}
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp9_ = character;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp10_ = g_unichar_to_string (_tmp9_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp11_ = _tmp10_;
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp13_ = (NULL == _tmp11_) ? 0 : g_quark_from_string (_tmp11_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			g_free (_tmp11_);
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp13_ == g_quark_from_string (TERMINAL_STREAM_ESCAPE_SEQUENCE_START_CHARACTER)) {
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				switch (0) {
#line 486 "TerminalStream.c"
					default:
					{
#line 86 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						terminal_stream_emit_sequence (self);
#line 87 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE;
#line 88 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						break;
#line 495 "TerminalStream.c"
					}
				}
			} else if (_tmp13_ == g_quark_from_string (TERMINAL_STREAM_DCS_SEQUENCE_START_CHARACTER)) {
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				switch (0) {
#line 501 "TerminalStream.c"
					default:
					{
#line 90 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						terminal_stream_emit_sequence (self);
#line 91 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE;
#line 92 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						break;
#line 510 "TerminalStream.c"
					}
				}
			} else if (_tmp13_ == g_quark_from_string (TERMINAL_STREAM_CSI_SEQUENCE_START_CHARACTER)) {
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				switch (0) {
#line 516 "TerminalStream.c"
					default:
					{
#line 94 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						terminal_stream_emit_sequence (self);
#line 95 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE;
#line 96 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						break;
#line 525 "TerminalStream.c"
					}
				}
			} else if (_tmp13_ == g_quark_from_string (TERMINAL_STREAM_OSC_SEQUENCE_START_CHARACTER)) {
#line 84 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				switch (0) {
#line 531 "TerminalStream.c"
					default:
					{
#line 98 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						terminal_stream_emit_sequence (self);
#line 99 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE;
#line 100 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
						break;
#line 540 "TerminalStream.c"
					}
				}
			}
#line 102 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 546 "TerminalStream.c"
		}
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER:
#line 550 "TerminalStream.c"
		{
#line 104 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 554 "TerminalStream.c"
		}
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE:
#line 558 "TerminalStream.c"
		{
			GString* _tmp14_;
			gssize _tmp15_;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp14_ = self->priv->sequence_builder;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp15_ = _tmp14_->len;
#line 106 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp15_ == ((gssize) 1)) {
#line 568 "TerminalStream.c"
				gunichar _tmp16_;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
				GQuark _tmp20_ = 0U;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp16_ = character;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp17_ = g_unichar_to_string (_tmp16_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp18_ = _tmp17_;
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp20_ = (NULL == _tmp18_) ? 0 : g_quark_from_string (_tmp18_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				g_free (_tmp18_);
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				if (_tmp20_ == g_quark_from_string (TERMINAL_STREAM_ESCAPE_SEQUENCE_DCS)) {
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					switch (0) {
#line 587 "TerminalStream.c"
						default:
						{
#line 111 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE;
#line 112 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							break;
#line 594 "TerminalStream.c"
						}
					}
				} else if (_tmp20_ == g_quark_from_string (TERMINAL_STREAM_ESCAPE_SEQUENCE_CSI)) {
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					switch (0) {
#line 600 "TerminalStream.c"
						default:
						{
#line 114 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE;
#line 115 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							break;
#line 607 "TerminalStream.c"
						}
					}
				} else if (_tmp20_ == g_quark_from_string (TERMINAL_STREAM_ESCAPE_SEQUENCE_OSC)) {
#line 108 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					switch (0) {
#line 613 "TerminalStream.c"
						default:
						{
#line 117 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE;
#line 118 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
							break;
#line 620 "TerminalStream.c"
						}
					}
				}
			}
#line 121 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 627 "TerminalStream.c"
		}
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE:
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE:
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE:
#line 635 "TerminalStream.c"
		{
#line 125 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 639 "TerminalStream.c"
		}
		default:
#line 71 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 644 "TerminalStream.c"
	}
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp21_ = self->priv->sequence_builder;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp22_ = character;
#line 128 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_append_unichar (_tmp21_, _tmp22_);
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp23_ = self->priv->parse_state;
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp24_ = old_parse_state;
#line 130 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (_tmp23_ != _tmp24_) {
#line 132 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return;
#line 660 "TerminalStream.c"
	}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp25_ = self->priv->parse_state;
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	switch (_tmp25_) {
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_TEXT:
#line 668 "TerminalStream.c"
		{
			GString* _tmp26_;
			const gchar* _tmp27_;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp26_ = self->priv->sequence_builder;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp27_ = _tmp26_->str;
#line 136 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			g_signal_emit_by_name (self, "transient-text-updated", _tmp27_);
#line 137 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 680 "TerminalStream.c"
		}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER:
#line 684 "TerminalStream.c"
		{
#line 139 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 688 "TerminalStream.c"
		}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE:
#line 692 "TerminalStream.c"
		{
			gunichar _tmp28_;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp28_ = character;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp29_ = g_unichar_to_string (_tmp28_);
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp30_ = _tmp29_;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp31_ = string_contains (TERMINAL_STREAM_ESCAPE_SEQUENCE_END_CHARACTERS, _tmp30_);
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp32_ = _tmp31_;
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_free0 (_tmp30_);
#line 142 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp32_) {
#line 143 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 144 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 717 "TerminalStream.c"
			}
#line 146 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 721 "TerminalStream.c"
		}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE:
#line 725 "TerminalStream.c"
		{
			gunichar _tmp33_;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_;
			gboolean _tmp36_ = FALSE;
			gboolean _tmp37_;
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp33_ = character;
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp34_ = g_unichar_to_string (_tmp33_);
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp35_ = _tmp34_;
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp36_ = string_contains (TERMINAL_STREAM_DCS_SEQUENCE_END_CHARACTERS, _tmp35_);
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp37_ = _tmp36_;
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_free0 (_tmp35_);
#line 148 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp37_) {
#line 149 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 150 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 750 "TerminalStream.c"
			}
#line 152 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 754 "TerminalStream.c"
		}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE:
#line 758 "TerminalStream.c"
		{
			gunichar _tmp38_;
			gchar* _tmp39_ = NULL;
			gchar* _tmp40_;
			gboolean _tmp41_ = FALSE;
			gboolean _tmp42_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp38_ = character;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp39_ = g_unichar_to_string (_tmp38_);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp40_ = _tmp39_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp41_ = string_contains (TERMINAL_STREAM_CSI_SEQUENCE_END_CHARACTERS, _tmp40_);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp42_ = _tmp41_;
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_free0 (_tmp40_);
#line 154 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp42_) {
#line 155 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 156 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 783 "TerminalStream.c"
			}
#line 158 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 787 "TerminalStream.c"
		}
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE:
#line 791 "TerminalStream.c"
		{
			gboolean _tmp43_ = FALSE;
			gunichar _tmp44_;
			gchar* _tmp45_ = NULL;
			gchar* _tmp46_;
			gboolean _tmp47_ = FALSE;
			gboolean _tmp48_;
			gboolean _tmp52_;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp44_ = character;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp45_ = g_unichar_to_string (_tmp44_);
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp46_ = _tmp45_;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp47_ = string_contains (TERMINAL_STREAM_OSC_SEQUENCE_END_CHARACTERS, _tmp46_);
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp48_ = _tmp47_;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_free0 (_tmp46_);
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp48_) {
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp43_ = TRUE;
#line 816 "TerminalStream.c"
			} else {
				GString* _tmp49_;
				const gchar* _tmp50_;
				gboolean _tmp51_ = FALSE;
#line 162 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp49_ = self->priv->sequence_builder;
#line 162 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp50_ = _tmp49_->str;
#line 162 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp51_ = g_str_has_suffix (_tmp50_, "\x1B\\");
#line 162 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp43_ = _tmp51_;
#line 829 "TerminalStream.c"
			}
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp52_ = _tmp43_;
#line 160 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp52_) {
#line 163 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_emit_sequence (self);
#line 164 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 839 "TerminalStream.c"
			}
#line 166 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 843 "TerminalStream.c"
		}
		default:
#line 134 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 848 "TerminalStream.c"
	}
}


static void terminal_stream_emit_sequence (TerminalStream* self) {
	GString* _tmp0_;
	gssize _tmp1_;
	TerminalStreamParseState _tmp2_;
	GString* _tmp11_;
#line 170 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 171 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->sequence_builder;
#line 171 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = _tmp0_->len;
#line 171 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (_tmp1_ == ((gssize) 0)) {
#line 172 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return;
#line 868 "TerminalStream.c"
	}
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = self->priv->parse_state;
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	switch (_tmp2_) {
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_TEXT:
#line 876 "TerminalStream.c"
		{
			GString* _tmp3_;
			const gchar* _tmp4_;
			TerminalStreamStreamElement* _tmp5_;
			TerminalStreamStreamElement* _tmp6_;
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp3_ = self->priv->sequence_builder;
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp4_ = _tmp3_->str;
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp5_ = terminal_stream_stream_element_new_from_text (_tmp4_);
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp6_ = _tmp5_;
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			g_signal_emit_by_name (self, "element-completed", _tmp6_);
#line 176 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_object_unref0 (_tmp6_);
#line 177 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 896 "TerminalStream.c"
		}
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CONTROL_CHARACTER:
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_ESCAPE_SEQUENCE:
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_DCS_SEQUENCE:
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_CSI_SEQUENCE:
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_PARSE_STATE_OSC_SEQUENCE:
#line 908 "TerminalStream.c"
		{
			GString* _tmp7_;
			const gchar* _tmp8_;
			TerminalStreamStreamElement* _tmp9_;
			TerminalStreamStreamElement* _tmp10_;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp7_ = self->priv->sequence_builder;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp8_ = _tmp7_->str;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp9_ = terminal_stream_stream_element_new_from_control_sequence (_tmp8_);
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp10_ = _tmp9_;
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			g_signal_emit_by_name (self, "element-completed", _tmp10_);
#line 183 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_object_unref0 (_tmp10_);
#line 184 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			break;
#line 928 "TerminalStream.c"
		}
		default:
#line 174 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 933 "TerminalStream.c"
	}
#line 187 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp11_ = self->priv->sequence_builder;
#line 187 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_erase (_tmp11_, (gssize) 0, (gssize) (-1));
#line 939 "TerminalStream.c"
}


TerminalStream* terminal_stream_construct (GType object_type) {
	TerminalStream * self = NULL;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = (TerminalStream*) g_object_new (object_type, NULL);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self;
#line 949 "TerminalStream.c"
}


TerminalStream* terminal_stream_new (void) {
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return terminal_stream_construct (TYPE_TERMINAL_STREAM);
#line 956 "TerminalStream.c"
}


GType terminal_stream_stream_element_stream_element_type_get_type (void) {
	static volatile gsize terminal_stream_stream_element_stream_element_type_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_stream_element_stream_element_type_type_id__volatile)) {
		static const GEnumValue values[] = {{TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT, "TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT", "text"}, {TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE, "TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE", "control-sequence"}, {0, NULL, NULL}};
		GType terminal_stream_stream_element_stream_element_type_type_id;
		terminal_stream_stream_element_stream_element_type_type_id = g_enum_register_static ("TerminalStreamStreamElementStreamElementType", values);
		g_once_init_leave (&terminal_stream_stream_element_stream_element_type_type_id__volatile, terminal_stream_stream_element_stream_element_type_type_id);
	}
	return terminal_stream_stream_element_stream_element_type_type_id__volatile;
}


GType terminal_stream_stream_element_control_sequence_type_get_type (void) {
	static volatile gsize terminal_stream_stream_element_control_sequence_type_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_stream_element_control_sequence_type_type_id__volatile)) {
		static const GEnumValue values[] = {{TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN", "unknown"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL", "bell"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE", "backspace"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN", "carriage-return"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS", "return-terminal-status"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED", "form-feed"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED", "line-feed"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN", "shift-in"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT", "shift-out"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB", "horizontal-tab"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB", "vertical-tab"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS", "seven-bit-controls"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS", "eight-bit-controls"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1", "set-ansi-conformance-level-1"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2", "set-ansi-conformance-level-2"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3", "set-ansi-conformance-level-3"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF", "dec-double-height-line-top-half"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF", "dec-double-height-line-bottom-half"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE", "dec-single-width-line"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE", "dec-double-width-line"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST", "dec-screen-alignment-test"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET", "select-default-character-set"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET", "select-utf8-character-set"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100", "designate-g0-character-set-vt100"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100", "designate-g1-character-set-vt100"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220", "designate-g2-character-set-vt220"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220", "designate-g3-character-set-vt220"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300", "designate-g1-character-set-vt300"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300", "designate-g2-character-set-vt300"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300", "designate-g3-character-set-vt300"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX", "back-index"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR", "save-cursor"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR", "restore-cursor"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX", "forward-index"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD", "application-keypad"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD", "normal-keypad"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN", "cursor-to-lower-left-corner-of-screen"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET", "full-reset"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK", "memory-lock"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK", "memory-unlock"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL", "invoke-g2-character-set-as-gl"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL", "invoke-g3-character-set-as-gl"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR", "invoke-g3-character-set-as-gr"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR", "invoke-g2-character-set-as-gr"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR", "invoke-g1-character-set-as-gr"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS", "user-defined-keys"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING", "request-status-string"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA", "set-termcap-data"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING", "request-termcap-string"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS", "insert-characters"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP", "cursor-up"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN", "cursor-down"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD", "cursor-forward"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD", "cursor-backward"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE", "cursor-next-line"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE", "cursor-preceding-line"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE", "cursor-character-absolute"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION", "cursor-position"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION", "cursor-forward-tabulation"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED", "erase-in-display-ed"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED", "erase-in-display-decsed"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL", "erase-in-line-el"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL", "erase-in-line-decsel"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES", "insert-lines"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES", "delete-lines"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS", "delete-characters"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES", "scroll-up-lines"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES", "scroll-down-lines"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING", "initiate-highlight-mouse-tracking"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES", "reset-title-modes-features"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS", "erase-characters"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION", "cursor-backward-tabulation"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE", "character-position-absolute"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE", "character-position-relative"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER", "repeat-preceding-graphic-character"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY", "send-device-attributes-primary"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY", "send-device-attributes-secondary"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE", "line-position-absolute"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE", "line-position-relative"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION", "horizontal-and-vertical-position"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR", "tab-clear"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE", "set-mode"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET", "dec-private-mode-set"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY", "media-copy"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC", "media-copy-dec"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE", "reset-mode"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET", "dec-private-mode-reset"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES", "character-attributes"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES", "set-or-reset-resource-values"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT", "device-status-report"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS", "disable-modifiers"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC", "device-status-report-dec"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE", "set-resource-value-pointer-mode"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET", "soft-terminal-reset"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE", "request-ansi-mode"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE", "request-dec-private-mode"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL", "set-conformance-level"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS", "load-leds"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE", "set-cursor-style"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE", "select-character-protection-attribute"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION", "set-scrolling-region"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES", "restore-dec-private-mode-values"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA", "change-attributes-in-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS", "set-left-and-right-margins"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS", "save-cursor-ansi-sys"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES", "save-dec-private-mode-values"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION", "window-manipulation"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA", "reverse-attributes-in-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES", "set-title-modes-features"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME", "set-warning-bell-volume"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS", "restore-cursor-ansi-sys"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME", "set-margin-bell-volume"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA", "copy-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE", "enable-filter-rectangle"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS", "request-terminal-parameters"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT", "select-attribute-change-extent"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA", "request-checksum-of-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA", "fill-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING", "enable-locator-reporting"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA", "erase-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS", "select-locator-events"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA", "selective-erase-rectangular-area"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION", "request-locator-position"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS", "insert-columns"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS", "delete-columns"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS", "set-text-parameters"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT", "ftcs-prompt"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START", "ftcs-command-start"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED", "ftcs-command-executed"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED", "ftcs-command-finished"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START", "ftcs-text-menu-start"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END", "ftcs-text-menu-end"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS", "ftcs-progress"}, {TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS, "TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS", "ftcs-execute-commands"}, {0, NULL, NULL}};
		GType terminal_stream_stream_element_control_sequence_type_type_id;
		terminal_stream_stream_element_control_sequence_type_type_id = g_enum_register_static ("TerminalStreamStreamElementControlSequenceType", values);
		g_once_init_leave (&terminal_stream_stream_element_control_sequence_type_type_id__volatile, terminal_stream_stream_element_control_sequence_type_type_id);
	}
	return terminal_stream_stream_element_control_sequence_type_type_id__volatile;
}


static void terminal_stream_stream_element_add_scf_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* character) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gunichar _tmp5_ = 0U;
#line 555 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (character != NULL);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence_type;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = character;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = g_regex_escape_string (_tmp1_, -1);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = _tmp2_;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = character;
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = terminal_stream_stream_element_get_final_character (_tmp4_);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_sequence_pattern (_tmp0_, _tmp3_, _tmp5_);
#line 556 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp3_);
#line 1009 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_esc_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* final_characters) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gunichar _tmp7_ = 0U;
#line 562 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (final_characters != NULL);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence_type;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = final_characters;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = g_regex_escape_string (_tmp1_, -1);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = _tmp2_;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = g_strconcat (TERMINAL_STREAM_STREAM_ELEMENT_ESC_PATTERN_START, _tmp3_, NULL);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = _tmp4_;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = final_characters;
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = terminal_stream_stream_element_get_final_character (_tmp6_);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_sequence_pattern (_tmp0_, _tmp5_, _tmp7_);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp5_);
#line 563 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp3_);
#line 1046 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_character) {
	GString* _tmp0_;
	GString* pattern_builder;
	GString* _tmp1_;
	GString* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GString* _tmp6_;
	GString* _tmp11_;
#line 571 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (intermediate_character != NULL);
#line 573 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = g_string_new ("");
#line 573 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	pattern_builder = _tmp0_;
#line 574 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = pattern_builder;
#line 574 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_append (_tmp1_, TERMINAL_STREAM_STREAM_ELEMENT_ESC_PATTERN_START);
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = pattern_builder;
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = intermediate_character;
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = g_regex_escape_string (_tmp3_, -1);
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = _tmp4_;
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_append (_tmp2_, _tmp5_);
#line 575 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp5_);
#line 576 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = pattern_builder;
#line 576 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_append (_tmp6_, "([");
#line 1086 "TerminalStream.c"
	{
		const gchar** final_character_collection = NULL;
		gint final_character_collection_length1 = 0;
		gint _final_character_collection_size_ = 0;
		gint final_character_it = 0;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection = TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection_length1 = G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS);
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		for (final_character_it = 0; final_character_it < G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS); final_character_it = final_character_it + 1) {
#line 1098 "TerminalStream.c"
			const gchar* final_character = NULL;
#line 577 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			final_character = final_character_collection[final_character_it];
#line 1102 "TerminalStream.c"
			{
				GString* _tmp7_;
				const gchar* _tmp8_;
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp7_ = pattern_builder;
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp8_ = final_character;
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp9_ = g_regex_escape_string (_tmp8_, -1);
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp10_ = _tmp9_;
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				g_string_append (_tmp7_, _tmp10_);
#line 578 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_free0 (_tmp10_);
#line 1120 "TerminalStream.c"
			}
		}
	}
#line 580 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp11_ = pattern_builder;
#line 580 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_string_append (_tmp11_, "])");
#line 1128 "TerminalStream.c"
	{
		const gchar** final_character_collection = NULL;
		gint final_character_collection_length1 = 0;
		gint _final_character_collection_size_ = 0;
		gint final_character_it = 0;
#line 582 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection = TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS;
#line 582 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection_length1 = G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS);
#line 582 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		for (final_character_it = 0; final_character_it < G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_CHARACTER_SET_DESIGNATOR_FINAL_CHARACTERS); final_character_it = final_character_it + 1) {
#line 1140 "TerminalStream.c"
			const gchar* final_character = NULL;
#line 582 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			final_character = final_character_collection[final_character_it];
#line 1144 "TerminalStream.c"
			{
				TerminalStreamStreamElementControlSequenceType _tmp12_;
				GString* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gunichar _tmp16_ = 0U;
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp12_ = control_sequence_type;
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp13_ = pattern_builder;
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp14_ = _tmp13_->str;
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp15_ = final_character;
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp16_ = terminal_stream_stream_element_get_final_character (_tmp15_);
#line 583 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_stream_element_add_sequence_pattern (_tmp12_, _tmp14_, _tmp16_);
#line 1163 "TerminalStream.c"
			}
		}
	}
#line 571 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_string_free0 (pattern_builder);
#line 1169 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_dcs_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_characters) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gunichar _tmp10_ = 0U;
#line 590 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (intermediate_characters != NULL);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence_type;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = intermediate_characters;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = g_regex_escape_string (_tmp1_, -1);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = _tmp2_;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = g_strconcat (TERMINAL_STREAM_STREAM_ELEMENT_DCS_PATTERN_START, _tmp3_, NULL);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = _tmp4_;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = g_strconcat (_tmp5_, TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_PATTERN, NULL);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = _tmp6_;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_ = g_strconcat (_tmp7_, TERMINAL_STREAM_STREAM_ELEMENT_DCS_PATTERN_END, NULL);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp9_ = _tmp8_;
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp10_ = terminal_stream_stream_element_get_final_character ("\x9C");
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_sequence_pattern (_tmp0_, _tmp9_, _tmp10_);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp9_);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp7_);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp5_);
#line 592 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp3_);
#line 1219 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_csi_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* final_characters, const gchar* private_mode_characters) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gunichar _tmp14_ = 0U;
#line 603 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (final_characters != NULL);
#line 603 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (private_mode_characters != NULL);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence_type;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = private_mode_characters;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = g_regex_escape_string (_tmp1_, -1);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = _tmp2_;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = g_strconcat (TERMINAL_STREAM_STREAM_ELEMENT_CSI_PATTERN_START, _tmp3_, NULL);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = _tmp4_;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = g_strconcat (_tmp5_, TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_PATTERN, NULL);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = _tmp6_;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_ = final_characters;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp9_ = g_regex_escape_string (_tmp8_, -1);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp10_ = _tmp9_;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp12_ = _tmp11_;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp13_ = final_characters;
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp14_ = terminal_stream_stream_element_get_final_character (_tmp13_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_sequence_pattern (_tmp0_, _tmp12_, _tmp14_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp12_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp10_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp7_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp5_);
#line 606 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp3_);
#line 1285 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_osc_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_pattern) {
#line 617 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (intermediate_pattern != NULL);
#line 1292 "TerminalStream.c"
	{
		const gchar** final_character_collection = NULL;
		gint final_character_collection_length1 = 0;
		gint _final_character_collection_size_ = 0;
		gint final_character_it = 0;
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection = TERMINAL_STREAM_STREAM_ELEMENT_OSC_FINAL_CHARACTERS;
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		final_character_collection_length1 = G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_OSC_FINAL_CHARACTERS);
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		for (final_character_it = 0; final_character_it < G_N_ELEMENTS (TERMINAL_STREAM_STREAM_ELEMENT_OSC_FINAL_CHARACTERS); final_character_it = final_character_it + 1) {
#line 1304 "TerminalStream.c"
			const gchar* final_character = NULL;
#line 619 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			final_character = final_character_collection[final_character_it];
#line 1308 "TerminalStream.c"
			{
				TerminalStreamStreamElementControlSequenceType _tmp0_;
				const gchar* _tmp1_;
				gchar* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				gunichar _tmp7_ = 0U;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp0_ = control_sequence_type;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp1_ = intermediate_pattern;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp2_ = g_strconcat (TERMINAL_STREAM_STREAM_ELEMENT_OSC_PATTERN_START, _tmp1_, NULL);
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp3_ = _tmp2_;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp4_ = g_strconcat (_tmp3_, TERMINAL_STREAM_STREAM_ELEMENT_OSC_PATTERN_END, NULL);
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp5_ = _tmp4_;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp6_ = final_character;
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp7_ = terminal_stream_stream_element_get_final_character (_tmp6_);
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_stream_element_add_sequence_pattern (_tmp0_, _tmp5_, _tmp7_);
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_free0 (_tmp5_);
#line 620 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_free0 (_tmp3_);
#line 1340 "TerminalStream.c"
			}
		}
	}
}


static void terminal_stream_stream_element_add_final_term_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* intermediate_characters) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
#line 627 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (intermediate_characters != NULL);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence_type;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = g_regex_escape_string (TERMINAL_STREAM_STREAM_ELEMENT_FINAL_TERM_PATTERN_DESIGNATOR, -1);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _tmp1_;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = intermediate_characters;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = g_regex_escape_string (_tmp3_, -1);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = _tmp4_;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = _tmp6_;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_ = g_strconcat (_tmp7_, ";", NULL);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp9_ = _tmp8_;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp10_ = g_strconcat (_tmp9_, TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_PATTERN, NULL);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp11_ = _tmp10_;
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_osc_sequence_pattern (_tmp0_, _tmp11_);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp11_);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp9_);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp7_);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp5_);
#line 637 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp2_);
#line 1398 "TerminalStream.c"
}


static gpointer _g_regex_ref0 (gpointer self) {
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self ? g_regex_ref (self) : NULL;
#line 1405 "TerminalStream.c"
}


static void terminal_stream_stream_element_add_sequence_pattern (TerminalStreamStreamElementControlSequenceType control_sequence_type, const gchar* pattern, gunichar final_character) {
	GRegex* patternRegex = NULL;
	GeeMultiMap* _tmp4_;
	gunichar _tmp5_;
	TerminalStreamStreamElementControlSequenceType _tmp6_;
	GRegex* _tmp7_;
	TerminalStreamStreamElementControlSequenceSpecification _tmp8_ = {0};
	TerminalStreamStreamElementControlSequenceSpecification _tmp9_;
	TerminalStreamStreamElementControlSequenceSpecification _tmp10_;
	GError * _inner_error_ = NULL;
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (pattern != NULL);
#line 1421 "TerminalStream.c"
	{
		const gchar* _tmp0_;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp0_ = pattern;
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp1_ = g_regex_new (_tmp0_, G_REGEX_OPTIMIZE, 0, &_inner_error_);
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp2_ = _tmp1_;
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		if (_inner_error_ != NULL) {
#line 1434 "TerminalStream.c"
			goto __catch6_g_error;
		}
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_regex_unref0 (patternRegex);
#line 649 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		patternRegex = _tmp2_;
#line 1441 "TerminalStream.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp3_;
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		e = _inner_error_;
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_inner_error_ = NULL;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp3_ = e->message;
#line 650 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_error ("TerminalStream.vala:650: %s", _tmp3_);
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_error_free0 (e);
#line 1458 "TerminalStream.c"
	}
	__finally6:
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (_inner_error_ != NULL) {
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_regex_unref0 (patternRegex);
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_clear_error (&_inner_error_);
#line 648 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return;
#line 1471 "TerminalStream.c"
	}
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = terminal_stream_stream_element_control_sequence_specifications;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = final_character;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = control_sequence_type;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = _g_regex_ref0 (patternRegex);
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	memset (&_tmp8_, 0, sizeof (TerminalStreamStreamElementControlSequenceSpecification));
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_.type = _tmp6_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_regex_unref0 (_tmp8_.pattern);
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_.pattern = _tmp7_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp9_ = _tmp8_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp10_ = _tmp9_;
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	gee_multi_map_set (_tmp4_, (gpointer) ((gintptr) _tmp5_), &_tmp10_);
#line 652 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_control_sequence_specification_destroy (&_tmp9_);
#line 644 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_regex_unref0 (patternRegex);
#line 1499 "TerminalStream.c"
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_;
	gunichar _tmp1_ = 0U;
#line 995 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 996 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 1517 "TerminalStream.c"
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1016 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp0_ = c;
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	result = (gint) (_tmp1_ - ((gchar*) self));
#line 1017 "/usr/share/vala-0.20/vapi/glib-2.0.vapi"
	return result;
#line 1535 "TerminalStream.c"
}


static gunichar terminal_stream_stream_element_get_final_character (const gchar* text) {
	gunichar result = 0U;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gunichar _tmp5_ = 0U;
#line 657 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (text != NULL, 0U);
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = text;
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = text;
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = text;
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = g_utf8_strlen (_tmp2_, (gssize) (-1));
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = string_index_of_nth_char (_tmp1_, (glong) (_tmp3_ - 1));
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = string_get_char (_tmp0_, (glong) _tmp4_);
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = _tmp5_;
#line 660 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 1565 "TerminalStream.c"
}


TerminalStreamStreamElement* terminal_stream_stream_element_construct_from_text (GType object_type, const gchar* text) {
	TerminalStreamStreamElement * self = NULL;
	const gchar* _tmp0_;
#line 663 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 663 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = (TerminalStreamStreamElement*) g_object_new (object_type, NULL);
#line 664 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_stream_element_type (self, TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_TEXT);
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = text;
#line 665 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_text (self, _tmp0_);
#line 663 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self;
#line 1584 "TerminalStream.c"
}


TerminalStreamStreamElement* terminal_stream_stream_element_new_from_text (const gchar* text) {
#line 663 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return terminal_stream_stream_element_construct_from_text (TERMINAL_STREAM_TYPE_STREAM_ELEMENT, text);
#line 1591 "TerminalStream.c"
}


TerminalStreamStreamElement* terminal_stream_stream_element_construct_from_control_sequence (GType object_type, const gchar* control_sequence) {
	TerminalStreamStreamElement * self = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	gunichar _tmp4_ = 0U;
	gunichar final_character;
	GeeMultiMap* _tmp5_;
	gunichar _tmp6_;
	gboolean _tmp7_ = FALSE;
	GMatchInfo* match_info = NULL;
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (control_sequence != NULL, NULL);
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = (TerminalStreamStreamElement*) g_object_new (object_type, NULL);
#line 669 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_stream_element_type (self, TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE);
#line 670 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = control_sequence;
#line 670 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_text (self, _tmp0_);
#line 672 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_control_sequence_type (self, TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_UNKNOWN);
#line 673 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 673 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _tmp1_;
#line 673 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_set_control_sequence_parameters (self, (GeeList*) _tmp2_);
#line 673 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_object_unref0 (_tmp2_);
#line 675 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = control_sequence;
#line 675 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = terminal_stream_stream_element_get_final_character (_tmp3_);
#line 675 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	final_character = _tmp4_;
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = terminal_stream_stream_element_control_sequence_specifications;
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = final_character;
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = gee_multi_map_contains (_tmp5_, (gpointer) ((gintptr) _tmp6_));
#line 677 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (!_tmp7_) {
#line 678 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return self;
#line 1643 "TerminalStream.c"
	}
	{
		GeeMultiMap* _tmp8_;
		gunichar _tmp9_;
		GeeCollection* _tmp10_ = NULL;
		GeeCollection* _tmp11_;
		GeeIterator* _tmp12_ = NULL;
		GeeIterator* _tmp13_;
		GeeIterator* _specification_it;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp8_ = terminal_stream_stream_element_control_sequence_specifications;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp9_ = final_character;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp10_ = gee_multi_map_get (_tmp8_, (gpointer) ((gintptr) _tmp9_));
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp11_ = _tmp10_;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp13_ = _tmp12_;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_object_unref0 (_tmp11_);
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_specification_it = _tmp13_;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		while (TRUE) {
#line 1671 "TerminalStream.c"
			GeeIterator* _tmp14_;
			gboolean _tmp15_ = FALSE;
			GeeIterator* _tmp16_;
			gpointer _tmp17_ = NULL;
			TerminalStreamStreamElementControlSequenceSpecification* specification;
			TerminalStreamStreamElementControlSequenceSpecification* _tmp18_;
			GRegex* _tmp19_;
			const gchar* _tmp20_;
			GMatchInfo* _tmp21_ = NULL;
			gboolean _tmp22_ = FALSE;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp14_ = _specification_it;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp15_ = gee_iterator_next (_tmp14_);
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (!_tmp15_) {
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				break;
#line 1690 "TerminalStream.c"
			}
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp16_ = _specification_it;
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp17_ = gee_iterator_get (_tmp16_);
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			specification = (TerminalStreamStreamElementControlSequenceSpecification*) _tmp17_;
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp18_ = specification;
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp19_ = (*_tmp18_).pattern;
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp20_ = control_sequence;
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp22_ = g_regex_match (_tmp19_, _tmp20_, G_REGEX_MATCH_ANCHORED, &_tmp21_);
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_g_match_info_free0 (match_info);
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			match_info = _tmp21_;
#line 686 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			if (_tmp22_) {
#line 1712 "TerminalStream.c"
				TerminalStreamStreamElementControlSequenceSpecification* _tmp23_;
				TerminalStreamStreamElementControlSequenceType _tmp24_;
				GMatchInfo* _tmp25_;
				gchar* _tmp26_ = NULL;
				gchar* parameter_string;
				gboolean _tmp27_ = FALSE;
				const gchar* _tmp28_;
				gboolean _tmp30_;
				const gchar* _tmp31_;
				GeeList* _tmp32_ = NULL;
				GeeList* _tmp33_;
#line 687 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp23_ = specification;
#line 687 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp24_ = (*_tmp23_).type;
#line 687 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_stream_element_set_control_sequence_type (self, _tmp24_);
#line 694 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp25_ = match_info;
#line 694 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp26_ = g_match_info_fetch (_tmp25_, 1);
#line 694 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				parameter_string = _tmp26_;
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp28_ = parameter_string;
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				if (_tmp28_ == NULL) {
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					_tmp27_ = TRUE;
#line 1742 "TerminalStream.c"
				} else {
					const gchar* _tmp29_;
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					_tmp29_ = parameter_string;
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					_tmp27_ = g_strcmp0 (_tmp29_, "") == 0;
#line 1749 "TerminalStream.c"
				}
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp30_ = _tmp27_;
#line 696 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				if (_tmp30_) {
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					_g_free0 (parameter_string);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					_terminal_stream_stream_element_control_sequence_specification_free0 (specification);
#line 697 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
					break;
#line 1761 "TerminalStream.c"
				}
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp31_ = parameter_string;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp32_ = terminal_stream_stream_element_parse_sequence_parameters (_tmp31_);
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp33_ = _tmp32_;
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				terminal_stream_stream_element_set_control_sequence_parameters (self, _tmp33_);
#line 699 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_object_unref0 (_tmp33_);
#line 701 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_free0 (parameter_string);
#line 701 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_terminal_stream_stream_element_control_sequence_specification_free0 (specification);
#line 701 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				break;
#line 1779 "TerminalStream.c"
			}
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_terminal_stream_stream_element_control_sequence_specification_free0 (specification);
#line 1783 "TerminalStream.c"
		}
#line 681 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_object_unref0 (_specification_it);
#line 1787 "TerminalStream.c"
	}
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_match_info_free0 (match_info);
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self;
#line 1793 "TerminalStream.c"
}


TerminalStreamStreamElement* terminal_stream_stream_element_new_from_control_sequence (const gchar* control_sequence) {
#line 668 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return terminal_stream_stream_element_construct_from_control_sequence (TERMINAL_STREAM_TYPE_STREAM_ELEMENT, control_sequence);
#line 1800 "TerminalStream.c"
}


static GeeList* terminal_stream_stream_element_parse_sequence_parameters (const gchar* parameter_string) {
	GeeList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* parameters;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** parts;
	gint parts_length1;
	gint _parts_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
#line 709 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (parameter_string != NULL, NULL);
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
#line 710 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	parameters = _tmp0_;
#line 712 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = parameter_string;
#line 712 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_DELIMITER, 0);
#line 712 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	parts = _tmp3_;
#line 712 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	parts_length1 = _vala_array_length (_tmp2_);
#line 712 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_parts_size_ = parts_length1;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = parts;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4__length1 = parts_length1;
#line 1836 "TerminalStream.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		part_collection = _tmp4_;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		part_collection_length1 = _tmp4__length1;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		for (part_it = 0; part_it < _tmp4__length1; part_it = part_it + 1) {
#line 1848 "TerminalStream.c"
			gchar* _tmp5_;
			gchar* part = NULL;
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			_tmp5_ = g_strdup (part_collection[part_it]);
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
			part = _tmp5_;
#line 1855 "TerminalStream.c"
			{
				GeeArrayList* _tmp6_;
				const gchar* _tmp7_;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp6_ = parameters;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_tmp7_ = part;
#line 717 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
#line 716 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
				_g_free0 (part);
#line 1867 "TerminalStream.c"
			}
		}
	}
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = (GeeList*) parameters;
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 720 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 1877 "TerminalStream.c"
}


gint terminal_stream_stream_element_get_numeric_parameter (TerminalStreamStreamElement* self, gint index, gint default_value) {
	gint result = 0;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 723 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 724 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_control_sequence_parameters;
#line 724 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 724 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _tmp1_;
#line 724 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = index;
#line 724 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (_tmp2_ <= _tmp3_) {
#line 1899 "TerminalStream.c"
		gint _tmp4_;
#line 726 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp4_ = default_value;
#line 726 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		result = _tmp4_;
#line 726 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return result;
#line 1907 "TerminalStream.c"
	} else {
		GeeList* _tmp5_;
		gint _tmp6_;
		gpointer _tmp7_ = NULL;
		gchar* _tmp8_;
		gint _tmp9_ = 0;
		gint _tmp10_;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp5_ = self->priv->_control_sequence_parameters;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp6_ = index;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp7_ = gee_list_get (_tmp5_, _tmp6_);
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp8_ = (gchar*) _tmp7_;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp9_ = atoi (_tmp8_);
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp10_ = _tmp9_;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_g_free0 (_tmp8_);
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		result = _tmp10_;
#line 728 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return result;
#line 1933 "TerminalStream.c"
	}
}


gchar* terminal_stream_stream_element_get_text_parameter (TerminalStreamStreamElement* self, gint index, const gchar* default_value) {
	gchar* result = NULL;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 732 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 732 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (default_value != NULL, NULL);
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_control_sequence_parameters;
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _tmp1_;
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = index;
#line 733 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	if (_tmp2_ <= _tmp3_) {
#line 1958 "TerminalStream.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp4_ = default_value;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		result = _tmp5_;
#line 735 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return result;
#line 1969 "TerminalStream.c"
	} else {
		GeeList* _tmp6_;
		gint _tmp7_;
		gpointer _tmp8_ = NULL;
#line 737 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp6_ = self->priv->_control_sequence_parameters;
#line 737 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp7_ = index;
#line 737 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		_tmp8_ = gee_list_get (_tmp6_, _tmp7_);
#line 737 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		result = (gchar*) _tmp8_;
#line 737 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		return result;
#line 1984 "TerminalStream.c"
	}
}


TerminalStreamStreamElement* terminal_stream_stream_element_construct (GType object_type) {
	TerminalStreamStreamElement * self = NULL;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = (TerminalStreamStreamElement*) g_object_new (object_type, NULL);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self;
#line 1995 "TerminalStream.c"
}


TerminalStreamStreamElement* terminal_stream_stream_element_new (void) {
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return terminal_stream_stream_element_construct (TERMINAL_STREAM_TYPE_STREAM_ELEMENT);
#line 2002 "TerminalStream.c"
}


TerminalStreamStreamElementStreamElementType terminal_stream_stream_element_get_stream_element_type (TerminalStreamStreamElement* self) {
	TerminalStreamStreamElementStreamElementType result;
	TerminalStreamStreamElementStreamElementType _tmp0_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_stream_element_type;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = _tmp0_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 2017 "TerminalStream.c"
}


void terminal_stream_stream_element_set_stream_element_type (TerminalStreamStreamElement* self, TerminalStreamStreamElementStreamElementType value) {
	TerminalStreamStreamElementStreamElementType _tmp0_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = value;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->_stream_element_type = _tmp0_;
#line 197 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_notify ((GObject *) self, "stream-element-type");
#line 2031 "TerminalStream.c"
}


const gchar* terminal_stream_stream_element_get_text (TerminalStreamStreamElement* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_text;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = _tmp0_;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 2046 "TerminalStream.c"
}


void terminal_stream_stream_element_set_text (TerminalStreamStreamElement* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = value;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (self->priv->_text);
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->_text = _tmp1_;
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_notify ((GObject *) self, "text");
#line 2065 "TerminalStream.c"
}


TerminalStreamStreamElementControlSequenceType terminal_stream_stream_element_get_control_sequence_type (TerminalStreamStreamElement* self) {
	TerminalStreamStreamElementControlSequenceType result;
	TerminalStreamStreamElementControlSequenceType _tmp0_;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_control_sequence_type;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = _tmp0_;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 2080 "TerminalStream.c"
}


void terminal_stream_stream_element_set_control_sequence_type (TerminalStreamStreamElement* self, TerminalStreamStreamElementControlSequenceType value) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = value;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->_control_sequence_type = _tmp0_;
#line 206 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_notify ((GObject *) self, "control-sequence-type");
#line 2094 "TerminalStream.c"
}


GeeList* terminal_stream_stream_element_get_control_sequence_parameters (TerminalStreamStreamElement* self) {
	GeeList* result;
	GeeList* _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = self->priv->_control_sequence_parameters;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	result = _tmp0_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return result;
#line 2109 "TerminalStream.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return self ? g_object_ref (self) : NULL;
#line 2116 "TerminalStream.c"
}


void terminal_stream_stream_element_set_control_sequence_parameters (TerminalStreamStreamElement* self, GeeList* value) {
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_return_if_fail (self != NULL);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = value;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_object_unref0 (self->priv->_control_sequence_parameters);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->_control_sequence_parameters = _tmp1_;
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_notify ((GObject *) self, "control-sequence-parameters");
#line 2135 "TerminalStream.c"
}


static void terminal_stream_stream_element_control_sequence_specification_copy (const TerminalStreamStreamElementControlSequenceSpecification* self, TerminalStreamStreamElementControlSequenceSpecification* dest) {
	TerminalStreamStreamElementControlSequenceType _tmp0_;
	GRegex* _tmp1_;
	GRegex* _tmp2_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = (*self).type;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	(*dest).type = _tmp0_;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = (*self).pattern;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _g_regex_ref0 (_tmp1_);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_regex_unref0 ((*dest).pattern);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	(*dest).pattern = _tmp2_;
#line 2155 "TerminalStream.c"
}


static void terminal_stream_stream_element_control_sequence_specification_destroy (TerminalStreamStreamElementControlSequenceSpecification* self) {
#line 358 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_regex_unref0 ((*self).pattern);
#line 2162 "TerminalStream.c"
}


static TerminalStreamStreamElementControlSequenceSpecification* terminal_stream_stream_element_control_sequence_specification_dup (const TerminalStreamStreamElementControlSequenceSpecification* self) {
	TerminalStreamStreamElementControlSequenceSpecification* dup;
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	dup = g_new0 (TerminalStreamStreamElementControlSequenceSpecification, 1);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_control_sequence_specification_copy (self, dup);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	return dup;
#line 2174 "TerminalStream.c"
}


static void terminal_stream_stream_element_control_sequence_specification_free (TerminalStreamStreamElementControlSequenceSpecification* self) {
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_control_sequence_specification_destroy (self);
#line 356 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_free (self);
#line 2183 "TerminalStream.c"
}


static GType terminal_stream_stream_element_control_sequence_specification_get_type (void) {
	static volatile gsize terminal_stream_stream_element_control_sequence_specification_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_stream_element_control_sequence_specification_type_id__volatile)) {
		GType terminal_stream_stream_element_control_sequence_specification_type_id;
		terminal_stream_stream_element_control_sequence_specification_type_id = g_boxed_type_register_static ("TerminalStreamStreamElementControlSequenceSpecification", (GBoxedCopyFunc) terminal_stream_stream_element_control_sequence_specification_dup, (GBoxedFreeFunc) terminal_stream_stream_element_control_sequence_specification_free);
		g_once_init_leave (&terminal_stream_stream_element_control_sequence_specification_type_id__volatile, terminal_stream_stream_element_control_sequence_specification_type_id);
	}
	return terminal_stream_stream_element_control_sequence_specification_type_id__volatile;
}


static void terminal_stream_stream_element_class_init (TerminalStreamStreamElementClass * klass) {
	GeeHashMultiMap* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_parent_class = g_type_class_peek_parent (klass);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_type_class_add_private (klass, sizeof (TerminalStreamStreamElementPrivate));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_terminal_stream_stream_element_get_property;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_terminal_stream_stream_element_set_property;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_stream_stream_element_finalize;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE, g_param_spec_enum ("stream-element-type", "stream-element-type", "stream-element-type", TERMINAL_STREAM_STREAM_ELEMENT_TYPE_STREAM_ELEMENT_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STREAM_STREAM_ELEMENT_TEXT, g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE, g_param_spec_enum ("control-sequence-type", "control-sequence-type", "control-sequence-type", TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_PARAMETERS, g_param_spec_object ("control-sequence-parameters", "control-sequence-parameters", "control-sequence-parameters", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_UINT, NULL, NULL, TERMINAL_STREAM_STREAM_ELEMENT_TYPE_CONTROL_SEQUENCE_SPECIFICATION, (GBoxedCopyFunc) terminal_stream_stream_element_control_sequence_specification_dup, terminal_stream_stream_element_control_sequence_specification_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 364 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_control_sequence_specifications = (GeeMultiMap*) _tmp0_;
#line 391 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BELL, "\x07");
#line 392 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACKSPACE, "\x08");
#line 393 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CARRIAGE_RETURN, "\x0D");
#line 394 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RETURN_TERMINAL_STATUS, "\x05");
#line 395 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORM_FEED, "\x0C");
#line 396 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_FEED, "\x0A");
#line 397 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_IN, "\x0F");
#line 398 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SHIFT_OUT, "\x0E");
#line 399 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_TAB, "\x09");
#line 400 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_scf_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_VERTICAL_TAB, "\x0B");
#line 405 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEVEN_BIT_CONTROLS, " F");
#line 406 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_EIGHT_BIT_CONTROLS, " G");
#line 407 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_1, " L");
#line 408 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_2, " M");
#line 409 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_ANSI_CONFORMANCE_LEVEL_3, " N");
#line 410 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_TOP_HALF, "#3");
#line 411 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_HEIGHT_LINE_BOTTOM_HALF, "#4");
#line 412 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SINGLE_WIDTH_LINE, "#5");
#line 413 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_DOUBLE_WIDTH_LINE, "#6");
#line 414 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_SCREEN_ALIGNMENT_TEST, "#8");
#line 415 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_DEFAULT_CHARACTER_SET, "%@");
#line 416 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_UTF8_CHARACTER_SET, "%G");
#line 417 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G0_CHARACTER_SET_VT100, "(");
#line 418 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT100, ")");
#line 419 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT220, "*");
#line 420 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT220, "+");
#line 421 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G1_CHARACTER_SET_VT300, "-");
#line 422 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G2_CHARACTER_SET_VT300, ".");
#line 423 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_designate_character_set_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DESIGNATE_G3_CHARACTER_SET_VT300, "/");
#line 424 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_BACK_INDEX, "6");
#line 425 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR, "7");
#line 426 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR, "8");
#line 427 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FORWARD_INDEX, "9");
#line 428 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_APPLICATION_KEYPAD, "=");
#line 429 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_NORMAL_KEYPAD, ">");
#line 430 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_TO_LOWER_LEFT_CORNER_OF_SCREEN, "F");
#line 431 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FULL_RESET, "c");
#line 432 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_LOCK, "l");
#line 433 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEMORY_UNLOCK, "m");
#line 434 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GL, "n");
#line 435 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GL, "o");
#line 436 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G3_CHARACTER_SET_AS_GR, "|");
#line 437 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G2_CHARACTER_SET_AS_GR, "}");
#line 438 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_esc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INVOKE_G1_CHARACTER_SET_AS_GR, "~");
#line 445 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_dcs_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_USER_DEFINED_KEYS, "");
#line 446 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_dcs_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_STATUS_STRING, "$q");
#line 447 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_dcs_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TERMCAP_DATA, "+p");
#line 448 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_dcs_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMCAP_STRING, "+q");
#line 453 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_CHARACTERS, "@", "");
#line 454 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_UP, "A", "");
#line 455 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_DOWN, "B", "");
#line 456 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD, "C", "");
#line 457 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD, "D", "");
#line 458 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_NEXT_LINE, "E", "");
#line 459 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_PRECEDING_LINE, "F", "");
#line 460 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_CHARACTER_ABSOLUTE, "G", "");
#line 461 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_POSITION, "H", "");
#line 462 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_FORWARD_TABULATION, "I", "");
#line 463 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_ED, "J", "");
#line 464 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_DISPLAY_DECSED, "J", "?");
#line 465 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_EL, "K", "");
#line 466 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_IN_LINE_DECSEL, "K", "?");
#line 467 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_LINES, "L", "");
#line 468 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_LINES, "M", "");
#line 469 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_CHARACTERS, "P", "");
#line 470 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_UP_LINES, "S", "");
#line 471 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SCROLL_DOWN_LINES, "T", "");
#line 473 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INITIATE_HIGHLIGHT_MOUSE_TRACKING, "T", "");
#line 474 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_TITLE_MODES_FEATURES, "T", ">");
#line 475 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_CHARACTERS, "X", "");
#line 476 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CURSOR_BACKWARD_TABULATION, "Z", "");
#line 477 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_ABSOLUTE, "`", "");
#line 478 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_POSITION_RELATIVE, "a", "");
#line 479 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REPEAT_PRECEDING_GRAPHIC_CHARACTER, "b", "");
#line 480 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_PRIMARY, "c", "");
#line 481 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SEND_DEVICE_ATTRIBUTES_SECONDARY, "c", ">");
#line 482 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_ABSOLUTE, "d", "");
#line 483 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LINE_POSITION_RELATIVE, "e", "");
#line 484 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_HORIZONTAL_AND_VERTICAL_POSITION, "f", "");
#line 485 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_TAB_CLEAR, "g", "");
#line 486 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MODE, "h", "");
#line 487 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_SET, "h", "?");
#line 488 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY, "i", "");
#line 489 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_MEDIA_COPY_DEC, "i", "?");
#line 490 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESET_MODE, "l", "");
#line 491 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEC_PRIVATE_MODE_RESET, "l", "?");
#line 492 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHARACTER_ATTRIBUTES, "m", "");
#line 493 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_OR_RESET_RESOURCE_VALUES, "m", ">");
#line 494 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT, "n", "");
#line 495 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DISABLE_MODIFIERS, "n", ">");
#line 496 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DEVICE_STATUS_REPORT_DEC, "n", "?");
#line 497 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_RESOURCE_VALUE_POINTER_MODE, "p", ">");
#line 499 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SOFT_TERMINAL_RESET, "!p", "");
#line 500 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_ANSI_MODE, "$p", "");
#line 501 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_DEC_PRIVATE_MODE, "$p", "?");
#line 502 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CONFORMANCE_LEVEL, "“p", "");
#line 503 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_LOAD_LEDS, "q", "");
#line 504 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_CURSOR_STYLE, " q", "");
#line 505 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_CHARACTER_PROTECTION_ATTRIBUTE, "“q", "");
#line 506 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_SCROLLING_REGION, "r", "");
#line 507 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_DEC_PRIVATE_MODE_VALUES, "r", "?");
#line 508 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_CHANGE_ATTRIBUTES_IN_RECTANGULAR_AREA, "$r", "");
#line 509 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_LEFT_AND_RIGHT_MARGINS, "s", "");
#line 511 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_CURSOR_ANSI_SYS, "s", "");
#line 512 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SAVE_DEC_PRIVATE_MODE_VALUES, "s", "?");
#line 513 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_WINDOW_MANIPULATION, "t", "");
#line 514 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REVERSE_ATTRIBUTES_IN_RECTANGULAR_AREA, "$t", "");
#line 515 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TITLE_MODES_FEATURES, "t", ">");
#line 516 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_WARNING_BELL_VOLUME, " t", "");
#line 518 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_RESTORE_CURSOR_ANSI_SYS, "u", "");
#line 519 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_MARGIN_BELL_VOLUME, " u", "");
#line 520 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_COPY_RECTANGULAR_AREA, "$v", "");
#line 521 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_FILTER_RECTANGLE, "’w", "");
#line 522 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_TERMINAL_PARAMETERS, "x", "");
#line 523 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_ATTRIBUTE_CHANGE_EXTENT, "*x", "");
#line 524 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_CHECKSUM_OF_RECTANGULAR_AREA, "*y", "");
#line 525 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FILL_RECTANGULAR_AREA, "$x", "");
#line 526 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ENABLE_LOCATOR_REPORTING, "’z", "");
#line 527 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_ERASE_RECTANGULAR_AREA, "$z", "");
#line 528 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECT_LOCATOR_EVENTS, "’{", "");
#line 529 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SELECTIVE_ERASE_RECTANGULAR_AREA, "${", "");
#line 530 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_REQUEST_LOCATOR_POSITION, "’|", "");
#line 531 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_INSERT_COLUMNS, " }", "");
#line 532 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_csi_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_DELETE_COLUMNS, " ~", "");
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp1_ = g_regex_escape_string (TERMINAL_STREAM_STREAM_ELEMENT_FINAL_TERM_PATTERN_DESIGNATOR, -1);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp2_ = _tmp1_;
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp3_ = g_strconcat ("(?!", _tmp2_, NULL);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp4_ = _tmp3_;
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp5_ = g_strconcat (_tmp4_, ")", NULL);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp6_ = _tmp5_;
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp7_ = g_strconcat (_tmp6_, TERMINAL_STREAM_STREAM_ELEMENT_PARAMETER_LIST_PATTERN, NULL);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp8_ = _tmp7_;
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_osc_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_SET_TEXT_PARAMETERS, _tmp8_);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp8_);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp6_);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp4_);
#line 536 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (_tmp2_);
#line 542 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROMPT, "A");
#line 543 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_START, "B");
#line 544 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_EXECUTED, "C");
#line 545 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_COMMAND_FINISHED, "D");
#line 546 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_START, "E");
#line 547 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_TEXT_MENU_END, "F");
#line 548 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_PROGRESS, "G");
#line 549 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_stream_element_add_final_term_sequence_pattern (TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE_FTCS_EXECUTE_COMMANDS, "H");
#line 2520 "TerminalStream.c"
}


static void terminal_stream_stream_element_instance_init (TerminalStreamStreamElement * self) {
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv = TERMINAL_STREAM_STREAM_ELEMENT_GET_PRIVATE (self);
#line 2527 "TerminalStream.c"
}


static void terminal_stream_stream_element_finalize (GObject* obj) {
	TerminalStreamStreamElement * self;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement);
#line 204 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_free0 (self->priv->_text);
#line 354 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_object_unref0 (self->priv->_control_sequence_parameters);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (terminal_stream_stream_element_parent_class)->finalize (obj);
#line 2541 "TerminalStream.c"
}


GType terminal_stream_stream_element_get_type (void) {
	static volatile gsize terminal_stream_stream_element_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_stream_element_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalStreamStreamElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_stream_stream_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalStreamStreamElement), 0, (GInstanceInitFunc) terminal_stream_stream_element_instance_init, NULL };
		GType terminal_stream_stream_element_type_id;
		terminal_stream_stream_element_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalStreamStreamElement", &g_define_type_info, 0);
		g_once_init_leave (&terminal_stream_stream_element_type_id__volatile, terminal_stream_stream_element_type_id);
	}
	return terminal_stream_stream_element_type_id__volatile;
}


static void _vala_terminal_stream_stream_element_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	TerminalStreamStreamElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	switch (property_id) {
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_value_set_enum (value, terminal_stream_stream_element_get_stream_element_type (self));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_TEXT:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_value_set_string (value, terminal_stream_stream_element_get_text (self));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_value_set_enum (value, terminal_stream_stream_element_get_control_sequence_type (self));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_PARAMETERS:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		g_value_set_object (value, terminal_stream_stream_element_get_control_sequence_parameters (self));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 2586 "TerminalStream.c"
		default:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 2592 "TerminalStream.c"
	}
}


static void _vala_terminal_stream_stream_element_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	TerminalStreamStreamElement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TERMINAL_STREAM_TYPE_STREAM_ELEMENT, TerminalStreamStreamElement);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	switch (property_id) {
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_STREAM_ELEMENT_TYPE:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		terminal_stream_stream_element_set_stream_element_type (self, g_value_get_enum (value));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_TEXT:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		terminal_stream_stream_element_set_text (self, g_value_get_string (value));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_TYPE:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		terminal_stream_stream_element_set_control_sequence_type (self, g_value_get_enum (value));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		case TERMINAL_STREAM_STREAM_ELEMENT_CONTROL_SEQUENCE_PARAMETERS:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		terminal_stream_stream_element_set_control_sequence_parameters (self, g_value_get_object (value));
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 2626 "TerminalStream.c"
		default:
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 195 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
		break;
#line 2632 "TerminalStream.c"
	}
}


static void terminal_stream_class_init (TerminalStreamClass * klass) {
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	terminal_stream_parent_class = g_type_class_peek_parent (klass);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_type_class_add_private (klass, sizeof (TerminalStreamPrivate));
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (klass)->finalize = terminal_stream_finalize;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_signal_new ("element_completed", TYPE_TERMINAL_STREAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TERMINAL_STREAM_TYPE_STREAM_ELEMENT);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	g_signal_new ("transient_text_updated", TYPE_TERMINAL_STREAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 2648 "TerminalStream.c"
}


static void terminal_stream_instance_init (TerminalStream * self) {
	GString* _tmp0_;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv = TERMINAL_STREAM_GET_PRIVATE (self);
#line 29 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->parse_state = TERMINAL_STREAM_PARSE_STATE_TEXT;
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_tmp0_ = g_string_new ("");
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self->priv->sequence_builder = _tmp0_;
#line 2662 "TerminalStream.c"
}


static void terminal_stream_finalize (GObject* obj) {
	TerminalStream * self;
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TERMINAL_STREAM, TerminalStream);
#line 40 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	_g_string_free0 (self->priv->sequence_builder);
#line 27 "/builddir/build/BUILD/finalterm-git-40.4a9ec96/src/TerminalStream.vala"
	G_OBJECT_CLASS (terminal_stream_parent_class)->finalize (obj);
#line 2674 "TerminalStream.c"
}


GType terminal_stream_get_type (void) {
	static volatile gsize terminal_stream_type_id__volatile = 0;
	if (g_once_init_enter (&terminal_stream_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TerminalStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) terminal_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TerminalStream), 0, (GInstanceInitFunc) terminal_stream_instance_init, NULL };
		GType terminal_stream_type_id;
		terminal_stream_type_id = g_type_register_static (G_TYPE_OBJECT, "TerminalStream", &g_define_type_info, 0);
		g_once_init_leave (&terminal_stream_type_id__volatile, terminal_stream_type_id);
	}
	return terminal_stream_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



